// DO NOT EDIT
// Generated by JFlex 1.8.2 http://jflex.de/
// source: PHPTokenizer.jflex

/*******************************************************************************
 * Copyright (c) 2006 Zend Corporation and IBM Corporation.
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *   Zend and IBM - Initial implementation
 *******************************************************************************/
/*nlsXXX*/
package org.eclipse.php.internal.core.documentModel.parser;

import java.io.CharArrayReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.dltk.annotations.NonNull;
import org.eclipse.php.core.PHPVersion;
import org.eclipse.php.internal.core.documentModel.parser.regions.PHPScriptRegion;
import org.eclipse.php.core.project.ProjectOptions;
import org.eclipse.wst.sse.core.internal.ltk.parser.BlockMarker;
import org.eclipse.wst.sse.core.internal.ltk.parser.BlockTokenizer;
import org.eclipse.wst.sse.core.internal.provisional.text.ITextRegion;
import org.eclipse.wst.sse.core.internal.provisional.text.ITextRegionList;
import org.eclipse.wst.sse.core.internal.util.Debug;
import org.eclipse.wst.sse.core.utils.StringUtils;
import org.eclipse.wst.xml.core.internal.Logger;
import org.eclipse.wst.xml.core.internal.parser.ContextRegionContainer;
import org.eclipse.wst.xml.core.internal.parser.IntStack;
import org.eclipse.wst.xml.core.internal.parser.regions.XMLParserRegionFactory;
import org.eclipse.wst.xml.core.internal.regions.DOMRegionContext;


// See https://github.com/jflex-de/jflex/issues/222
@SuppressWarnings("FallThrough")
public class PHPTokenizer implements BlockTokenizer, PHPRegionContext, DOMRegionContext {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int ST_CDATA_TEXT = 2;
  public static final int ST_CDATA_END = 4;
  public static final int ST_XML_COMMENT = 6;
  public static final int ST_XML_COMMENT_END = 8;
  public static final int ST_PI = 10;
  public static final int ST_PI_WS = 12;
  public static final int ST_PI_CONTENT = 14;
  public static final int ST_XML_PI_ATTRIBUTE_NAME = 16;
  public static final int ST_XML_PI_EQUALS = 18;
  public static final int ST_XML_PI_ATTRIBUTE_VALUE = 20;
  public static final int ST_XML_PI_TAG_CLOSE = 22;
  public static final int ST_DHTML_ATTRIBUTE_NAME = 24;
  public static final int ST_DHTML_EQUALS = 26;
  public static final int ST_DHTML_ATTRIBUTE_VALUE = 28;
  public static final int ST_XML_TAG_NAME = 30;
  public static final int ST_XML_ATTRIBUTE_NAME = 32;
  public static final int ST_XML_EQUALS = 34;
  public static final int ST_XML_ATTRIBUTE_VALUE = 36;
  public static final int ST_XML_DECLARATION = 38;
  public static final int ST_XML_DECLARATION_CLOSE = 40;
  public static final int ST_XML_DOCTYPE_DECLARATION = 42;
  public static final int ST_XML_DOCTYPE_EXTERNAL_ID = 44;
  public static final int ST_XML_DOCTYPE_ID_PUBLIC = 46;
  public static final int ST_XML_DOCTYPE_ID_SYSTEM = 48;
  public static final int ST_XML_ELEMENT_DECLARATION = 50;
  public static final int ST_XML_ELEMENT_DECLARATION_CONTENT = 52;
  public static final int ST_XML_ATTLIST_DECLARATION = 54;
  public static final int ST_XML_ATTLIST_DECLARATION_CONTENT = 56;
  public static final int ST_BLOCK_TAG_SCAN = 58;
  public static final int ST_PHP_CONTENT = 60;
  public static final int ST_XML_ATTRIBUTE_VALUE_SQUOTED = 62;
  public static final int ST_XML_ATTRIBUTE_VALUE_DQUOTED = 64;
  public static final int ST_BLOCK_TAG_INTERNAL_SCAN = 66;
  public static final int ST_ABORT_EMBEDDED = 68;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7,  7, 
     8,  8,  9,  9, 10, 10, 11, 11, 12, 12, 13, 13, 14, 14, 15, 15, 
    16, 16, 17, 17, 18, 18, 19, 19, 20, 20, 21, 21, 22, 22, 23, 23, 
    24, 24, 25, 25, 26, 26, 27, 27, 28, 28, 29, 29, 30, 30, 31, 31, 
    32, 32, 33, 33, 33, 33
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\1\u0200\1\u0300\1\u0400\1\u0500\1\u0600\2\u0700"+
    "\1\u0800\1\u0900\1\u0a00\1\u0b00\1\u0c00\1\u0d00\1\u0e00\1\u0f00"+
    "\1\u1000\14\u0700\1\u1100\1\u1200\1\u1300\1\u1400\16\u0700\1\u1500"+
    "\1\u1600\34\u0700\121\u1700\1\u1800\14\u0700\53\u1900\1\u1a00\10\u1b00"+
    "\u1020\u0700";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\2\0\1\3\22\0\1\3\1\4"+
    "\1\5\1\6\1\7\1\10\1\11\1\12\5\7\1\13"+
    "\1\14\1\15\12\16\1\17\1\20\1\21\1\22\1\23"+
    "\1\24\1\7\1\25\1\26\1\27\1\30\1\31\1\32"+
    "\1\33\1\34\1\35\2\33\1\36\1\37\1\40\1\41"+
    "\1\42\1\33\1\43\1\44\1\45\1\46\2\33\1\47"+
    "\1\50\1\33\1\51\1\0\1\52\1\0\1\17\1\0"+
    "\1\53\1\26\1\54\1\55\1\56\1\32\1\33\1\57"+
    "\1\35\2\33\1\60\1\61\1\40\1\41\1\42\1\33"+
    "\1\43\1\62\1\63\1\46\2\33\1\64\1\65\1\33"+
    "\1\0\1\66\72\0\1\67\10\0\27\70\1\0\37\70"+
    "\1\0\72\70\2\0\13\70\2\0\10\70\1\0\65\70"+
    "\1\0\104\70\11\0\44\70\3\0\2\70\4\0\36\70"+
    "\70\0\131\70\22\0\7\70\16\0\2\67\56\0\106\67"+
    "\32\0\2\67\44\0\1\70\1\67\3\70\1\0\1\70"+
    "\1\0\24\70\1\0\54\70\1\0\7\70\3\0\1\70"+
    "\1\0\1\70\1\0\1\70\1\0\1\70\1\0\22\70"+
    "\15\0\14\70\1\0\102\70\1\0\14\70\1\0\44\70"+
    "\1\0\4\67\11\0\65\70\2\0\2\70\2\0\2\70"+
    "\3\0\34\70\2\0\10\70\2\0\2\70\67\0\46\70"+
    "\2\0\1\70\7\0\46\70\12\0\21\67\1\0\27\67"+
    "\1\0\3\67\1\0\1\67\1\0\2\67\1\0\1\67"+
    "\13\0\33\70\5\0\3\70\56\0\32\70\5\0\1\67"+
    "\12\70\10\67\15\0\12\67\6\0\1\67\107\70\2\0"+
    "\5\70\1\0\17\70\1\0\4\70\1\0\1\70\17\67"+
    "\2\70\2\67\1\0\4\67\2\0\12\67\u0107\0\3\67"+
    "\1\0\65\70\2\0\1\67\1\70\20\67\3\0\4\67"+
    "\3\0\12\70\2\67\2\0\12\67\21\0\3\67\1\0"+
    "\10\70\2\0\2\70\2\0\26\70\1\0\7\70\1\0"+
    "\1\70\3\0\4\70\2\0\1\67\1\0\7\67\2\0"+
    "\2\67\2\0\3\67\11\0\1\67\4\0\2\70\1\0"+
    "\3\70\2\67\2\0\12\67\2\70\20\0\1\67\2\0"+
    "\6\70\4\0\2\70\2\0\26\70\1\0\7\70\1\0"+
    "\2\70\1\0\2\70\1\0\2\70\2\0\1\67\1\0"+
    "\5\67\4\0\2\67\2\0\3\67\13\0\4\70\1\0"+
    "\1\70\7\0\14\67\3\70\14\0\3\67\1\0\7\70"+
    "\1\0\1\70\1\0\3\70\1\0\26\70\1\0\7\70"+
    "\1\0\2\70\1\0\5\70\2\0\1\67\1\70\10\67"+
    "\1\0\3\67\1\0\3\67\22\0\1\70\5\0\12\67"+
    "\21\0\3\67\1\0\10\70\2\0\2\70\2\0\26\70"+
    "\1\0\7\70\1\0\2\70\2\0\4\70\2\0\1\67"+
    "\1\70\6\67\3\0\2\67\2\0\3\67\10\0\2\67"+
    "\4\0\2\70\1\0\3\70\4\0\12\67\22\0\2\67"+
    "\1\0\6\70\3\0\3\70\1\0\4\70\3\0\2\70"+
    "\1\0\1\70\1\0\2\70\3\0\2\70\3\0\3\70"+
    "\3\0\10\70\1\0\3\70\4\0\5\67\3\0\3\67"+
    "\1\0\4\67\11\0\1\67\17\0\11\67\21\0\3\67"+
    "\1\0\10\70\1\0\3\70\1\0\27\70\1\0\12\70"+
    "\1\0\5\70\4\0\7\67\1\0\3\67\1\0\4\67"+
    "\7\0\2\67\11\0\2\70\4\0\12\67\22\0\2\67"+
    "\1\0\10\70\1\0\3\70\1\0\27\70\1\0\12\70"+
    "\1\0\5\70\4\0\7\67\1\0\3\67\1\0\4\67"+
    "\7\0\2\67\7\0\1\70\1\0\2\70\4\0\12\67"+
    "\22\0\2\67\1\0\10\70\1\0\3\70\1\0\27\70"+
    "\1\0\20\70\4\0\6\67\2\0\3\67\1\0\4\67"+
    "\11\0\1\67\10\0\2\70\4\0\12\67\221\0\56\70"+
    "\1\0\1\70\1\67\2\70\7\67\5\0\6\70\11\67"+
    "\1\0\12\67\47\0\2\70\1\0\1\70\2\0\2\70"+
    "\1\0\1\70\2\0\1\70\6\0\4\70\1\0\7\70"+
    "\1\0\3\70\1\0\1\70\1\0\1\70\2\0\2\70"+
    "\1\0\2\70\1\0\1\70\1\67\2\70\6\67\1\0"+
    "\2\67\1\70\2\0\5\70\1\0\1\67\1\0\6\67"+
    "\2\0\12\67\76\0\2\67\6\0\12\67\13\0\1\67"+
    "\1\0\1\67\1\0\1\67\4\0\2\67\10\70\1\0"+
    "\41\70\7\0\24\67\1\0\6\67\4\0\6\67\1\0"+
    "\1\67\1\0\25\67\3\0\7\67\1\0\1\67\346\0"+
    "\46\70\12\0\47\70\11\0\1\70\1\0\2\70\1\0"+
    "\3\70\1\0\1\70\1\0\2\70\1\0\5\70\51\0"+
    "\1\70\1\0\1\70\1\0\1\70\13\0\1\70\1\0"+
    "\1\70\1\0\1\70\3\0\2\70\3\0\1\70\5\0"+
    "\3\70\1\0\1\70\1\0\1\70\1\0\1\70\1\0"+
    "\1\70\3\0\2\70\3\0\2\70\1\0\1\70\50\0"+
    "\1\70\11\0\1\70\2\0\1\70\2\0\2\70\7\0"+
    "\2\70\1\0\1\70\1\0\7\70\50\0\1\70\4\0"+
    "\1\70\10\0\1\70\6\0\234\70\4\0\132\70\6\0"+
    "\26\70\2\0\6\70\2\0\46\70\2\0\6\70\2\0"+
    "\10\70\1\0\1\70\1\0\1\70\1\0\1\70\1\0"+
    "\37\70\2\0\65\70\1\0\7\70\1\0\1\70\3\0"+
    "\3\70\1\0\7\70\3\0\4\70\2\0\6\70\4\0"+
    "\15\70\5\0\3\70\1\0\7\70\323\0\15\67\4\0"+
    "\1\67\104\0\1\70\3\0\2\70\2\0\1\70\121\0"+
    "\3\70\202\0\1\67\1\0\1\70\31\0\11\70\6\67"+
    "\1\0\5\67\13\0\124\70\4\0\2\67\2\0\2\67"+
    "\2\0\132\70\1\0\3\67\6\0\50\70\323\0\u01a6\70"+
    "\132\0\u01a4\70\134\0\u0100\71";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[7168];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\1\1\4\0\1\2\2\0\3\2\3\0\1\3\1\4"+
    "\12\2\1\5\1\2\1\6\5\0\1\1\2\7\1\10"+
    "\2\11\1\7\1\12\2\7\2\13\1\7\1\2\1\14"+
    "\1\7\3\14\1\15\3\16\1\17\1\7\1\20\1\21"+
    "\3\7\1\21\2\7\1\22\1\23\1\24\3\3\1\7"+
    "\1\4\1\7\1\25\1\26\1\25\1\27\1\10\1\30"+
    "\1\31\1\32\1\33\1\7\2\10\1\34\4\7\1\35"+
    "\2\7\3\36\1\7\1\36\3\37\1\7\1\37\3\40"+
    "\1\7\2\5\1\41\3\42\1\7\2\6\1\43\2\44"+
    "\3\45\1\46\1\47\1\50\1\46\1\51\1\0\1\1"+
    "\1\0\1\1\1\52\1\53\1\54\1\53\3\0\1\55"+
    "\3\14\1\56\1\57\2\0\1\21\4\0\1\3\4\0"+
    "\1\60\1\61\2\0\1\31\1\0\1\62\5\0\1\63"+
    "\4\0\1\36\1\0\1\36\2\0\2\36\2\0\1\63"+
    "\2\0\1\37\4\0\1\63\2\0\1\40\1\0\1\40"+
    "\2\0\2\40\1\0\1\5\2\53\2\0\1\42\1\0"+
    "\1\42\2\0\2\42\1\0\1\6\2\53\1\64\1\65"+
    "\2\1\1\66\2\0\1\67\2\0\1\53\1\0\1\70"+
    "\1\71\1\14\2\72\6\0\1\36\2\0\1\40\1\0"+
    "\1\5\1\53\1\5\1\0\1\42\1\0\1\6\1\53"+
    "\1\6\1\1\1\73\1\0\1\74\2\0\2\14\7\0"+
    "\2\5\1\0\2\6\2\0\2\14\5\0\2\5\2\6"+
    "\1\0\1\53\1\75\1\14\3\0\1\76\1\77\1\5"+
    "\1\53\1\6\1\53\1\0\1\14\1\100\1\101\1\102"+
    "\1\5\1\6\1\0\1\14\1\5\1\6\1\103\1\14"+
    "\2\103\4\14\1\104";

  private static int [] zzUnpackAction() {
    int [] result = new int[323];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\72\0\164\0\256\0\350\0\u0122\0\u015c\0\u0196"+
    "\0\u01d0\0\u020a\0\u0244\0\u027e\0\u02b8\0\u02f2\0\u032c\0\u0366"+
    "\0\u03a0\0\u03da\0\u0414\0\u044e\0\u0488\0\u04c2\0\u04fc\0\u0536"+
    "\0\u0570\0\u05aa\0\u05e4\0\u061e\0\u0658\0\u0692\0\u06cc\0\u0706"+
    "\0\u0740\0\u077a\0\u07b4\0\u07ee\0\u0828\0\u0862\0\u089c\0\u08d6"+
    "\0\u089c\0\u089c\0\u08d6\0\u0910\0\u089c\0\u08d6\0\u094a\0\u0984"+
    "\0\u09be\0\u09f8\0\u0a32\0\u0a6c\0\u0aa6\0\u0ae0\0\u089c\0\u08d6"+
    "\0\u0b1a\0\u0b54\0\u0b8e\0\u089c\0\u0bc8\0\u0c02\0\u0c3c\0\u0bc8"+
    "\0\u0c76\0\u0b1a\0\u0cb0\0\u0cea\0\u089c\0\u089c\0\u0d24\0\u0d5e"+
    "\0\u0d98\0\u0dd2\0\u0e0c\0\u0e46\0\u0e80\0\u089c\0\u0eba\0\u0ef4"+
    "\0\u0f2e\0\u089c\0\u0f68\0\u0fa2\0\u0fdc\0\u1016\0\u1050\0\u108a"+
    "\0\u089c\0\u10c4\0\u10fe\0\u1138\0\u1172\0\u11ac\0\u11e6\0\u1220"+
    "\0\u125a\0\u1294\0\u12ce\0\u125a\0\u1308\0\u1342\0\u137c\0\u13b6"+
    "\0\u1342\0\u13f0\0\u142a\0\u1464\0\u149e\0\u142a\0\u14d8\0\u1512"+
    "\0\u089c\0\u154c\0\u1586\0\u15c0\0\u154c\0\u15fa\0\u1634\0\u089c"+
    "\0\u089c\0\u08d6\0\u089c\0\u166e\0\u08d6\0\u16a8\0\u089c\0\u16e2"+
    "\0\u171c\0\u089c\0\u1756\0\u1790\0\u17ca\0\u1804\0\u183e\0\u1878"+
    "\0\u089c\0\u18b2\0\u18ec\0\u1926\0\u1960\0\u089c\0\u199a\0\u19d4"+
    "\0\u1a0e\0\u089c\0\u089c\0\u0bc8\0\u0c02\0\u089c\0\u0c3c\0\u0cb0"+
    "\0\u0d24\0\u1a48\0\u089c\0\u0d5e\0\u1a82\0\u0d98\0\u0dd2\0\u089c"+
    "\0\u1abc\0\u0f68\0\u0fa2\0\u089c\0\u0fdc\0\u1af6\0\u183e\0\u1b30"+
    "\0\u1b6a\0\u1ba4\0\u1172\0\u089c\0\u1bde\0\u1c18\0\u125a\0\u1c52"+
    "\0\u089c\0\u1294\0\u1c8c\0\u1cc6\0\u1d00\0\u1d3a\0\u1d74\0\u1d3a"+
    "\0\u1308\0\u125a\0\u1342\0\u1dae\0\u089c\0\u137c\0\u1de8\0\u13b6"+
    "\0\u13f0\0\u1342\0\u142a\0\u1e22\0\u089c\0\u1464\0\u1e5c\0\u1e96"+
    "\0\u1ed0\0\u1f0a\0\u1f44\0\u1f0a\0\u1f7e\0\u1fb8\0\u1ff2\0\u154c"+
    "\0\u202c\0\u089c\0\u1586\0\u2066\0\u20a0\0\u20da\0\u2114\0\u214e"+
    "\0\u2114\0\u2188\0\u21c2\0\u21fc\0\u089c\0\u089c\0\u2236\0\u2270"+
    "\0\u089c\0\u22aa\0\u22e4\0\u089c\0\u231e\0\u2358\0\u089c\0\u2392"+
    "\0\u089c\0\u089c\0\u23cc\0\u09be\0\u2406\0\u2440\0\u247a\0\u24b4"+
    "\0\u24ee\0\u2528\0\u1c8c\0\u2562\0\u2562\0\u1e5c\0\u259c\0\u259c"+
    "\0\u25d6\0\u14d8\0\u2610\0\u2066\0\u264a\0\u264a\0\u2684\0\u15fa"+
    "\0\u26be\0\u26f8\0\u089c\0\u2732\0\u089c\0\u276c\0\u27a6\0\u27e0"+
    "\0\u281a\0\u2854\0\u288e\0\u28c8\0\u2902\0\u293c\0\u1d74\0\u1f44"+
    "\0\u2976\0\u29b0\0\u214e\0\u29ea\0\u2a24\0\u2a5e\0\u2a98\0\u2ad2"+
    "\0\u2b0c\0\u2b46\0\u2b80\0\u2bba\0\u2bf4\0\u2c2e\0\u2c68\0\u2ca2"+
    "\0\u2cdc\0\u2d16\0\u2d50\0\u2a98\0\u09be\0\u2d8a\0\u2dc4\0\u2dfe"+
    "\0\u2e38\0\u089c\0\u089c\0\u2e72\0\u2ca2\0\u2eac\0\u2d16\0\u2ee6"+
    "\0\u2f20\0\u089c\0\u089c\0\u089c\0\u2f5a\0\u2f94\0\u2fce\0\u3008"+
    "\0\u3042\0\u307c\0\u089c\0\u30b6\0\u14d8\0\u15fa\0\u30f0\0\u312a"+
    "\0\u3164\0\u319e\0\u09be";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[323];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\10\43\1\44\1\45\7\43\1\46\50\43\21\47\1\50"+
    "\47\47\1\0\2\51\1\52\16\51\1\53\30\51\1\54"+
    "\16\51\1\0\21\55\1\56\47\55\1\0\2\51\1\52"+
    "\10\51\1\57\5\51\1\53\47\51\1\0\1\51\3\60"+
    "\13\51\1\61\1\51\1\53\2\51\1\62\10\61\1\63"+
    "\11\61\1\64\1\61\2\51\11\61\1\65\1\61\2\51"+
    "\1\61\1\0\1\51\3\66\15\51\1\53\2\51\1\62"+
    "\44\51\1\0\2\67\1\52\16\67\1\70\2\67\1\71"+
    "\44\67\1\0\1\51\3\60\13\51\1\72\1\51\1\53"+
    "\2\51\1\73\24\72\2\51\13\72\2\51\1\72\1\0"+
    "\1\51\3\60\13\51\1\72\1\51\1\53\1\74\1\51"+
    "\1\73\24\72\2\51\13\72\2\51\1\72\1\0\1\75"+
    "\3\60\1\75\1\76\4\75\1\77\2\75\1\100\3\75"+
    "\1\53\1\75\1\51\1\101\45\75\2\51\1\52\16\51"+
    "\1\53\2\51\1\102\44\51\1\0\2\51\1\52\12\51"+
    "\1\103\1\51\1\104\1\51\1\53\1\51\1\105\1\51"+
    "\24\104\2\51\13\104\2\51\1\104\1\0\2\51\1\52"+
    "\12\51\1\103\1\51\1\104\1\51\1\53\1\106\1\105"+
    "\1\51\24\104\2\51\13\104\2\51\1\104\1\0\1\107"+
    "\1\51\1\52\1\51\1\107\1\110\4\107\1\111\2\107"+
    "\1\112\3\107\1\53\1\107\1\105\46\107\15\113\1\114"+
    "\1\113\1\115\1\113\1\46\1\113\1\116\1\113\24\117"+
    "\2\113\13\117\2\113\1\117\1\113\1\51\3\60\11\51"+
    "\1\114\1\51\1\120\1\51\1\121\1\51\1\116\1\51"+
    "\24\120\2\51\13\120\2\51\1\120\1\0\1\51\3\60"+
    "\11\51\1\114\1\51\1\120\1\51\1\121\1\122\1\116"+
    "\1\51\24\120\2\51\13\120\2\51\1\120\1\0\1\123"+
    "\3\60\1\123\1\124\4\123\1\125\2\123\1\126\3\123"+
    "\1\127\1\123\1\116\46\123\1\51\3\60\15\51\1\130"+
    "\1\51\1\131\1\51\1\132\2\51\1\133\1\134\21\51"+
    "\1\132\1\51\1\133\1\134\12\51\1\0\1\51\3\60"+
    "\15\51\1\53\1\51\1\131\25\51\1\135\17\51\1\0"+
    "\1\51\3\60\13\51\1\136\1\51\1\53\1\51\1\131"+
    "\1\51\24\136\1\135\1\51\13\136\2\51\1\136\1\0"+
    "\1\51\3\60\15\51\1\53\1\51\1\131\16\51\1\137"+
    "\1\51\1\140\4\51\1\135\10\51\1\140\6\51\1\0"+
    "\1\141\3\60\1\141\1\142\4\141\1\143\2\141\1\144"+
    "\3\141\1\53\1\141\1\131\25\141\1\145\20\141\1\146"+
    "\3\60\1\146\1\147\4\146\1\150\2\146\1\151\3\146"+
    "\1\53\1\146\1\131\25\146\1\152\20\146\1\153\3\60"+
    "\1\153\1\154\4\153\1\155\2\153\1\156\3\153\1\53"+
    "\1\153\1\131\46\153\21\157\1\160\1\157\1\161\46\157"+
    "\1\162\3\60\1\162\1\163\4\162\1\164\2\162\1\165"+
    "\3\162\1\53\1\162\1\131\46\162\21\166\1\167\1\166"+
    "\1\170\46\166\21\171\1\172\47\171\1\0\10\173\1\174"+
    "\10\173\1\175\2\173\1\174\44\173\1\0\12\176\1\177"+
    "\6\176\1\200\50\176\5\201\1\202\13\201\1\200\50\201"+
    "\2\51\1\52\16\51\1\53\47\51\1\0\10\43\2\0"+
    "\7\43\1\0\50\43\1\0\3\203\13\0\1\204\5\0"+
    "\24\204\2\0\13\204\2\0\1\204\2\0\3\203\2\0"+
    "\1\205\10\0\1\206\5\0\24\206\2\0\13\206\2\0"+
    "\1\206\5\0\1\207\3\0\1\210\4\0\1\211\6\0"+
    "\1\212\143\0\1\213\3\0\1\210\13\0\1\212\117\0"+
    "\1\214\32\0\1\215\57\0\3\60\101\0\2\61\1\0"+
    "\2\61\5\0\24\61\2\0\13\61\1\0\2\61\24\0"+
    "\1\216\61\0\2\61\1\0\2\61\5\0\12\61\1\217"+
    "\11\61\2\0\6\61\1\217\4\61\1\0\2\61\14\0"+
    "\2\61\1\0\2\61\5\0\12\61\1\220\11\61\2\0"+
    "\6\61\1\220\4\61\1\0\2\61\14\0\2\61\1\0"+
    "\2\61\5\0\12\61\1\220\11\61\2\0\6\61\1\221"+
    "\4\61\1\0\2\61\2\0\3\66\111\0\1\222\61\0"+
    "\2\72\1\0\2\72\5\0\24\72\2\0\13\72\1\0"+
    "\2\72\24\0\1\223\46\0\1\75\3\0\1\75\1\0"+
    "\4\75\1\0\2\75\1\224\3\75\1\0\1\75\1\0"+
    "\46\75\5\225\1\226\13\225\1\0\50\225\12\227\1\226"+
    "\6\227\1\0\50\227\1\75\3\0\1\75\1\0\4\75"+
    "\1\0\2\75\1\224\3\75\1\0\1\75\1\223\46\75"+
    "\15\0\1\230\5\0\1\105\61\0\2\104\1\0\2\104"+
    "\5\0\24\104\2\0\13\104\1\0\2\104\1\0\1\107"+
    "\3\0\1\107\1\0\4\107\1\0\2\107\1\231\3\107"+
    "\1\0\1\107\1\0\46\107\1\110\3\232\1\110\1\233"+
    "\4\110\1\232\2\110\1\234\3\110\1\0\1\110\1\232"+
    "\46\110\1\111\3\235\1\111\1\235\4\111\1\233\2\111"+
    "\1\236\3\111\1\0\1\111\1\235\46\111\1\107\3\0"+
    "\1\107\1\0\4\107\1\0\2\107\1\237\3\107\1\0"+
    "\1\107\1\105\46\107\15\113\1\0\3\113\1\0\1\113"+
    "\1\0\1\113\24\0\2\113\13\0\2\113\1\0\1\113"+
    "\23\0\1\240\46\0\13\113\2\115\1\0\2\115\1\113"+
    "\1\0\1\113\1\0\1\113\24\117\2\113\13\117\1\113"+
    "\1\115\1\117\1\113\13\0\2\117\1\0\2\117\5\0"+
    "\24\117\2\0\13\117\1\0\2\117\14\0\2\120\1\0"+
    "\2\120\5\0\24\120\2\0\13\120\1\0\2\120\5\0"+
    "\1\207\3\0\1\210\4\0\1\211\1\0\1\241\4\0"+
    "\1\212\24\241\2\0\13\241\2\0\1\241\1\0\1\123"+
    "\3\0\1\123\1\0\4\123\1\0\2\123\1\242\3\123"+
    "\1\0\1\123\1\0\46\123\5\243\1\244\13\243\1\0"+
    "\50\243\12\245\1\244\6\245\1\0\50\245\1\123\3\0"+
    "\1\123\1\0\4\123\1\0\2\123\1\242\3\123\1\0"+
    "\1\123\1\240\46\123\4\0\1\207\3\0\1\210\4\0"+
    "\1\211\1\0\1\246\4\0\1\212\24\246\2\0\13\246"+
    "\2\0\1\246\5\0\1\247\3\0\1\210\4\0\1\211"+
    "\6\0\1\212\112\0\1\250\15\0\1\250\47\0\1\251"+
    "\66\0\1\252\21\0\1\252\11\0\52\253\1\254\17\253"+
    "\13\0\2\136\1\0\2\136\5\0\24\136\2\0\13\136"+
    "\1\0\2\136\47\0\1\255\73\0\1\256\14\0\1\256"+
    "\4\0\1\141\3\0\1\141\1\0\4\141\1\0\2\141"+
    "\1\257\3\141\1\0\1\141\1\0\46\141\1\142\3\260"+
    "\1\142\1\261\4\142\1\260\2\142\1\262\3\142\1\0"+
    "\1\142\1\260\46\142\1\263\1\264\2\265\1\266\1\264"+
    "\3\266\1\263\1\267\2\266\1\270\3\266\1\0\1\266"+
    "\1\264\25\266\2\263\13\266\4\263\1\145\3\253\1\145"+
    "\1\253\4\145\1\253\2\145\1\271\3\145\1\253\1\145"+
    "\1\253\26\145\1\272\17\145\1\146\3\0\1\146\1\0"+
    "\4\146\1\0\2\146\1\273\3\146\1\0\1\146\1\0"+
    "\46\146\1\147\3\274\1\147\1\275\4\147\1\274\2\147"+
    "\1\276\3\147\1\274\1\147\1\274\46\147\1\150\3\277"+
    "\1\150\1\277\4\150\1\275\2\150\1\300\3\150\1\277"+
    "\1\150\1\277\46\150\1\152\3\253\1\152\1\253\4\152"+
    "\1\253\2\152\1\301\3\152\1\253\1\152\1\253\26\152"+
    "\1\302\17\152\1\153\3\0\1\153\1\0\4\153\1\0"+
    "\2\153\1\303\3\153\1\0\1\153\1\0\46\153\1\154"+
    "\3\304\1\154\1\305\4\154\1\304\2\154\1\306\3\154"+
    "\1\0\1\154\1\304\46\154\1\307\1\310\2\311\1\312"+
    "\1\310\3\312\1\307\1\313\2\312\1\314\3\312\1\0"+
    "\1\312\1\310\25\312\2\307\13\312\4\307\23\157\1\0"+
    "\52\157\1\315\3\157\1\316\12\157\1\0\1\317\45\157"+
    "\1\162\3\0\1\162\1\0\4\162\1\0\2\162\1\320"+
    "\3\162\1\0\1\162\1\0\46\162\1\163\3\321\1\163"+
    "\1\322\4\163\1\321\2\163\1\323\3\163\1\0\1\163"+
    "\1\321\46\163\1\324\1\325\2\326\1\327\1\325\3\327"+
    "\1\324\1\330\2\327\1\331\3\327\1\0\1\327\1\325"+
    "\25\327\2\324\13\327\4\324\23\166\1\0\52\166\1\332"+
    "\3\166\1\333\12\166\1\0\1\334\45\166\23\0\1\335"+
    "\46\0\12\176\1\0\6\176\1\0\50\176\4\0\1\213"+
    "\3\0\1\210\4\0\1\336\6\0\1\212\45\0\5\201"+
    "\1\0\13\201\1\0\50\201\1\0\3\203\13\0\1\43"+
    "\5\0\24\43\2\0\13\43\2\0\1\43\1\0\1\337"+
    "\3\340\4\337\2\0\1\337\2\204\1\337\2\204\1\341"+
    "\1\0\3\337\24\204\2\337\13\204\1\337\2\204\1\337"+
    "\16\0\1\342\45\0\1\343\5\0\1\337\3\340\4\337"+
    "\2\0\1\337\2\206\1\337\2\206\1\344\1\0\3\337"+
    "\24\206\2\337\13\206\1\337\2\206\1\337\13\0\1\345"+
    "\35\0\1\346\42\0\1\347\71\0\1\347\17\0\1\350"+
    "\100\0\1\346\43\0\1\351\71\0\1\352\61\0\2\61"+
    "\1\0\2\61\5\0\15\61\1\353\6\61\2\0\13\61"+
    "\1\0\2\61\14\0\2\61\1\0\2\61\5\0\11\61"+
    "\1\354\12\61\2\0\5\61\1\354\5\61\1\0\2\61"+
    "\14\0\2\61\1\0\2\61\5\0\11\61\1\354\12\61"+
    "\2\0\5\61\1\355\5\61\1\0\2\61\1\0\5\232"+
    "\1\233\13\232\1\0\50\232\12\235\1\233\6\235\1\0"+
    "\50\235\13\0\2\241\1\0\2\241\5\0\24\241\2\0"+
    "\13\241\1\0\2\241\14\0\2\246\1\0\2\246\5\0"+
    "\24\246\2\0\13\246\1\0\2\246\46\0\1\356\15\0"+
    "\1\356\35\0\1\357\24\0\1\357\46\0\1\360\24\0"+
    "\1\360\41\0\1\361\107\0\1\362\15\0\1\362\7\0"+
    "\5\260\1\261\13\260\1\0\50\260\1\263\3\264\1\263"+
    "\1\264\4\263\1\261\2\263\1\363\3\263\1\0\1\263"+
    "\1\264\46\263\12\264\1\261\6\264\1\0\62\264\1\364"+
    "\6\264\1\0\50\264\1\263\3\264\1\263\1\264\4\263"+
    "\1\364\2\263\1\363\3\263\1\0\1\263\1\264\46\263"+
    "\12\0\1\365\57\0\5\274\1\275\64\274\12\277\1\275"+
    "\57\277\5\304\1\305\13\304\1\0\50\304\1\307\3\310"+
    "\1\307\1\310\4\307\1\305\2\307\1\366\3\307\1\0"+
    "\1\307\1\310\46\307\12\310\1\305\6\310\1\0\62\310"+
    "\1\367\6\310\1\0\50\310\1\307\3\310\1\307\1\310"+
    "\4\307\1\367\2\307\1\366\3\307\1\0\1\307\1\310"+
    "\46\307\12\0\1\370\57\0\23\157\1\0\25\157\1\371"+
    "\42\157\1\372\1\0\70\157\1\372\1\0\16\157\1\373"+
    "\27\157\5\321\1\322\13\321\1\0\50\321\1\324\3\325"+
    "\1\324\1\325\4\324\1\322\2\324\1\374\3\324\1\0"+
    "\1\324\1\325\46\324\12\325\1\322\6\325\1\0\62\325"+
    "\1\375\6\325\1\0\50\325\1\324\3\325\1\324\1\325"+
    "\4\324\1\375\2\324\1\374\3\324\1\0\1\324\1\325"+
    "\46\324\12\0\1\376\57\0\23\166\1\0\25\166\1\377"+
    "\42\166\1\u0100\1\0\70\166\1\u0100\1\0\16\166\1\u0101"+
    "\27\166\10\337\2\0\6\337\2\0\51\337\3\340\4\337"+
    "\2\0\6\337\1\u0102\1\0\50\337\16\0\1\342\1\0"+
    "\1\u0103\67\0\1\u0104\6\0\6\u0104\20\0\4\u0104\26\0"+
    "\1\u0105\105\0\1\u0106\76\0\1\u0107\22\0\1\u0107\25\0"+
    "\2\61\1\0\2\61\5\0\14\61\1\u0108\7\61\2\0"+
    "\13\61\1\0\2\61\14\0\1\u0109\1\61\1\0\2\61"+
    "\5\0\24\61\2\0\13\61\1\0\2\61\37\0\1\u010a"+
    "\21\0\1\u010a\56\0\1\u010b\15\0\1\u010b\45\0\1\u010c"+
    "\21\0\1\u010c\46\0\1\u010d\21\0\1\u010d\56\0\1\u010e"+
    "\15\0\1\u010e\10\0\3\u010f\1\0\3\u010f\1\0\1\267"+
    "\6\u010f\1\0\1\u010f\1\0\25\u010f\2\0\13\u010f\6\0"+
    "\3\u0110\1\0\3\u0110\1\0\1\313\6\u0110\1\0\1\u0110"+
    "\1\0\25\u0110\2\0\13\u0110\4\0\23\157\1\0\3\157"+
    "\1\u0111\65\157\1\0\10\157\1\u0112\22\157\1\u0112\12\157"+
    "\2\0\3\u0113\1\0\3\u0113\1\0\1\330\6\u0113\1\0"+
    "\1\u0113\1\0\25\u0113\2\0\13\u0113\4\0\23\166\1\0"+
    "\3\166\1\u0114\65\166\1\0\10\166\1\u0115\22\166\1\u0115"+
    "\12\166\20\0\1\u0102\67\0\1\u0104\1\0\1\u0103\4\0"+
    "\6\u0104\20\0\4\u0104\43\0\1\u0116\103\0\1\u0117\23\0"+
    "\1\u0117\16\0\2\61\1\0\2\61\5\0\16\61\1\u0118"+
    "\5\61\2\0\13\61\1\0\2\61\14\0\2\61\1\0"+
    "\2\61\5\0\24\61\2\0\7\61\1\u0119\3\61\1\0"+
    "\2\61\36\0\1\u011a\104\0\1\u011b\14\0\1\u011b\35\0"+
    "\1\u011c\24\0\1\u011c\50\0\1\u011d\65\0\1\u011e\24\0"+
    "\1\u011e\13\0\23\157\1\0\4\157\1\u011f\64\157\1\0"+
    "\16\157\1\u0120\23\157\1\u0120\3\157\23\166\1\0\4\166"+
    "\1\u0121\64\166\1\0\16\166\1\u0122\23\166\1\u0122\3\166"+
    "\25\0\1\u0123\45\0\3\u0124\101\0\2\61\1\0\2\61"+
    "\5\0\20\61\1\u0125\3\61\2\0\10\61\1\u0125\2\61"+
    "\1\0\2\61\14\0\2\61\1\0\2\61\5\0\24\61"+
    "\2\0\10\61\1\u0126\2\61\1\0\2\61\45\0\1\u0127"+
    "\15\0\1\u0127\51\0\1\u0128\67\0\1\u0129\60\0\1\u012a"+
    "\24\0\1\u012a\54\0\1\u012b\21\0\1\u012b\10\0\23\157"+
    "\1\0\1\157\1\u012c\45\157\3\u012d\17\157\1\0\46\157"+
    "\23\166\1\0\1\166\1\u012e\45\166\3\u012f\17\166\1\0"+
    "\46\166\45\0\1\u0130\37\0\2\61\1\0\2\61\5\0"+
    "\24\61\2\0\12\61\1\u0131\1\0\2\61\46\0\1\u0132"+
    "\15\0\1\u0132\37\0\1\u0133\24\0\1\u0133\60\0\1\u0134"+
    "\15\0\1\u0134\6\0\23\157\1\0\21\157\1\u0135\24\157"+
    "\23\166\1\0\21\166\1\u0136\24\166\25\0\1\u0137\57\0"+
    "\2\61\1\0\2\61\5\0\24\61\2\0\5\61\1\u0138"+
    "\5\61\1\0\2\61\1\0\23\157\1\0\1\157\1\u0139"+
    "\44\157\23\166\1\0\1\166\1\u013a\44\166\51\0\1\u013b"+
    "\33\0\2\61\1\0\2\61\5\0\24\61\2\0\3\61"+
    "\1\u013c\7\61\1\0\2\61\1\0\23\157\1\0\25\157"+
    "\1\u013d\20\157\23\166\1\0\25\166\1\u013e\20\166\13\0"+
    "\2\61\1\0\2\61\5\0\24\61\2\0\7\61\1\u013f"+
    "\3\61\1\0\2\61\14\0\2\61\1\0\2\61\5\0"+
    "\24\61\2\0\4\61\1\u0140\6\61\1\0\2\61\14\0"+
    "\2\61\1\0\2\61\5\0\24\61\2\0\3\61\1\u0141"+
    "\7\61\1\0\2\61\14\0\2\61\1\0\2\61\5\0"+
    "\24\61\2\0\3\61\1\u0142\7\61\1\0\2\61\14\0"+
    "\2\61\1\0\2\61\5\0\24\61\2\0\10\61\1\u0143"+
    "\2\61\1\0\2\61\1\0";

  private static int [] zzUnpackTrans() {
    int [] result = new int[12760];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\1\1\4\0\1\1\2\0\3\1\3\0\17\1\5\0"+
    "\4\1\1\11\1\1\2\11\2\1\1\11\11\1\1\11"+
    "\4\1\1\11\10\1\2\11\7\1\1\11\3\1\1\11"+
    "\6\1\1\11\27\1\1\11\6\1\2\11\1\1\1\11"+
    "\3\1\1\11\2\1\1\11\1\0\1\1\1\0\3\1"+
    "\1\11\1\1\3\0\1\11\3\1\2\11\2\0\1\11"+
    "\4\0\1\11\4\0\1\11\1\1\2\0\1\11\1\0"+
    "\1\1\5\0\1\11\4\0\1\11\1\0\1\1\2\0"+
    "\2\1\2\0\1\1\2\0\1\11\4\0\1\1\2\0"+
    "\1\11\1\0\1\1\2\0\2\1\1\0\3\1\2\0"+
    "\1\11\1\0\1\1\2\0\2\1\1\0\3\1\2\11"+
    "\2\1\1\11\2\0\1\11\2\0\1\11\1\0\2\11"+
    "\3\1\6\0\1\1\2\0\1\1\1\0\3\1\1\0"+
    "\1\1\1\0\4\1\1\11\1\0\1\11\2\0\2\1"+
    "\7\0\2\1\1\0\2\1\2\0\2\1\5\0\4\1"+
    "\1\0\3\1\3\0\2\11\4\1\1\0\1\1\3\11"+
    "\2\1\1\0\3\1\1\11\10\1";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[323];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * the number of characters from the last newline up to the start of the
   * matched text
   */
  //private int yycolumn;

  /**
   * zzAtBOL == true <=> the scanner is currently at the beginning of a line
   */
  //private boolean zzAtBOL = true;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  @SuppressWarnings("unused")
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  private boolean zzEOFDone;

  /* user code: */
	private int fTokenCount = 0;

	// required holders for white-space compacting
	private boolean fShouldLoadBuffered = false;
	private String fBufferedContext = null;
	private String fBufferedText = null;
	private int fBufferedStart = 1;
	private int fBufferedLength = 0;

	// help for php container text region
	private ContextRegionContainer fBufferedEmbeddedContainer = null;
	private String f_context = null;

	// state stack for handling embedded regions
	private IntStack fStateStack = new IntStack();

	// a "hint" as to what an embedded region should be evaluated
	private String fEmbeddedHint = UNDEFINED;
	// a "hint" as to what state to enter once an embedded region has
	// been completed
	private int fEmbeddedPostState = YYINITIAL;
	// the container used to create embedded regions
	private ContextRegionContainer fEmbeddedContainer = null;
	private static final String PROXY_CONTEXT = "PROXY_CONTEXT";

	private String context = null;
	private String text = null;
	private int start = 0;
	private int textLength = 0;
	private int length = 0;

	// offset for tracking position specific block tags
	private int fOffset = 0;

	// the name of the current tag being opened
	private String fCurrentTagName = null;

	// the list of tag name BlockMarkers
	private List<BlockMarker> fBlockMarkers = new ArrayList<>();

	// required to not seek text blocks on an end tag
	private boolean fIsBlockingEnabled = false;
	private boolean fIsCaseSensitiveBlocking = true;

	// the name of the current tag inside of an embedded region
	private String internalTagName = null;
	private String internalContext = null;

	private final XMLParserRegionFactory fRegionFactory = new XMLParserRegionFactory();
	private PHPVersion phpVersion = ProjectOptions.getDefaultPHPVersion();
	private boolean isSupportingASPTags = ProjectOptions.getDefaultIsSupportingASPTags();
	private boolean useShortTags = ProjectOptions.getDefaultUseShortTags();
/**
 * user method
 */
protected final boolean containsTagName(char[] markerTagName, int offset, int tagnameLength) {
	for (int j = 0; j < fBlockMarkers.size(); j++) {
		BlockMarker marker = fBlockMarkers.get(j);
		if (marker.getTagName().length() == tagnameLength) {
			boolean matchesSoFar = true;
			for (int i = 0; i < tagnameLength && matchesSoFar; i++) {
				if (marker.isCaseSensitive()) {
					if (marker.getTagName().charAt(i) != markerTagName[i + offset])
						matchesSoFar = false;
				} else {
					if (Character.toLowerCase(marker.getTagName().charAt(i)) != Character.toLowerCase(markerTagName[i + offset]))
						matchesSoFar = false;
				}
			}
			if (matchesSoFar)
				return true;
		}
	}
	return false;
}
/**
 * user method
 *
 * Return ALL of the regions scannable within the remaining text
 * Note: for verification use
 */
public final List<ITextRegion> getRegions() {
	List<ITextRegion> tokens = new ArrayList<>();
	ITextRegion region = null;
	try {
		region = getNextToken();
		while (region != null) {
			if (region != null) {
				tokens.add(region);
			}
			region = getNextToken();
		}
	}
	catch (StackOverflowError e) {
		Logger.logException(getClass().getName()+": input could not be tokenized correctly at position " + getOffset(), e);//$NON-NLS-1$
		throw e;
	}
	catch (Exception e) {
		// Since this is convenience method and NOT the recommended
		// way of getting tokens, many errors are simply hidden
		Logger.logException("Exception not handled retrieving regions: " + e.getLocalizedMessage(), e);//$NON-NLS-1$
	}
	return tokens;
}
/**
 * user method
 */
protected final boolean containsTagName(String markerTagName) {
	Iterator<BlockMarker> blocks = fBlockMarkers.iterator();
	while (blocks.hasNext()) {
		BlockMarker marker = blocks.next();
		if (marker.isCaseSensitive()) {
			if (marker.getTagName().equals(markerTagName))
				return true;
		} else {
			if (marker.getTagName().equalsIgnoreCase(markerTagName))
				return true;
		}
	}
	return false;
}
/**
 * user method
 */
@Override
public final void addBlockMarker(BlockMarker marker) {
	if (containsTagName(marker.getTagName()))
		return;
	fBlockMarkers.add(marker);
}
/**
 * user method
 */
@Override
public final void removeBlockMarker(BlockMarker marker) {
	fBlockMarkers.remove(marker);
}
/**
 * user method
 */
@Override
public final void removeBlockMarker(String tagname) {
	if (fBlockMarkers != null) {
		Iterator<BlockMarker> blocks = fBlockMarkers.iterator();
		while (blocks.hasNext()) {
			if (blocks.next().getTagName().equals(tagname))
				blocks.remove();
		}
	}
}
/* user method */
public boolean getBlockMarkerCaseSensitivity() {
	return getBlockMarkerCaseSensitivity(fCurrentTagName);
}
/* user method */
public boolean getBlockMarkerCaseSensitivity(String name) {
	Iterator<BlockMarker> iterator = fBlockMarkers.iterator();
	while (iterator.hasNext()) {
		BlockMarker marker = iterator.next();
		boolean casesensitive = marker.isCaseSensitive();
		if (casesensitive && marker.getTagName().equals(name))
			return casesensitive;
		else if (!casesensitive && marker.getTagName().equalsIgnoreCase(name))
			return casesensitive;
	}
	return true;
}
/* user method */
public String getBlockMarkerContext() {
	return getBlockMarkerContext(fCurrentTagName);
}
/* user method */
public String getBlockMarkerContext(String name) {
	Iterator<BlockMarker> iterator = fBlockMarkers.iterator();
	while (iterator.hasNext()) {
		BlockMarker marker = iterator.next();
		if (marker.getTagName().equals(name))
			return marker.getContext();
	}
	return BLOCK_TEXT;
}
/* user method */
@Override
public List<BlockMarker> getBlockMarkers() {
	return fBlockMarkers;
}
/* user method */
@Override
public final int getOffset() {
	return fOffset + ((int) yychar);
}
private final boolean isBlockMarker() {
	return isBlockMarker(fCurrentTagName);
}
private final boolean isBlockMarker(String tagName) {
	if (!fIsBlockingEnabled)
		return false;
	return containsTagName(tagName);
}
/**
 * user method
 */
@Override
public final void beginBlockTagScan(String newTagName) {
	beginBlockMarkerScan(newTagName, BLOCK_TEXT);
}
/**
 * user method
 *
 * Special tokenizer setup.  Allows tokenization to be initiated at the
 * start of a text block within a "newTagName" tag.
 *
 * Example:
 *	Tokenizer toker = new Tokenizer();
 *	toker.setCaseSensitiveBlocking(false);
 *	toker.reset(new java.io.StringReader("afiuhqwkejhtasihgalkwhtq</scripter></scr></script>asgdasga"));
 *	toker.beginBlockMarkerScan("script", BLOCK_TEXT);
 *	toker.getRegions();
 *
 * Returns:
 *	BLOCK_TEXT: 0-40
 *	XML_END_TAG_OPEN: 41-42
 *	XML_TAG_NAME: 43-48
 *	XML_TAG_CLOSE: 49-49
 *	XML_CONTENT: 50-57
 *
 */
@Override
public final void beginBlockMarkerScan(String newTagName, String blockcontext) {
	yybegin(ST_BLOCK_TAG_SCAN);
	fCurrentTagName = newTagName;
}
/**
 * Method doScan.
 *
 * Returns a context region for all of the text from the current position upto the end of input or
 * to right *before* the first occurrence of searchString
 *
 * @param searchString - target string to search for ex.: "-->", "</tagname"
 * @param requireTailSeparator - whether the target must be immediately followed by whitespace or '>'
 * @param context - the context of the scanned region if non-zero length
 * @param exitState - the state to go to if the region was of non-zero length
 * @param abortState - the state to go to if the searchString was found immediately
 * @return String - the context found: the desired context on a non-zero length match, the abortContext on immediate success
 * @throws IOException
 */
private final String doScan(String searchString, boolean allowPHP, boolean requireTailSeparator, String searchContext, int exitState, int immediateFallbackState) throws IOException {
	boolean stillSearching = true;
	// Disable further block (probably)
	fIsBlockingEnabled = false;
	int searchStringLength = searchString.length();
	int n = 0;
	boolean same = false;
	while (stillSearching) {
		n = 0;
		// Ensure that enough data from the input exists to compare against the search String.
		n = yy_advance();
		while (n != YYEOF && zzCurrentPos < searchStringLength)
			n = yy_advance();
		// If the input was too short or we've exhausted the input, stop immediately.
		if (n == YYEOF) {
			stillSearching = false;
		} else {

			/**
			 * Look for starting PHPs "<?"
			 */
			// Look for a PHP beginning at the current position; this case wouldn't be handled by the preceding section
			// since it relies upon *having* closeTagStringLength amount of input to work as designed. Must be sure we don't
			// spill over the end of the buffer while checking.
			if (allowPHP && zzStartRead != fLastInternalBlockStart && zzCurrentPos > 0 && zzCurrentPos < zzEndRead - 1 &&
					zzBuffer[zzCurrentPos - 1] == '<' &&
					(zzBuffer[zzCurrentPos] == '?' || (zzBuffer[zzCurrentPos] == '%' && isSupportingASPTags))) {
				fLastInternalBlockStart = zzMarkedPos = zzCurrentPos - 1;
				zzCurrentPos = zzMarkedPos + 1;
				int resumeState = yystate();
				yybegin(ST_BLOCK_TAG_INTERNAL_SCAN);
				if (zzMarkedPos == zzStartRead) {
					String jspContext = primGetNextToken();
					yybegin(resumeState);
					return jspContext;
				}
				return searchContext;
			}

			// 2) zzCurrentPos - jspstarter.length : There's not searchStringLength of input available; check for a JSP 2 spots back in what we could read
			// ---
			// Look for a JSP beginning at the current position; this case wouldn't be handled by the preceding section
			// since it relies upon *having* closeTagStringLength amount of input to work as designed.  Must be sure we don't
			// spill over the end of the buffer while checking.
			else if (allowPHP && zzStartRead != fLastInternalBlockStart && zzCurrentPos > 0 && zzCurrentPos < zzEndRead - 1 &&
					zzBuffer[zzCurrentPos - 1] == '<' && zzBuffer[zzCurrentPos] == '?') {
				fLastInternalBlockStart = zzMarkedPos = zzCurrentPos - 1;
				zzCurrentPos = zzMarkedPos + 1;
				int resumeState = yystate();
				yybegin(ST_BLOCK_TAG_INTERNAL_SCAN);
				if (zzMarkedPos == zzStartRead) {
					String jspContext = primGetNextToken();
					yybegin(resumeState);
					return jspContext;
				}
				return searchContext;
			}
			// 3) zzCurrentPos..(zzCurrentPos + jspStartlength - 1) : Check at the start of the block one time
			// ---
			// Look for a JSP beginning immediately in the block area; this case wouldn't be handled by the preceding section
			// since it relies upon zzCurrentPos equaling exactly the previous end +1 to work as designed.
			else if (allowPHP && zzStartRead != fLastInternalBlockStart && zzStartRead > 0 &&
					zzStartRead < zzEndRead - 1 && zzBuffer[zzStartRead] == '<' && zzBuffer[zzStartRead + 1] == '?') {
				fLastInternalBlockStart = zzMarkedPos = zzStartRead;
				zzCurrentPos = zzMarkedPos + 1;
				int resumeState = yystate();
				yybegin(ST_BLOCK_TAG_INTERNAL_SCAN);
				if (zzMarkedPos == zzStartRead) {
					String jspContext = primGetNextToken();
					yybegin(resumeState);
					return jspContext;
				}
				return searchContext;
			}

			// Check the characters in the target versus the last targetLength characters read from the buffer
			// and see if it matches
			if (n == YYEOF) {
				stillSearching = false;
			} else {
				same = true;
				// Ensure that we've not encountered a complete block (<%%>) that was *shorter* than the closeTagString and
				// thus found twice at current-targetLength [since the first scan would have come out this far anyway].
				// Check the characters in the target versus the last targetLength characters read from the buffer
				// and see if it matches

				// safety check for array accesses (zzCurrentPos is the *last* character we can check against)
				if (zzCurrentPos >= searchStringLength && zzCurrentPos <= zzEndRead) {
					for (int i = 0; i < searchStringLength; i++) {
						if (same && fIsCaseSensitiveBlocking)
							same = zzBuffer[i + zzCurrentPos - searchStringLength] == searchString.charAt(i);
						else if (same && !fIsCaseSensitiveBlocking)
							same = Character.toLowerCase(zzBuffer[i + zzCurrentPos - searchStringLength]) == Character.toLowerCase(searchString.charAt(i));
					}
				}
				// safety check failed; no match is possible right now
				else {
					same = false;
				}
			}
			if (same && requireTailSeparator && zzCurrentPos < zzEndRead) {
				// Additional check for close tags to ensure that targetString="</script" doesn't match
				// "</scriptS"
				char lastCheckChar = zzBuffer[zzCurrentPos];
				// Succeed on "</script>" and "</script "
				if (lastCheckChar == '>' || Character.isWhitespace(lastCheckChar))
					stillSearching = false;
			} else {
				stillSearching = !same || (zzCurrentPos < zzStartRead + searchStringLength);
			}
		}
	}
	if (n != YYEOF || same) {
		// We've stopped short of the end or definitely found a match
		zzMarkedPos = zzCurrentPos - searchStringLength;
		zzCurrentPos = zzMarkedPos + 1;
		// If the searchString occurs at the very beginning of what would have
		// been a Block, resume scanning normally immediately
		if (zzMarkedPos == zzStartRead) {
			yybegin(immediateFallbackState);
			return primGetNextToken();
		}
	} else {
		// We ran through the rest of the input
		zzMarkedPos = zzCurrentPos;
		zzCurrentPos++;
	}
	yybegin(exitState);
	// If the ending occurs at the very beginning of what would have
	// been a Block, resume scanning normally immediately
	if (zzMarkedPos == zzStartRead)
		return primGetNextToken();
	return searchContext;
}

/**
 * Method doScanEndPhp
 *
 * @see doScan(searchString, req...)
 * this version can handle two strings as options to search string
 * it originally written to support ?> or %> close tags to php
 * The two strings must be on the same length
 *
 * @param context - the context of the scanned region if non-zero length
 * @param exitState - the state to go to if the region was of non-zero length
 * @param abortState - the state to go to if the searchString was found immediately
 * @return String - the context found: the desired context on a non-zero length match, the abortContext on immediate success
 * @throws IOException
 */
private PHPScriptRegion bufferedTextRegion = null;
private final String doScanEndPHP(String searchContext, int exitState, int immediateFallbackState) throws IOException {
	yypushback(1); // begin with the last char

	final AbstractPHPLexer phpLexer = getPHPLexer();
	PHPScriptRegion region = new PHPScriptRegion(searchContext, ((int) yychar), phpVersion, isSupportingASPTags, useShortTags, phpLexer);

	// restore the locations / states
	reset(zzReader, phpLexer.getZZBuffer(), phpLexer.getParameters());

	bufferedTextRegion = region;

	yybegin(exitState);
	return searchContext;
}

/**
 * @param project
 * @param stream
 * @return a new lexer for the given project with the given stream initialized with current parameters
 */
@NonNull
private AbstractPHPLexer getPHPLexer() {
	final AbstractPHPLexer lexer = PHPLexerFactory.createLexer(zzReader, phpVersion);
	int[] currentParameters = getParameters();
	// this value is specific to each PHP version lexer
	currentParameters[6] = lexer.getInScriptingState();
	lexer.reset(zzReader, zzBuffer, currentParameters);

	lexer.setAspTags(isSupportingASPTags);
	return lexer;
}

// call the doScan without searching for PHP internal code
private final String doScan(String searchString, boolean requireTailSeparator, String searchContext, int exitState, int immediateFallbackState) throws IOException {
	return doScan(searchString, true, requireTailSeparator, searchContext, exitState, immediateFallbackState);
}

	/* user method */
	private final void assembleEmbeddedTagSequence(String startType, String endTagName) {
		assembleEmbeddedContainer(startType, null, endTagName);
	}
	/* user method */
	private final void assembleEmbeddedContainer(String startType, String[] endTypes) {
		assembleEmbeddedContainer(startType, endTypes, null);
	}
	/* user method */
	private final void assembleEmbeddedContainer(String startType, String endType) {
		assembleEmbeddedContainer(startType, new String[]{endType}, null);
	}
	/**
	 *  user method
	 *
	 * Assembles an embedded container beginning with the given startType as
	 * the first ContextRegion within it and of the type fEmbeddedHint.  The
	 * endTypes[] array contains the context types that will cause a successful
	 * exit.  Use of the endTagName parameter alters this behavior to force an
	 * exit on an XML_TAG_CLOSE after seeing an XML_TAG_NAME whose significant
	 * text matches the endTagName String.  All contents in between are
	 * insignificant, and yes, this means comments are allowed inside.
	 **/
	private final void assembleEmbeddedContainer(String startType, String[] endTypes, String endTagName) {
		// the context of the region being added to the embedded container
		internalContext = startType;
		// keep track of where this container began; to provide relative indeces for the regions
		int containerStart = ((int) yychar);
		boolean notFinished = true;
		// keep track of where we seem to be so that the endTagName can be checked
		boolean isInEndTag = false;
		boolean isInFirstTag = true;
		// create the embedded container and setup its "type"
		if (fEmbeddedContainer == null) {
			fEmbeddedContainer = new ContextRegionContainer();
			fEmbeddedContainer.setType(fEmbeddedHint);
			fEmbeddedContainer.setStart(containerStart);
			// TODO: parent region needs to be set .... but not sure where to get it from
			// fEmbeddedContainer.setParent(parentRegion);
		}
		containerStart = fEmbeddedContainer.getStart();
		while (notFinished) {
			// add the region to the container
			if (internalContext != null && internalContext != PROXY_CONTEXT) {

				ITextRegion newToken;
				// if it is php content we extract the tokens
				if (internalContext == PHP_CONTENT) {
					newToken = bufferedTextRegion;
					bufferedTextRegion.adjustStart(-containerStart);
				} else {
					newToken = fRegionFactory.createToken(internalContext, ((int) yychar) - containerStart, yylength(), yylength());
				}
				fEmbeddedContainer.getRegions().add(newToken);
				fEmbeddedContainer.setLength(fEmbeddedContainer.getLength() + newToken.getLength());
				fEmbeddedContainer.setTextLength(fEmbeddedContainer.getTextLength() + newToken.getLength());
				// DW, 4/16/2003 token regions no longer have parents
				//newToken.setParent(fEmbeddedContainer);
			}
			try {
				// longscan determines whether to attempt a blockTagScan within the embedded container
				boolean longscan = false;
				// save the tokenizer state in case of a block tag scan
				int previousState = yystate();
				String previousCurrentTagName = fCurrentTagName;
				int previousPostState = fEmbeddedPostState;
				String previousEmbeddedHint = fEmbeddedHint;
				// determine if a block tag scan is necessary
				if (internalContext == XML_TAG_NAME) {
					internalTagName = yytext();
					if (!isNestable(internalTagName)) {
						internalTagName = null;
						// snagged a tag name we shouldn't have
						fEmbeddedPostState = ST_ABORT_EMBEDDED;
						notFinished = false;
					}
				} else if (internalContext == XML_TAG_OPEN || internalContext == XML_END_TAG_OPEN) {
					internalTagName = null;
				}
				// do upkeep for endTagName usage; must be here since the next token could be the close
				if (internalContext == XML_END_TAG_OPEN) {
					isInEndTag = true;
				} else if (internalContext == XML_TAG_CLOSE) {
					isInFirstTag = isInEndTag = false;
				} else {
					ITextRegionList embeddedRegions = fEmbeddedContainer.getRegions();
					if (embeddedRegions.size() > 2 && (embeddedRegions.get(embeddedRegions.size() - 1)).getType() == XML_TAG_CLOSE && (embeddedRegions.get(embeddedRegions.size() - 3)).getType() == XML_TAG_OPEN && internalTagName != null) {
						if (containsTagName(internalTagName)) {
							longscan = true;
							yybegin(ST_BLOCK_TAG_SCAN);
						}
					}
				}
				if (longscan)
					fCurrentTagName = internalTagName;
				// read the next region and context
				internalContext = primGetNextToken();
				if (longscan) {
					// Returning from a block tag scan requires restoring some state variables
					// as well as handling the block region and setting up for normal scanning
					// inside the embedded container

					ITextRegion newToken;
					// if it is php content we extract the tokens
					if (internalContext == PHP_CONTENT) {
						newToken = bufferedTextRegion;
						bufferedTextRegion.adjustStart(-containerStart);
					} else {
						newToken = fRegionFactory.createToken(internalContext, ((int) yychar) - containerStart, yylength(), yylength());
					}

					fEmbeddedContainer.getRegions().add(newToken);
					fEmbeddedContainer.setLength(fEmbeddedContainer.getLength() + newToken.getLength());
					fEmbeddedContainer.setTextLength(fEmbeddedContainer.getTextLength() + newToken.getLength());
					// DW, 4/16/2003 token regions no longer have parents
					// newToken.setParent(fEmbeddedContainer);
					longscan = false;
					fEmbeddedPostState = previousPostState;
					fEmbeddedHint = previousEmbeddedHint;
					fCurrentTagName = previousCurrentTagName;
					yybegin(previousState);
					internalContext = primGetNextToken();
				}
			} catch (IOException e) {
				// primGetNextToken() calls may throw an IOException
				Logger.logException(e);
				internalContext = null;
				notFinished = false;
				break;
			} catch (Exception f) {
				// some other exception happened; never should
				Logger.logException(f);
				// ... but IllegalArgumentException(CoreMessages.getString("UnknownPHPVersion_*"))
				// can be thrown from doScanEndPHP(), so avoid infinite loops
				internalContext = null;
				notFinished = false;
				break;
			}
			boolean isEndingType = yystate() == ST_ABORT_EMBEDDED;
			if (!isEndingType) {
				// check for ending context
				if (endTagName == null) {
					for (int i = 0; i < endTypes.length; i++) {
						isEndingType = isEndingType || (internalContext == endTypes[i]);
					}
				} else {
					isEndingType = ((isInEndTag && internalContext == XML_TAG_CLOSE) || (isInFirstTag && internalContext == XML_EMPTY_TAG_CLOSE)) && internalTagName != null && internalTagName.equals(endTagName);
				}
			}
			ITextRegionList embeddedList = fEmbeddedContainer.getRegions();
			notFinished = notFinished && ((!isEndingType) && !isEOF() && (endTagName != null || internalContext != UNDEFINED) && !(internalContext == PROXY_CONTEXT && (embeddedList.get(embeddedList.size() - 1)).getType() == UNDEFINED));
		}
		// finish adding the last context
		if (internalContext != null && internalContext != PROXY_CONTEXT) {
			ITextRegion newToken = fRegionFactory.createToken(internalContext, ((int) yychar) - containerStart, yylength(), yylength());
			fEmbeddedContainer.getRegions().add(newToken);
			// DW, 4/16/2003 token regions no longer have parents
			//newToken.setParent(fEmbeddedContainer);
			fEmbeddedContainer.setLength(((int) yychar) - containerStart + yylength());
			fEmbeddedContainer.setTextLength(((int) yychar) - containerStart + yylength());
		}
		yybegin(fEmbeddedPostState);
	}

	/**
	 * user method
	 */
	private boolean isNestable(String tagName) {
		return false; //true is for jsp
	}

/**
 * user method
 *
 * A generic lookahead-like operation
 */
private final String doBlockScan(String target, String targetContext, int immediateFallbackState) throws IOException {
	return doScan(target, false, targetContext, immediateFallbackState, immediateFallbackState);
}
/**
 * user method
 * does a lookahead for the current tag name
 */
private final String doBlockTagScan() throws IOException {
	fIsCaseSensitiveBlocking = getBlockMarkerCaseSensitivity();
	return doScan("</" + fCurrentTagName, true, getBlockMarkerContext(fCurrentTagName), YYINITIAL, YYINITIAL);
}

/**
 * this method is only intended to be called at creation of a new
 * PHPTokenizer (and before first scan) to avoid problems with
 * bufferedTextRegion and other cached informations depending on project
 * properties and settings
 */
public void setProjectSettings(@NonNull PHPVersion phpVersion, boolean isSupportingASPTags, boolean useShortTags) {
	this.phpVersion = phpVersion;
	this.isSupportingASPTags = isSupportingASPTags;
	this.useShortTags = useShortTags;
	this.bufferedTextRegion = null;
}

// NB: this method resets the lexer only partially
private void reset(java.io.Reader reader, char[] buffer, int[] parameters) {
	this.bufferedTextRegion = null;
	this.zzReader = reader;
	this.zzBuffer = buffer;
	this.zzFinalHighSurrogate = 0;
	this.zzMarkedPos = parameters[0];
	this._zzPushbackPos = parameters[1];
	this.zzCurrentPos = parameters[2];
	this.zzStartRead = parameters[3];
	this.zzEndRead = parameters[4];
	this.yyline = parameters[5];
	this.yychar = this.zzStartRead - this._zzPushbackPos;
}

public int[] getParameters() {
	return new int[]{zzMarkedPos, _zzPushbackPos, zzCurrentPos, zzStartRead, zzEndRead, yyline, zzLexicalState};
}

/**
 * user method
 *
 * Converts the raw context String returned by the primGetNextToken()
 * method into a full ITextRegion by pulling in values for the
 * current offset within the scanning text.
 *
 * Returns null when EOF is encountered and attaches intermittently
 * discovered whitespace onto the end of useful regions.
 *
 * Note that this algorithm caches the token following the one being returned
 * so that whitespace can be collapsed.
 */
@Override
public final ITextRegion getNextToken() throws IOException {
	fEmbeddedContainer = null;
	// load the starting non-whitespace token (assume that it is so)
	if (fShouldLoadBuffered) {
		if (fBufferedEmbeddedContainer != null) {
			ITextRegion container = fBufferedEmbeddedContainer;
			fBufferedEmbeddedContainer = null;
			fShouldLoadBuffered = false;
			return container;
		}
		context = fBufferedContext;
		text = fBufferedText;
		start = fBufferedStart;
		textLength = length = fBufferedLength;
		fShouldLoadBuffered = false;
	} else {
		context = primGetNextToken();
		if (context == PROXY_CONTEXT) {
			return fEmbeddedContainer;
		} else if (context == XML_TAG_OPEN) {
			fIsBlockingEnabled = true;
		} else if (context == XML_END_TAG_OPEN) {
			fIsBlockingEnabled = false;
		}
		text = yytext();
		if (context == XML_TAG_NAME) {
			if (containsTagName(zzBuffer, zzStartRead, zzMarkedPos - zzStartRead))
				fCurrentTagName = text;
			else
				fCurrentTagName = null;
		} else if (context == XML_TAG_OPEN) {
			fIsBlockingEnabled = true;
		} else if (context == XML_END_TAG_OPEN) {
			fIsBlockingEnabled = false;
		}
		start = ((int) yychar);
		textLength = length = yylength();
		if (zzAtEOF) {
			fTokenCount++;
			return null;
		}
	}

	// store the next token
	f_context = primGetNextToken();
	if (f_context == PROXY_CONTEXT) {
		fBufferedEmbeddedContainer = fEmbeddedContainer;
		fShouldLoadBuffered = true;
	} else if (f_context == XML_TAG_NAME) {
		if (containsTagName(zzBuffer, zzStartRead, zzMarkedPos - zzStartRead))
			fCurrentTagName = yytext();
		else
			fCurrentTagName = null;
	} else if (f_context == XML_TAG_OPEN) {
		fIsBlockingEnabled = true;
	} else if (f_context == XML_END_TAG_OPEN) {
		fIsBlockingEnabled = false;
	}
	fBufferedContext = f_context;
	fBufferedText = yytext();
	if (fBufferedContext == XML_TAG_NAME) {
		if (containsTagName(zzBuffer, zzStartRead, zzMarkedPos - zzStartRead))
			fCurrentTagName = fBufferedText;
		else
			fCurrentTagName = null;
	} else if (fBufferedContext == XML_TAG_OPEN) {
		fIsBlockingEnabled = true;
	} else if (fBufferedContext == XML_END_TAG_OPEN) {
		fIsBlockingEnabled = false;
	}
	fBufferedStart = ((int) yychar);
	fBufferedLength = yylength();
	if (fBufferedContext == WHITE_SPACE) {
		fShouldLoadBuffered = false;
		length += fBufferedLength;
	}else {
		fShouldLoadBuffered = true;
	}
	if (context == null) {
		// EOF
		if (Debug.debugTokenizer) {
			System.out.println(getClass().getName() + " discovered " + fTokenCount + " tokens."); //$NON-NLS-1$ //$NON-NLS-2$
		}
		return null;
	}
	fTokenCount++;

	// if it is php content we extract the tokens
	if (context == PHP_CONTENT) {
		return bufferedTextRegion;
	} else {
		return fRegionFactory.createToken(context, start, textLength, length, null, fCurrentTagName);
	}
}

/* user method */
public PHPTokenizer() {
	super();
}
/* user method */
public PHPTokenizer(char[] charArray) {
	this(new CharArrayReader(charArray));
}
/* user method */
@Override
public void reset(char[] charArray) {
	reset(new CharArrayReader(charArray), 0);
}
/* user method */
@Override
public void reset(char[] charArray, int newOffset) {
	reset(new CharArrayReader(charArray), newOffset);
}
/* user method */
@Override
public void reset(java.io.InputStream in) {
	reset(new java.io.InputStreamReader(in), 0);
}
/* user method */
@Override
public void reset(java.io.InputStream in, int newOffset) {
	reset(new java.io.InputStreamReader(in), newOffset);
}
/* user method */
@Override
public void reset(java.io.Reader in) {
	reset(in, 0);
}
/**
 * user method *
 *
 * Reset internal counters and vars to "newly created" values, in the hopes
 * that resetting a pre-existing tokenizer is faster than creating a new one.
 *
 * This method contains code blocks that were essentially duplicated from the
 * <em>generated</em> output of this specification before this method was
 * added.  Those code blocks were under the above copyright.
 */
@Override
public void reset(java.io.Reader in, int newOffset) {
	if (Debug.debugTokenizer) {
		System.out.println("resetting tokenizer");//$NON-NLS-1$
	}
	this.bufferedTextRegion = null;
	fOffset = newOffset;

	/* the input device */
	zzReader = in;

	/* the current state of the DFA */
	zzState = 0;

	/* the current lexical state */
	zzLexicalState = YYINITIAL;

	/* this buffer contains the current text to be matched and is
	the source of the yytext() string */
	java.util.Arrays.fill(zzBuffer, (char) 0);

	/* the textposition at the last accepting state */
	zzMarkedPos = 0;

	/* the textposition at the last state to be included in yytext */
	_zzPushbackPos = 0;

	/* the current text position in the buffer */
	zzCurrentPos = 0;

	/* startRead marks the beginning of the yytext() string in the buffer */
	zzStartRead = 0;

	/**
	 * endRead marks the last character in the buffer, that has been read
	 * from input
	 */
	zzEndRead = 0;

	/* The number of occupied positions in zzBuffer beyond zzEndRead */
	zzFinalHighSurrogate = 0;

	/* number of newlines encountered up to the start of the matched text */
	yyline = 0;

	/* the number of characters up to the start of the matched text */
	yychar = 0;

	/* zzAtBOL == true <=> the scanner is currently at the beginning of a line */
	//zzAtBOL = true;

	/* zzAtEOF == true <=> the scanner has returned a value for EOF */
	zzAtEOF = false;


	/* user vars: */
	fLastInternalBlockStart = -1;

	fTokenCount = 0;

	fShouldLoadBuffered = false;
	fBufferedContext = null;
	fBufferedText = null;
	fBufferedStart = 1;
	fBufferedLength = 0;
	fStateStack = new IntStack();

	context = null;
	text = null;
	start = 0;
	textLength = 0;
	length = 0;
}

	/**
	 * user method
	 *
	 */
	@Override
	public BlockTokenizer newInstance() {
		PHPTokenizer newInstance = new PHPTokenizer();
		// global tagmarkers can be shared; they have no state and
		// are never destroyed (e.g. 'release')
		for (int i = 0; i < fBlockMarkers.size(); i++) {
			BlockMarker blockMarker = fBlockMarkers.get(i);
			if (blockMarker.isGlobal())
				newInstance.addBlockMarker(blockMarker);
		}
		return newInstance;
	}
/* user method */
private final String scanXMLCommentText() throws IOException {
	// Scan for '-->' and return the text up to that point as
	//   XML_COMMENT_TEXT unless the string occurs IMMEDIATELY, in which
	//  case change to the ST_XML_COMMENT_END state and return the next
	//  context as usual.
	return doScan("-->", true, false, XML_COMMENT_TEXT, ST_XML_COMMENT_END, ST_XML_COMMENT_END);
}


  /** the textposition at the last state to be included in yytext */
  private int _zzPushbackPos;

  // where the last internal container block was found
  private int fLastInternalBlockStart = -1;

  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public PHPTokenizer(java.io.Reader in) {
    this.zzReader = in;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      _zzPushbackPos-= zzStartRead;
      fLastInternalBlockStart = -1;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate) {
      /* if not: blow it up */
      char newBuffer[] = new char[zzBuffer.length * 2];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      throw new java.io.IOException(
          "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Gets the next input character.
   *
   * @return      the next character of the input stream, EOF if the
   *              end of the stream is reached.
   * @exception   IOException  if any I/O-Error occurs
   */
  private int yy_advance() throws java.io.IOException {

    /* standard case */
    if (zzCurrentPos < zzEndRead) return zzBuffer[zzCurrentPos++];

    /* if the eof is reached, we don't need to work hard */
    if (zzAtEOF) return YYEOF;

    /* otherwise: need to refill the buffer */

    /* first: make room (if you can) */
    if (zzRefill()) {
      return YYEOF;
    }

    return zzBuffer[zzCurrentPos++];
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    if (zzBuffer.length > ZZ_BUFFERSIZE) {
      zzBuffer = new char[ZZ_BUFFERSIZE];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      //zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      _zzPushbackPos = 0;
      fLastInternalBlockStart = -1;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      //yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    Logger.log(Logger.ERROR, message);
    try {
    throw new Error(message);
    } catch(Error e) {
      // BC
    }
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }


  /**
   * user method - common.sse
   */
  private final void dump(String s) {
    if (Debug.debugTokenizer) {
      System.out.println(s + " (" + yychar + "-" + //$NON-NLS-1$ //$NON-NLS-2$
        (yylength() + yychar) + "):\'" + //$NON-NLS-1$
        StringUtils.escape(yytext()) + "\'"); //$NON-NLS-1$
    }
  }


  /**
   * user method - common.sse
   */
  public final boolean isEOF() {
    return zzAtEOF;
  }


  /**
   * Contains user EOF-code, which will be executed exactly once,
   * when the end of file is reached
   */
  private void zzDoEOF() {
    if (!zzEOFDone) {
      zzEOFDone = true;
    
// do nothing, this is the downstream parser's job
    }
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public String primGetNextToken() throws java.io.IOException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          zzR = false;
          break;
        case '\r':
          yyline++;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
          }
          break;
        default:
          zzR = false;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
            zzDoEOF();
        return null;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { if (Debug.debugTokenizer)
		dump("\nXML content");//$NON-NLS-1$
	return XML_CONTENT;
            }
            // fall through
          case 69: break;
          case 2:
            { if (Debug.debugTokenizer)
		dump("white space");//$NON-NLS-1$
	return WHITE_SPACE;
            }
            // fall through
          case 70: break;
          case 3:
            { if (Debug.debugTokenizer)
		dump("DHTML processing instruction attribute value");//$NON-NLS-1$
	fEmbeddedHint = XML_TAG_ATTRIBUTE_NAME;
	fEmbeddedPostState = ST_XML_EQUALS;
	yybegin(ST_DHTML_ATTRIBUTE_NAME);
	return XML_TAG_ATTRIBUTE_VALUE;
            }
            // fall through
          case 71: break;
          case 4:
            { // inappropriate tag name
	if (!fStateStack.empty() && (fStateStack.peek() == ST_XML_ATTRIBUTE_VALUE_SQUOTED || fStateStack.peek() == ST_XML_ATTRIBUTE_VALUE_DQUOTED)) {
		yybegin(ST_ABORT_EMBEDDED);
		yypushback(yylength() - 1);
		return XML_TAG_ATTRIBUTE_VALUE;
	}
	yybegin(YYINITIAL);
	return XML_CONTENT;
            }
            // fall through
          case 72: break;
          case 5:
            { if (Debug.debugTokenizer)
		dump("elementdecl contentspec");//$NON-NLS-1$
	return XML_ELEMENT_DECL_CONTENT;
            }
            // fall through
          case 73: break;
          case 6:
            { if (Debug.debugTokenizer)
		dump("attlist contentspec");//$NON-NLS-1$
	return XML_ATTLIST_DECL_CONTENT;
            }
            // fall through
          case 74: break;
          case 7:
            { if (Debug.debugTokenizer)
		System.out.println("!!!unexpected!!!: \"" + yytext() + "\":" + //$NON-NLS-1$ //$NON-NLS-2$
			yychar + "-" + (yychar + yylength()));//$NON-NLS-1$
	return UNDEFINED;
            }
            // fall through
          case 75: break;
          case 8:
            { if (Debug.debugTokenizer)
		dump("\nstart tag open");//$NON-NLS-1$
	fEmbeddedHint = XML_TAG_NAME;
	fEmbeddedPostState = ST_XML_ATTRIBUTE_NAME;
	yybegin(ST_XML_TAG_NAME);
	return XML_TAG_OPEN;
            }
            // fall through
          case 76: break;
          case 9:
            { if (Debug.debugTokenizer)
		dump("CDATA text");//$NON-NLS-1$
	fEmbeddedPostState = ST_CDATA_TEXT;
	fEmbeddedHint = XML_CDATA_TEXT;
	String blockContext = doBlockScan("]]>", XML_CDATA_TEXT, ST_CDATA_END);//$NON-NLS-1$
	if (blockContext == XML_CDATA_TEXT)
		yybegin(ST_CDATA_END);
	return blockContext;
            }
            // fall through
          case 77: break;
          case 10:
            { if (Debug.debugTokenizer)
		dump("LINE FEED");//$NON-NLS-1$
	return WHITE_SPACE;
            }
            // fall through
          case 78: break;
          case 11:
            { if (Debug.debugTokenizer)
		dump("comment content");//$NON-NLS-1$
	return scanXMLCommentText();
            }
            // fall through
          case 79: break;
          case 12:
            { if (Debug.debugTokenizer)
		dump("processing instruction target");//$NON-NLS-1$
	fEmbeddedHint = XML_CONTENT;
	yybegin(ST_PI_WS);
	return XML_TAG_NAME;
            }
            // fall through
          case 80: break;
          case 13:
            { yybegin(ST_PI_CONTENT);
	return WHITE_SPACE;
            }
            // fall through
          case 81: break;
          case 14:
            { // block scan until close is found
	return doScan("?>", false, false, XML_PI_CONTENT, ST_XML_PI_TAG_CLOSE, ST_XML_PI_TAG_CLOSE);
            }
            // fall through
          case 82: break;
          case 15:
            { if (Debug.debugTokenizer)
		dump("XML processing instruction attribute name");//$NON-NLS-1$
	yybegin(ST_XML_PI_EQUALS);
	return XML_TAG_ATTRIBUTE_NAME;
            }
            // fall through
          case 83: break;
          case 16:
            { if (Debug.debugTokenizer)
		dump("XML processing instruction '='");//$NON-NLS-1$
	fEmbeddedHint = XML_TAG_ATTRIBUTE_VALUE;
	fEmbeddedPostState = ST_XML_ATTRIBUTE_NAME;
	yybegin(ST_XML_PI_ATTRIBUTE_VALUE);
	return XML_TAG_ATTRIBUTE_EQUALS;
            }
            // fall through
          case 84: break;
          case 17:
            { if (Debug.debugTokenizer)
		dump("XML processing instruction attribute value");//$NON-NLS-1$
	fEmbeddedHint = XML_TAG_ATTRIBUTE_NAME;
	fEmbeddedPostState = ST_XML_EQUALS;
	yybegin(ST_XML_PI_ATTRIBUTE_NAME);
	return XML_TAG_ATTRIBUTE_VALUE;
            }
            // fall through
          case 85: break;
          case 18:
            { if (Debug.debugTokenizer)
		dump("DHTML processing instruction attribute name");//$NON-NLS-1$
	yybegin(ST_DHTML_EQUALS);
	return XML_TAG_ATTRIBUTE_NAME;
            }
            // fall through
          case 86: break;
          case 19:
            { if (Debug.debugTokenizer)
		dump("DHTML processing instruction end");//$NON-NLS-1$
	fEmbeddedHint = UNDEFINED;
	yybegin(YYINITIAL);
	return XML_PI_CLOSE;
            }
            // fall through
          case 87: break;
          case 20:
            { if (Debug.debugTokenizer)
		dump("DHTML processing instruction '='");//$NON-NLS-1$
	fEmbeddedHint = XML_TAG_ATTRIBUTE_VALUE;
	fEmbeddedPostState = ST_XML_ATTRIBUTE_NAME;
	yybegin(ST_DHTML_ATTRIBUTE_VALUE);
	return XML_TAG_ATTRIBUTE_EQUALS;
            }
            // fall through
          case 88: break;
          case 21:
            { if (Debug.debugTokenizer)
		dump("tag name");//$NON-NLS-1$
	fEmbeddedHint = XML_TAG_ATTRIBUTE_NAME;
	fEmbeddedPostState = ST_XML_EQUALS;
	yybegin(ST_XML_ATTRIBUTE_NAME);
	return XML_TAG_NAME;
            }
            // fall through
          case 89: break;
          case 22:
            { // tag close
	fEmbeddedHint = UNDEFINED;
	if (isBlockMarker()) {
		fEmbeddedHint = getBlockMarkerContext();
		fEmbeddedPostState = ST_BLOCK_TAG_SCAN;
		yybegin(ST_BLOCK_TAG_SCAN);
	}
	else
		yybegin(YYINITIAL);
	return XML_TAG_CLOSE;
            }
            // fall through
          case 90: break;
          case 23:
            { // attr name
	fEmbeddedHint = XML_TAG_ATTRIBUTE_NAME;
	fEmbeddedPostState = ST_XML_ATTRIBUTE_NAME;
	yybegin(ST_XML_EQUALS);
	return XML_TAG_ATTRIBUTE_NAME;
            }
            // fall through
          case 91: break;
          case 24:
            { // equals
	fEmbeddedHint = XML_TAG_ATTRIBUTE_VALUE;
	fEmbeddedPostState = ST_XML_ATTRIBUTE_NAME;
	yybegin(ST_XML_ATTRIBUTE_VALUE);
	return XML_TAG_ATTRIBUTE_EQUALS;
            }
            // fall through
          case 92: break;
          case 25:
            { // attr value
	fEmbeddedHint = XML_TAG_ATTRIBUTE_NAME;
	fEmbeddedPostState = ST_XML_EQUALS;
	yybegin(ST_XML_ATTRIBUTE_NAME);
	return XML_TAG_ATTRIBUTE_VALUE;
            }
            // fall through
          case 93: break;
          case 26:
            { fEmbeddedHint = XML_TAG_ATTRIBUTE_VALUE;
	fEmbeddedPostState = ST_XML_ATTRIBUTE_VALUE_DQUOTED;
	yybegin(ST_XML_ATTRIBUTE_VALUE_DQUOTED);
	fStateStack.push(yystate());
	assembleEmbeddedContainer(XML_TAG_ATTRIBUTE_VALUE_DQUOTE, XML_TAG_ATTRIBUTE_VALUE_DQUOTE);
	fStateStack.pop();
	fEmbeddedHint = XML_TAG_ATTRIBUTE_NAME;
	fEmbeddedPostState = ST_XML_EQUALS;
	yybegin(ST_XML_ATTRIBUTE_NAME);
	return PROXY_CONTEXT;
            }
            // fall through
          case 94: break;
          case 27:
            { // begin embedded region: " + fEmbeddedHint
	fEmbeddedHint = XML_TAG_ATTRIBUTE_VALUE;
	fEmbeddedPostState = ST_XML_ATTRIBUTE_VALUE_SQUOTED;
	yybegin(ST_XML_ATTRIBUTE_VALUE_SQUOTED);
	fStateStack.push(yystate());
	// JSP attribute value start - complex single quoted
	assembleEmbeddedContainer(XML_TAG_ATTRIBUTE_VALUE_SQUOTE, XML_TAG_ATTRIBUTE_VALUE_SQUOTE);
	fStateStack.pop();
	fEmbeddedHint = XML_TAG_ATTRIBUTE_NAME;
	fEmbeddedPostState = ST_XML_EQUALS;
	yybegin(ST_XML_ATTRIBUTE_NAME);
	return PROXY_CONTEXT;
            }
            // fall through
          case 95: break;
          case 28:
            { if (Debug.debugTokenizer)
		dump("declaration end");//$NON-NLS-1$
	if (Debug.debugTokenizer) {
		if (fStateStack.peek() != YYINITIAL)
			System.out.println("end embedded region");//$NON-NLS-1$
	}
	yybegin(fStateStack.pop());
	return XML_DECLARATION_CLOSE;
            }
            // fall through
          case 96: break;
          case 29:
            { if (Debug.debugTokenizer)
		dump("doctype type");//$NON-NLS-1$
	yybegin(ST_XML_DOCTYPE_EXTERNAL_ID);
	return XML_DOCTYPE_NAME;
            }
            // fall through
          case 97: break;
          case 30:
            { if (Debug.debugTokenizer)
		dump("doctype public reference");//$NON-NLS-1$
	yybegin(ST_XML_DOCTYPE_ID_SYSTEM);
	return XML_DOCTYPE_EXTERNAL_ID_PUBREF;
            }
            // fall through
          case 98: break;
          case 31:
            { if (Debug.debugTokenizer)
		dump("doctype system reference");//$NON-NLS-1$
	yybegin(ST_XML_DECLARATION_CLOSE);
	return XML_DOCTYPE_EXTERNAL_ID_SYSREF;
            }
            // fall through
          case 99: break;
          case 32:
            { if (Debug.debugTokenizer)
		dump("elementdecl name");//$NON-NLS-1$
	yybegin(ST_XML_ELEMENT_DECLARATION_CONTENT);
	return XML_ELEMENT_DECL_NAME;
            }
            // fall through
          case 100: break;
          case 33:
            { if (Debug.debugTokenizer)
		dump("elementdecl close");//$NON-NLS-1$
	if (Debug.debugTokenizer) {
		if (fStateStack.peek() != YYINITIAL)
			System.out.println("end embedded region");//$NON-NLS-1$
	}
	yybegin(fStateStack.pop());
	return XML_DECLARATION_CLOSE;
            }
            // fall through
          case 101: break;
          case 34:
            { if (Debug.debugTokenizer)
		dump("attlist name");//$NON-NLS-1$
	yybegin(ST_XML_ATTLIST_DECLARATION_CONTENT);
	return XML_ATTLIST_DECL_NAME;
            }
            // fall through
          case 102: break;
          case 35:
            { if (Debug.debugTokenizer)
		dump("attlist close");//$NON-NLS-1$
	if (Debug.debugTokenizer) {
		if (fStateStack.peek() != YYINITIAL)
			System.out.println("end embedded region");//$NON-NLS-1$
	}
	yybegin(fStateStack.pop());
	return XML_DECLARATION_CLOSE;
            }
            // fall through
          case 103: break;
          case 36:
            { return doBlockTagScan();
            }
            // fall through
          case 104: break;
          case 37:
            { return doScanEndPHP(PHP_CONTENT, ST_PHP_CONTENT, ST_PHP_CONTENT);
            }
            // fall through
          case 105: break;
          case 38:
            { return XML_TAG_ATTRIBUTE_VALUE;
            }
            // fall through
          case 106: break;
          case 39:
            { return XML_TAG_ATTRIBUTE_VALUE_SQUOTE;
            }
            // fall through
          case 107: break;
          case 40:
            { // begin embedded region: " + fEmbeddedHint
	int incomingState = yystate();
	fEmbeddedHint = XML_TAG_ATTRIBUTE_VALUE;
	fEmbeddedPostState = ST_XML_ATTRIBUTE_NAME;
	// tag inside of JSP attribute value start
	yybegin(ST_XML_TAG_NAME);
	assembleEmbeddedContainer(XML_TAG_OPEN, new String[]{XML_TAG_CLOSE, XML_EMPTY_TAG_CLOSE});
	if (yystate() != ST_ABORT_EMBEDDED) {
		// set incoming state when container
		// was correctly assembled
		yybegin(incomingState);
	}
	return PROXY_CONTEXT;
            }
            // fall through
          case 108: break;
          case 41:
            { return XML_TAG_ATTRIBUTE_VALUE_DQUOTE;
            }
            // fall through
          case 109: break;
          case 42:
            { fStateStack.push(yystate());
	if (Debug.debugTokenizer)
		dump("\ndeclaration start");//$NON-NLS-1$
	yybegin(ST_XML_DECLARATION);
	return XML_DECLARATION_OPEN;
            }
            // fall through
          case 110: break;
          case 43:
            { if (Debug.debugTokenizer)
		dump("\nprocessing instruction start");//$NON-NLS-1$
	if ("<?".equals(yytext()) //$NON-NLS-1$
			&& !useShortTags) {
		yybegin(ST_PI);
		return XML_PI_OPEN;
	} else if ("<?=".equals(yytext()) //$NON-NLS-1$
			&& !PHPVersion.PHP5_3.isLessThan(phpVersion)
			&& !useShortTags) {
		yybegin(ST_PI);
		return XML_PI_OPEN;
	} else if (("<%".equals(yytext()) //$NON-NLS-1$
			|| "<%=".equals(yytext())) //$NON-NLS-1$
			&& !isSupportingASPTags) {
		yypushback(yylength() - 1);
		yybegin(ST_XML_TAG_NAME);
		return XML_TAG_OPEN;
	} else {
		// removeing trailing whitespaces for the php open
		String phpStart = yytext();
		int i = phpStart.length() - 1;
		while (i >= 0
				&& Character.isWhitespace(phpStart.charAt(i--))) {
			yypushback(1);
		}
		fStateStack.push(yystate());// YYINITIAL
		if (fStateStack.peek() == YYINITIAL) {
			// the simple case, just a regular scriptlet out in
			// content
			yybegin(ST_PHP_CONTENT);
			return PHP_OPEN;
		} else {
			if (yystate() == ST_XML_ATTRIBUTE_VALUE_DQUOTED)
				fEmbeddedPostState = ST_XML_ATTRIBUTE_VALUE_DQUOTED;
			else if (yystate() == ST_XML_ATTRIBUTE_VALUE_SQUOTED)
				fEmbeddedPostState = ST_XML_ATTRIBUTE_VALUE_SQUOTED;
			else if (yystate() == ST_CDATA_TEXT) {
				fEmbeddedPostState = ST_CDATA_TEXT;
				fEmbeddedHint = XML_CDATA_TEXT;
			}
			yybegin(ST_PHP_CONTENT);
			assembleEmbeddedContainer(PHP_OPEN, PHP_CLOSE);
			if (yystate() == ST_ABORT_EMBEDDED) {
				// leave with unchanged state
				return PROXY_CONTEXT;
			}
			// required help for successive embedded regions
			if (yystate() == ST_XML_TAG_NAME) {
				fEmbeddedHint = XML_TAG_NAME;
				fEmbeddedPostState = ST_XML_ATTRIBUTE_NAME;
			} else if ((yystate() == ST_XML_ATTRIBUTE_NAME || yystate() == ST_XML_EQUALS)) {
				fEmbeddedHint = XML_TAG_ATTRIBUTE_NAME;
				fEmbeddedPostState = ST_XML_EQUALS;
			} else if (yystate() == ST_XML_ATTRIBUTE_VALUE) {
				fEmbeddedHint = XML_TAG_ATTRIBUTE_VALUE;
				fEmbeddedPostState = ST_XML_ATTRIBUTE_NAME;
			}
			return PROXY_CONTEXT;
		}
	}
            }
            // fall through
          case 111: break;
          case 44:
            { // end tag open
	fEmbeddedHint = XML_TAG_NAME;
	fEmbeddedPostState = ST_XML_ATTRIBUTE_NAME;
	yybegin(ST_XML_TAG_NAME);
	return XML_END_TAG_OPEN;
            }
            // fall through
          case 112: break;
          case 45:
            { if (Debug.debugTokenizer)
		dump("processing instruction end");//$NON-NLS-1$
	fEmbeddedHint = UNDEFINED;
	yybegin(YYINITIAL);
	return XML_PI_CLOSE;
            }
            // fall through
          case 113: break;
          case 46:
            { // ended with nothing inside
	fEmbeddedHint = UNDEFINED;
	yybegin(YYINITIAL);
	return XML_PI_CLOSE;
            }
            // fall through
          case 114: break;
          case 47:
            { if (Debug.debugTokenizer)
		dump("XML processing instruction end");//$NON-NLS-1$
	fEmbeddedHint = UNDEFINED;
	yybegin(YYINITIAL);
	return XML_PI_CLOSE;
            }
            // fall through
          case 115: break;
          case 48:
            { yybegin(YYINITIAL);
	fEmbeddedHint = UNDEFINED;
	// empty tag close
	return XML_EMPTY_TAG_CLOSE;
            }
            // fall through
          case 116: break;
          case 49:
            { String tagName = yytext().substring(1);
	// pushback to just after the opening bracket
	yypushback(yylength() - 1);
	/*
	 * If this tag can not be nested or we're already searching for an
	 * attribute name, equals, or value, return immediately.
	 */
	if (!isNestable(tagName) || (!fStateStack.empty() && (fStateStack.peek() == ST_XML_ATTRIBUTE_NAME || fStateStack.peek() == ST_XML_EQUALS || fStateStack.peek() == ST_XML_ATTRIBUTE_VALUE))) {
		yybegin(ST_XML_TAG_NAME);
		return XML_TAG_OPEN;
	}
	if (Debug.debugTokenizer)
		dump("tag in place of attr name");//$NON-NLS-1$
	fEmbeddedHint = XML_TAG_ATTRIBUTE_NAME;
	fEmbeddedPostState = ST_XML_ATTRIBUTE_NAME;
	fStateStack.push(yystate());
	// embedded container should be looking for the name (again) next
	yybegin(ST_XML_TAG_NAME);
	assembleEmbeddedTagSequence(XML_TAG_OPEN, tagName); // ?
	fStateStack.pop();
	yybegin(ST_XML_EQUALS);
	return PROXY_CONTEXT;
            }
            // fall through
          case 117: break;
          case 50:
            { String tagName = yytext().substring(1);
	// pushback to just after the opening bracket
	yypushback(yylength() - 1);
	/*
	 * If this tag can not be nested or we're already searching for an
	 * attribute name, equals, or value, return immediately.
	 */
	if (!isNestable(tagName) || (!fStateStack.empty() && (fStateStack.peek() == ST_XML_ATTRIBUTE_NAME || fStateStack.peek() == ST_XML_EQUALS || fStateStack.peek() == ST_XML_ATTRIBUTE_VALUE))) {
		yybegin(ST_XML_TAG_NAME);
		return XML_TAG_OPEN;
	}
	if (Debug.debugTokenizer)
		dump("tag in place of attr value");//$NON-NLS-1$
	fEmbeddedHint = XML_TAG_ATTRIBUTE_VALUE;
	fEmbeddedPostState = ST_XML_ATTRIBUTE_NAME;
	fStateStack.push(yystate());
	// embedded container should be looking for the name (again) next
	yybegin(ST_XML_TAG_NAME);
	assembleEmbeddedTagSequence(XML_TAG_OPEN, tagName); // ?
	fStateStack.pop();
	yybegin(ST_XML_ATTRIBUTE_NAME);
	return PROXY_CONTEXT;
            }
            // fall through
          case 118: break;
          case 51:
            { return XML_DOCTYPE_INTERNAL_SUBSET;
            }
            // fall through
          case 119: break;
          case 52:
            { yybegin(fStateStack.pop());
	return PHP_CLOSE;
            }
            // fall through
          case 120: break;
          case 53:
            { // begin embedded region: " + fEmbeddedHint);//$NON-NLS-1$
	int incomingState = yystate();
	fEmbeddedHint = XML_TAG_ATTRIBUTE_VALUE;
	fEmbeddedPostState = ST_XML_ATTRIBUTE_NAME;
	// Php attribute value start - end tag
	yybegin(ST_XML_TAG_NAME);
	assembleEmbeddedContainer(XML_END_TAG_OPEN, new String[]{XML_TAG_CLOSE, XML_EMPTY_TAG_CLOSE});
	if (yystate() != ST_ABORT_EMBEDDED) {
		// set incoming state when container
		// was correctly assembled
		yybegin(incomingState);
	}
	return PROXY_CONTEXT;
            }
            // fall through
          case 121: break;
          case 54:
            { if (Debug.debugTokenizer)
		dump("\nPEReference");//$NON-NLS-1$
	return XML_PE_REFERENCE;
            }
            // fall through
          case 122: break;
          case 55:
            { if (Debug.debugTokenizer)
		dump("\nEntityRef");//$NON-NLS-1$
	return XML_ENTITY_REFERENCE;
            }
            // fall through
          case 123: break;
          case 56:
            { if (Debug.debugTokenizer)
		dump("CDATA end");//$NON-NLS-1$
	yybegin(fStateStack.pop());
	return XML_CDATA_CLOSE;
            }
            // fall through
          case 124: break;
          case 57:
            { if (Debug.debugTokenizer)
		dump("comment end");//$NON-NLS-1$
	fEmbeddedHint = UNDEFINED;
	yybegin(YYINITIAL);
	return XML_COMMENT_CLOSE;
            }
            // fall through
          case 125: break;
          case 58:
            { if (Debug.debugTokenizer)
		dump("XML processing instruction target");//$NON-NLS-1$
	fEmbeddedHint = XML_TAG_ATTRIBUTE_NAME;
	fEmbeddedPostState = ST_XML_EQUALS;
	yybegin(ST_XML_PI_ATTRIBUTE_NAME);
	return XML_TAG_NAME;
            }
            // fall through
          case 126: break;
          case 59:
            { if (Debug.debugTokenizer)
		dump("\nCharRef");//$NON-NLS-1$
	return XML_CHAR_REFERENCE;
            }
            // fall through
          case 127: break;
          case 60:
            { if (Debug.debugTokenizer)
		dump("\ncomment start");//$NON-NLS-1$
	fEmbeddedHint = XML_COMMENT_TEXT;
	fEmbeddedPostState = ST_XML_COMMENT;
	yybegin(ST_XML_COMMENT);
	return XML_COMMENT_OPEN;
            }
            // fall through
          case 128: break;
          case 61:
            { if (Debug.debugTokenizer)
		dump("DHTML processing instruction target");//$NON-NLS-1$
	fEmbeddedHint = XML_TAG_ATTRIBUTE_NAME;
	fEmbeddedPostState = ST_XML_EQUALS;
	yybegin(ST_DHTML_ATTRIBUTE_NAME);
	return XML_TAG_NAME;
            }
            // fall through
          case 129: break;
          case 62:
            { if (Debug.debugTokenizer)
		dump("doctype external id");//$NON-NLS-1$
	yybegin(ST_XML_DOCTYPE_ID_PUBLIC);
	return XML_DOCTYPE_EXTERNAL_ID_PUBLIC;
            }
            // fall through
          case 130: break;
          case 63:
            { if (Debug.debugTokenizer)
		dump("doctype external id");//$NON-NLS-1$
	yybegin(ST_XML_DOCTYPE_ID_SYSTEM);
	return XML_DOCTYPE_EXTERNAL_ID_SYSTEM;
            }
            // fall through
          case 131: break;
          case 64:
            { if (Debug.debugTokenizer)
		dump("attlist");//$NON-NLS-1$
	yybegin(ST_XML_ATTLIST_DECLARATION);
	return XML_ATTLIST_DECLARATION;
            }
            // fall through
          case 132: break;
          case 65:
            { if (Debug.debugTokenizer)
		dump("doctype");//$NON-NLS-1$
	yybegin(ST_XML_DOCTYPE_DECLARATION);
	return XML_DOCTYPE_DECLARATION;
            }
            // fall through
          case 133: break;
          case 66:
            { if (Debug.debugTokenizer)
		dump("element");//$NON-NLS-1$
	yybegin(ST_XML_ELEMENT_DECLARATION);
	return XML_ELEMENT_DECLARATION;
            }
            // fall through
          case 134: break;
          case 67:
            { if (Debug.debugTokenizer)
		dump("\nCDATA start");//$NON-NLS-1$
	fStateStack.push(yystate());
	yybegin(ST_CDATA_TEXT);
	return XML_CDATA_OPEN;
            }
            // fall through
          case 135: break;
          case 68:
            { if (Debug.debugTokenizer)
		dump("XSL processing instruction target");//$NON-NLS-1$
	fEmbeddedPostState = ST_XML_EQUALS;
	yybegin(ST_XML_PI_ATTRIBUTE_NAME);
	return XML_TAG_NAME;
            }
            // fall through
          case 136: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }


}
