// DO NOT EDIT
// Generated by JFlex 1.8.2 http://jflex.de/
// source: highlighting_scanner.jflex

/*******************************************************************************
 * Copyright (c) 2006, 2017 Zend Corporation and IBM Corporation.
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *   Zend and IBM - Initial implementation
 *******************************************************************************/

package org.eclipse.php.internal.core.documentModel.parser.php5;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.php.core.compiler.ast.nodes.PHPDocTag.TagKind;

//@SuppressWarnings({"unused", "nls"})


// See https://github.com/jflex-de/jflex/issues/222
@SuppressWarnings("FallThrough")
public class PHPLexer extends org.eclipse.php.internal.core.documentModel.parser.AbstractPHPLexer {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int ST_PHP_IN_SCRIPTING = 2;
  public static final int ST_PHP_DOUBLE_QUOTES = 4;
  public static final int ST_PHP_SINGLE_QUOTE = 6;
  public static final int ST_PHP_BACKQUOTE = 8;
  public static final int ST_PHP_QUOTES_AFTER_VARIABLE = 10;
  public static final int ST_PHP_HEREDOC = 12;
  public static final int ST_PHP_START_HEREDOC = 14;
  public static final int ST_PHP_END_HEREDOC = 16;
  public static final int ST_PHP_LOOKING_FOR_PROPERTY = 18;
  public static final int ST_PHP_VAR_OFFSET = 20;
  public static final int ST_PHP_COMMENT = 22;
  public static final int ST_PHP_DOC_COMMENT = 24;
  public static final int ST_PHP_LINE_COMMENT = 26;
  public static final int ST_PHP_HIGHLIGHTING_ERROR = 28;
  public static final int ST_PHP_DOLLAR_CURLY_OPEN = 30;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7,  7, 
     8,  8,  9,  9, 10, 10, 11, 11, 12, 12, 13, 13, 14, 14, 15, 15
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\37\u0200\1\u0300\266\u0200\10\u0400\40\u0200\u1000\u0500";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\2\0\1\3\22\0\1\1\1\4"+
    "\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14"+
    "\1\15\1\16\1\17\1\20\1\21\1\22\1\23\11\24"+
    "\1\25\1\26\1\27\1\30\1\31\1\32\1\33\1\34"+
    "\1\35\1\36\1\37\1\40\1\41\1\42\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\54"+
    "\1\55\1\56\1\57\1\60\1\61\1\62\1\63\1\64"+
    "\1\65\1\66\1\67\1\70\1\71\1\72\1\73\1\34"+
    "\1\35\1\36\1\37\1\40\1\41\1\42\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\54"+
    "\1\55\1\56\1\57\1\60\1\61\1\62\1\63\1\64"+
    "\1\65\1\74\1\75\1\76\1\17\1\0\260\77\2\100"+
    "\115\77\1\101\u01aa\77\1\102\325\77\u0100\103\u0100\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1536];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\6\0\1\1\11\0\1\2\1\3\1\4\1\5\1\6"+
    "\3\4\1\7\7\4\2\10\1\4\1\11\4\4\25\12"+
    "\1\13\1\14\1\4\1\15\1\1\1\16\5\17\1\1"+
    "\3\17\3\20\2\1\3\2\2\21\1\0\1\2\2\22"+
    "\1\23\1\24\2\25\2\10\1\12\1\26\2\27\4\30"+
    "\3\31\3\32\1\33\1\34\1\35\1\36\1\37\1\0"+
    "\1\17\3\0\2\40\1\37\1\41\14\0\1\42\1\10"+
    "\1\43\1\10\1\0\1\44\1\37\1\45\3\12\1\46"+
    "\1\0\6\12\1\47\14\12\1\50\6\12\1\37\16\12"+
    "\3\0\2\51\1\52\1\53\1\54\1\51\4\0\2\51"+
    "\1\55\3\0\1\1\2\51\1\56\3\0\1\57\1\52"+
    "\1\60\1\61\1\62\1\0\1\63\1\64\1\36\1\65"+
    "\1\40\12\0\1\66\1\10\1\0\2\12\1\0\10\12"+
    "\1\67\11\12\1\70\11\12\1\71\14\12\1\72\1\12"+
    "\1\73\1\74\6\12\1\75\1\76\1\1\1\77\2\0"+
    "\2\100\1\40\12\0\1\101\1\0\3\12\1\102\7\12"+
    "\1\103\1\104\6\12\1\105\1\106\4\12\1\107\7\12"+
    "\1\110\1\111\7\12\1\112\3\12\1\113\10\12\1\114"+
    "\1\115\6\0\1\116\3\0\2\117\1\12\1\120\1\121"+
    "\1\122\1\123\1\124\1\125\4\12\1\126\2\12\1\127"+
    "\3\12\1\130\1\131\7\12\1\132\1\12\1\133\7\12"+
    "\1\134\1\135\1\136\6\12\4\0\4\12\1\137\1\12"+
    "\1\140\5\12\1\141\4\12\1\142\2\12\1\143\1\12"+
    "\1\144\1\145\1\146\6\12\2\0\2\12\1\147\1\150"+
    "\4\12\1\151\1\152\2\12\1\153\2\12\1\154\1\12"+
    "\1\155\6\12\1\156\1\157\3\12\1\160\1\161\7\12"+
    "\1\162\2\12\1\163\3\12\1\164\3\12\1\165\1\166"+
    "\1\12\1\167\3\12\1\170\1\171\1\172\1\12\1\173"+
    "\3\12\1\174\4\12\1\175\1\176\1\177\3\12\1\200";

  private static int [] zzUnpackAction() {
    int [] result = new int[543];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\104\0\210\0\314\0\u0110\0\u0154\0\u0198\0\u01dc"+
    "\0\u0220\0\u0264\0\u02a8\0\u02ec\0\u0330\0\u0374\0\u03b8\0\u03fc"+
    "\0\0\0\u0440\0\u0484\0\u04c8\0\0\0\u050c\0\u0550\0\u0594"+
    "\0\u05d8\0\u061c\0\0\0\u0660\0\u06a4\0\u06e8\0\u072c\0\u0770"+
    "\0\u07b4\0\u07f8\0\u083c\0\0\0\u0880\0\u08c4\0\u0908\0\u094c"+
    "\0\u0990\0\u09d4\0\u0a18\0\u0a5c\0\u0aa0\0\u0ae4\0\u0b28\0\u0b6c"+
    "\0\u0bb0\0\u0bf4\0\u0c38\0\u0c7c\0\u0cc0\0\u0d04\0\u0d48\0\u0d8c"+
    "\0\u0dd0\0\u0e14\0\u0e58\0\u0e9c\0\u0ee0\0\0\0\u0f24\0\u0f68"+
    "\0\u0fac\0\u0ff0\0\0\0\u1034\0\u1078\0\u10bc\0\u1100\0\u1144"+
    "\0\u1188\0\u11cc\0\u1210\0\u1254\0\0\0\u1298\0\u12dc\0\u1320"+
    "\0\u1364\0\u13a8\0\u13ec\0\u1430\0\0\0\u1474\0\u14b8\0\u14fc"+
    "\0\0\0\u1540\0\u1584\0\0\0\0\0\u15c8\0\u160c\0\u1650"+
    "\0\u1694\0\0\0\u16d8\0\u171c\0\0\0\u1760\0\u17a4\0\u17e8"+
    "\0\u182c\0\0\0\u1870\0\u18b4\0\0\0\u094c\0\0\0\u18f8"+
    "\0\u193c\0\u1980\0\u0660\0\u04c8\0\0\0\u19c4\0\u1a08\0\u1a4c"+
    "\0\u1a90\0\u1ad4\0\0\0\0\0\u05d8\0\u1b18\0\u061c\0\u1b5c"+
    "\0\u1ba0\0\u1be4\0\u1c28\0\u1c6c\0\u1cb0\0\u1cf4\0\u1d38\0\u1d7c"+
    "\0\0\0\u1dc0\0\u1e04\0\u1e48\0\u1e8c\0\0\0\u1ed0\0\0"+
    "\0\u1f14\0\u1f58\0\u1f9c\0\u0b6c\0\u1fe0\0\u2024\0\u2068\0\u20ac"+
    "\0\u20f0\0\u2134\0\u2178\0\u0b6c\0\u21bc\0\u2200\0\u2244\0\u2288"+
    "\0\u22cc\0\u2310\0\u2354\0\u2398\0\u23dc\0\u2420\0\u2464\0\u24a8"+
    "\0\u0b6c\0\u24ec\0\u2530\0\u2574\0\u25b8\0\u25fc\0\u2640\0\u0b6c"+
    "\0\u2684\0\u26c8\0\u270c\0\u2750\0\u2794\0\u27d8\0\u281c\0\u2860"+
    "\0\u28a4\0\u28e8\0\u292c\0\u2970\0\u29b4\0\u29f8\0\u2a3c\0\u1078"+
    "\0\u2a80\0\0\0\u2a3c\0\u2ac4\0\0\0\0\0\u2a80\0\u2b08"+
    "\0\u2b4c\0\u1210\0\u2b90\0\u2b4c\0\u2b90\0\0\0\u2bd4\0\u13ec"+
    "\0\u2c18\0\u2c5c\0\u2bd4\0\u2c18\0\0\0\u1474\0\u2ca0\0\u2ce4"+
    "\0\0\0\u2d28\0\0\0\0\0\u17a4\0\u2d6c\0\0\0\u2db0"+
    "\0\u2df4\0\u2e38\0\u2e7c\0\u2ec0\0\u2f04\0\u2f48\0\u2f8c\0\u2fd0"+
    "\0\u3014\0\u3058\0\u309c\0\u30e0\0\u3124\0\u3168\0\u1e8c\0\u31ac"+
    "\0\u31f0\0\u3234\0\u3278\0\u32bc\0\u3300\0\u3344\0\u3388\0\u33cc"+
    "\0\u3410\0\u3454\0\u3498\0\u0b6c\0\u34dc\0\u3520\0\u3564\0\u35a8"+
    "\0\u35ec\0\u3630\0\u3674\0\u36b8\0\u36fc\0\u3740\0\u3784\0\u37c8"+
    "\0\u380c\0\u3850\0\u3894\0\u38d8\0\u391c\0\u3960\0\u39a4\0\u0b6c"+
    "\0\u39e8\0\u3a2c\0\u3a70\0\u3ab4\0\u3af8\0\u3b3c\0\u3b80\0\u3bc4"+
    "\0\u3c08\0\u3c4c\0\u3c90\0\u3cd4\0\u0b6c\0\u3d18\0\u0b6c\0\u0b6c"+
    "\0\u3d5c\0\u3da0\0\u3de4\0\u3e28\0\u3e6c\0\u3eb0\0\0\0\0"+
    "\0\u3ef4\0\0\0\u3f38\0\u3f7c\0\0\0\u3fc0\0\u4004\0\u4048"+
    "\0\u408c\0\u40d0\0\u4114\0\u4158\0\u419c\0\u41e0\0\u4224\0\u4268"+
    "\0\u42ac\0\0\0\u42f0\0\u4334\0\u4378\0\u43bc\0\u0b6c\0\u4400"+
    "\0\u4444\0\u4488\0\u44cc\0\u4510\0\u4554\0\u4598\0\u0b6c\0\u45dc"+
    "\0\u4620\0\u4664\0\u46a8\0\u46ec\0\u4730\0\u4774\0\u0b6c\0\u0b6c"+
    "\0\u47b8\0\u47fc\0\u4840\0\u4884\0\u0b6c\0\u48c8\0\u490c\0\u4950"+
    "\0\u4994\0\u49d8\0\u4a1c\0\u4a60\0\u0b6c\0\u0b6c\0\u4aa4\0\u4ae8"+
    "\0\u4b2c\0\u4b70\0\u4bb4\0\u4bf8\0\u4c3c\0\u0b6c\0\u4c80\0\u4cc4"+
    "\0\u4d08\0\u0b6c\0\u4d4c\0\u4d90\0\u4dd4\0\u4e18\0\u4e5c\0\u4ea0"+
    "\0\u4ee4\0\u4f28\0\0\0\u1a90\0\u4f6c\0\u4fb0\0\u4ff4\0\u5038"+
    "\0\u507c\0\u50c0\0\0\0\u5104\0\u5148\0\u518c\0\0\0\u51d0"+
    "\0\u5214\0\u0b6c\0\u0b6c\0\u0b6c\0\u0b6c\0\u0b6c\0\u0b6c\0\u5258"+
    "\0\u529c\0\u52e0\0\u5324\0\u0b6c\0\u5368\0\u53ac\0\u0b6c\0\u53f0"+
    "\0\u5434\0\u5478\0\u0b6c\0\u0b6c\0\u54bc\0\u5500\0\u5544\0\u5588"+
    "\0\u55cc\0\u5610\0\u5654\0\u0b6c\0\u5698\0\u0b6c\0\u56dc\0\u5720"+
    "\0\u5764\0\u57a8\0\u57ec\0\u5830\0\u5874\0\u0b6c\0\u0b6c\0\u0b6c"+
    "\0\u58b8\0\u58fc\0\u5940\0\u5984\0\u59c8\0\u5a0c\0\u5a50\0\u5a94"+
    "\0\u5ad8\0\u5b1c\0\u5b60\0\u5ba4\0\u5be8\0\u5c2c\0\u0b6c\0\u5c70"+
    "\0\u5cb4\0\u5cf8\0\u5d3c\0\u5d80\0\u5dc4\0\u5e08\0\u0b6c\0\u5e4c"+
    "\0\u5e90\0\u5ed4\0\u5f18\0\u0b6c\0\u5f5c\0\u5fa0\0\u0b6c\0\u5fe4"+
    "\0\u0b6c\0\u0b6c\0\u0b6c\0\u6028\0\u606c\0\u60b0\0\u60f4\0\u6138"+
    "\0\u617c\0\u61c0\0\u6204\0\u6248\0\u628c\0\u0b6c\0\u0b6c\0\u62d0"+
    "\0\u6314\0\u6358\0\u639c\0\u0b6c\0\u0b6c\0\u63e0\0\u6424\0\u6468"+
    "\0\u64ac\0\u64f0\0\u0b6c\0\u6534\0\u6578\0\u65bc\0\u6600\0\u6644"+
    "\0\u6688\0\u66cc\0\u6710\0\u0b6c\0\u0b6c\0\u6754\0\u6798\0\u67dc"+
    "\0\u0b6c\0\u0b6c\0\u6820\0\u6864\0\u68a8\0\u68ec\0\u6930\0\u6974"+
    "\0\u69b8\0\u0b6c\0\u69fc\0\u6a40\0\u0b6c\0\u6a84\0\u6ac8\0\u6b0c"+
    "\0\u0b6c\0\u6b50\0\u6b94\0\u6bd8\0\u0b6c\0\u0b6c\0\u6c1c\0\u0b6c"+
    "\0\u6c60\0\u6ca4\0\u6ce8\0\u0b6c\0\u0b6c\0\u0b6c\0\u6d2c\0\u0b6c"+
    "\0\u6d70\0\u6db4\0\u6df8\0\u0b6c\0\u6e3c\0\u6e80\0\u6ec4\0\u6f08"+
    "\0\u0b6c\0\u0b6c\0\u0b6c\0\u6f4c\0\u6f90\0\u6fd4\0\u0b6c";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[543];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\104\0\1\21\3\22\1\23\1\24\1\25\1\26\1\27"+
    "\1\30\1\31\1\32\1\33\1\34\1\35\1\33\1\36"+
    "\1\37\1\40\1\41\1\42\1\43\1\44\1\45\1\46"+
    "\1\47\1\50\1\33\1\51\1\52\1\53\1\54\1\55"+
    "\1\56\1\57\1\60\1\61\2\60\1\62\1\60\1\63"+
    "\1\64\1\65\1\60\1\66\1\67\1\70\1\71\1\72"+
    "\1\73\1\74\2\60\1\33\1\21\1\33\1\34\1\75"+
    "\1\76\1\77\1\100\1\101\1\60\1\61\1\67\2\60"+
    "\5\102\1\103\1\102\1\104\57\102\1\105\4\102\1\106"+
    "\7\102\12\107\1\103\54\107\1\110\14\107\7\111\1\112"+
    "\57\111\1\113\3\111\1\103\1\114\7\111\20\115\1\116"+
    "\53\115\1\117\7\115\2\120\2\121\3\120\1\122\57\120"+
    "\1\123\4\120\1\124\7\120\34\125\32\126\4\125\1\126"+
    "\4\125\5\126\2\21\1\127\1\130\77\21\1\0\20\131"+
    "\1\132\13\131\32\133\4\131\1\133\4\131\5\133\1\21"+
    "\3\134\2\135\1\134\1\136\2\135\1\134\10\135\1\137"+
    "\1\140\7\135\15\60\1\141\14\60\1\33\1\134\1\142"+
    "\1\135\1\60\4\135\5\60\15\143\1\144\66\143\15\145"+
    "\1\146\15\145\1\147\40\145\1\150\7\145\2\151\1\152"+
    "\1\153\4\151\1\154\20\151\1\155\1\156\51\151\1\157"+
    "\3\160\77\157\1\0\2\21\1\0\31\21\32\161\4\21"+
    "\1\161\1\21\1\162\2\21\5\161\1\0\3\22\130\0"+
    "\1\163\53\0\5\164\1\165\1\164\1\166\57\164\1\167"+
    "\4\164\1\170\7\164\34\0\23\171\1\172\6\171\4\0"+
    "\1\171\4\0\5\171\30\0\1\173\1\174\63\0\1\173"+
    "\16\0\1\173\53\0\12\175\1\165\54\175\1\176\14\175"+
    "\1\0\1\177\32\0\1\200\1\201\1\0\1\202\1\0"+
    "\1\203\2\0\1\204\5\0\1\205\2\0\1\206\1\207"+
    "\1\0\1\210\17\0\1\204\1\207\32\0\1\173\71\0"+
    "\1\173\11\0\1\173\73\0\1\173\7\0\1\173\1\211"+
    "\75\0\2\212\3\0\1\173\70\0\1\213\4\0\1\25"+
    "\5\0\1\173\74\0\1\212\1\0\2\42\13\0\1\214"+
    "\22\0\1\215\41\0\1\212\1\0\2\42\13\0\1\214"+
    "\70\0\1\216\105\0\1\217\2\173\102\0\1\163\1\173"+
    "\102\0\1\173\1\163\103\0\1\220\75\0\2\60\7\0"+
    "\1\60\1\221\13\60\1\222\3\60\1\223\1\224\7\60"+
    "\4\0\1\60\4\0\2\60\1\224\2\60\5\0\1\24"+
    "\4\0\1\31\10\0\2\60\2\0\1\225\4\0\21\60"+
    "\1\226\10\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\1\227\12\60\1\230\2\60\1\231\13\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\4\60\1\232"+
    "\3\60\1\233\5\60\1\234\13\60\4\0\1\60\4\0"+
    "\1\60\1\233\3\60\23\0\2\60\7\0\2\60\1\235"+
    "\10\60\1\236\1\237\1\240\7\60\1\241\1\60\1\242"+
    "\2\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\1\243\7\60\1\244\5\60\1\245\2\60\1\246\2\60"+
    "\1\247\5\60\4\0\1\60\4\0\1\60\1\244\3\60"+
    "\23\0\2\60\7\0\13\60\1\250\16\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\32\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\5\60\1\251\6\60"+
    "\1\252\1\253\4\60\1\254\7\60\4\0\1\60\4\0"+
    "\2\60\1\254\2\60\23\0\2\60\7\0\10\60\1\255"+
    "\21\60\4\0\1\60\4\0\1\60\1\255\3\60\23\0"+
    "\2\60\7\0\4\60\1\256\17\60\1\257\5\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\21\60\1\260"+
    "\10\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\1\261\20\60\1\262\2\60\1\263\5\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\4\60\1\264\25\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\4\60"+
    "\1\265\16\60\1\266\2\60\1\267\3\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\7\60\1\270\11\60"+
    "\1\271\10\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\15\60\1\272\4\60\1\273\7\60\4\0\1\60"+
    "\4\0\2\60\1\273\2\60\23\0\2\60\7\0\1\274"+
    "\31\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\7\60\1\275\22\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\16\60\1\64\13\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\32\60\4\0\1\276\4\0"+
    "\5\60\1\0\3\77\130\0\1\173\44\0\1\173\7\0"+
    "\3\101\100\0\5\102\1\0\1\102\1\277\57\102\1\300"+
    "\4\102\1\301\14\102\1\302\1\102\1\303\24\102\32\304"+
    "\1\102\1\300\2\102\1\304\1\102\1\305\2\102\5\304"+
    "\111\102\1\302\1\102\1\306\57\102\1\300\4\102\1\307"+
    "\7\102\12\107\1\0\54\107\1\310\26\107\1\165\54\107"+
    "\1\165\14\107\7\111\1\311\57\111\1\312\3\111\1\0"+
    "\1\313\16\111\1\314\24\111\32\304\1\111\1\312\2\111"+
    "\1\304\1\302\1\305\2\111\5\304\113\111\1\306\57\111"+
    "\1\312\3\111\1\302\1\315\7\111\31\0\1\316\61\0"+
    "\1\306\74\0\2\120\2\121\3\120\1\317\57\120\1\320"+
    "\4\120\1\321\11\120\2\121\3\120\1\317\24\120\32\322"+
    "\1\120\1\320\2\120\1\322\1\120\1\321\2\120\5\322"+
    "\2\120\2\121\3\120\1\323\24\120\32\304\1\120\1\320"+
    "\2\120\1\304\1\120\1\305\2\120\5\304\2\120\2\121"+
    "\102\120\2\121\3\120\1\306\57\120\1\320\4\120\1\324"+
    "\7\120\2\0\2\325\17\0\2\326\1\0\1\327\5\0"+
    "\32\326\4\0\1\326\4\0\5\326\34\0\32\330\4\0"+
    "\1\330\4\0\5\330\2\0\1\127\31\0\32\330\4\0"+
    "\1\330\4\0\5\330\31\0\1\331\75\0\2\133\7\0"+
    "\32\133\4\0\1\133\4\0\5\133\34\0\32\332\4\0"+
    "\1\332\4\0\5\332\23\0\2\140\36\0\1\215\43\0"+
    "\2\140\102\0\2\60\7\0\24\60\1\257\5\60\4\0"+
    "\1\60\4\0\5\60\15\143\1\0\66\143\22\0\1\333"+
    "\103\0\1\334\61\0\1\335\3\0\11\335\1\0\66\335"+
    "\33\0\1\336\50\0\2\151\2\152\4\151\1\152\20\151"+
    "\2\152\51\151\2\0\1\337\132\0\1\340\53\0\3\160"+
    "\123\0\2\161\7\0\32\161\4\0\1\161\4\0\5\161"+
    "\1\0\3\341\30\0\32\342\4\0\1\342\4\0\5\342"+
    "\5\164\1\165\1\164\1\166\24\164\32\0\1\164\1\167"+
    "\2\164\1\0\1\164\1\0\2\164\5\0\111\164\1\165"+
    "\1\164\1\0\57\164\1\167\4\164\1\170\7\164\23\0"+
    "\2\171\7\0\32\171\4\0\1\171\4\0\5\171\23\0"+
    "\2\171\7\0\7\171\1\343\22\171\4\0\1\171\4\0"+
    "\5\171\104\175\55\0\1\344\72\0\1\345\5\0\1\346"+
    "\25\0\1\345\55\0\1\347\100\0\1\350\105\0\1\351"+
    "\67\0\1\352\106\0\1\353\122\0\1\354\75\0\1\355"+
    "\55\0\2\212\13\0\1\214\60\0\1\356\104\0\1\140"+
    "\1\0\1\140\2\0\2\140\102\0\2\357\7\0\6\357"+
    "\71\0\1\360\1\173\76\0\2\60\7\0\22\60\1\361"+
    "\7\60\4\0\1\60\4\0\2\60\1\361\2\60\23\0"+
    "\2\60\7\0\3\60\1\260\26\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\21\60\1\362\10\60\4\0"+
    "\1\60\4\0\5\60\27\0\1\363\77\0\2\60\7\0"+
    "\4\60\1\364\25\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\22\60\1\365\1\366\6\60\4\0\1\60"+
    "\4\0\2\60\1\365\2\60\23\0\2\60\7\0\1\367"+
    "\15\60\1\370\13\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\15\60\1\371\14\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\2\60\1\372\2\60\1\373"+
    "\24\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\4\60\1\374\25\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\7\60\1\375\22\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\22\60\1\376\7\60\4\0"+
    "\1\60\4\0\2\60\1\376\2\60\23\0\2\60\7\0"+
    "\17\60\1\377\12\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\3\60\1\u0100\26\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\1\u0101\31\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\10\60\1\u0102\12\60"+
    "\1\u0103\6\60\4\0\1\60\4\0\1\60\1\u0102\3\60"+
    "\23\0\2\60\7\0\13\60\1\u0104\16\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\15\60\1\u0105\14\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\21\60"+
    "\1\u0106\10\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\16\60\1\u0107\13\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\15\60\1\u0108\14\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\16\60\1\u0109\13\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\17\60"+
    "\1\u010a\12\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\2\60\1\u010b\17\60\1\u010c\1\u010d\6\60\4\0"+
    "\1\60\4\0\2\60\1\u010c\2\60\23\0\2\60\7\0"+
    "\22\60\1\u010e\7\60\4\0\1\60\4\0\2\60\1\u010e"+
    "\2\60\23\0\2\60\7\0\22\60\1\u010f\7\60\4\0"+
    "\1\60\4\0\2\60\1\u010f\2\60\23\0\2\60\7\0"+
    "\26\60\1\u0110\3\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\13\60\1\u0111\16\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\21\60\1\u0112\10\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\10\60\1\u0113"+
    "\5\60\1\u0114\13\60\4\0\1\60\4\0\1\60\1\u0113"+
    "\3\60\23\0\2\60\7\0\1\60\1\u0115\30\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\20\60\1\u0116"+
    "\2\60\1\u0117\6\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\13\60\1\u0118\16\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\1\u0119\31\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\10\60\1\u011a\21\60"+
    "\4\0\1\60\4\0\1\60\1\u011a\3\60\23\0\2\60"+
    "\7\0\21\60\1\u011b\10\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\24\60\1\u011c\3\60\1\u011d\1\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\22\60"+
    "\1\u011e\7\60\4\0\1\60\4\0\2\60\1\u011e\2\60"+
    "\23\0\2\60\7\0\4\60\1\u011f\25\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\21\60\1\u0120\10\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\10\60"+
    "\1\u0121\21\60\4\0\1\60\4\0\1\60\1\u0121\3\60"+
    "\23\0\2\60\7\0\2\60\1\u0122\2\60\1\u0123\1\60"+
    "\1\u0124\3\60\1\u0125\1\u0126\15\60\4\0\1\60\4\0"+
    "\5\60\5\102\1\302\1\102\1\303\24\102\32\0\1\102"+
    "\1\300\2\102\1\0\1\102\1\0\2\102\5\0\5\102"+
    "\1\302\1\102\1\0\57\102\1\300\4\102\1\307\7\102"+
    "\23\0\2\304\7\0\32\304\1\u0127\3\0\1\304\4\0"+
    "\5\304\12\107\1\0\54\107\1\0\14\107\7\111\1\314"+
    "\24\111\32\0\1\111\1\312\2\111\1\0\1\302\1\0"+
    "\2\111\5\0\7\111\1\0\57\111\1\312\3\111\1\302"+
    "\1\315\7\111\2\120\2\121\3\120\1\323\24\120\32\0"+
    "\1\120\1\320\2\120\1\0\1\120\1\0\2\120\5\0"+
    "\2\120\2\121\3\120\1\0\57\120\1\320\4\120\1\324"+
    "\11\120\2\u0128\3\120\1\317\13\120\2\322\1\120\1\u0129"+
    "\5\120\32\322\1\120\1\320\2\120\1\322\1\120\1\321"+
    "\2\120\5\322\2\0\2\325\102\0\2\u012a\17\0\2\330"+
    "\1\0\1\u012b\5\0\32\330\4\0\1\330\4\0\5\330"+
    "\23\0\2\332\7\0\32\332\4\0\1\332\4\0\5\332"+
    "\20\0\1\u012c\13\0\32\u012c\20\0\1\u012d\1\u012e\101\0"+
    "\3\341\123\0\2\342\7\0\32\342\4\0\1\342\4\0"+
    "\5\342\23\0\2\171\7\0\10\171\1\u012f\21\171\4\0"+
    "\1\171\4\0\1\171\1\u012f\3\171\55\0\1\u0130\77\0"+
    "\1\u0131\104\0\1\u0132\111\0\1\u0133\75\0\1\u0134\110\0"+
    "\1\u0135\71\0\1\u0136\72\0\1\u0137\124\0\1\u0138\104\0"+
    "\1\u0139\22\0\1\u0139\24\0\1\u013a\62\0\1\360\32\0"+
    "\32\u013b\4\0\1\u013b\4\0\5\u013b\23\0\2\60\7\0"+
    "\23\60\1\u013c\6\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\1\u013d\31\60\4\0\1\60\4\0\5\60"+
    "\27\0\1\360\77\0\2\60\7\0\1\u013e\31\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\4\60\1\u013f"+
    "\25\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\2\60\1\u0140\27\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\22\60\1\u0141\7\60\4\0\1\60\4\0"+
    "\2\60\1\u0141\2\60\23\0\2\60\7\0\15\60\1\u0142"+
    "\14\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\22\60\1\u0143\1\u0144\6\60\4\0\1\60\4\0\2\60"+
    "\1\u0143\2\60\23\0\2\60\7\0\13\60\1\u0145\16\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\1\u0146"+
    "\31\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\16\60\1\u0147\13\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\4\60\1\u0148\25\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\23\60\1\u0149\6\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\3\60\1\u014a"+
    "\1\60\1\u014b\2\60\1\u014c\11\60\1\u014d\3\60\1\u014e"+
    "\3\60\4\0\1\60\4\0\1\60\1\u014c\1\u014d\2\60"+
    "\23\0\2\60\7\0\13\60\1\u014f\16\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\23\60\1\u0150\6\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\4\60"+
    "\1\u0151\25\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\22\60\1\u0152\7\60\4\0\1\60\4\0\2\60"+
    "\1\u0152\2\60\23\0\2\60\7\0\1\u0153\31\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\4\60\1\u0154"+
    "\25\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\14\60\1\u0155\15\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\2\60\1\u0156\27\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\1\60\1\u0157\30\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\13\60\1\u0158"+
    "\16\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\13\60\1\u0159\16\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\23\60\1\u015a\6\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\4\60\1\u015b\25\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\4\60\1\u015c"+
    "\25\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\23\60\1\u015d\6\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\13\60\1\u015e\16\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\4\60\1\u015f\25\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\15\60\1\u0160"+
    "\7\60\1\u0161\4\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\23\60\1\u0162\6\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\13\60\1\u0163\16\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\24\60\1\u0164"+
    "\5\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\24\60\1\u0165\5\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\5\60\1\u0166\24\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\23\60\1\u0167\6\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\23\60\1\u0168"+
    "\6\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\16\60\1\u0169\13\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\4\60\1\u016a\25\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\4\60\1\u016b\25\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\13\60\1\u016c"+
    "\16\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\13\60\1\u016d\16\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\10\60\1\u016e\13\60\1\u016f\5\60\4\0"+
    "\1\60\4\0\1\60\1\u016e\3\60\23\0\2\60\7\0"+
    "\1\u0170\31\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\10\60\1\u0171\21\60\4\0\1\60\4\0\1\60"+
    "\1\u0171\3\60\23\0\2\60\7\0\4\60\1\u0172\25\60"+
    "\4\0\1\60\4\0\5\60\2\120\2\u0128\3\120\1\317"+
    "\57\120\1\320\4\120\1\321\7\120\2\0\2\u012a\120\0"+
    "\1\u012c\13\0\32\u012c\10\0\1\u0173\7\0\1\u012d\124\0"+
    "\2\171\7\0\22\171\1\u0174\7\171\4\0\1\171\4\0"+
    "\2\171\1\u0174\2\171\34\0\1\u0175\103\0\1\u0176\116\0"+
    "\1\u0177\71\0\1\u0178\102\0\1\u0179\50\0\1\u017a\12\0"+
    "\1\u017b\23\0\1\u017c\103\0\1\u017d\112\0\1\u017a\100\0"+
    "\1\u017e\33\0\1\u017e\43\0\1\u0179\45\0\1\u017f\1\u0180"+
    "\17\0\2\u013b\7\0\32\u013b\4\0\1\u013b\4\0\5\u013b"+
    "\23\0\2\60\7\0\21\60\1\u0181\10\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\30\60\1\u0182\1\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\12\60"+
    "\1\u0183\17\60\4\0\1\60\4\0\3\60\1\u0183\1\60"+
    "\23\0\2\60\7\0\7\60\1\u0184\22\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\22\60\1\u0185\7\60"+
    "\4\0\1\60\4\0\2\60\1\u0185\2\60\23\0\2\60"+
    "\7\0\4\60\1\u0186\25\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\23\60\1\u0187\6\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\10\60\1\u0188\21\60"+
    "\4\0\1\60\4\0\1\60\1\u0188\3\60\23\0\2\60"+
    "\7\0\1\u0189\31\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\24\60\1\u018a\5\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\10\60\1\u018b\21\60\4\0"+
    "\1\60\4\0\1\60\1\u018b\3\60\23\0\2\60\7\0"+
    "\30\60\1\u018c\1\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\4\60\1\u018d\25\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\16\60\1\u018e\13\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\5\60\1\u018f"+
    "\24\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\26\60\1\u0190\3\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\7\60\1\u0191\22\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\15\60\1\u0192\14\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\4\60\1\u0193"+
    "\25\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\13\60\1\u0194\16\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\1\u0195\31\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\23\60\1\u0196\6\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\1\u0197\31\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\4\60\1\u0198"+
    "\25\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\24\60\1\u0199\5\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\1\u019a\31\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\21\60\1\u019b\10\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\23\60\1\u019c\6\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\15\60"+
    "\1\u019d\14\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\23\60\1\u019e\6\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\1\u019f\31\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\4\60\1\u01a0\25\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\10\60\1\u01a1"+
    "\21\60\4\0\1\60\4\0\1\60\1\u01a1\3\60\23\0"+
    "\2\60\7\0\10\60\1\u01a2\21\60\4\0\1\60\4\0"+
    "\1\60\1\u01a2\3\60\23\0\2\60\7\0\21\60\1\u01a3"+
    "\10\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\10\60\1\u01a4\21\60\4\0\1\60\4\0\1\60\1\u01a4"+
    "\3\60\23\0\2\60\7\0\2\60\1\u01a5\27\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\26\60\1\u01a6"+
    "\3\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\23\60\1\u01a7\6\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\4\60\1\u01a8\25\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\1\u01a9\31\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\13\60\1\u01aa\16\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\15\60"+
    "\1\u01ab\14\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\13\60\1\u01ac\16\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\15\60\1\u01ad\14\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\23\60\1\u01ae\6\60"+
    "\4\0\1\60\4\0\5\60\64\0\1\u017a\74\0\1\u0175"+
    "\27\0\1\u017a\12\0\1\u017b\23\0\1\u01af\112\0\1\u01b0"+
    "\113\0\1\u017a\25\0\1\u017a\12\0\1\u017b\131\0\1\u01b1"+
    "\77\0\1\u0179\116\0\1\u01b2\34\0\1\u017f\124\0\2\60"+
    "\7\0\1\u01b3\31\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\15\60\1\u01b4\14\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\21\60\1\u01b5\10\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\13\60\1\u01b6"+
    "\16\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\5\60\1\u01b7\24\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\2\60\1\u01b8\27\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\21\60\1\u01b9\10\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\10\60\1\u01ba"+
    "\21\60\4\0\1\60\4\0\1\60\1\u01ba\3\60\23\0"+
    "\2\60\7\0\10\60\1\u01bb\21\60\4\0\1\60\4\0"+
    "\1\60\1\u01bb\3\60\23\0\2\60\7\0\3\60\1\u01bc"+
    "\26\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\2\60\1\u01bd\27\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\10\60\1\u01be\21\60\4\0\1\60\4\0"+
    "\1\60\1\u01be\3\60\23\0\2\60\7\0\13\60\1\u01bf"+
    "\16\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\14\60\1\u01c0\15\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\3\60\1\u01c1\26\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\15\60\1\u01c2\14\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\5\60\1\u01c3"+
    "\24\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\23\60\1\u01c4\6\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\23\60\1\u01c5\6\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\2\60\1\u01c6\27\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\2\60\1\u01c7"+
    "\27\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\21\60\1\u01c8\10\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\15\60\1\u01c9\14\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\2\60\1\u01ca\27\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\7\60\1\u01cb"+
    "\22\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\22\60\1\u01cc\7\60\4\0\1\60\4\0\2\60\1\u01cc"+
    "\2\60\23\0\2\60\7\0\4\60\1\u01cd\25\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\2\60\1\u01ce"+
    "\27\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\23\60\1\u01cf\6\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\4\60\1\u01d0\25\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\7\60\1\u01d1\22\60\4\0"+
    "\1\60\4\0\5\60\34\0\1\u01d2\107\0\1\u017a\103\0"+
    "\1\u01d3\105\0\1\u017a\64\0\2\60\7\0\2\60\1\u01d4"+
    "\27\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\24\60\1\u01d5\5\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\4\60\1\u01d6\25\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\23\60\1\u01d7\6\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\13\60\1\u01d8"+
    "\16\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\4\60\1\u01d9\25\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\23\60\1\u01da\6\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\13\60\1\u01db\16\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\22\60\1\u01dc"+
    "\7\60\4\0\1\60\4\0\2\60\1\u01dc\2\60\23\0"+
    "\2\60\7\0\7\60\1\u01dd\22\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\16\60\1\u01de\13\60\4\0"+
    "\1\60\4\0\5\60\23\0\2\60\7\0\4\60\1\u01df"+
    "\25\60\4\0\1\60\4\0\5\60\23\0\2\60\7\0"+
    "\4\60\1\u01e0\25\60\4\0\1\60\4\0\5\60\23\0"+
    "\2\60\7\0\2\60\1\u01e1\27\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\1\u01e2\31\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\4\60\1\u01e3\25\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\23\60"+
    "\1\u01e4\6\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\4\60\1\u01e5\25\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\22\60\1\u01e6\7\60\4\0\1\60"+
    "\4\0\2\60\1\u01e6\2\60\23\0\2\60\7\0\32\60"+
    "\4\0\1\u01e7\4\0\5\60\23\0\2\60\7\0\23\60"+
    "\1\u01e8\6\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\32\60\4\0\1\u01e9\4\0\5\60\23\0\2\60"+
    "\7\0\32\60\4\0\1\u01ea\4\0\5\60\23\0\2\60"+
    "\7\0\16\60\1\u01eb\13\60\4\0\1\60\4\0\5\60"+
    "\51\0\1\u017a\107\0\1\u017a\51\0\2\60\7\0\23\60"+
    "\1\u01ec\6\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\4\60\1\u01ed\25\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\1\u01ee\31\60\4\0\1\60\4\0"+
    "\5\60\23\0\2\60\7\0\1\u01ef\31\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\2\60\1\u01f0\27\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\4\60"+
    "\1\u01f1\25\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\15\60\1\u01f2\14\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\15\60\1\u01f3\14\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\32\60\4\0\1\u01f4"+
    "\4\0\5\60\23\0\2\60\7\0\4\60\1\u01f5\25\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\2\60"+
    "\1\u01f6\27\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\4\60\1\u01f7\25\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\32\60\4\0\1\u01f8\4\0\5\60"+
    "\23\0\2\60\7\0\32\60\4\0\1\u01f9\4\0\5\60"+
    "\23\0\2\60\7\0\32\60\4\0\1\u01fa\4\0\5\60"+
    "\23\0\2\60\7\0\10\60\1\u01fb\21\60\4\0\1\60"+
    "\4\0\1\60\1\u01fb\3\60\23\0\2\60\7\0\2\60"+
    "\1\u01fc\27\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\32\60\4\0\1\u01fd\4\0\5\60\23\0\2\60"+
    "\7\0\3\60\1\u01fe\26\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\21\60\1\u01ff\10\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\2\60\1\u0200\27\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\7\60"+
    "\1\u0201\22\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\23\60\1\u0202\6\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\16\60\1\u0203\13\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\16\60\1\u0204\13\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\4\60"+
    "\1\u0205\25\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\3\60\1\u0206\26\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\16\60\1\u0207\13\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\32\60\4\0\1\u0208"+
    "\4\0\5\60\23\0\2\60\7\0\16\60\1\u0209\13\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\16\60"+
    "\1\u020a\13\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\32\60\4\0\1\u020b\4\0\5\60\23\0\2\60"+
    "\7\0\4\60\1\u020c\25\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\7\60\1\u020d\22\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\22\60\1\u020e\7\60"+
    "\4\0\1\60\4\0\2\60\1\u020e\2\60\23\0\2\60"+
    "\7\0\15\60\1\u020f\14\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\5\60\1\u0210\24\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\15\60\1\u0211\14\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\15\60"+
    "\1\u0212\14\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\14\60\1\u0213\15\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\32\60\4\0\1\u0214\4\0\5\60"+
    "\23\0\2\60\7\0\2\60\1\u0215\27\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\2\60\1\u0216\27\60"+
    "\4\0\1\60\4\0\5\60\23\0\2\60\7\0\32\60"+
    "\4\0\1\u0217\4\0\5\60\23\0\2\60\7\0\17\60"+
    "\1\u0218\12\60\4\0\1\60\4\0\5\60\23\0\2\60"+
    "\7\0\4\60\1\u0219\25\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\4\60\1\u021a\25\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\32\60\4\0\1\u021b"+
    "\4\0\5\60\23\0\2\60\7\0\10\60\1\u021c\21\60"+
    "\4\0\1\60\4\0\1\60\1\u021c\3\60\23\0\2\60"+
    "\7\0\13\60\1\u021d\16\60\4\0\1\60\4\0\5\60"+
    "\23\0\2\60\7\0\4\60\1\u021e\25\60\4\0\1\60"+
    "\4\0\5\60\23\0\2\60\7\0\21\60\1\u021f\10\60"+
    "\4\0\1\60\4\0\5\60";

  private static int [] zzUnpackTrans() {
    int [] result = new int[28696];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\1\10\5\0\1\1\11\0\1\11\3\1\1\11\5\1"+
    "\1\11\10\1\1\11\31\1\1\11\4\1\1\11\11\1"+
    "\1\11\7\1\1\11\1\1\1\0\1\1\1\11\2\1"+
    "\2\11\4\1\1\11\2\1\1\11\4\1\1\11\2\1"+
    "\1\11\1\1\1\11\4\1\1\0\1\11\3\0\2\1"+
    "\2\11\14\0\1\11\3\1\1\0\1\11\1\1\1\11"+
    "\4\1\1\0\51\1\3\0\1\11\2\1\2\11\1\1"+
    "\4\0\2\1\1\11\3\0\3\1\1\11\3\0\1\11"+
    "\1\1\2\11\1\1\1\0\1\11\4\1\12\0\2\1"+
    "\1\0\2\1\1\0\63\1\2\11\1\1\1\11\2\0"+
    "\1\11\2\1\12\0\1\11\1\0\67\1\1\11\1\1"+
    "\6\0\1\11\3\0\1\11\57\1\4\0\37\1\2\0"+
    "\114\1";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[543];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  @SuppressWarnings("unused")
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  @SuppressWarnings("unused")
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  @SuppressWarnings("unused")
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	public PHPLexer(int state) {
		initialize(state);
	}

	// NB: this method resets the lexer only partially
	@Override
	protected void reset(java.io.Reader reader, char[] buffer, int[] parameters) {
		this.zzReader = reader;
		this.zzBuffer = buffer;
		this.zzFinalHighSurrogate = 0;
		this.zzMarkedPos = parameters[0];
		this._zzPushbackPos = parameters[1];
		this.zzCurrentPos = parameters[2];
		this.zzStartRead = parameters[3];
		this.zzEndRead = parameters[4];
		this.yyline = parameters[5];
		initialize(parameters[6]);
	}

	@Override
	public int getInScriptingState() {
		return ST_PHP_IN_SCRIPTING;
	}

	private static final int[] heredocStates = new int[] { ST_PHP_HEREDOC, ST_PHP_START_HEREDOC, ST_PHP_END_HEREDOC };

	@Override
	public int[] getHeredocStates() {
		return heredocStates;
	}

	private static final int[] phpQuotesStates = new int[] { ST_PHP_DOUBLE_QUOTES, ST_PHP_SINGLE_QUOTE, ST_PHP_BACKQUOTE, ST_PHP_HEREDOC, ST_PHP_START_HEREDOC, ST_PHP_END_HEREDOC };

	@Override
	public int[] getPHPQuotesStates() {
		return phpQuotesStates;
	}

	@Override
	public int[] getParameters() {
		return new int[]{zzMarkedPos, _zzPushbackPos, zzCurrentPos, zzStartRead, zzEndRead, yyline, zzLexicalState};
	}

	@Override
	protected int getZZLexicalState() {
		return zzLexicalState;
	}

	@Override
	protected int getZZMarkedPos() {
		return zzMarkedPos;
	}

	@Override
	protected int getZZEndRead() {
		return zzEndRead;
	}

	@Override
	public char[] getZZBuffer() {
		return zzBuffer;
	}

	@Override
	protected int getZZStartRead() {
		return this.zzStartRead;
	}

	@Override
	protected int getZZPushBackPosition() {
		return this._zzPushbackPos;
	}

	@Override
	protected void pushBack(int i) {
		yypushback(i);
	}

	@Override
	public int getScriptingState() {
		return ST_PHP_IN_SCRIPTING;
	}

	// A pool of states. To avoid creation of a new state on each createMemento.
	private static final Map<LexerState, LexerState> lexerStates = new HashMap<>();

	@Override
	protected Map<LexerState, LexerState> getLexerStates() {
		return lexerStates;
	}

	// End user code


  /** the textposition at the last state to be included in yytext */
  private int _zzPushbackPos;

  /* The following fields are added in order to support the change in zzRefill */
  private String oldString = null;
  private boolean useOldString = false;
  private int startPos = 0;

  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public PHPLexer(java.io.Reader in) {
    this.zzReader = in;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    if (useOldString) {
      String saveOldString = oldString;
      oldString = new String(zzBuffer, startPos, zzMarkedPos - startPos);
      if (saveOldString != null) {
        oldString = saveOldString + oldString;
      }
    }

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      _zzPushbackPos-= zzStartRead;
      startPos = 0;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate) {
      /* if not: blow it up */
      char newBuffer[] = new char[zzBuffer.length * 2];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      throw new java.io.IOException(
          "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Gets the next input character.
   *
   * @return      the next character of the input stream, EOF if the
   *              end of the stream is reached.
   * @exception   IOException  if any I/O-Error occurs
   */
  private int yy_advance() throws java.io.IOException {

    /* standard case */
    if (zzCurrentPos < zzEndRead) return zzBuffer[zzCurrentPos++];

    /* if the eof is reached, we don't need to work hard */
    if (zzAtEOF) return YYEOF;

    /* otherwise: need to refill the buffer */

    String saveOldString = oldString;
    oldString = null;

    /* first: make room (if you can) */
    if (zzRefill()) {
      oldString = saveOldString;
      return YYEOF;
    }

    oldString = saveOldString;

    return zzBuffer[zzCurrentPos++];
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    if (zzBuffer.length > ZZ_BUFFERSIZE) {
      zzBuffer = new char[ZZ_BUFFERSIZE];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      _zzPushbackPos = 0;
      startPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      oldString = null;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }


	/**
	 * user method - common.sse
	 */
	private void updateStartPos() {
		updateStartPos(zzMarkedPos);
	}


	/**
	 * user method - common.sse
	 */
	private void updateStartPos(int position) {
		startPos = position;
		oldString = null;
	}


	/**
	 * user method - common.sse
	 */
	public final boolean isEOF() {
		return zzAtEOF;
	}




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public String yylex() throws java.io.IOException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return null;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { return PHP_ENCAPSED_AND_WHITESPACE;
            }
            // fall through
          case 129: break;
          case 2:
            { yypushback(1);
	pushState(ST_PHP_HIGHLIGHTING_ERROR);
            }
            // fall through
          case 130: break;
          case 3:
            { return WHITESPACE;
            }
            // fall through
          case 131: break;
          case 4:
            { return PHP_TOKEN;
            }
            // fall through
          case 132: break;
          case 5:
            { pushState(ST_PHP_DOUBLE_QUOTES);
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 133: break;
          case 6:
            { pushState(ST_PHP_LINE_COMMENT);
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 134: break;
          case 7:
            { pushState(ST_PHP_SINGLE_QUOTE);
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 135: break;
          case 8:
            { return PHP_NUMBER;
            }
            // fall through
          case 136: break;
          case 9:
            { return PHP_SEMICOLON;
            }
            // fall through
          case 137: break;
          case 10:
            { return PHP_LABEL;
            }
            // fall through
          case 138: break;
          case 11:
            { pushState(ST_PHP_BACKQUOTE);
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 139: break;
          case 12:
            { // Whitespaces are directly appended to the curly before pushState()
	// is effective or whitespaces would be stored in a separate ContextRegion.
	// Method PhpTokenContainer#addLast() will correct the curlies length...
	if (!phpStack.isEmpty()) {
		// Only push the state when stack is not empty, it's useless otherwise
		// (and it pollutes the stack).
		pushState(ST_PHP_IN_SCRIPTING);
	}
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 140: break;
          case 13:
            { // Whitespaces are directly appended to the curly before pushState()
	// is effective or whitespaces would be stored in a separate ContextRegion.
	// Method PhpTokenContainer#addLast() will correct the curlies length...
	if (!phpStack.isEmpty()) {
		popState();
		// If new state is not ST_PHP_IN_SCRIPTING then some blanks are signifiant (like newlines
		// after the closing curly and before an ending heredoc tag), so don't append them...
		// See rule <ST_PHP_HEREDOC>{HEREDOC_CHARS}*({HEREDOC_NEWLINE}+({LABEL}";"?)?)?
		if (getZZLexicalState() != ST_PHP_IN_SCRIPTING) {
			yypushback(yylength() - 1);
		}
	}
	return PHP_CURLY_CLOSE;
            }
            // fall through
          case 141: break;
          case 14:
            { popState();
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 142: break;
          case 15:
            { return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 143: break;
          case 16:
            { yypushback(1);
		popState();
            }
            // fall through
          case 144: break;
          case 17:
            { yypushback(1);
	yybegin(ST_PHP_HEREDOC);
            }
            // fall through
          case 145: break;
          case 18:
            { yypushback(1);
	popState();
            }
            // fall through
          case 146: break;
          case 19:
            { popState();
	return PHP_LABEL;
            }
            // fall through
          case 147: break;
          case 20:
            { yypushback(1);
	popState();
	return PHP_ENCAPSED_AND_WHITESPACE;
            }
            // fall through
          case 148: break;
          case 21:
            { //the difference from the original rules comes from the fact that we took ';' out of tokens
	return UNKNOWN_TOKEN;
            }
            // fall through
          case 149: break;
          case 22:
            { popState();
	return PHP_TOKEN;
            }
            // fall through
          case 150: break;
          case 23:
            { return PHP_COMMENT;
            }
            // fall through
          case 151: break;
          case 24:
            { return PHPDOC_COMMENT;
            }
            // fall through
          case 152: break;
          case 25:
            { String yytext = yytext();
	switch (yytext.charAt(yytext.length() - 1)) {
		case '?':
		case '%':
		case '>':
			yypushback(1);
			if (yylength() > 0) {
				return PHP_LINE_COMMENT;
			}
			break;
		default:
			popState();
			return PHP_LINE_COMMENT;
	}
            }
            // fall through
          case 153: break;
          case 26:
            { return PHP_LINE_COMMENT;
            }
            // fall through
          case 154: break;
          case 27:
            { return UNKNOWN_TOKEN;
            }
            // fall through
          case 155: break;
          case 28:
            { popState();return WHITESPACE;
            }
            // fall through
          case 156: break;
          case 29:
            { yybegin(ST_PHP_IN_SCRIPTING);
	return PHP_ENCAPSED_VARIABLE;
            }
            // fall through
          case 157: break;
          case 30:
            { yybegin(ST_PHP_IN_SCRIPTING);
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 158: break;
          case 31:
            { return PHP_OPERATOR;
            }
            // fall through
          case 159: break;
          case 32:
            { return PHP_VARIABLE;
            }
            // fall through
          case 160: break;
          case 33:
            { if (asp_tags) {
		return PHP_CLOSETAG;
	}
	return UNKNOWN_TOKEN;
            }
            // fall through
          case 161: break;
          case 34:
            { pushState(ST_PHP_LOOKING_FOR_PROPERTY);
	return PHP_OBJECT_OPERATOR;
            }
            // fall through
          case 162: break;
          case 35:
            { pushState(ST_PHP_COMMENT);
	return PHP_COMMENT_START;
            }
            // fall through
          case 163: break;
          case 36:
            { return PHP_PAAMAYIM_NEKUDOTAYIM;
            }
            // fall through
          case 164: break;
          case 37:
            { return PHP_CLOSETAG;
            }
            // fall through
          case 165: break;
          case 38:
            { return PHP_AS;
            }
            // fall through
          case 166: break;
          case 39:
            { return PHP_DO;
            }
            // fall through
          case 167: break;
          case 40:
            { return PHP_IF;
            }
            // fall through
          case 168: break;
          case 41:
            { yypushback(1);
	return PHP_ENCAPSED_AND_WHITESPACE;
            }
            // fall through
          case 169: break;
          case 42:
            { pushState(ST_PHP_QUOTES_AFTER_VARIABLE);
	return PHP_VARIABLE;
            }
            // fall through
          case 170: break;
          case 43:
            { // We can have nested curlies after applying this rule,
	// so we have to count all curlies...
	yypushback(1);
	pushState(ST_PHP_DOLLAR_CURLY_OPEN);
	return PHP_TOKEN;
            }
            // fall through
          case 171: break;
          case 44:
            { // We can have nested curlies after applying rule below for "${",
	// so we have to count all curlies...
	yypushback(1);
	pushState(ST_PHP_IN_SCRIPTING);
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 172: break;
          case 45:
            { popState();
	pushState(ST_PHP_LOOKING_FOR_PROPERTY);
	return PHP_OBJECT_OPERATOR;
            }
            // fall through
          case 173: break;
          case 46:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}

	String heredoc = getHeredocId();
	int heredoc_len = heredoc.length();
	if (label_len == heredoc_len && yytext.substring(0, label_len).equals(heredoc)) {
		// we must (at least) push the newline character back
		yypushback(1);
		popHeredocId();
		popState();
		return PHP_HEREDOC_CLOSE_TAG;
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
		return PHP_ENCAPSED_AND_WHITESPACE;
	}
            }
            // fall through
          case 174: break;
          case 47:
            { return PHP_OBJECT_OPERATOR;
            }
            // fall through
          case 175: break;
          case 48:
            { popState();
	return PHP_COMMENT_END;
            }
            // fall through
          case 176: break;
          case 49:
            { popState();
	return PHPDOC_COMMENT_END;
            }
            // fall through
          case 177: break;
          case 50:
            { TagKind tagkind = TagKind.getTagKindFromValue(yytext());
		if (tagkind != null && tagkind != TagKind.UNKNOWN
			&& /* ignore @todo tag */ tagkind != TagKind.TODO) {
				return PHPDOC_GENERIC_TAG;
		}
		return PHPDOC_COMMENT;
            }
            // fall through
          case 178: break;
          case 51:
            { popState();
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 179: break;
          case 52:
            { if (asp_tags) {
		return PHP_CLOSETAG;
	}
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 180: break;
          case 53:
            { yypushback(yylength() - 1);
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 181: break;
          case 54:
            { pushState(ST_PHP_DOC_COMMENT);
	return PHPDOC_COMMENT_START;
            }
            // fall through
          case 182: break;
          case 55:
            { return PHP_DIE;
            }
            // fall through
          case 183: break;
          case 56:
            { return PHP_FOR;
            }
            // fall through
          case 184: break;
          case 57:
            { return PHP_NEW;
            }
            // fall through
          case 185: break;
          case 58:
            { return PHP_TRY;
            }
            // fall through
          case 186: break;
          case 59:
            { return PHP_USE;
            }
            // fall through
          case 187: break;
          case 60:
            { return PHP_VAR;
            }
            // fall through
          case 188: break;
          case 61:
            { yypushback(1);
	pushState(ST_PHP_VAR_OFFSET);
	return PHP_VARIABLE;
            }
            // fall through
          case 189: break;
          case 62:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}
	String heredoc = getHeredocId();
	int heredoc_len = heredoc.length();
	int startIndex = label_len - heredoc_len;
	if (startIndex > 0 && yytext.substring(startIndex, label_len).equals(heredoc)
		&& (yytext.charAt(startIndex - 1) == '\n' || yytext.charAt(startIndex - 1) == '\r')) {

		if (startIndex - 2 >= 0
			&& yytext.charAt(startIndex - 2) == '\r'
			&& yytext.charAt(startIndex - 1) == '\n') {
			startIndex-= 2;
		} else {
			startIndex--;
		}
		yypushback(yylength() - startIndex);

		yybegin(ST_PHP_END_HEREDOC);
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
	}
	// In some cases, all text is pushed back (using yypushback()),
	// especially when the parsed document has Windows newlines.
	// In those cases, ignore this rule and try next one...
	if (yylength() > 0) {
		return PHP_ENCAPSED_AND_WHITESPACE;
	}
            }
            // fall through
          case 190: break;
          case 63:
            { // we must (at least) push the newline character back
	yypushback(1);
	popHeredocId();
	popState();
	return PHP_HEREDOC_CLOSE_TAG;
            }
            // fall through
          case 191: break;
          case 64:
            { yypushback(yylength() - 2);
	if (asp_tags) {
		return PHP_CLOSETAG;
	}
	popState();
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 192: break;
          case 65:
            { yypushback(2);
	pushState(ST_PHP_COMMENT);
	return PHP_COMMENT_START;
            }
            // fall through
          case 193: break;
          case 66:
            { return PHP_CASE;
            }
            // fall through
          case 194: break;
          case 67:
            { return PHP_ECHO;
            }
            // fall through
          case 195: break;
          case 68:
            { return PHP_ELSE;
            }
            // fall through
          case 196: break;
          case 69:
            { return PHP_EVAL;
            }
            // fall through
          case 197: break;
          case 70:
            { return PHP_EXIT;
            }
            // fall through
          case 198: break;
          case 71:
            { return PHP_FROM;
            }
            // fall through
          case 199: break;
          case 72:
            { return PHP_LIST;
            }
            // fall through
          case 200: break;
          case 73:
            { return PHP_KEYWORD;
            }
            // fall through
          case 201: break;
          case 74:
            { return PHP_SELF;
            }
            // fall through
          case 202: break;
          case 75:
            { return PHP_TRUE;
            }
            // fall through
          case 203: break;
          case 76:
            { TagKind tagkind = TagKind.getTagKindFromValue(yytext());
		if (tagkind != null && tagkind != TagKind.UNKNOWN) {
			return PHPDOC_GENERIC_TAG;
		}
		return PHPDOC_COMMENT;
            }
            // fall through
          case 204: break;
          case 77:
            { return PHP_THIS;
            }
            // fall through
          case 205: break;
          case 78:
            { return PHP_CASTING;
            }
            // fall through
          case 206: break;
          case 79:
            { String yytext = yytext();
	int bprefix = (yytext.charAt(0) != '<') ? 1 : 0;
	int startString = 3 + bprefix;
	int heredoc_len = yylength() - bprefix - 3 - 1 - (yytext.charAt(yylength() - 2) == '\r' ? 1 : 0);
	while ((yytext.charAt(startString) == ' ') || (yytext.charAt(startString) == '\t')) {
		startString++;
		heredoc_len--;
	}
	pushHeredocId(yytext.substring(startString, heredoc_len + startString));
	pushState(ST_PHP_START_HEREDOC);
	return PHP_HEREDOC_START_TAG;
            }
            // fall through
          case 207: break;
          case 80:
            { return PHP_ARRAY;
            }
            // fall through
          case 208: break;
          case 81:
            { return PHP_BREAK;
            }
            // fall through
          case 209: break;
          case 82:
            { return PHP_CATCH;
            }
            // fall through
          case 210: break;
          case 83:
            { return PHP_CLASS;
            }
            // fall through
          case 211: break;
          case 84:
            { return PHP_CLONE;
            }
            // fall through
          case 212: break;
          case 85:
            { return PHP_CONST;
            }
            // fall through
          case 213: break;
          case 86:
            { return PHP_EMPTY;
            }
            // fall through
          case 214: break;
          case 87:
            { return PHP_ENDIF;
            }
            // fall through
          case 215: break;
          case 88:
            { return PHP_FALSE;
            }
            // fall through
          case 216: break;
          case 89:
            { return PHP_FINAL;
            }
            // fall through
          case 217: break;
          case 90:
            { return PHP_ISSET;
            }
            // fall through
          case 218: break;
          case 91:
            { return PHP_PRINT;
            }
            // fall through
          case 219: break;
          case 92:
            { return PHP_THROW;
            }
            // fall through
          case 220: break;
          case 93:
            { return PHP_UNSET;
            }
            // fall through
          case 221: break;
          case 94:
            { return PHP_WHILE;
            }
            // fall through
          case 222: break;
          case 95:
            { return PHP_ELSEIF;
            }
            // fall through
          case 223: break;
          case 96:
            { return PHP_ENDFOR;
            }
            // fall through
          case 224: break;
          case 97:
            { return PHP_GLOBAL;
            }
            // fall through
          case 225: break;
          case 98:
            { return PHP_PARENT;
            }
            // fall through
          case 226: break;
          case 99:
            { return PHP_PUBLIC;
            }
            // fall through
          case 227: break;
          case 100:
            { return PHP_RETURN;
            }
            // fall through
          case 228: break;
          case 101:
            { return PHP_STATIC;
            }
            // fall through
          case 229: break;
          case 102:
            { return PHP_SWITCH;
            }
            // fall through
          case 230: break;
          case 103:
            { return PHP_DECLARE;
            }
            // fall through
          case 231: break;
          case 104:
            { return PHP_DEFAULT;
            }
            // fall through
          case 232: break;
          case 105:
            { return PHP_EXTENDS;
            }
            // fall through
          case 233: break;
          case 106:
            { return PHP_FOREACH;
            }
            // fall through
          case 234: break;
          case 107:
            { return PHP_INCLUDE;
            }
            // fall through
          case 235: break;
          case 108:
            { return PHP_PRIVATE;
            }
            // fall through
          case 236: break;
          case 109:
            { return PHP_REQUIRE;
            }
            // fall through
          case 237: break;
          case 110:
            { return PHP_ABSTRACT;
            }
            // fall through
          case 238: break;
          case 111:
            { return PHP_CONTINUE;
            }
            // fall through
          case 239: break;
          case 112:
            { return PHP_ENDWHILE;
            }
            // fall through
          case 240: break;
          case 113:
            { return PHP_FUNCTION;
            }
            // fall through
          case 241: break;
          case 114:
            { return PHP__FILE__;
            }
            // fall through
          case 242: break;
          case 115:
            { return PHP__LINE__;
            }
            // fall through
          case 243: break;
          case 116:
            { return PHP_ENDSWITCH;
            }
            // fall through
          case 244: break;
          case 117:
            { return PHP_INTERFACE;
            }
            // fall through
          case 245: break;
          case 118:
            { return PHP_PROTECTED;
            }
            // fall through
          case 246: break;
          case 119:
            { return PHP__CLASS__;
            }
            // fall through
          case 247: break;
          case 120:
            { return PHP_ENDDECLARE;
            }
            // fall through
          case 248: break;
          case 121:
            { return PHP_ENDFOREACH;
            }
            // fall through
          case 249: break;
          case 122:
            { return PHP_IMPLEMENTS;
            }
            // fall through
          case 250: break;
          case 123:
            { return PHP_INSTANCEOF;
            }
            // fall through
          case 251: break;
          case 124:
            { return PHP__METHOD__;
            }
            // fall through
          case 252: break;
          case 125:
            { return PHP_INCLUDE_ONCE;
            }
            // fall through
          case 253: break;
          case 126:
            { return PHP_REQUIRE_ONCE;
            }
            // fall through
          case 254: break;
          case 127:
            { return PHP__FUNCTION__;
            }
            // fall through
          case 255: break;
          case 128:
            { return PHP_HALT_COMPILER;
            }
            // fall through
          case 256: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }


}
