// DO NOT EDIT
// Generated by JFlex 1.8.2 http://jflex.de/
// source: highlighting_scanner.jflex

/*******************************************************************************
 * Copyright (c) 2006, 2017 Zend Corporation and IBM Corporation.
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *   Zend and IBM - Initial implementation
 *******************************************************************************/

package org.eclipse.php.internal.core.documentModel.parser.php53;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.php.core.compiler.ast.nodes.PHPDocTag.TagKind;

//@SuppressWarnings({"unused", "nls"})


// See https://github.com/jflex-de/jflex/issues/222
@SuppressWarnings("FallThrough")
public class PHPLexer extends org.eclipse.php.internal.core.documentModel.parser.AbstractPHPLexer {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int ST_PHP_IN_SCRIPTING = 2;
  public static final int ST_PHP_DOUBLE_QUOTES = 4;
  public static final int ST_PHP_SINGLE_QUOTE = 6;
  public static final int ST_PHP_BACKQUOTE = 8;
  public static final int ST_PHP_QUOTES_AFTER_VARIABLE = 10;
  public static final int ST_PHP_HEREDOC = 12;
  public static final int ST_PHP_NOWDOC = 14;
  public static final int ST_PHP_START_HEREDOC = 16;
  public static final int ST_PHP_START_NOWDOC = 18;
  public static final int ST_PHP_END_HEREDOC = 20;
  public static final int ST_PHP_LOOKING_FOR_PROPERTY = 22;
  public static final int ST_PHP_VAR_OFFSET = 24;
  public static final int ST_PHP_COMMENT = 26;
  public static final int ST_PHP_DOC_COMMENT = 28;
  public static final int ST_PHP_LINE_COMMENT = 30;
  public static final int ST_PHP_HIGHLIGHTING_ERROR = 32;
  public static final int ST_PHP_END_NOWDOC = 34;
  public static final int ST_PHP_DOLLAR_CURLY_OPEN = 36;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7,  7, 
     8,  8,  9,  9, 10, 10, 11, 11, 12, 12, 13, 13, 14, 14, 15, 15, 
    16, 16, 17, 17, 18, 18
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\37\u0200\1\u0300\266\u0200\10\u0400\40\u0200\u1000\u0500";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\2\0\1\3\22\0\1\1\1\4"+
    "\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14"+
    "\1\15\1\16\1\17\1\20\1\21\1\22\1\23\11\24"+
    "\1\25\1\26\1\27\1\30\1\31\1\32\1\33\1\34"+
    "\1\35\1\36\1\37\1\40\1\41\1\42\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\54"+
    "\1\55\1\56\1\57\1\60\1\61\1\62\1\63\1\64"+
    "\1\65\1\66\1\67\1\70\1\71\1\72\1\73\1\34"+
    "\1\35\1\36\1\37\1\40\1\41\1\42\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\54"+
    "\1\55\1\56\1\57\1\60\1\61\1\62\1\63\1\64"+
    "\1\65\1\74\1\75\1\76\1\17\1\0\260\77\2\100"+
    "\115\77\1\101\u01aa\77\1\102\325\77\u0100\103\u0100\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1536];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\6\0\1\1\1\2\13\0\1\3\1\4\1\5\1\6"+
    "\1\7\3\5\1\10\7\5\2\11\1\5\1\12\4\5"+
    "\24\13\1\14\1\13\1\15\1\16\1\5\1\17\1\1"+
    "\1\20\5\2\1\1\3\2\3\21\2\1\3\3\1\2"+
    "\2\22\2\23\1\0\1\3\2\24\1\25\1\26\2\27"+
    "\2\11\1\13\1\30\2\31\4\32\3\33\3\34\1\35"+
    "\1\36\1\0\1\3\1\37\1\40\1\41\1\0\1\2"+
    "\3\0\2\42\1\41\1\43\14\0\1\44\1\11\1\45"+
    "\1\11\1\0\1\46\1\41\1\47\3\13\1\50\1\0"+
    "\6\13\1\51\15\13\1\52\7\13\1\41\16\13\3\0"+
    "\2\53\1\54\1\55\1\56\1\53\4\0\2\53\1\57"+
    "\3\0\1\1\2\53\1\2\1\60\2\0\1\61\3\0"+
    "\1\62\1\54\1\63\1\64\1\65\1\0\1\66\1\67"+
    "\1\0\1\40\1\70\1\42\12\0\1\71\1\11\1\0"+
    "\2\13\1\0\10\13\1\72\11\13\1\73\13\13\1\74"+
    "\14\13\1\75\1\13\1\76\1\77\10\13\1\100\1\101"+
    "\1\1\1\102\1\2\1\103\2\0\2\104\1\105\1\0"+
    "\1\42\12\0\1\106\3\0\3\13\1\107\7\13\1\110"+
    "\1\111\6\13\1\112\1\113\4\13\1\114\2\13\1\115"+
    "\5\13\1\116\1\13\1\117\7\13\1\120\3\13\1\121"+
    "\12\13\1\122\1\123\6\0\1\124\5\0\2\125\1\13"+
    "\1\126\1\127\1\130\1\131\1\132\1\133\4\13\1\134"+
    "\2\13\1\135\3\13\1\136\1\137\7\13\1\140\2\13"+
    "\1\141\7\13\1\142\1\143\1\144\10\13\5\0\4\13"+
    "\1\145\1\13\1\146\5\13\1\147\5\13\1\150\2\13"+
    "\1\151\1\13\1\152\1\153\1\154\10\13\2\0\2\13"+
    "\1\155\1\156\4\13\1\157\1\160\2\13\1\161\3\13"+
    "\1\162\1\13\1\163\1\13\1\164\6\13\1\165\1\166"+
    "\3\13\1\167\1\170\10\13\1\171\2\13\1\172\4\13"+
    "\1\173\3\13\1\174\1\175\1\176\1\13\1\177\4\13"+
    "\1\200\1\201\1\202\1\13\1\203\3\13\1\204\6\13"+
    "\1\205\1\206\1\207\3\13\1\210\1\13\1\211";

  private static int [] zzUnpackAction() {
    int [] result = new int[593];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\104\0\210\0\314\0\u0110\0\u0154\0\u0198\0\u01dc"+
    "\0\u0220\0\u0264\0\u02a8\0\u02ec\0\u0330\0\u0374\0\u03b8\0\u03fc"+
    "\0\u0440\0\u0484\0\u04c8\0\0\0\u050c\0\u0550\0\u0594\0\0"+
    "\0\u05d8\0\u061c\0\u0660\0\u06a4\0\u06e8\0\0\0\u072c\0\u0770"+
    "\0\u07b4\0\u07f8\0\u083c\0\u0880\0\u08c4\0\u0908\0\0\0\u094c"+
    "\0\u0990\0\u09d4\0\u0a18\0\u0a5c\0\u0aa0\0\u0ae4\0\u0b28\0\u0b6c"+
    "\0\u0bb0\0\u0bf4\0\u0c38\0\u0c7c\0\u0cc0\0\u0d04\0\u0d48\0\u0d8c"+
    "\0\u0dd0\0\u0e14\0\u0e58\0\u0e9c\0\u0ee0\0\u0f24\0\u0f68\0\0"+
    "\0\u0fac\0\0\0\u0ff0\0\u1034\0\u1078\0\u10bc\0\0\0\u1100"+
    "\0\u1144\0\u1188\0\u11cc\0\u1210\0\u1254\0\u1298\0\u12dc\0\u1320"+
    "\0\0\0\u1364\0\u13a8\0\u13ec\0\u1430\0\u1474\0\u14b8\0\u14fc"+
    "\0\u1540\0\0\0\u1584\0\0\0\u15c8\0\u160c\0\u1650\0\0"+
    "\0\u1694\0\u16d8\0\0\0\0\0\u171c\0\u1760\0\u17a4\0\u17e8"+
    "\0\0\0\u182c\0\u1870\0\0\0\u18b4\0\u18f8\0\u193c\0\u1980"+
    "\0\0\0\u19c4\0\u1a08\0\0\0\u0a18\0\0\0\u1a4c\0\u1a90"+
    "\0\u1ad4\0\u1b18\0\u1b5c\0\u072c\0\u0594\0\0\0\u1ba0\0\u1be4"+
    "\0\u1c28\0\u1c6c\0\u1cb0\0\0\0\0\0\u06a4\0\u1cf4\0\u06e8"+
    "\0\u1d38\0\u1d7c\0\u1dc0\0\u1e04\0\u1e48\0\u1e8c\0\u1ed0\0\u1f14"+
    "\0\u1f58\0\0\0\u1f9c\0\u1fe0\0\u2024\0\u2068\0\0\0\u20ac"+
    "\0\0\0\u20f0\0\u2134\0\u2178\0\u0c38\0\u21bc\0\u2200\0\u2244"+
    "\0\u2288\0\u22cc\0\u2310\0\u2354\0\u0c38\0\u2398\0\u23dc\0\u2420"+
    "\0\u2464\0\u24a8\0\u24ec\0\u2530\0\u2574\0\u25b8\0\u25fc\0\u2640"+
    "\0\u2684\0\u26c8\0\u0c38\0\u270c\0\u2750\0\u2794\0\u27d8\0\u281c"+
    "\0\u2860\0\u28a4\0\u0c38\0\u28e8\0\u292c\0\u2970\0\u29b4\0\u29f8"+
    "\0\u2a3c\0\u2a80\0\u2ac4\0\u2b08\0\u2b4c\0\u2b90\0\u2bd4\0\u2c18"+
    "\0\u2c5c\0\u2ca0\0\u1144\0\u2ce4\0\0\0\u2ca0\0\u2d28\0\0"+
    "\0\0\0\u2ce4\0\u2d6c\0\u2db0\0\u12dc\0\u2df4\0\u2db0\0\u2df4"+
    "\0\0\0\u2e38\0\u14b8\0\u2e7c\0\u2ec0\0\u2e38\0\u2e7c\0\u2f04"+
    "\0\0\0\u1584\0\u2f48\0\0\0\u15c8\0\u2f8c\0\u2fd0\0\0"+
    "\0\u3014\0\0\0\0\0\u18f8\0\u3058\0\0\0\u309c\0\u30e0"+
    "\0\u3124\0\u3168\0\u31ac\0\u31f0\0\u3234\0\u3278\0\u32bc\0\u3300"+
    "\0\u3344\0\u3388\0\u33cc\0\u3410\0\u3454\0\u3498\0\u2068\0\u34dc"+
    "\0\u3520\0\u3564\0\u35a8\0\u35ec\0\u3630\0\u3674\0\u36b8\0\u36fc"+
    "\0\u3740\0\u3784\0\u37c8\0\u0c38\0\u380c\0\u3850\0\u3894\0\u38d8"+
    "\0\u391c\0\u3960\0\u39a4\0\u39e8\0\u3a2c\0\u3a70\0\u3ab4\0\u3af8"+
    "\0\u3b3c\0\u3b80\0\u3bc4\0\u3c08\0\u3c4c\0\u3c90\0\u3cd4\0\u3d18"+
    "\0\u3d5c\0\u0c38\0\u3da0\0\u3de4\0\u3e28\0\u3e6c\0\u3eb0\0\u3ef4"+
    "\0\u3f38\0\u3f7c\0\u3fc0\0\u4004\0\u4048\0\u408c\0\u0c38\0\u40d0"+
    "\0\u0c38\0\u0c38\0\u4114\0\u4158\0\u419c\0\u41e0\0\u4224\0\u4268"+
    "\0\u42ac\0\u42f0\0\0\0\0\0\u4334\0\0\0\u4378\0\0"+
    "\0\u43bc\0\u4400\0\0\0\u4444\0\0\0\u4488\0\u44cc\0\u4510"+
    "\0\u4554\0\u4598\0\u45dc\0\u4620\0\u4664\0\u46a8\0\u46ec\0\u4730"+
    "\0\u4774\0\0\0\u47b8\0\u47fc\0\u4840\0\u4884\0\u48c8\0\u490c"+
    "\0\u0c38\0\u4950\0\u4994\0\u49d8\0\u4a1c\0\u4a60\0\u4aa4\0\u4ae8"+
    "\0\u0c38\0\u4b2c\0\u4b70\0\u4bb4\0\u4bf8\0\u4c3c\0\u4c80\0\u4cc4"+
    "\0\u0c38\0\u0c38\0\u4d08\0\u4d4c\0\u4d90\0\u4dd4\0\u0c38\0\u4e18"+
    "\0\u4e5c\0\u0c38\0\u4ea0\0\u4ee4\0\u4f28\0\u4f6c\0\u4fb0\0\u0c38"+
    "\0\u4ff4\0\u0c38\0\u5038\0\u507c\0\u50c0\0\u5104\0\u5148\0\u518c"+
    "\0\u51d0\0\u0c38\0\u5214\0\u5258\0\u529c\0\u0c38\0\u52e0\0\u5324"+
    "\0\u5368\0\u53ac\0\u53f0\0\u5434\0\u5478\0\u54bc\0\u5500\0\u5544"+
    "\0\0\0\u1c6c\0\u5588\0\u55cc\0\u5610\0\u5654\0\u5698\0\u56dc"+
    "\0\0\0\u5720\0\u5764\0\u57a8\0\u57ec\0\u5830\0\0\0\u5874"+
    "\0\u58b8\0\u0c38\0\u0c38\0\u0c38\0\u0c38\0\u0c38\0\u0c38\0\u58fc"+
    "\0\u5940\0\u5984\0\u59c8\0\u0c38\0\u5a0c\0\u5a50\0\u0c38\0\u5a94"+
    "\0\u5ad8\0\u5b1c\0\u0c38\0\u0c38\0\u5b60\0\u5ba4\0\u5be8\0\u5c2c"+
    "\0\u5c70\0\u5cb4\0\u5cf8\0\u0c38\0\u5d3c\0\u5d80\0\u0c38\0\u5dc4"+
    "\0\u5e08\0\u5e4c\0\u5e90\0\u5ed4\0\u5f18\0\u5f5c\0\u0c38\0\u0c38"+
    "\0\u0c38\0\u5fa0\0\u5fe4\0\u6028\0\u606c\0\u60b0\0\u60f4\0\u6138"+
    "\0\u617c\0\u61c0\0\u6204\0\u6248\0\u628c\0\u62d0\0\u6314\0\u6358"+
    "\0\u639c\0\u63e0\0\u0c38\0\u6424\0\u6468\0\u64ac\0\u64f0\0\u6534"+
    "\0\u6578\0\u65bc\0\u0c38\0\u6600\0\u6644\0\u6688\0\u66cc\0\u6710"+
    "\0\u0c38\0\u6754\0\u6798\0\u0c38\0\u67dc\0\u0c38\0\u0c38\0\u0c38"+
    "\0\u6820\0\u6864\0\u68a8\0\u68ec\0\u6930\0\u6974\0\u69b8\0\u69fc"+
    "\0\u6a40\0\u6a84\0\u6ac8\0\u6b0c\0\u0c38\0\u0c38\0\u6b50\0\u6b94"+
    "\0\u6bd8\0\u6c1c\0\u0c38\0\u0c38\0\u6c60\0\u6ca4\0\u6ce8\0\u6d2c"+
    "\0\u6d70\0\u6db4\0\u0c38\0\u6df8\0\u6e3c\0\u6e80\0\u0c38\0\u6ec4"+
    "\0\u6f08\0\u6f4c\0\u6f90\0\u6fd4\0\u7018\0\u0c38\0\u0c38\0\u705c"+
    "\0\u70a0\0\u70e4\0\u0c38\0\u0c38\0\u7128\0\u716c\0\u71b0\0\u71f4"+
    "\0\u7238\0\u727c\0\u72c0\0\u7304\0\u0c38\0\u7348\0\u738c\0\u0c38"+
    "\0\u73d0\0\u7414\0\u7458\0\u749c\0\u0c38\0\u74e0\0\u7524\0\u7568"+
    "\0\u0c38\0\u0c38\0\u0c38\0\u75ac\0\u0c38\0\u75f0\0\u7634\0\u7678"+
    "\0\u76bc\0\u0c38\0\u0c38\0\u0c38\0\u7700\0\u0c38\0\u7744\0\u7788"+
    "\0\u77cc\0\u0c38\0\u7810\0\u7854\0\u7898\0\u78dc\0\u7920\0\u7964"+
    "\0\u0c38\0\u0c38\0\u0c38\0\u79a8\0\u79ec\0\u7a30\0\u0c38\0\u7a74"+
    "\0\u0c38";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[593];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\104\0\1\24\3\25\1\26\1\27\1\30\1\31\1\32"+
    "\1\33\1\34\1\35\1\36\1\37\1\40\1\36\1\41"+
    "\1\42\1\43\1\44\1\45\1\46\1\47\1\50\1\51"+
    "\1\52\1\53\1\36\1\54\1\55\1\56\1\57\1\60"+
    "\1\61\1\62\1\63\1\64\2\63\1\65\1\63\1\66"+
    "\1\67\1\70\1\63\1\71\1\72\1\73\1\74\1\75"+
    "\1\76\1\77\2\63\1\36\1\100\1\36\1\37\1\101"+
    "\1\102\1\103\1\104\1\105\1\63\1\64\1\72\2\63"+
    "\5\106\1\107\1\106\1\110\57\106\1\111\4\106\1\112"+
    "\7\106\12\113\1\107\54\113\1\114\14\113\7\115\1\116"+
    "\57\115\1\117\3\115\1\107\1\120\7\115\20\121\1\122"+
    "\53\121\1\123\7\121\2\124\2\125\3\124\1\126\57\124"+
    "\1\127\4\124\1\130\7\124\2\10\2\131\100\10\34\132"+
    "\32\133\4\132\1\133\4\132\5\133\34\134\32\135\4\134"+
    "\1\135\4\134\5\135\2\24\1\136\1\137\77\24\1\0"+
    "\1\140\3\25\14\140\1\141\13\140\32\142\4\140\1\142"+
    "\4\140\5\142\1\24\3\143\2\144\1\143\1\145\2\144"+
    "\1\143\10\144\1\146\1\147\7\144\15\63\1\150\14\63"+
    "\1\36\1\143\1\151\1\144\1\63\4\144\5\63\15\152"+
    "\1\153\66\152\15\154\1\155\15\154\1\156\40\154\1\157"+
    "\7\154\2\160\1\161\1\162\4\160\1\163\20\160\1\164"+
    "\1\165\51\160\1\166\3\167\77\166\1\0\2\24\1\170"+
    "\1\171\77\24\1\0\2\24\1\0\31\24\32\172\4\24"+
    "\1\172\1\24\1\173\2\24\5\172\1\0\3\25\130\0"+
    "\1\174\53\0\5\175\1\176\1\175\1\177\57\175\1\200"+
    "\4\175\1\201\7\175\34\0\23\202\1\203\6\202\4\0"+
    "\1\202\4\0\5\202\30\0\1\204\1\205\63\0\1\204"+
    "\16\0\1\204\53\0\12\206\1\176\54\206\1\207\14\206"+
    "\1\0\1\210\32\0\1\211\1\212\1\0\1\213\1\0"+
    "\1\214\2\0\1\215\5\0\1\216\2\0\1\217\1\220"+
    "\1\0\1\221\17\0\1\215\1\220\32\0\1\204\71\0"+
    "\1\204\11\0\1\204\73\0\1\204\7\0\1\204\1\222"+
    "\75\0\2\223\3\0\1\204\70\0\1\224\4\0\1\30"+
    "\5\0\1\204\74\0\1\223\1\0\2\45\13\0\1\225"+
    "\22\0\1\226\41\0\1\223\1\0\2\45\13\0\1\225"+
    "\70\0\1\227\105\0\1\230\2\204\102\0\1\174\1\204"+
    "\102\0\1\204\1\174\103\0\1\231\75\0\2\63\7\0"+
    "\1\63\1\232\13\63\1\233\3\63\1\234\1\235\7\63"+
    "\4\0\1\63\4\0\2\63\1\235\2\63\5\0\1\27"+
    "\4\0\1\34\10\0\2\63\2\0\1\236\4\0\21\63"+
    "\1\237\10\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\1\240\12\63\1\241\2\63\1\242\13\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\4\63\1\243"+
    "\3\63\1\244\5\63\1\245\13\63\4\0\1\63\4\0"+
    "\1\63\1\244\3\63\23\0\2\63\7\0\2\63\1\246"+
    "\10\63\1\247\1\250\1\251\7\63\1\252\1\63\1\253"+
    "\2\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\1\254\7\63\1\255\5\63\1\256\2\63\1\257\2\63"+
    "\1\260\5\63\4\0\1\63\4\0\1\63\1\255\3\63"+
    "\23\0\2\63\7\0\13\63\1\261\2\63\1\262\13\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\32\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\5\63"+
    "\1\263\6\63\1\264\1\265\4\63\1\266\7\63\4\0"+
    "\1\63\4\0\2\63\1\266\2\63\23\0\2\63\7\0"+
    "\10\63\1\267\21\63\4\0\1\63\4\0\1\63\1\267"+
    "\3\63\23\0\2\63\7\0\1\270\3\63\1\271\17\63"+
    "\1\272\5\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\21\63\1\273\10\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\1\274\20\63\1\275\2\63\1\276"+
    "\5\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\4\63\1\277\25\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\4\63\1\300\16\63\1\301\2\63\1\302"+
    "\3\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\7\63\1\303\11\63\1\304\10\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\15\63\1\305\4\63\1\306"+
    "\7\63\4\0\1\63\4\0\2\63\1\306\2\63\23\0"+
    "\2\63\7\0\1\307\31\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\7\63\1\310\22\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\16\63\1\67\13\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\32\63"+
    "\4\0\1\311\4\0\5\63\1\0\3\103\130\0\1\204"+
    "\44\0\1\204\7\0\3\105\100\0\5\106\1\0\1\106"+
    "\1\312\57\106\1\313\4\106\1\314\14\106\1\315\1\106"+
    "\1\316\24\106\32\317\1\106\1\313\2\106\1\317\1\106"+
    "\1\320\2\106\5\317\111\106\1\315\1\106\1\321\57\106"+
    "\1\313\4\106\1\322\7\106\12\113\1\0\54\113\1\323"+
    "\26\113\1\176\54\113\1\176\14\113\7\115\1\324\57\115"+
    "\1\325\3\115\1\0\1\326\16\115\1\327\24\115\32\317"+
    "\1\115\1\325\2\115\1\317\1\315\1\320\2\115\5\317"+
    "\113\115\1\321\57\115\1\325\3\115\1\315\1\330\7\115"+
    "\31\0\1\331\61\0\1\321\74\0\2\124\2\125\3\124"+
    "\1\332\57\124\1\333\4\124\1\334\11\124\2\125\3\124"+
    "\1\332\24\124\32\335\1\124\1\333\2\124\1\335\1\124"+
    "\1\334\2\124\5\335\2\124\2\125\3\124\1\336\24\124"+
    "\32\317\1\124\1\333\2\124\1\317\1\124\1\320\2\124"+
    "\5\317\2\124\2\125\102\124\2\125\3\124\1\321\57\124"+
    "\1\333\4\124\1\337\7\124\2\10\2\131\30\10\32\340"+
    "\4\10\1\340\4\10\5\340\2\0\2\341\17\0\2\342"+
    "\1\0\1\343\5\0\32\342\4\0\1\342\4\0\5\342"+
    "\2\0\2\344\17\0\2\345\1\0\1\346\5\0\32\345"+
    "\4\0\1\345\4\0\5\345\34\0\32\347\4\0\1\347"+
    "\4\0\5\347\2\0\1\136\31\0\32\347\4\0\1\347"+
    "\4\0\5\347\31\0\1\350\75\0\2\142\7\0\32\142"+
    "\4\0\1\142\4\0\5\142\34\0\32\351\4\0\1\351"+
    "\4\0\5\351\23\0\2\147\36\0\1\226\43\0\2\147"+
    "\102\0\2\63\7\0\24\63\1\272\5\63\4\0\1\63"+
    "\4\0\5\63\15\152\1\0\66\152\22\0\1\352\103\0"+
    "\1\353\61\0\1\354\3\0\11\354\1\0\66\354\33\0"+
    "\1\355\50\0\2\160\2\161\4\160\1\161\20\160\2\161"+
    "\51\160\2\0\1\356\132\0\1\357\53\0\3\167\134\0"+
    "\32\360\4\0\1\360\4\0\5\360\2\0\1\170\31\0"+
    "\32\360\4\0\1\360\4\0\5\360\23\0\2\172\7\0"+
    "\32\172\4\0\1\172\4\0\5\172\1\0\3\361\30\0"+
    "\32\362\4\0\1\362\4\0\5\362\5\175\1\176\1\175"+
    "\1\177\24\175\32\0\1\175\1\200\2\175\1\0\1\175"+
    "\1\0\2\175\5\0\111\175\1\176\1\175\1\0\57\175"+
    "\1\200\4\175\1\201\7\175\23\0\2\202\7\0\32\202"+
    "\4\0\1\202\4\0\5\202\23\0\2\202\7\0\7\202"+
    "\1\363\22\202\4\0\1\202\4\0\5\202\104\206\55\0"+
    "\1\364\72\0\1\365\5\0\1\366\25\0\1\365\55\0"+
    "\1\367\100\0\1\370\105\0\1\371\67\0\1\372\106\0"+
    "\1\373\122\0\1\374\75\0\1\375\55\0\2\223\13\0"+
    "\1\225\60\0\1\376\104\0\1\147\1\0\1\147\2\0"+
    "\2\147\102\0\2\377\7\0\6\377\71\0\1\u0100\1\204"+
    "\76\0\2\63\7\0\22\63\1\u0101\7\63\4\0\1\63"+
    "\4\0\2\63\1\u0101\2\63\23\0\2\63\7\0\3\63"+
    "\1\273\26\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\21\63\1\u0102\10\63\4\0\1\63\4\0\5\63"+
    "\27\0\1\u0103\77\0\2\63\7\0\4\63\1\u0104\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\22\63"+
    "\1\u0105\1\u0106\6\63\4\0\1\63\4\0\2\63\1\u0105"+
    "\2\63\23\0\2\63\7\0\1\u0107\15\63\1\u0108\13\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\15\63"+
    "\1\u0109\14\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\2\63\1\u010a\2\63\1\u010b\24\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\4\63\1\u010c\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\7\63"+
    "\1\u010d\22\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\22\63\1\u010e\7\63\4\0\1\63\4\0\2\63"+
    "\1\u010e\2\63\23\0\2\63\7\0\17\63\1\u010f\12\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\3\63"+
    "\1\u0110\26\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\1\u0111\31\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\10\63\1\u0112\12\63\1\u0113\6\63\4\0"+
    "\1\63\4\0\1\63\1\u0112\3\63\23\0\2\63\7\0"+
    "\13\63\1\u0114\16\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\15\63\1\u0115\14\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\21\63\1\u0116\10\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\16\63\1\u0117"+
    "\13\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\15\63\1\u0118\14\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\16\63\1\u0119\13\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\23\63\1\u011a\6\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\17\63\1\u011b"+
    "\12\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\2\63\1\u011c\17\63\1\u011d\1\u011e\6\63\4\0\1\63"+
    "\4\0\2\63\1\u011d\2\63\23\0\2\63\7\0\22\63"+
    "\1\u011f\7\63\4\0\1\63\4\0\2\63\1\u011f\2\63"+
    "\23\0\2\63\7\0\22\63\1\u0120\7\63\4\0\1\63"+
    "\4\0\2\63\1\u0120\2\63\23\0\2\63\7\0\14\63"+
    "\1\u0121\15\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\26\63\1\u0122\3\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\13\63\1\u0123\16\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\21\63\1\u0124\10\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\10\63"+
    "\1\u0125\5\63\1\u0126\13\63\4\0\1\63\4\0\1\63"+
    "\1\u0125\3\63\23\0\2\63\7\0\1\63\1\u0127\30\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\20\63"+
    "\1\u0128\2\63\1\u0129\6\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\13\63\1\u012a\16\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\1\u012b\31\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\10\63\1\u012c"+
    "\21\63\4\0\1\63\4\0\1\63\1\u012c\3\63\23\0"+
    "\2\63\7\0\21\63\1\u012d\10\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\24\63\1\u012e\3\63\1\u012f"+
    "\1\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\22\63\1\u0130\7\63\4\0\1\63\4\0\2\63\1\u0130"+
    "\2\63\23\0\2\63\7\0\4\63\1\u0131\25\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\21\63\1\u0132"+
    "\10\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\10\63\1\u0133\21\63\4\0\1\63\4\0\1\63\1\u0133"+
    "\3\63\23\0\2\63\7\0\2\63\1\u0134\1\u0135\1\63"+
    "\1\u0136\1\63\1\u0137\3\63\1\u0138\1\u0139\1\u013a\14\63"+
    "\4\0\1\63\4\0\5\63\5\106\1\315\1\106\1\316"+
    "\24\106\32\0\1\106\1\313\2\106\1\0\1\106\1\0"+
    "\2\106\5\0\5\106\1\315\1\106\1\0\57\106\1\313"+
    "\4\106\1\322\7\106\23\0\2\317\7\0\32\317\1\u013b"+
    "\3\0\1\317\4\0\5\317\12\113\1\0\54\113\1\0"+
    "\14\113\7\115\1\327\24\115\32\0\1\115\1\325\2\115"+
    "\1\0\1\315\1\0\2\115\5\0\7\115\1\0\57\115"+
    "\1\325\3\115\1\315\1\330\7\115\2\124\2\125\3\124"+
    "\1\336\24\124\32\0\1\124\1\333\2\124\1\0\1\124"+
    "\1\0\2\124\5\0\2\124\2\125\3\124\1\0\57\124"+
    "\1\333\4\124\1\337\11\124\2\u013c\3\124\1\332\13\124"+
    "\2\335\1\124\1\u013d\5\124\32\335\1\124\1\333\2\124"+
    "\1\335\1\124\1\334\2\124\5\335\2\10\2\u013e\17\10"+
    "\2\340\1\10\1\u013f\5\10\32\340\4\10\1\340\4\10"+
    "\5\340\2\0\2\341\102\0\2\344\102\0\2\u0140\17\0"+
    "\2\347\1\0\1\u0141\5\0\32\347\4\0\1\347\4\0"+
    "\5\347\23\0\2\351\7\0\32\351\4\0\1\351\4\0"+
    "\5\351\20\0\1\u0142\13\0\32\u0142\20\0\1\u0143\1\u0144"+
    "\102\0\2\u0145\17\0\2\360\1\0\1\u0146\5\0\32\360"+
    "\4\0\1\360\4\0\5\360\1\0\3\361\123\0\2\362"+
    "\7\0\32\362\4\0\1\362\4\0\5\362\23\0\2\202"+
    "\7\0\10\202\1\u0147\21\202\4\0\1\202\4\0\1\202"+
    "\1\u0147\3\202\55\0\1\u0148\77\0\1\u0149\104\0\1\u014a"+
    "\111\0\1\u014b\75\0\1\u014c\110\0\1\u014d\71\0\1\u014e"+
    "\72\0\1\u014f\124\0\1\u0150\104\0\1\u0151\22\0\1\u0151"+
    "\24\0\1\u0152\62\0\1\u0100\3\0\1\u0153\4\0\1\u0154"+
    "\21\0\32\u0155\4\0\1\u0155\4\0\5\u0155\23\0\2\63"+
    "\7\0\23\63\1\u0156\6\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\1\u0157\31\63\4\0\1\63\4\0"+
    "\5\63\27\0\1\u0100\77\0\2\63\7\0\1\u0158\31\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\4\63"+
    "\1\u0159\25\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\2\63\1\u015a\27\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\22\63\1\u015b\7\63\4\0\1\63"+
    "\4\0\2\63\1\u015b\2\63\23\0\2\63\7\0\15\63"+
    "\1\u015c\14\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\22\63\1\u015d\1\u015e\6\63\4\0\1\63\4\0"+
    "\2\63\1\u015d\2\63\23\0\2\63\7\0\13\63\1\u015f"+
    "\16\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\1\u0160\31\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\16\63\1\u0161\13\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\4\63\1\u0162\25\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\23\63\1\u0163\6\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\3\63"+
    "\1\u0164\1\63\1\u0165\2\63\1\u0166\11\63\1\u0167\3\63"+
    "\1\u0168\3\63\4\0\1\63\4\0\1\63\1\u0166\1\u0167"+
    "\2\63\23\0\2\63\7\0\13\63\1\u0169\16\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\23\63\1\u016a"+
    "\6\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\4\63\1\u016b\25\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\22\63\1\u016c\7\63\4\0\1\63\4\0"+
    "\2\63\1\u016c\2\63\23\0\2\63\7\0\1\u016d\31\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\4\63"+
    "\1\u016e\25\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\14\63\1\u016f\15\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\2\63\1\u0170\27\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\1\63\1\u0171\30\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\16\63"+
    "\1\u0172\13\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\13\63\1\u0173\16\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\13\63\1\u0174\16\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\23\63\1\u0175\6\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\4\63"+
    "\1\u0176\25\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\4\63\1\u0177\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\23\63\1\u0178\6\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\4\63\1\u0179\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\13\63"+
    "\1\u017a\16\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\4\63\1\u017b\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\15\63\1\u017c\7\63\1\u017d\4\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\23\63"+
    "\1\u017e\6\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\13\63\1\u017f\16\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\24\63\1\u0180\5\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\24\63\1\u0181\5\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\5\63"+
    "\1\u0182\24\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\23\63\1\u0183\6\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\23\63\1\u0184\6\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\16\63\1\u0185\13\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\4\63"+
    "\1\u0186\25\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\4\63\1\u0187\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\13\63\1\u0188\16\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\13\63\1\u0189\16\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\10\63"+
    "\1\u018a\21\63\4\0\1\63\4\0\1\63\1\u018a\3\63"+
    "\23\0\2\63\7\0\10\63\1\u018b\13\63\1\u018c\5\63"+
    "\4\0\1\63\4\0\1\63\1\u018b\3\63\23\0\2\63"+
    "\7\0\1\u018d\31\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\10\63\1\u018e\21\63\4\0\1\63\4\0"+
    "\1\63\1\u018e\3\63\23\0\2\63\7\0\4\63\1\u018f"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\1\u0190\31\63\4\0\1\63\4\0\5\63\2\124\2\u013c"+
    "\3\124\1\332\57\124\1\333\4\124\1\334\7\124\2\10"+
    "\2\u013e\100\10\2\0\2\u0140\120\0\1\u0142\13\0\32\u0142"+
    "\10\0\1\u0191\7\0\1\u0143\103\0\2\u0145\123\0\2\202"+
    "\7\0\22\202\1\u0192\7\202\4\0\1\202\4\0\2\202"+
    "\1\u0192\2\202\34\0\1\u0193\103\0\1\u0194\116\0\1\u0195"+
    "\71\0\1\u0196\102\0\1\u0197\50\0\1\u0198\12\0\1\u0199"+
    "\23\0\1\u019a\103\0\1\u019b\112\0\1\u0198\100\0\1\u019c"+
    "\33\0\1\u019c\43\0\1\u0197\77\0\32\u019d\4\0\1\u019d"+
    "\4\0\5\u019d\34\0\32\u019e\4\0\1\u019e\4\0\5\u019e"+
    "\2\0\1\u019f\1\u01a0\17\0\2\u0155\7\0\32\u0155\4\0"+
    "\1\u0155\4\0\5\u0155\23\0\2\63\7\0\21\63\1\u01a1"+
    "\10\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\30\63\1\u01a2\1\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\12\63\1\u01a3\17\63\4\0\1\63\4\0"+
    "\3\63\1\u01a3\1\63\23\0\2\63\7\0\7\63\1\u01a4"+
    "\22\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\22\63\1\u01a5\7\63\4\0\1\63\4\0\2\63\1\u01a5"+
    "\2\63\23\0\2\63\7\0\4\63\1\u01a6\25\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\23\63\1\u01a7"+
    "\6\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\10\63\1\u01a8\21\63\4\0\1\63\4\0\1\63\1\u01a8"+
    "\3\63\23\0\2\63\7\0\1\u01a9\31\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\24\63\1\u01aa\5\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\10\63"+
    "\1\u01ab\21\63\4\0\1\63\4\0\1\63\1\u01ab\3\63"+
    "\23\0\2\63\7\0\30\63\1\u01ac\1\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\4\63\1\u01ad\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\16\63"+
    "\1\u01ae\13\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\5\63\1\u01af\24\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\26\63\1\u01b0\3\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\7\63\1\u01b1\22\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\15\63"+
    "\1\u01b2\14\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\4\63\1\u01b3\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\13\63\1\u01b4\16\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\1\u01b5\31\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\23\63\1\u01b6"+
    "\6\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\1\u01b7\31\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\4\63\1\u01b8\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\24\63\1\u01b9\5\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\1\u01ba\31\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\21\63\1\u01bb"+
    "\10\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\23\63\1\u01bc\6\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\22\63\1\u01bd\7\63\4\0\1\63\4\0"+
    "\2\63\1\u01bd\2\63\23\0\2\63\7\0\15\63\1\u01be"+
    "\14\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\23\63\1\u01bf\6\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\1\u01c0\31\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\4\63\1\u01c1\25\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\10\63\1\u01c2\21\63"+
    "\4\0\1\63\4\0\1\63\1\u01c2\3\63\23\0\2\63"+
    "\7\0\10\63\1\u01c3\21\63\4\0\1\63\4\0\1\63"+
    "\1\u01c3\3\63\23\0\2\63\7\0\21\63\1\u01c4\10\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\10\63"+
    "\1\u01c5\21\63\4\0\1\63\4\0\1\63\1\u01c5\3\63"+
    "\23\0\2\63\7\0\2\63\1\u01c6\27\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\26\63\1\u01c7\3\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\23\63"+
    "\1\u01c8\6\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\4\63\1\u01c9\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\1\u01ca\31\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\21\63\1\u01cb\10\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\13\63\1\u01cc"+
    "\16\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\15\63\1\u01cd\14\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\13\63\1\u01ce\16\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\15\63\1\u01cf\14\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\23\63\1\u01d0"+
    "\6\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\14\63\1\u01d1\15\63\4\0\1\63\4\0\5\63\64\0"+
    "\1\u0198\74\0\1\u0193\27\0\1\u0198\12\0\1\u0199\23\0"+
    "\1\u01d2\112\0\1\u01d3\113\0\1\u0198\25\0\1\u0198\12\0"+
    "\1\u0199\131\0\1\u01d4\77\0\1\u0197\116\0\1\u01d5\37\0"+
    "\1\u01d6\15\0\2\u019d\7\0\32\u019d\4\0\1\u019d\4\0"+
    "\5\u019d\12\0\1\u01d6\10\0\2\u019e\7\0\32\u019e\4\0"+
    "\1\u019e\4\0\5\u019e\2\0\1\u019f\124\0\2\63\7\0"+
    "\1\u01d7\31\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\15\63\1\u01d8\14\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\21\63\1\u01d9\10\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\13\63\1\u01da\16\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\5\63"+
    "\1\u01db\24\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\2\63\1\u01dc\27\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\21\63\1\u01dd\10\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\10\63\1\u01de\21\63"+
    "\4\0\1\63\4\0\1\63\1\u01de\3\63\23\0\2\63"+
    "\7\0\10\63\1\u01df\21\63\4\0\1\63\4\0\1\63"+
    "\1\u01df\3\63\23\0\2\63\7\0\3\63\1\u01e0\26\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\2\63"+
    "\1\u01e1\27\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\10\63\1\u01e2\21\63\4\0\1\63\4\0\1\63"+
    "\1\u01e2\3\63\23\0\2\63\7\0\13\63\1\u01e3\16\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\14\63"+
    "\1\u01e4\15\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\3\63\1\u01e5\26\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\15\63\1\u01e6\14\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\5\63\1\u01e7\24\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\17\63"+
    "\1\u01e8\12\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\23\63\1\u01e9\6\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\23\63\1\u01ea\6\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\2\63\1\u01eb\27\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\2\63"+
    "\1\u01ec\27\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\21\63\1\u01ed\10\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\15\63\1\u01ee\14\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\2\63\1\u01ef\27\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\7\63"+
    "\1\u01f0\22\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\22\63\1\u01f1\7\63\4\0\1\63\4\0\2\63"+
    "\1\u01f1\2\63\23\0\2\63\7\0\32\63\4\0\1\u01f2"+
    "\4\0\5\63\23\0\2\63\7\0\4\63\1\u01f3\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\2\63"+
    "\1\u01f4\27\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\23\63\1\u01f5\6\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\4\63\1\u01f6\25\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\7\63\1\u01f7\22\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\4\63"+
    "\1\u01f8\25\63\4\0\1\63\4\0\5\63\34\0\1\u01f9"+
    "\107\0\1\u0198\103\0\1\u01fa\105\0\1\u0198\43\0\1\u019f"+
    "\1\u01a0\123\0\2\63\7\0\2\63\1\u01fb\27\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\24\63\1\u01fc"+
    "\5\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\4\63\1\u01fd\25\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\23\63\1\u01fe\6\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\13\63\1\u01ff\16\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\4\63\1\u0200"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\23\63\1\u0201\6\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\13\63\1\u0202\16\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\22\63\1\u0203\7\63\4\0"+
    "\1\63\4\0\2\63\1\u0203\2\63\23\0\2\63\7\0"+
    "\7\63\1\u0204\22\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\16\63\1\u0205\13\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\4\63\1\u0206\25\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\4\63\1\u0207"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\2\63\1\u0208\27\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\1\u0209\31\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\1\u020a\31\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\4\63\1\u020b\25\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\23\63\1\u020c"+
    "\6\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\4\63\1\u020d\25\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\22\63\1\u020e\7\63\4\0\1\63\4\0"+
    "\2\63\1\u020e\2\63\23\0\2\63\7\0\32\63\4\0"+
    "\1\u020f\4\0\5\63\23\0\2\63\7\0\32\63\4\0"+
    "\1\u0210\4\0\5\63\23\0\2\63\7\0\23\63\1\u0211"+
    "\6\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\32\63\4\0\1\u0212\4\0\5\63\23\0\2\63\7\0"+
    "\32\63\4\0\1\u0213\4\0\5\63\23\0\2\63\7\0"+
    "\16\63\1\u0214\13\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\22\63\1\u0215\7\63\4\0\1\63\4\0"+
    "\2\63\1\u0215\2\63\51\0\1\u0198\107\0\1\u0198\51\0"+
    "\2\63\7\0\23\63\1\u0216\6\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\4\63\1\u0217\25\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\1\u0218\31\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\1\u0219"+
    "\31\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\2\63\1\u021a\27\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\4\63\1\u021b\25\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\15\63\1\u021c\14\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\15\63\1\u021d"+
    "\14\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\32\63\4\0\1\u021e\4\0\5\63\23\0\2\63\7\0"+
    "\4\63\1\u021f\25\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\2\63\1\u0220\27\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\2\63\1\u0221\27\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\4\63\1\u0222"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\32\63\4\0\1\u0223\4\0\5\63\23\0\2\63\7\0"+
    "\32\63\4\0\1\u0224\4\0\5\63\23\0\2\63\7\0"+
    "\32\63\4\0\1\u0225\4\0\5\63\23\0\2\63\7\0"+
    "\10\63\1\u0226\21\63\4\0\1\63\4\0\1\63\1\u0226"+
    "\3\63\23\0\2\63\7\0\2\63\1\u0227\27\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\32\63\4\0"+
    "\1\u0228\4\0\5\63\23\0\2\63\7\0\3\63\1\u0229"+
    "\26\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\17\63\1\u022a\12\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\21\63\1\u022b\10\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\2\63\1\u022c\27\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\7\63\1\u022d"+
    "\22\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\23\63\1\u022e\6\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\16\63\1\u022f\13\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\16\63\1\u0230\13\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\4\63\1\u0231"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\4\63\1\u0232\25\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\3\63\1\u0233\26\63\4\0\1\63\4\0"+
    "\5\63\23\0\2\63\7\0\16\63\1\u0234\13\63\4\0"+
    "\1\63\4\0\5\63\23\0\2\63\7\0\32\63\4\0"+
    "\1\u0235\4\0\5\63\23\0\2\63\7\0\16\63\1\u0236"+
    "\13\63\4\0\1\63\4\0\5\63\23\0\2\63\7\0"+
    "\16\63\1\u0237\13\63\4\0\1\63\4\0\5\63\23\0"+
    "\2\63\7\0\32\63\4\0\1\u0238\4\0\5\63\23\0"+
    "\2\63\7\0\1\u0239\31\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\4\63\1\u023a\25\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\7\63\1\u023b\22\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\22\63"+
    "\1\u023c\7\63\4\0\1\63\4\0\2\63\1\u023c\2\63"+
    "\23\0\2\63\7\0\15\63\1\u023d\14\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\5\63\1\u023e\24\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\15\63"+
    "\1\u023f\14\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\15\63\1\u0240\14\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\14\63\1\u0241\15\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\32\63\4\0\1\u0242"+
    "\4\0\5\63\23\0\2\63\7\0\2\63\1\u0243\27\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\2\63"+
    "\1\u0244\27\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\2\63\1\u0245\27\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\32\63\4\0\1\u0246\4\0\5\63"+
    "\23\0\2\63\7\0\17\63\1\u0247\12\63\4\0\1\63"+
    "\4\0\5\63\23\0\2\63\7\0\4\63\1\u0248\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\2\63\7\0\4\63"+
    "\1\u0249\25\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\4\63\1\u024a\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\32\63\4\0\1\u024b\4\0\5\63"+
    "\23\0\2\63\7\0\10\63\1\u024c\21\63\4\0\1\63"+
    "\4\0\1\63\1\u024c\3\63\23\0\2\63\7\0\32\63"+
    "\4\0\1\u024d\4\0\5\63\23\0\2\63\7\0\13\63"+
    "\1\u024e\16\63\4\0\1\63\4\0\5\63\23\0\2\63"+
    "\7\0\32\63\4\0\1\u024f\4\0\5\63\23\0\2\63"+
    "\7\0\4\63\1\u0250\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\2\63\7\0\21\63\1\u0251\10\63\4\0\1\63"+
    "\4\0\5\63";

  private static int [] zzUnpackTrans() {
    int [] result = new int[31416];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\1\10\5\0\2\1\13\0\1\11\3\1\1\11\5\1"+
    "\1\11\10\1\1\11\30\1\1\11\1\1\1\11\4\1"+
    "\1\11\11\1\1\11\10\1\1\11\1\1\1\11\1\1"+
    "\1\0\1\1\1\11\2\1\2\11\4\1\1\11\2\1"+
    "\1\11\4\1\1\11\2\1\1\11\1\1\1\11\1\1"+
    "\1\0\4\1\1\0\1\11\3\0\2\1\2\11\14\0"+
    "\1\11\3\1\1\0\1\11\1\1\1\11\4\1\1\0"+
    "\53\1\3\0\1\11\2\1\2\11\1\1\4\0\2\1"+
    "\1\11\3\0\4\1\1\11\2\0\1\11\3\0\1\11"+
    "\1\1\2\11\1\1\1\0\1\11\1\1\1\0\3\1"+
    "\12\0\2\1\1\0\2\1\1\0\67\1\2\11\1\1"+
    "\1\11\1\1\1\11\2\0\1\11\1\1\1\11\1\0"+
    "\1\1\12\0\1\11\3\0\73\1\1\11\1\1\6\0"+
    "\1\11\5\0\1\11\62\1\5\0\42\1\2\0\127\1";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[593];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  @SuppressWarnings("unused")
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  @SuppressWarnings("unused")
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  @SuppressWarnings("unused")
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	public PHPLexer(int state) {
		initialize(state);
	}

	// NB: this method resets the lexer only partially
	@Override
	protected void reset(java.io.Reader reader, char[] buffer, int[] parameters) {
		this.zzReader = reader;
		this.zzBuffer = buffer;
		this.zzFinalHighSurrogate = 0;
		this.zzMarkedPos = parameters[0];
		this._zzPushbackPos = parameters[1];
		this.zzCurrentPos = parameters[2];
		this.zzStartRead = parameters[3];
		this.zzEndRead = parameters[4];
		this.yyline = parameters[5];
		initialize(parameters[6]);
	}

	@Override
	public int getInScriptingState() {
		return ST_PHP_IN_SCRIPTING;
	}

	private static final int[] heredocStates = new int[] { ST_PHP_HEREDOC, ST_PHP_NOWDOC, ST_PHP_START_HEREDOC, ST_PHP_START_NOWDOC, ST_PHP_END_HEREDOC, ST_PHP_END_NOWDOC };

	@Override
	public int[] getHeredocStates() {
		return heredocStates;
	}

	private static final int[] phpQuotesStates = new int[] { ST_PHP_DOUBLE_QUOTES, ST_PHP_SINGLE_QUOTE, ST_PHP_BACKQUOTE, ST_PHP_HEREDOC, ST_PHP_NOWDOC, ST_PHP_START_HEREDOC, ST_PHP_START_NOWDOC, ST_PHP_END_HEREDOC, ST_PHP_END_NOWDOC };

	@Override
	public int[] getPHPQuotesStates() {
		return phpQuotesStates;
	}

	@Override
	public int[] getParameters() {
		return new int[]{zzMarkedPos, _zzPushbackPos, zzCurrentPos, zzStartRead, zzEndRead, yyline, zzLexicalState};
	}

	@Override
	protected int getZZLexicalState() {
		return zzLexicalState;
	}

	@Override
	protected int getZZMarkedPos() {
		return zzMarkedPos;
	}

	@Override
	protected int getZZEndRead() {
		return zzEndRead;
	}

	@Override
	public char[] getZZBuffer() {
		return zzBuffer;
	}

	@Override
	protected int getZZStartRead() {
		return this.zzStartRead;
	}

	@Override
	protected int getZZPushBackPosition() {
		return this._zzPushbackPos;
	}

	@Override
	protected void pushBack(int i) {
		yypushback(i);
	}

	@Override
	public int getScriptingState() {
		return ST_PHP_IN_SCRIPTING;
	}

	// A pool of states. To avoid creation of a new state on each createMemento.
	private static final Map<LexerState, LexerState> lexerStates = new HashMap<>();

	@Override
	protected Map<LexerState, LexerState> getLexerStates() {
		return lexerStates;
	}

	// End user code


  /** the textposition at the last state to be included in yytext */
  private int _zzPushbackPos;

  /* The following fields are added in order to support the change in zzRefill */
  private String oldString = null;
  private boolean useOldString = false;
  private int startPos = 0;

  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public PHPLexer(java.io.Reader in) {
    this.zzReader = in;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    if (useOldString) {
      String saveOldString = oldString;
      oldString = new String(zzBuffer, startPos, zzMarkedPos - startPos);
      if (saveOldString != null) {
        oldString = saveOldString + oldString;
      }
    }

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      _zzPushbackPos-= zzStartRead;
      startPos = 0;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate) {
      /* if not: blow it up */
      char newBuffer[] = new char[zzBuffer.length * 2];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      throw new java.io.IOException(
          "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Gets the next input character.
   *
   * @return      the next character of the input stream, EOF if the
   *              end of the stream is reached.
   * @exception   IOException  if any I/O-Error occurs
   */
  private int yy_advance() throws java.io.IOException {

    /* standard case */
    if (zzCurrentPos < zzEndRead) return zzBuffer[zzCurrentPos++];

    /* if the eof is reached, we don't need to work hard */
    if (zzAtEOF) return YYEOF;

    /* otherwise: need to refill the buffer */

    String saveOldString = oldString;
    oldString = null;

    /* first: make room (if you can) */
    if (zzRefill()) {
      oldString = saveOldString;
      return YYEOF;
    }

    oldString = saveOldString;

    return zzBuffer[zzCurrentPos++];
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    if (zzBuffer.length > ZZ_BUFFERSIZE) {
      zzBuffer = new char[ZZ_BUFFERSIZE];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      _zzPushbackPos = 0;
      startPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      oldString = null;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }


	/**
	 * user method - common.sse
	 */
	private void updateStartPos() {
		updateStartPos(zzMarkedPos);
	}


	/**
	 * user method - common.sse
	 */
	private void updateStartPos(int position) {
		startPos = position;
		oldString = null;
	}


	/**
	 * user method - common.sse
	 */
	public final boolean isEOF() {
		return zzAtEOF;
	}




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public String yylex() throws java.io.IOException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return null;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { return PHP_ENCAPSED_AND_WHITESPACE;
            }
            // fall through
          case 138: break;
          case 2:
            { return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 139: break;
          case 3:
            { yypushback(1);
	pushState(ST_PHP_HIGHLIGHTING_ERROR);
            }
            // fall through
          case 140: break;
          case 4:
            { return WHITESPACE;
            }
            // fall through
          case 141: break;
          case 5:
            { return PHP_TOKEN;
            }
            // fall through
          case 142: break;
          case 6:
            { pushState(ST_PHP_DOUBLE_QUOTES);
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 143: break;
          case 7:
            { pushState(ST_PHP_LINE_COMMENT);
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 144: break;
          case 8:
            { pushState(ST_PHP_SINGLE_QUOTE);
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 145: break;
          case 9:
            { return PHP_NUMBER;
            }
            // fall through
          case 146: break;
          case 10:
            { return PHP_SEMICOLON;
            }
            // fall through
          case 147: break;
          case 11:
            { return PHP_LABEL;
            }
            // fall through
          case 148: break;
          case 12:
            { return PHP_NS_SEPARATOR;
            }
            // fall through
          case 149: break;
          case 13:
            { pushState(ST_PHP_BACKQUOTE);
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 150: break;
          case 14:
            { // Whitespaces are directly appended to the curly before pushState()
	// is effective or whitespaces would be stored in a separate ContextRegion.
	// Method PhpTokenContainer#addLast() will correct the curlies length...
	if (!phpStack.isEmpty()) {
		// Only push the state when stack is not empty, it's useless otherwise
		// (and it pollutes the stack).
		pushState(ST_PHP_IN_SCRIPTING);
	}
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 151: break;
          case 15:
            { // Whitespaces are directly appended to the curly before pushState()
	// is effective or whitespaces would be stored in a separate ContextRegion.
	// Method PhpTokenContainer#addLast() will correct the curlies length...
	if (!phpStack.isEmpty()) {
		popState();
		// If new state is not ST_PHP_IN_SCRIPTING then some blanks are signifiant (like newlines
		// after the closing curly and before an ending heredoc tag), so don't append them...
		// See rule <ST_PHP_HEREDOC>{HEREDOC_CHARS}*({HEREDOC_NEWLINE}+({LABEL}";"?)?)?
		if (getZZLexicalState() != ST_PHP_IN_SCRIPTING) {
			yypushback(yylength() - 1);
		}
	}
	return PHP_CURLY_CLOSE;
            }
            // fall through
          case 152: break;
          case 16:
            { popState();
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 153: break;
          case 17:
            { yypushback(1);
		popState();
            }
            // fall through
          case 154: break;
          case 18:
            { yypushback(1);
	yybegin(ST_PHP_HEREDOC);
            }
            // fall through
          case 155: break;
          case 19:
            { yypushback(1);
	yybegin(ST_PHP_NOWDOC);
            }
            // fall through
          case 156: break;
          case 20:
            { yypushback(1);
	popState();
            }
            // fall through
          case 157: break;
          case 21:
            { popState();
	return PHP_LABEL;
            }
            // fall through
          case 158: break;
          case 22:
            { yypushback(1);
	popState();
	return PHP_ENCAPSED_AND_WHITESPACE;
            }
            // fall through
          case 159: break;
          case 23:
            { //the difference from the original rules comes from the fact that we took ';' out of tokens
	return UNKNOWN_TOKEN;
            }
            // fall through
          case 160: break;
          case 24:
            { popState();
	return PHP_TOKEN;
            }
            // fall through
          case 161: break;
          case 25:
            { return PHP_COMMENT;
            }
            // fall through
          case 162: break;
          case 26:
            { return PHPDOC_COMMENT;
            }
            // fall through
          case 163: break;
          case 27:
            { String yytext = yytext();
	switch (yytext.charAt(yytext.length() - 1)) {
		case '?':
		case '%':
		case '>':
			yypushback(1);
			if (yylength() > 0) {
				return PHP_LINE_COMMENT;
			}
			break;
		default:
			popState();
			return PHP_LINE_COMMENT;
	}
            }
            // fall through
          case 164: break;
          case 28:
            { return PHP_LINE_COMMENT;
            }
            // fall through
          case 165: break;
          case 29:
            { return UNKNOWN_TOKEN;
            }
            // fall through
          case 166: break;
          case 30:
            { popState();return WHITESPACE;
            }
            // fall through
          case 167: break;
          case 31:
            { yybegin(ST_PHP_IN_SCRIPTING);
	return PHP_ENCAPSED_VARIABLE;
            }
            // fall through
          case 168: break;
          case 32:
            { yybegin(ST_PHP_IN_SCRIPTING);
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 169: break;
          case 33:
            { return PHP_OPERATOR;
            }
            // fall through
          case 170: break;
          case 34:
            { return PHP_VARIABLE;
            }
            // fall through
          case 171: break;
          case 35:
            { if (asp_tags) {
		return PHP_CLOSETAG;
	}
	return UNKNOWN_TOKEN;
            }
            // fall through
          case 172: break;
          case 36:
            { pushState(ST_PHP_LOOKING_FOR_PROPERTY);
	return PHP_OBJECT_OPERATOR;
            }
            // fall through
          case 173: break;
          case 37:
            { pushState(ST_PHP_COMMENT);
	return PHP_COMMENT_START;
            }
            // fall through
          case 174: break;
          case 38:
            { return PHP_PAAMAYIM_NEKUDOTAYIM;
            }
            // fall through
          case 175: break;
          case 39:
            { return PHP_CLOSETAG;
            }
            // fall through
          case 176: break;
          case 40:
            { return PHP_AS;
            }
            // fall through
          case 177: break;
          case 41:
            { return PHP_DO;
            }
            // fall through
          case 178: break;
          case 42:
            { return PHP_IF;
            }
            // fall through
          case 179: break;
          case 43:
            { yypushback(1);
	return PHP_ENCAPSED_AND_WHITESPACE;
            }
            // fall through
          case 180: break;
          case 44:
            { pushState(ST_PHP_QUOTES_AFTER_VARIABLE);
	return PHP_VARIABLE;
            }
            // fall through
          case 181: break;
          case 45:
            { // We can have nested curlies after applying this rule,
	// so we have to count all curlies...
	yypushback(1);
	pushState(ST_PHP_DOLLAR_CURLY_OPEN);
	return PHP_TOKEN;
            }
            // fall through
          case 182: break;
          case 46:
            { // We can have nested curlies after applying rule below for "${",
	// so we have to count all curlies...
	yypushback(1);
	pushState(ST_PHP_IN_SCRIPTING);
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 183: break;
          case 47:
            { popState();
	pushState(ST_PHP_LOOKING_FOR_PROPERTY);
	return PHP_OBJECT_OPERATOR;
            }
            // fall through
          case 184: break;
          case 48:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}

	String heredoc = getHeredocId();
	int heredoc_len = heredoc.length();
	if (label_len == heredoc_len && yytext.substring(0, label_len).equals(heredoc)) {
		// we must (at least) push the newline character back
		yypushback(1);
		popHeredocId();
		popState();
		return PHP_HEREDOC_CLOSE_TAG;
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
		return PHP_ENCAPSED_AND_WHITESPACE;
	}
            }
            // fall through
          case 185: break;
          case 49:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}

	String nowdoc = getHeredocId();
	int nowdoc_len = nowdoc.length();
	if (label_len == nowdoc_len && yytext.substring(0, label_len).equals(nowdoc)) {
		// we must (at least) push the newline character back
		yypushback(1);
		popHeredocId();
		popState();
		return PHP_NOWDOC_CLOSE_TAG;
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
		return PHP_CONSTANT_ENCAPSED_STRING;
	}
            }
            // fall through
          case 186: break;
          case 50:
            { return PHP_OBJECT_OPERATOR;
            }
            // fall through
          case 187: break;
          case 51:
            { popState();
	return PHP_COMMENT_END;
            }
            // fall through
          case 188: break;
          case 52:
            { popState();
	return PHPDOC_COMMENT_END;
            }
            // fall through
          case 189: break;
          case 53:
            { TagKind tagkind = TagKind.getTagKindFromValue(yytext());
		if (tagkind != null && tagkind != TagKind.UNKNOWN
			&& /* ignore @todo tag */ tagkind != TagKind.TODO) {
				return PHPDOC_GENERIC_TAG;
		}
		return PHPDOC_COMMENT;
            }
            // fall through
          case 190: break;
          case 54:
            { popState();
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 191: break;
          case 55:
            { if (asp_tags) {
		return PHP_CLOSETAG;
	}
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 192: break;
          case 56:
            { yypushback(yylength() - 1);
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 193: break;
          case 57:
            { pushState(ST_PHP_DOC_COMMENT);
	return PHPDOC_COMMENT_START;
            }
            // fall through
          case 194: break;
          case 58:
            { return PHP_DIE;
            }
            // fall through
          case 195: break;
          case 59:
            { return PHP_FOR;
            }
            // fall through
          case 196: break;
          case 60:
            { return PHP_NEW;
            }
            // fall through
          case 197: break;
          case 61:
            { return PHP_TRY;
            }
            // fall through
          case 198: break;
          case 62:
            { return PHP_USE;
            }
            // fall through
          case 199: break;
          case 63:
            { return PHP_VAR;
            }
            // fall through
          case 200: break;
          case 64:
            { yypushback(1);
	pushState(ST_PHP_VAR_OFFSET);
	return PHP_VARIABLE;
            }
            // fall through
          case 201: break;
          case 65:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}
	String heredoc = getHeredocId();
	int heredoc_len = heredoc.length();
	int startIndex = label_len - heredoc_len;
	if (startIndex > 0 && yytext.substring(startIndex, label_len).equals(heredoc)
		&& (yytext.charAt(startIndex - 1) == '\n' || yytext.charAt(startIndex - 1) == '\r')) {

		if (startIndex - 2 >= 0
			&& yytext.charAt(startIndex - 2) == '\r'
			&& yytext.charAt(startIndex - 1) == '\n') {
			startIndex-= 2;
		} else {
			startIndex--;
		}
		yypushback(yylength() - startIndex);

		yybegin(ST_PHP_END_HEREDOC);
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
	}
	// In some cases, all text is pushed back (using yypushback()),
	// especially when the parsed document has Windows newlines.
	// In those cases, ignore this rule and try next one...
	if (yylength() > 0) {
		return PHP_ENCAPSED_AND_WHITESPACE;
	}
            }
            // fall through
          case 202: break;
          case 66:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}
	String nowdoc = getHeredocId();
	int nowdoc_len = nowdoc.length();
	int startIndex = label_len - nowdoc_len;
	if (startIndex > 0 && yytext.substring(startIndex, label_len).equals(nowdoc)
		&& (yytext.charAt(startIndex - 1) == '\n' || yytext.charAt(startIndex - 1) == '\r')) {

		if (startIndex - 2 >= 0
			&& yytext.charAt(startIndex - 2) == '\r'
			&& yytext.charAt(startIndex - 1) == '\n') {
			startIndex-= 2;
		} else {
			startIndex--;
		}
		yypushback(yylength() - startIndex);

		yybegin(ST_PHP_END_NOWDOC);
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
	}
	// In some cases, all text is pushed back (using yypushback()),
	// especially when the parsed document has Windows newlines.
	// In those cases, ignore this rule and try next one...
	if (yylength() > 0) {
		return PHP_CONSTANT_ENCAPSED_STRING;
	}
            }
            // fall through
          case 203: break;
          case 67:
            { // we must (at least) push the newline character back
	yypushback(1);
	popHeredocId();
	popState();
	return PHP_HEREDOC_CLOSE_TAG;
            }
            // fall through
          case 204: break;
          case 68:
            { yypushback(yylength() - 2);
	if (asp_tags) {
		return PHP_CLOSETAG;
	}
	popState();
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 205: break;
          case 69:
            { // we must (at least) push the newline character back
	yypushback(1);
	popHeredocId();
	popState();
	return PHP_NOWDOC_CLOSE_TAG;
            }
            // fall through
          case 206: break;
          case 70:
            { yypushback(2);
	pushState(ST_PHP_COMMENT);
	return PHP_COMMENT_START;
            }
            // fall through
          case 207: break;
          case 71:
            { return PHP_CASE;
            }
            // fall through
          case 208: break;
          case 72:
            { return PHP_ECHO;
            }
            // fall through
          case 209: break;
          case 73:
            { return PHP_ELSE;
            }
            // fall through
          case 210: break;
          case 74:
            { return PHP_EVAL;
            }
            // fall through
          case 211: break;
          case 75:
            { return PHP_EXIT;
            }
            // fall through
          case 212: break;
          case 76:
            { return PHP_FROM;
            }
            // fall through
          case 213: break;
          case 77:
            { return PHP_GOTO;
            }
            // fall through
          case 214: break;
          case 78:
            { return PHP_LIST;
            }
            // fall through
          case 215: break;
          case 79:
            { return PHP_KEYWORD;
            }
            // fall through
          case 216: break;
          case 80:
            { return PHP_SELF;
            }
            // fall through
          case 217: break;
          case 81:
            { return PHP_TRUE;
            }
            // fall through
          case 218: break;
          case 82:
            { TagKind tagkind = TagKind.getTagKindFromValue(yytext());
		if (tagkind != null && tagkind != TagKind.UNKNOWN) {
			return PHPDOC_GENERIC_TAG;
		}
		return PHPDOC_COMMENT;
            }
            // fall through
          case 219: break;
          case 83:
            { return PHP_THIS;
            }
            // fall through
          case 220: break;
          case 84:
            { return PHP_CASTING;
            }
            // fall through
          case 221: break;
          case 85:
            { String yytext = yytext();
	int bprefix = (yytext.charAt(0) != '<') ? 1 : 0;
	int startString = 3 + bprefix;

	int hereOrNowDoc_len = yylength() - bprefix - 3 - 1 - (yytext.charAt(yylength() - 2) == '\r' ? 1 : 0);
	while ((yytext.charAt(startString) == ' ') || (yytext.charAt(startString) == '\t')) {
		startString++;
		hereOrNowDoc_len--;
	}
	String hereOrNowDoc = yytext.substring(startString, hereOrNowDoc_len + startString);
	if (hereOrNowDoc.charAt(0) == '\'') {
		pushHeredocId(hereOrNowDoc.substring(1, hereOrNowDoc_len - 1));
		pushState(ST_PHP_START_NOWDOC);
		return PHP_NOWDOC_START_TAG;
	} else if (hereOrNowDoc.charAt(0) == '"') {
		pushHeredocId(hereOrNowDoc.substring(1, hereOrNowDoc_len - 1));
		pushState(ST_PHP_START_HEREDOC);
		return PHP_HEREDOC_START_TAG;
	} else {
		pushHeredocId(hereOrNowDoc);
		pushState(ST_PHP_START_HEREDOC);
		return PHP_HEREDOC_START_TAG;
	}
            }
            // fall through
          case 222: break;
          case 86:
            { return PHP_ARRAY;
            }
            // fall through
          case 223: break;
          case 87:
            { return PHP_BREAK;
            }
            // fall through
          case 224: break;
          case 88:
            { return PHP_CATCH;
            }
            // fall through
          case 225: break;
          case 89:
            { return PHP_CLASS;
            }
            // fall through
          case 226: break;
          case 90:
            { return PHP_CLONE;
            }
            // fall through
          case 227: break;
          case 91:
            { return PHP_CONST;
            }
            // fall through
          case 228: break;
          case 92:
            { return PHP_EMPTY;
            }
            // fall through
          case 229: break;
          case 93:
            { return PHP_ENDIF;
            }
            // fall through
          case 230: break;
          case 94:
            { return PHP_FALSE;
            }
            // fall through
          case 231: break;
          case 95:
            { return PHP_FINAL;
            }
            // fall through
          case 232: break;
          case 96:
            { return PHP_ISSET;
            }
            // fall through
          case 233: break;
          case 97:
            { return PHP_PRINT;
            }
            // fall through
          case 234: break;
          case 98:
            { return PHP_THROW;
            }
            // fall through
          case 235: break;
          case 99:
            { return PHP_UNSET;
            }
            // fall through
          case 236: break;
          case 100:
            { return PHP_WHILE;
            }
            // fall through
          case 237: break;
          case 101:
            { return PHP_ELSEIF;
            }
            // fall through
          case 238: break;
          case 102:
            { return PHP_ENDFOR;
            }
            // fall through
          case 239: break;
          case 103:
            { return PHP_GLOBAL;
            }
            // fall through
          case 240: break;
          case 104:
            { return PHP_PARENT;
            }
            // fall through
          case 241: break;
          case 105:
            { return PHP_PUBLIC;
            }
            // fall through
          case 242: break;
          case 106:
            { return PHP_RETURN;
            }
            // fall through
          case 243: break;
          case 107:
            { return PHP_STATIC;
            }
            // fall through
          case 244: break;
          case 108:
            { return PHP_SWITCH;
            }
            // fall through
          case 245: break;
          case 109:
            { return PHP_DECLARE;
            }
            // fall through
          case 246: break;
          case 110:
            { return PHP_DEFAULT;
            }
            // fall through
          case 247: break;
          case 111:
            { return PHP_EXTENDS;
            }
            // fall through
          case 248: break;
          case 112:
            { return PHP_FOREACH;
            }
            // fall through
          case 249: break;
          case 113:
            { return PHP_INCLUDE;
            }
            // fall through
          case 250: break;
          case 114:
            { return PHP_PRIVATE;
            }
            // fall through
          case 251: break;
          case 115:
            { return PHP_REQUIRE;
            }
            // fall through
          case 252: break;
          case 116:
            { return PHP__DIR__;
            }
            // fall through
          case 253: break;
          case 117:
            { return PHP_ABSTRACT;
            }
            // fall through
          case 254: break;
          case 118:
            { return PHP_CONTINUE;
            }
            // fall through
          case 255: break;
          case 119:
            { return PHP_ENDWHILE;
            }
            // fall through
          case 256: break;
          case 120:
            { return PHP_FUNCTION;
            }
            // fall through
          case 257: break;
          case 121:
            { return PHP__FILE__;
            }
            // fall through
          case 258: break;
          case 122:
            { return PHP__LINE__;
            }
            // fall through
          case 259: break;
          case 123:
            { return PHP_ENDSWITCH;
            }
            // fall through
          case 260: break;
          case 124:
            { return PHP_INTERFACE;
            }
            // fall through
          case 261: break;
          case 125:
            { return PHP_NAMESPACE;
            }
            // fall through
          case 262: break;
          case 126:
            { return PHP_PROTECTED;
            }
            // fall through
          case 263: break;
          case 127:
            { return PHP__CLASS__;
            }
            // fall through
          case 264: break;
          case 128:
            { return PHP_ENDDECLARE;
            }
            // fall through
          case 265: break;
          case 129:
            { return PHP_ENDFOREACH;
            }
            // fall through
          case 266: break;
          case 130:
            { return PHP_IMPLEMENTS;
            }
            // fall through
          case 267: break;
          case 131:
            { return PHP_INSTANCEOF;
            }
            // fall through
          case 268: break;
          case 132:
            { return PHP__METHOD__;
            }
            // fall through
          case 269: break;
          case 133:
            { return PHP_INCLUDE_ONCE;
            }
            // fall through
          case 270: break;
          case 134:
            { return PHP_REQUIRE_ONCE;
            }
            // fall through
          case 271: break;
          case 135:
            { return PHP__FUNCTION__;
            }
            // fall through
          case 272: break;
          case 136:
            { return PHP__NAMESPACE__;
            }
            // fall through
          case 273: break;
          case 137:
            { return PHP_HALT_COMPILER;
            }
            // fall through
          case 274: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }


}
