// DO NOT EDIT
// Generated by JFlex 1.8.2 http://jflex.de/
// source: highlighting_scanner.jflex

/*******************************************************************************
 * Copyright (c) 2006, 2017 Zend Corporation and IBM Corporation.
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *   Zend and IBM - Initial implementation
 *******************************************************************************/

package org.eclipse.php.internal.core.documentModel.parser.php54;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.php.core.compiler.ast.nodes.PHPDocTag.TagKind;

//@SuppressWarnings({"unused", "nls"})


// See https://github.com/jflex-de/jflex/issues/222
@SuppressWarnings("FallThrough")
public class PHPLexer extends org.eclipse.php.internal.core.documentModel.parser.AbstractPHPLexer {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int ST_PHP_IN_SCRIPTING = 2;
  public static final int ST_PHP_DOUBLE_QUOTES = 4;
  public static final int ST_PHP_SINGLE_QUOTE = 6;
  public static final int ST_PHP_BACKQUOTE = 8;
  public static final int ST_PHP_QUOTES_AFTER_VARIABLE = 10;
  public static final int ST_PHP_HEREDOC = 12;
  public static final int ST_PHP_NOWDOC = 14;
  public static final int ST_PHP_START_HEREDOC = 16;
  public static final int ST_PHP_START_NOWDOC = 18;
  public static final int ST_PHP_END_HEREDOC = 20;
  public static final int ST_PHP_LOOKING_FOR_PROPERTY = 22;
  public static final int ST_PHP_VAR_OFFSET = 24;
  public static final int ST_PHP_COMMENT = 26;
  public static final int ST_PHP_DOC_COMMENT = 28;
  public static final int ST_PHP_LINE_COMMENT = 30;
  public static final int ST_PHP_HIGHLIGHTING_ERROR = 32;
  public static final int ST_PHP_END_NOWDOC = 34;
  public static final int ST_PHP_DOLLAR_CURLY_OPEN = 36;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7,  7, 
     8,  8,  9,  9, 10, 10, 11, 11, 12, 12, 13, 13, 14, 14, 15, 15, 
    16, 16, 17, 17, 18, 18
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\37\u0200\1\u0300\266\u0200\10\u0400\40\u0200\u1000\u0500";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\2\0\1\3\22\0\1\1\1\4"+
    "\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14"+
    "\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24"+
    "\10\25\1\26\1\27\1\30\1\31\1\32\1\33\1\34"+
    "\1\35\1\36\1\37\1\40\1\41\1\42\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\54"+
    "\1\55\1\56\1\57\1\60\1\61\1\62\1\63\1\64"+
    "\1\65\1\66\1\67\1\70\1\71\1\72\1\73\1\74"+
    "\1\35\1\36\1\37\1\40\1\41\1\42\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\54"+
    "\1\55\1\56\1\57\1\60\1\61\1\62\1\63\1\64"+
    "\1\65\1\66\1\75\1\76\1\77\1\17\1\0\260\100"+
    "\2\101\115\100\1\102\u01aa\100\1\103\325\100\u0100\104\u0100\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1536];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\6\0\1\1\1\2\13\0\1\3\1\4\1\5\1\6"+
    "\1\7\3\5\1\10\7\5\2\11\1\5\1\12\4\5"+
    "\24\13\1\14\1\13\1\15\1\16\1\5\1\17\1\1"+
    "\1\20\5\2\1\1\3\2\3\21\2\1\3\3\1\2"+
    "\2\22\2\23\1\0\1\3\2\24\1\25\1\26\2\27"+
    "\2\11\1\13\1\30\2\31\4\32\3\33\3\34\1\35"+
    "\1\36\1\0\1\3\1\37\1\40\1\41\1\0\1\2"+
    "\3\0\2\42\1\41\1\43\14\0\1\44\1\11\1\45"+
    "\1\0\1\11\1\0\1\46\1\41\1\47\3\13\1\50"+
    "\1\0\6\13\1\51\15\13\1\52\7\13\1\41\16\13"+
    "\3\0\2\53\1\54\1\55\1\56\1\53\4\0\2\53"+
    "\1\57\3\0\1\1\2\53\1\2\1\60\2\0\1\61"+
    "\3\0\1\62\1\54\1\63\1\64\1\65\1\0\1\66"+
    "\1\67\1\0\1\40\1\70\1\42\12\0\1\71\2\11"+
    "\1\0\2\13\1\0\11\13\1\72\11\13\1\73\13\13"+
    "\1\74\15\13\1\75\1\13\1\76\1\77\10\13\1\100"+
    "\1\101\1\1\1\102\1\2\1\103\2\0\2\104\1\105"+
    "\1\0\1\42\12\0\1\106\3\0\4\13\1\107\7\13"+
    "\1\110\1\111\6\13\1\112\1\113\4\13\1\114\2\13"+
    "\1\115\5\13\1\116\1\13\1\117\7\13\1\120\4\13"+
    "\1\121\12\13\1\122\1\123\6\0\1\124\5\0\2\125"+
    "\1\13\1\126\1\127\1\13\1\130\1\131\1\132\1\133"+
    "\4\13\1\134\2\13\1\135\3\13\1\136\1\137\10\13"+
    "\1\140\2\13\1\141\7\13\1\142\1\143\1\144\1\145"+
    "\10\13\5\0\5\13\1\146\1\13\1\147\5\13\1\150"+
    "\6\13\1\151\2\13\1\152\1\13\1\153\1\154\1\155"+
    "\10\13\2\0\3\13\1\156\1\157\4\13\1\160\1\161"+
    "\2\13\1\162\4\13\1\163\1\13\1\164\1\13\1\165"+
    "\6\13\1\166\1\167\1\170\3\13\1\171\1\172\11\13"+
    "\1\173\2\13\1\174\4\13\1\175\3\13\1\176\1\177"+
    "\1\200\1\201\1\13\1\202\4\13\1\203\1\204\1\205"+
    "\1\13\1\206\3\13\1\207\6\13\1\210\1\211\1\212"+
    "\3\13\1\213\1\13\1\214";

  private static int [] zzUnpackAction() {
    int [] result = new int[609];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\105\0\212\0\317\0\u0114\0\u0159\0\u019e\0\u01e3"+
    "\0\u0228\0\u026d\0\u02b2\0\u02f7\0\u033c\0\u0381\0\u03c6\0\u040b"+
    "\0\u0450\0\u0495\0\u04da\0\0\0\u051f\0\u0564\0\u05a9\0\0"+
    "\0\u05ee\0\u0633\0\u0678\0\u06bd\0\u0702\0\0\0\u0747\0\u078c"+
    "\0\u07d1\0\u0816\0\u085b\0\u08a0\0\u08e5\0\u092a\0\0\0\u096f"+
    "\0\u09b4\0\u09f9\0\u0a3e\0\u0a83\0\u0ac8\0\u0b0d\0\u0b52\0\u0b97"+
    "\0\u0bdc\0\u0c21\0\u0c66\0\u0cab\0\u0cf0\0\u0d35\0\u0d7a\0\u0dbf"+
    "\0\u0e04\0\u0e49\0\u0e8e\0\u0ed3\0\u0f18\0\u0f5d\0\u0fa2\0\0"+
    "\0\u0fe7\0\0\0\u102c\0\u1071\0\u10b6\0\u10fb\0\0\0\u1140"+
    "\0\u1185\0\u11ca\0\u120f\0\u1254\0\u1299\0\u12de\0\u1323\0\u1368"+
    "\0\0\0\u13ad\0\u13f2\0\u1437\0\u147c\0\u14c1\0\u1506\0\u154b"+
    "\0\u1590\0\0\0\u15d5\0\0\0\u161a\0\u165f\0\u16a4\0\0"+
    "\0\u16e9\0\u172e\0\0\0\0\0\u1773\0\u17b8\0\u17fd\0\u1842"+
    "\0\0\0\u1887\0\u18cc\0\0\0\u1911\0\u1956\0\u199b\0\u19e0"+
    "\0\0\0\u1a25\0\u1a6a\0\0\0\u0a3e\0\0\0\u1aaf\0\u1af4"+
    "\0\u1b39\0\u1b7e\0\u1bc3\0\u0747\0\u05a9\0\0\0\u1c08\0\u1c4d"+
    "\0\u1c92\0\u1cd7\0\u1d1c\0\0\0\0\0\u06bd\0\u1d61\0\u0702"+
    "\0\u1da6\0\u1deb\0\u1e30\0\u1e75\0\u1eba\0\u1eff\0\u1f44\0\u1f89"+
    "\0\u1fce\0\0\0\u2013\0\u2058\0\u209d\0\u20e2\0\u2127\0\0"+
    "\0\u216c\0\0\0\u21b1\0\u21f6\0\u223b\0\u0c66\0\u2280\0\u22c5"+
    "\0\u230a\0\u234f\0\u2394\0\u23d9\0\u241e\0\u0c66\0\u2463\0\u24a8"+
    "\0\u24ed\0\u2532\0\u2577\0\u25bc\0\u2601\0\u2646\0\u268b\0\u26d0"+
    "\0\u2715\0\u275a\0\u279f\0\u0c66\0\u27e4\0\u2829\0\u286e\0\u28b3"+
    "\0\u28f8\0\u293d\0\u2982\0\u0c66\0\u29c7\0\u2a0c\0\u2a51\0\u2a96"+
    "\0\u2adb\0\u2b20\0\u2b65\0\u2baa\0\u2bef\0\u2c34\0\u2c79\0\u2cbe"+
    "\0\u2d03\0\u2d48\0\u2d8d\0\u1185\0\u2dd2\0\0\0\u2d8d\0\u2e17"+
    "\0\0\0\0\0\u2dd2\0\u2e5c\0\u2ea1\0\u1323\0\u2ee6\0\u2ea1"+
    "\0\u2ee6\0\0\0\u2f2b\0\u1506\0\u2f70\0\u2fb5\0\u2f2b\0\u2f70"+
    "\0\u2ffa\0\0\0\u15d5\0\u303f\0\0\0\u161a\0\u3084\0\u30c9"+
    "\0\0\0\u310e\0\0\0\0\0\u1956\0\u3153\0\0\0\u3198"+
    "\0\u31dd\0\u3222\0\u3267\0\u32ac\0\u32f1\0\u3336\0\u337b\0\u33c0"+
    "\0\u3405\0\u344a\0\u348f\0\u34d4\0\u3519\0\u355e\0\u35a3\0\u209d"+
    "\0\u2127\0\u35e8\0\u362d\0\u3672\0\u36b7\0\u36fc\0\u3741\0\u3786"+
    "\0\u37cb\0\u3810\0\u3855\0\u389a\0\u38df\0\u3924\0\u0c66\0\u3969"+
    "\0\u39ae\0\u39f3\0\u3a38\0\u3a7d\0\u3ac2\0\u3b07\0\u3b4c\0\u3b91"+
    "\0\u3bd6\0\u3c1b\0\u3c60\0\u3ca5\0\u3cea\0\u3d2f\0\u3d74\0\u3db9"+
    "\0\u3dfe\0\u3e43\0\u3e88\0\u3ecd\0\u0c66\0\u3f12\0\u3f57\0\u3f9c"+
    "\0\u3fe1\0\u4026\0\u406b\0\u40b0\0\u40f5\0\u413a\0\u417f\0\u41c4"+
    "\0\u4209\0\u424e\0\u0c66\0\u4293\0\u0c66\0\u0c66\0\u42d8\0\u431d"+
    "\0\u4362\0\u43a7\0\u43ec\0\u4431\0\u4476\0\u44bb\0\0\0\0"+
    "\0\u4500\0\0\0\u4545\0\0\0\u458a\0\u45cf\0\0\0\u4614"+
    "\0\0\0\u4659\0\u469e\0\u46e3\0\u4728\0\u476d\0\u47b2\0\u47f7"+
    "\0\u483c\0\u4881\0\u48c6\0\u490b\0\u4950\0\0\0\u4995\0\u49da"+
    "\0\u4a1f\0\u4a64\0\u4aa9\0\u4aee\0\u4b33\0\u0c66\0\u4b78\0\u4bbd"+
    "\0\u4c02\0\u4c47\0\u4c8c\0\u4cd1\0\u4d16\0\u0c66\0\u4d5b\0\u4da0"+
    "\0\u4de5\0\u4e2a\0\u4e6f\0\u4eb4\0\u4ef9\0\u0c66\0\u0c66\0\u4f3e"+
    "\0\u4f83\0\u4fc8\0\u500d\0\u0c66\0\u5052\0\u5097\0\u0c66\0\u50dc"+
    "\0\u5121\0\u5166\0\u51ab\0\u51f0\0\u0c66\0\u5235\0\u0c66\0\u527a"+
    "\0\u52bf\0\u5304\0\u5349\0\u538e\0\u53d3\0\u5418\0\u0c66\0\u545d"+
    "\0\u54a2\0\u54e7\0\u552c\0\u0c66\0\u5571\0\u55b6\0\u55fb\0\u5640"+
    "\0\u5685\0\u56ca\0\u570f\0\u5754\0\u5799\0\u57de\0\0\0\u1cd7"+
    "\0\u5823\0\u5868\0\u58ad\0\u58f2\0\u5937\0\u597c\0\0\0\u59c1"+
    "\0\u5a06\0\u5a4b\0\u5a90\0\u5ad5\0\0\0\u5b1a\0\u5b5f\0\u0c66"+
    "\0\u0c66\0\u5ba4\0\u0c66\0\u0c66\0\u0c66\0\u0c66\0\u5be9\0\u5c2e"+
    "\0\u5c73\0\u5cb8\0\u0c66\0\u5cfd\0\u5d42\0\u0c66\0\u5d87\0\u5dcc"+
    "\0\u5e11\0\u0c66\0\u0c66\0\u5e56\0\u5e9b\0\u5ee0\0\u5f25\0\u5f6a"+
    "\0\u5faf\0\u5ff4\0\u6039\0\u0c66\0\u607e\0\u60c3\0\u0c66\0\u6108"+
    "\0\u614d\0\u6192\0\u61d7\0\u621c\0\u6261\0\u62a6\0\u0c66\0\u0c66"+
    "\0\u0c66\0\u0c66\0\u62eb\0\u6330\0\u6375\0\u63ba\0\u63ff\0\u6444"+
    "\0\u6489\0\u64ce\0\u6513\0\u6558\0\u659d\0\u65e2\0\u6627\0\u666c"+
    "\0\u66b1\0\u66f6\0\u673b\0\u6780\0\u0c66\0\u67c5\0\u680a\0\u684f"+
    "\0\u6894\0\u68d9\0\u691e\0\u6963\0\u0c66\0\u69a8\0\u69ed\0\u6a32"+
    "\0\u6a77\0\u6abc\0\u6b01\0\u0c66\0\u6b46\0\u6b8b\0\u0c66\0\u6bd0"+
    "\0\u0c66\0\u0c66\0\u0c66\0\u6c15\0\u6c5a\0\u6c9f\0\u6ce4\0\u6d29"+
    "\0\u6d6e\0\u6db3\0\u6df8\0\u6e3d\0\u6e82\0\u6ec7\0\u6f0c\0\u6f51"+
    "\0\u0c66\0\u0c66\0\u6f96\0\u6fdb\0\u7020\0\u7065\0\u0c66\0\u0c66"+
    "\0\u70aa\0\u70ef\0\u7134\0\u7179\0\u71be\0\u7203\0\u7248\0\u0c66"+
    "\0\u728d\0\u72d2\0\u7317\0\u0c66\0\u735c\0\u73a1\0\u73e6\0\u742b"+
    "\0\u7470\0\u74b5\0\u0c66\0\u0c66\0\u0c66\0\u74fa\0\u753f\0\u7584"+
    "\0\u0c66\0\u0c66\0\u75c9\0\u760e\0\u7653\0\u7698\0\u76dd\0\u7722"+
    "\0\u7767\0\u77ac\0\u77f1\0\u0c66\0\u7836\0\u787b\0\u0c66\0\u78c0"+
    "\0\u7905\0\u794a\0\u798f\0\u0c66\0\u79d4\0\u7a19\0\u7a5e\0\u0c66"+
    "\0\u0c66\0\u0c66\0\u0c66\0\u7aa3\0\u0c66\0\u7ae8\0\u7b2d\0\u7b72"+
    "\0\u7bb7\0\u0c66\0\u0c66\0\u0c66\0\u7bfc\0\u0c66\0\u7c41\0\u7c86"+
    "\0\u7ccb\0\u0c66\0\u7d10\0\u7d55\0\u7d9a\0\u7ddf\0\u7e24\0\u7e69"+
    "\0\u0c66\0\u0c66\0\u0c66\0\u7eae\0\u7ef3\0\u7f38\0\u0c66\0\u7f7d"+
    "\0\u0c66";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[609];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\105\0\1\24\3\25\1\26\1\27\1\30\1\31\1\32"+
    "\1\33\1\34\1\35\1\36\1\37\1\40\1\36\1\41"+
    "\1\42\1\43\1\44\2\45\1\46\1\47\1\50\1\51"+
    "\1\52\1\53\1\36\1\54\1\55\1\56\1\57\1\60"+
    "\1\61\1\62\1\63\1\64\2\63\1\65\1\63\1\66"+
    "\1\67\1\70\1\63\1\71\1\72\1\73\1\74\1\75"+
    "\1\76\1\77\2\63\1\36\1\100\1\36\1\37\1\101"+
    "\1\102\1\103\1\104\1\105\1\63\1\64\1\72\2\63"+
    "\5\106\1\107\1\106\1\110\60\106\1\111\4\106\1\112"+
    "\7\106\12\113\1\107\55\113\1\114\14\113\7\115\1\116"+
    "\60\115\1\117\3\115\1\107\1\120\7\115\20\121\1\122"+
    "\54\121\1\123\7\121\2\124\2\125\3\124\1\126\60\124"+
    "\1\127\4\124\1\130\7\124\2\10\2\131\101\10\35\132"+
    "\32\133\4\132\1\133\4\132\5\133\35\134\32\135\4\134"+
    "\1\135\4\134\5\135\2\24\1\136\1\137\100\24\1\0"+
    "\1\140\3\25\14\140\1\141\14\140\32\142\4\140\1\142"+
    "\4\140\5\142\1\24\3\143\2\144\1\143\1\145\2\144"+
    "\1\143\10\144\1\146\2\147\7\144\15\63\1\150\14\63"+
    "\1\36\1\143\1\151\1\144\1\63\4\144\5\63\15\152"+
    "\1\153\67\152\15\154\1\155\16\154\1\156\40\154\1\157"+
    "\7\154\2\160\1\161\1\162\4\160\1\163\21\160\1\164"+
    "\1\165\51\160\1\166\3\167\100\166\1\0\2\24\1\170"+
    "\1\171\100\24\1\0\2\24\1\0\32\24\32\172\4\24"+
    "\1\172\1\24\1\173\2\24\5\172\1\0\3\25\132\0"+
    "\1\174\53\0\5\175\1\176\1\175\1\177\60\175\1\200"+
    "\4\175\1\201\7\175\35\0\23\202\1\203\6\202\4\0"+
    "\1\202\4\0\5\202\31\0\1\204\1\205\63\0\1\204"+
    "\17\0\1\204\53\0\12\206\1\176\55\206\1\207\14\206"+
    "\1\0\1\210\33\0\1\211\1\212\1\0\1\213\1\0"+
    "\1\214\2\0\1\215\5\0\1\216\2\0\1\217\1\220"+
    "\1\0\1\221\17\0\1\215\1\220\33\0\1\204\71\0"+
    "\1\204\12\0\1\204\73\0\1\204\10\0\1\204\1\222"+
    "\75\0\3\223\3\0\1\204\70\0\1\224\4\0\1\30"+
    "\6\0\1\204\74\0\1\223\1\0\3\45\10\0\1\225"+
    "\2\0\1\226\22\0\1\227\41\0\1\223\1\0\3\45"+
    "\13\0\1\226\71\0\1\230\106\0\1\231\2\204\103\0"+
    "\1\174\1\204\103\0\1\204\1\174\104\0\1\232\75\0"+
    "\3\63\7\0\1\63\1\233\13\63\1\234\3\63\1\235"+
    "\1\236\7\63\4\0\1\63\4\0\2\63\1\236\2\63"+
    "\5\0\1\27\4\0\1\34\10\0\3\63\2\0\1\237"+
    "\4\0\21\63\1\240\10\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\1\241\12\63\1\242\2\63\1\243"+
    "\13\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\4\63\1\244\3\63\1\245\5\63\1\246\13\63\4\0"+
    "\1\63\4\0\1\63\1\245\3\63\23\0\3\63\7\0"+
    "\2\63\1\247\10\63\1\250\1\251\1\252\7\63\1\253"+
    "\1\63\1\254\2\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\1\255\7\63\1\256\5\63\1\257\2\63"+
    "\1\260\2\63\1\261\5\63\4\0\1\63\4\0\1\63"+
    "\1\256\3\63\23\0\3\63\7\0\13\63\1\262\2\63"+
    "\1\263\13\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\32\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\5\63\1\264\6\63\1\265\1\266\4\63\1\267"+
    "\7\63\4\0\1\63\4\0\2\63\1\267\2\63\23\0"+
    "\3\63\7\0\10\63\1\270\21\63\4\0\1\63\4\0"+
    "\1\63\1\270\3\63\23\0\3\63\7\0\1\271\3\63"+
    "\1\272\17\63\1\273\5\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\21\63\1\274\10\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\1\275\20\63\1\276"+
    "\2\63\1\277\5\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\4\63\1\300\25\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\4\63\1\301\16\63\1\302"+
    "\2\63\1\303\3\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\7\63\1\304\11\63\1\305\10\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\15\63\1\306"+
    "\4\63\1\307\7\63\4\0\1\63\4\0\2\63\1\307"+
    "\2\63\23\0\3\63\7\0\1\310\31\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\7\63\1\311\22\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\16\63"+
    "\1\67\13\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\32\63\4\0\1\312\4\0\5\63\1\0\3\103"+
    "\132\0\1\204\44\0\1\204\7\0\3\105\101\0\5\106"+
    "\1\0\1\106\1\313\60\106\1\314\4\106\1\315\14\106"+
    "\1\316\1\106\1\317\25\106\32\320\1\106\1\314\2\106"+
    "\1\320\1\106\1\321\2\106\5\320\112\106\1\316\1\106"+
    "\1\322\60\106\1\314\4\106\1\323\7\106\12\113\1\0"+
    "\55\113\1\324\26\113\1\176\55\113\1\176\14\113\7\115"+
    "\1\325\60\115\1\326\3\115\1\0\1\327\16\115\1\330"+
    "\25\115\32\320\1\115\1\326\2\115\1\320\1\316\1\321"+
    "\2\115\5\320\114\115\1\322\60\115\1\326\3\115\1\316"+
    "\1\331\7\115\32\0\1\332\61\0\1\322\75\0\2\124"+
    "\2\125\3\124\1\333\60\124\1\334\4\124\1\335\11\124"+
    "\2\125\3\124\1\333\25\124\32\336\1\124\1\334\2\124"+
    "\1\336\1\124\1\335\2\124\5\336\2\124\2\125\3\124"+
    "\1\337\25\124\32\320\1\124\1\334\2\124\1\320\1\124"+
    "\1\321\2\124\5\320\2\124\2\125\103\124\2\125\3\124"+
    "\1\322\60\124\1\334\4\124\1\340\7\124\2\10\2\131"+
    "\31\10\32\341\4\10\1\341\4\10\5\341\2\0\2\342"+
    "\17\0\3\343\1\0\1\344\5\0\32\343\4\0\1\343"+
    "\4\0\5\343\2\0\2\345\17\0\3\346\1\0\1\347"+
    "\5\0\32\346\4\0\1\346\4\0\5\346\35\0\32\350"+
    "\4\0\1\350\4\0\5\350\2\0\1\136\32\0\32\350"+
    "\4\0\1\350\4\0\5\350\32\0\1\351\75\0\3\142"+
    "\7\0\32\142\4\0\1\142\4\0\5\142\35\0\32\352"+
    "\4\0\1\352\4\0\5\352\23\0\3\147\10\0\1\225"+
    "\25\0\1\227\43\0\3\147\102\0\3\63\7\0\24\63"+
    "\1\273\5\63\4\0\1\63\4\0\5\63\15\152\1\0"+
    "\67\152\22\0\1\353\104\0\1\354\62\0\1\355\3\0"+
    "\11\355\1\0\67\355\34\0\1\356\50\0\2\160\2\161"+
    "\4\160\1\161\21\160\2\161\51\160\2\0\1\357\134\0"+
    "\1\360\53\0\3\167\136\0\32\361\4\0\1\361\4\0"+
    "\5\361\2\0\1\170\32\0\32\361\4\0\1\361\4\0"+
    "\5\361\23\0\3\172\7\0\32\172\4\0\1\172\4\0"+
    "\5\172\1\0\3\362\31\0\32\363\4\0\1\363\4\0"+
    "\5\363\5\175\1\176\1\175\1\177\25\175\32\0\1\175"+
    "\1\200\2\175\1\0\1\175\1\0\2\175\5\0\112\175"+
    "\1\176\1\175\1\0\60\175\1\200\4\175\1\201\7\175"+
    "\23\0\3\202\7\0\32\202\4\0\1\202\4\0\5\202"+
    "\23\0\3\202\7\0\7\202\1\364\22\202\4\0\1\202"+
    "\4\0\5\202\105\206\56\0\1\365\73\0\1\366\5\0"+
    "\1\367\25\0\1\366\56\0\1\370\101\0\1\371\106\0"+
    "\1\372\70\0\1\373\107\0\1\374\123\0\1\375\76\0"+
    "\1\376\55\0\3\223\13\0\1\226\60\0\1\377\112\0"+
    "\2\u0100\76\0\1\147\1\0\1\147\2\0\3\147\102\0"+
    "\3\u0101\7\0\6\u0101\72\0\1\u0102\1\204\76\0\3\63"+
    "\7\0\22\63\1\u0103\7\63\4\0\1\63\4\0\2\63"+
    "\1\u0103\2\63\23\0\3\63\7\0\3\63\1\274\26\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\21\63"+
    "\1\u0104\10\63\4\0\1\63\4\0\5\63\30\0\1\u0105"+
    "\77\0\3\63\7\0\4\63\1\u0106\25\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\13\63\1\u0107\6\63"+
    "\1\u0108\1\u0109\6\63\4\0\1\63\4\0\2\63\1\u0108"+
    "\2\63\23\0\3\63\7\0\1\u010a\15\63\1\u010b\13\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\15\63"+
    "\1\u010c\14\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\2\63\1\u010d\2\63\1\u010e\24\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\4\63\1\u010f\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\7\63"+
    "\1\u0110\22\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\22\63\1\u0111\7\63\4\0\1\63\4\0\2\63"+
    "\1\u0111\2\63\23\0\3\63\7\0\17\63\1\u0112\12\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\3\63"+
    "\1\u0113\26\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\1\u0114\31\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\10\63\1\u0115\12\63\1\u0116\6\63\4\0"+
    "\1\63\4\0\1\63\1\u0115\3\63\23\0\3\63\7\0"+
    "\13\63\1\u0117\16\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\15\63\1\u0118\14\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\21\63\1\u0119\10\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\16\63\1\u011a"+
    "\13\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\15\63\1\u011b\14\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\16\63\1\u011c\13\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\23\63\1\u011d\6\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\17\63\1\u011e"+
    "\12\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\2\63\1\u011f\17\63\1\u0120\1\u0121\6\63\4\0\1\63"+
    "\4\0\2\63\1\u0120\2\63\23\0\3\63\7\0\22\63"+
    "\1\u0122\7\63\4\0\1\63\4\0\2\63\1\u0122\2\63"+
    "\23\0\3\63\7\0\22\63\1\u0123\7\63\4\0\1\63"+
    "\4\0\2\63\1\u0123\2\63\23\0\3\63\7\0\14\63"+
    "\1\u0124\15\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\26\63\1\u0125\3\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\13\63\1\u0126\16\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\21\63\1\u0127\10\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\10\63"+
    "\1\u0128\5\63\1\u0129\13\63\4\0\1\63\4\0\1\63"+
    "\1\u0128\3\63\23\0\3\63\7\0\1\63\1\u012a\30\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\20\63"+
    "\1\u012b\2\63\1\u012c\6\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\13\63\1\u012d\16\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\1\u012e\31\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\10\63\1\u012f"+
    "\21\63\4\0\1\63\4\0\1\63\1\u012f\3\63\23\0"+
    "\3\63\7\0\21\63\1\u0130\10\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\1\u0131\23\63\1\u0132\3\63"+
    "\1\u0133\1\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\22\63\1\u0134\7\63\4\0\1\63\4\0\2\63"+
    "\1\u0134\2\63\23\0\3\63\7\0\4\63\1\u0135\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\21\63"+
    "\1\u0136\10\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\10\63\1\u0137\21\63\4\0\1\63\4\0\1\63"+
    "\1\u0137\3\63\23\0\3\63\7\0\2\63\1\u0138\1\u0139"+
    "\1\63\1\u013a\1\63\1\u013b\3\63\1\u013c\1\u013d\1\u013e"+
    "\14\63\4\0\1\63\4\0\5\63\5\106\1\316\1\106"+
    "\1\317\25\106\32\0\1\106\1\314\2\106\1\0\1\106"+
    "\1\0\2\106\5\0\5\106\1\316\1\106\1\0\60\106"+
    "\1\314\4\106\1\323\7\106\23\0\3\320\7\0\32\320"+
    "\1\u013f\3\0\1\320\4\0\5\320\12\113\1\0\55\113"+
    "\1\0\14\113\7\115\1\330\25\115\32\0\1\115\1\326"+
    "\2\115\1\0\1\316\1\0\2\115\5\0\7\115\1\0"+
    "\60\115\1\326\3\115\1\316\1\331\7\115\2\124\2\125"+
    "\3\124\1\337\25\124\32\0\1\124\1\334\2\124\1\0"+
    "\1\124\1\0\2\124\5\0\2\124\2\125\3\124\1\0"+
    "\60\124\1\334\4\124\1\340\11\124\2\u0140\3\124\1\333"+
    "\13\124\3\336\1\124\1\u0141\5\124\32\336\1\124\1\334"+
    "\2\124\1\336\1\124\1\335\2\124\5\336\2\10\2\u0142"+
    "\17\10\3\341\1\10\1\u0143\5\10\32\341\4\10\1\341"+
    "\4\10\5\341\2\0\2\342\103\0\2\345\103\0\2\u0144"+
    "\17\0\3\350\1\0\1\u0145\5\0\32\350\4\0\1\350"+
    "\4\0\5\350\23\0\3\352\7\0\32\352\4\0\1\352"+
    "\4\0\5\352\20\0\1\u0146\14\0\32\u0146\20\0\1\u0147"+
    "\1\u0148\103\0\2\u0149\17\0\3\361\1\0\1\u014a\5\0"+
    "\32\361\4\0\1\361\4\0\5\361\1\0\3\362\124\0"+
    "\3\363\7\0\32\363\4\0\1\363\4\0\5\363\23\0"+
    "\3\202\7\0\10\202\1\u014b\21\202\4\0\1\202\4\0"+
    "\1\202\1\u014b\3\202\56\0\1\u014c\100\0\1\u014d\105\0"+
    "\1\u014e\112\0\1\u014f\76\0\1\u0150\111\0\1\u0151\72\0"+
    "\1\u0152\73\0\1\u0153\125\0\1\u0154\105\0\1\u0155\22\0"+
    "\1\u0155\24\0\1\u0156\63\0\1\u0102\3\0\1\u0157\4\0"+
    "\1\u0158\22\0\32\u0159\4\0\1\u0159\4\0\5\u0159\23\0"+
    "\3\63\7\0\23\63\1\u015a\6\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\1\u015b\31\63\4\0\1\63"+
    "\4\0\5\63\30\0\1\u0102\77\0\3\63\7\0\1\u015c"+
    "\31\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\13\63\1\u015d\16\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\4\63\1\u015e\25\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\2\63\1\u015f\27\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\22\63\1\u0160"+
    "\7\63\4\0\1\63\4\0\2\63\1\u0160\2\63\23\0"+
    "\3\63\7\0\15\63\1\u0161\14\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\22\63\1\u0162\1\u0163\6\63"+
    "\4\0\1\63\4\0\2\63\1\u0162\2\63\23\0\3\63"+
    "\7\0\13\63\1\u0164\16\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\1\u0165\31\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\16\63\1\u0166\13\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\4\63\1\u0167"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\23\63\1\u0168\6\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\3\63\1\u0169\1\63\1\u016a\2\63\1\u016b"+
    "\11\63\1\u016c\3\63\1\u016d\3\63\4\0\1\63\4\0"+
    "\1\63\1\u016b\1\u016c\2\63\23\0\3\63\7\0\13\63"+
    "\1\u016e\16\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\23\63\1\u016f\6\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\4\63\1\u0170\25\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\22\63\1\u0171\7\63"+
    "\4\0\1\63\4\0\2\63\1\u0171\2\63\23\0\3\63"+
    "\7\0\1\u0172\31\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\4\63\1\u0173\25\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\14\63\1\u0174\15\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\2\63\1\u0175"+
    "\27\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\1\63\1\u0176\30\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\16\63\1\u0177\13\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\13\63\1\u0178\16\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\13\63\1\u0179"+
    "\16\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\23\63\1\u017a\6\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\4\63\1\u017b\25\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\4\63\1\u017c\25\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\23\63\1\u017d"+
    "\6\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\4\63\1\u017e\25\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\13\63\1\u017f\16\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\4\63\1\u0180\25\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\15\63\1\u0181"+
    "\7\63\1\u0182\4\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\23\63\1\u0183\6\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\13\63\1\u0184\16\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\24\63\1\u0185"+
    "\5\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\24\63\1\u0186\5\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\5\63\1\u0187\24\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\23\63\1\u0188\6\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\23\63\1\u0189"+
    "\6\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\16\63\1\u018a\13\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\10\63\1\u018b\21\63\4\0\1\63\4\0"+
    "\1\63\1\u018b\3\63\23\0\3\63\7\0\4\63\1\u018c"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\4\63\1\u018d\25\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\13\63\1\u018e\16\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\13\63\1\u018f\16\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\10\63\1\u0190"+
    "\21\63\4\0\1\63\4\0\1\63\1\u0190\3\63\23\0"+
    "\3\63\7\0\10\63\1\u0191\13\63\1\u0192\5\63\4\0"+
    "\1\63\4\0\1\63\1\u0191\3\63\23\0\3\63\7\0"+
    "\1\u0193\31\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\10\63\1\u0194\21\63\4\0\1\63\4\0\1\63"+
    "\1\u0194\3\63\23\0\3\63\7\0\4\63\1\u0195\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\1\u0196"+
    "\31\63\4\0\1\63\4\0\5\63\2\124\2\u0140\3\124"+
    "\1\333\60\124\1\334\4\124\1\335\7\124\2\10\2\u0142"+
    "\101\10\2\0\2\u0144\121\0\1\u0146\14\0\32\u0146\10\0"+
    "\1\u0197\7\0\1\u0147\104\0\2\u0149\124\0\3\202\7\0"+
    "\22\202\1\u0198\7\202\4\0\1\202\4\0\2\202\1\u0198"+
    "\2\202\35\0\1\u0199\104\0\1\u019a\117\0\1\u019b\72\0"+
    "\1\u019c\103\0\1\u019d\50\0\1\u019e\12\0\1\u019f\24\0"+
    "\1\u01a0\104\0\1\u01a1\113\0\1\u019e\101\0\1\u01a2\33\0"+
    "\1\u01a2\44\0\1\u019d\100\0\32\u01a3\4\0\1\u01a3\4\0"+
    "\5\u01a3\35\0\32\u01a4\4\0\1\u01a4\4\0\5\u01a4\2\0"+
    "\1\u01a5\1\u01a6\17\0\3\u0159\7\0\32\u0159\4\0\1\u0159"+
    "\4\0\5\u0159\23\0\3\63\7\0\21\63\1\u01a7\10\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\30\63"+
    "\1\u01a8\1\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\12\63\1\u01a9\17\63\4\0\1\63\4\0\3\63"+
    "\1\u01a9\1\63\23\0\3\63\7\0\1\u01aa\31\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\7\63\1\u01ab"+
    "\22\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\22\63\1\u01ac\7\63\4\0\1\63\4\0\2\63\1\u01ac"+
    "\2\63\23\0\3\63\7\0\4\63\1\u01ad\25\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\23\63\1\u01ae"+
    "\6\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\10\63\1\u01af\21\63\4\0\1\63\4\0\1\63\1\u01af"+
    "\3\63\23\0\3\63\7\0\1\u01b0\31\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\24\63\1\u01b1\5\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\10\63"+
    "\1\u01b2\21\63\4\0\1\63\4\0\1\63\1\u01b2\3\63"+
    "\23\0\3\63\7\0\30\63\1\u01b3\1\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\4\63\1\u01b4\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\16\63"+
    "\1\u01b5\13\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\5\63\1\u01b6\24\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\26\63\1\u01b7\3\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\7\63\1\u01b8\22\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\15\63"+
    "\1\u01b9\14\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\4\63\1\u01ba\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\13\63\1\u01bb\16\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\1\u01bc\31\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\23\63\1\u01bd"+
    "\6\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\1\u01be\31\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\4\63\1\u01bf\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\24\63\1\u01c0\5\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\1\u01c1\3\63\1\u01c2"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\21\63\1\u01c3\10\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\23\63\1\u01c4\6\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\22\63\1\u01c5\7\63\4\0"+
    "\1\63\4\0\2\63\1\u01c5\2\63\23\0\3\63\7\0"+
    "\15\63\1\u01c6\14\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\23\63\1\u01c7\6\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\1\u01c8\31\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\4\63\1\u01c9\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\10\63"+
    "\1\u01ca\21\63\4\0\1\63\4\0\1\63\1\u01ca\3\63"+
    "\23\0\3\63\7\0\10\63\1\u01cb\21\63\4\0\1\63"+
    "\4\0\1\63\1\u01cb\3\63\23\0\3\63\7\0\21\63"+
    "\1\u01cc\10\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\10\63\1\u01cd\21\63\4\0\1\63\4\0\1\63"+
    "\1\u01cd\3\63\23\0\3\63\7\0\2\63\1\u01ce\27\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\26\63"+
    "\1\u01cf\3\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\23\63\1\u01d0\6\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\23\63\1\u01d1\6\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\4\63\1\u01d2\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\1\u01d3"+
    "\31\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\21\63\1\u01d4\10\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\13\63\1\u01d5\16\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\15\63\1\u01d6\14\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\13\63\1\u01d7"+
    "\16\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\15\63\1\u01d8\14\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\23\63\1\u01d9\6\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\14\63\1\u01da\15\63\4\0"+
    "\1\63\4\0\5\63\65\0\1\u019e\75\0\1\u0199\27\0"+
    "\1\u019e\12\0\1\u019f\24\0\1\u01db\113\0\1\u01dc\114\0"+
    "\1\u019e\25\0\1\u019e\12\0\1\u019f\133\0\1\u01dd\100\0"+
    "\1\u019d\117\0\1\u01de\37\0\1\u01df\15\0\3\u01a3\7\0"+
    "\32\u01a3\4\0\1\u01a3\4\0\5\u01a3\12\0\1\u01df\10\0"+
    "\3\u01a4\7\0\32\u01a4\4\0\1\u01a4\4\0\5\u01a4\2\0"+
    "\1\u01a5\125\0\3\63\7\0\1\u01e0\31\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\1\63\1\u01e1\30\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\15\63"+
    "\1\u01e2\14\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\21\63\1\u01e3\10\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\13\63\1\u01e4\16\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\5\63\1\u01e5\24\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\2\63"+
    "\1\u01e6\27\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\21\63\1\u01e7\10\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\10\63\1\u01e8\21\63\4\0\1\63"+
    "\4\0\1\63\1\u01e8\3\63\23\0\3\63\7\0\10\63"+
    "\1\u01e9\21\63\4\0\1\63\4\0\1\63\1\u01e9\3\63"+
    "\23\0\3\63\7\0\3\63\1\u01ea\26\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\2\63\1\u01eb\27\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\10\63"+
    "\1\u01ec\21\63\4\0\1\63\4\0\1\63\1\u01ec\3\63"+
    "\23\0\3\63\7\0\13\63\1\u01ed\16\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\14\63\1\u01ee\15\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\3\63"+
    "\1\u01ef\26\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\15\63\1\u01f0\14\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\1\u01f1\31\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\5\63\1\u01f2\24\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\17\63\1\u01f3"+
    "\12\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\23\63\1\u01f4\6\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\23\63\1\u01f5\6\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\2\63\1\u01f6\27\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\2\63\1\u01f7"+
    "\27\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\21\63\1\u01f8\10\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\15\63\1\u01f9\14\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\2\63\1\u01fa\27\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\7\63\1\u01fb"+
    "\22\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\22\63\1\u01fc\7\63\4\0\1\63\4\0\2\63\1\u01fc"+
    "\2\63\23\0\3\63\7\0\32\63\4\0\1\u01fd\4\0"+
    "\5\63\23\0\3\63\7\0\4\63\1\u01fe\25\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\2\63\1\u01ff"+
    "\27\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\23\63\1\u0200\6\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\4\63\1\u0201\25\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\7\63\1\u0202\22\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\4\63\1\u0203"+
    "\25\63\4\0\1\63\4\0\5\63\35\0\1\u0204\110\0"+
    "\1\u019e\104\0\1\u0205\106\0\1\u019e\43\0\1\u01a5\1\u01a6"+
    "\124\0\3\63\7\0\2\63\1\u0206\27\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\13\63\1\u0207\16\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\24\63"+
    "\1\u0208\5\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\4\63\1\u0209\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\23\63\1\u020a\6\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\13\63\1\u020b\16\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\4\63"+
    "\1\u020c\25\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\23\63\1\u020d\6\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\13\63\1\u020e\16\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\22\63\1\u020f\7\63"+
    "\4\0\1\63\4\0\2\63\1\u020f\2\63\23\0\3\63"+
    "\7\0\7\63\1\u0210\22\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\16\63\1\u0211\13\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\4\63\1\u0212\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\4\63"+
    "\1\u0213\25\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\2\63\1\u0214\27\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\3\63\1\u0215\26\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\1\u0216\31\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\1\u0217\31\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\4\63"+
    "\1\u0218\25\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\23\63\1\u0219\6\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\4\63\1\u021a\25\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\22\63\1\u021b\7\63"+
    "\4\0\1\63\4\0\2\63\1\u021b\2\63\23\0\3\63"+
    "\7\0\32\63\4\0\1\u021c\4\0\5\63\23\0\3\63"+
    "\7\0\32\63\4\0\1\u021d\4\0\5\63\23\0\3\63"+
    "\7\0\23\63\1\u021e\6\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\32\63\4\0\1\u021f\4\0\5\63"+
    "\23\0\3\63\7\0\32\63\4\0\1\u0220\4\0\5\63"+
    "\23\0\3\63\7\0\16\63\1\u0221\13\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\22\63\1\u0222\7\63"+
    "\4\0\1\63\4\0\2\63\1\u0222\2\63\52\0\1\u019e"+
    "\110\0\1\u019e\51\0\3\63\7\0\23\63\1\u0223\6\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\4\63"+
    "\1\u0224\25\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\4\63\1\u0225\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\1\u0226\31\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\1\u0227\31\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\2\63\1\u0228\27\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\4\63"+
    "\1\u0229\25\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\15\63\1\u022a\14\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\15\63\1\u022b\14\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\32\63\4\0\1\u022c"+
    "\4\0\5\63\23\0\3\63\7\0\4\63\1\u022d\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\16\63"+
    "\1\u022e\13\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\2\63\1\u022f\27\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\2\63\1\u0230\27\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\4\63\1\u0231\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\32\63"+
    "\4\0\1\u0232\4\0\5\63\23\0\3\63\7\0\32\63"+
    "\4\0\1\u0233\4\0\5\63\23\0\3\63\7\0\32\63"+
    "\4\0\1\u0234\4\0\5\63\23\0\3\63\7\0\10\63"+
    "\1\u0235\21\63\4\0\1\63\4\0\1\63\1\u0235\3\63"+
    "\23\0\3\63\7\0\2\63\1\u0236\27\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\32\63\4\0\1\u0237"+
    "\4\0\5\63\23\0\3\63\7\0\3\63\1\u0238\26\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\17\63"+
    "\1\u0239\12\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\21\63\1\u023a\10\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\2\63\1\u023b\27\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\7\63\1\u023c\22\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\23\63"+
    "\1\u023d\6\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\16\63\1\u023e\13\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\16\63\1\u023f\13\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\5\63\1\u0240\24\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\4\63"+
    "\1\u0241\25\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\4\63\1\u0242\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\3\63\1\u0243\26\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\16\63\1\u0244\13\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\32\63"+
    "\4\0\1\u0245\4\0\5\63\23\0\3\63\7\0\16\63"+
    "\1\u0246\13\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\16\63\1\u0247\13\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\32\63\4\0\1\u0248\4\0\5\63"+
    "\23\0\3\63\7\0\1\u0249\31\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\4\63\1\u024a\25\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\7\63\1\u024b"+
    "\22\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\22\63\1\u024c\7\63\4\0\1\63\4\0\2\63\1\u024c"+
    "\2\63\23\0\3\63\7\0\15\63\1\u024d\14\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\5\63\1\u024e"+
    "\24\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\15\63\1\u024f\14\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\15\63\1\u0250\14\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\14\63\1\u0251\15\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\32\63\4\0"+
    "\1\u0252\4\0\5\63\23\0\3\63\7\0\2\63\1\u0253"+
    "\27\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\2\63\1\u0254\27\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\2\63\1\u0255\27\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\32\63\4\0\1\u0256\4\0"+
    "\5\63\23\0\3\63\7\0\17\63\1\u0257\12\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\4\63\1\u0258"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\4\63\1\u0259\25\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\4\63\1\u025a\25\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\32\63\4\0\1\u025b\4\0"+
    "\5\63\23\0\3\63\7\0\10\63\1\u025c\21\63\4\0"+
    "\1\63\4\0\1\63\1\u025c\3\63\23\0\3\63\7\0"+
    "\32\63\4\0\1\u025d\4\0\5\63\23\0\3\63\7\0"+
    "\13\63\1\u025e\16\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\32\63\4\0\1\u025f\4\0\5\63\23\0"+
    "\3\63\7\0\4\63\1\u0260\25\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\21\63\1\u0261\10\63\4\0"+
    "\1\63\4\0\5\63";

  private static int [] zzUnpackTrans() {
    int [] result = new int[32706];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\1\10\5\0\2\1\13\0\1\11\3\1\1\11\5\1"+
    "\1\11\10\1\1\11\30\1\1\11\1\1\1\11\4\1"+
    "\1\11\11\1\1\11\10\1\1\11\1\1\1\11\1\1"+
    "\1\0\1\1\1\11\2\1\2\11\4\1\1\11\2\1"+
    "\1\11\4\1\1\11\2\1\1\11\1\1\1\11\1\1"+
    "\1\0\4\1\1\0\1\11\3\0\2\1\2\11\14\0"+
    "\1\11\2\1\1\0\1\1\1\0\1\11\1\1\1\11"+
    "\4\1\1\0\53\1\3\0\1\11\2\1\2\11\1\1"+
    "\4\0\2\1\1\11\3\0\4\1\1\11\2\0\1\11"+
    "\3\0\1\11\1\1\2\11\1\1\1\0\1\11\1\1"+
    "\1\0\3\1\12\0\3\1\1\0\2\1\1\0\71\1"+
    "\2\11\1\1\1\11\1\1\1\11\2\0\1\11\1\1"+
    "\1\11\1\0\1\1\12\0\1\11\3\0\75\1\1\11"+
    "\1\1\6\0\1\11\5\0\1\11\65\1\5\0\44\1"+
    "\2\0\134\1";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[609];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  @SuppressWarnings("unused")
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  @SuppressWarnings("unused")
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  @SuppressWarnings("unused")
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	public PHPLexer(int state) {
		initialize(state);
	}

	// NB: this method resets the lexer only partially
	@Override
	protected void reset(java.io.Reader reader, char[] buffer, int[] parameters) {
		this.zzReader = reader;
		this.zzBuffer = buffer;
		this.zzFinalHighSurrogate = 0;
		this.zzMarkedPos = parameters[0];
		this._zzPushbackPos = parameters[1];
		this.zzCurrentPos = parameters[2];
		this.zzStartRead = parameters[3];
		this.zzEndRead = parameters[4];
		this.yyline = parameters[5];
		initialize(parameters[6]);
	}

	@Override
	public int getInScriptingState() {
		return ST_PHP_IN_SCRIPTING;
	}

	private static final int[] heredocStates = new int[] { ST_PHP_HEREDOC, ST_PHP_NOWDOC, ST_PHP_START_HEREDOC, ST_PHP_START_NOWDOC, ST_PHP_END_HEREDOC, ST_PHP_END_NOWDOC };

	@Override
	public int[] getHeredocStates() {
		return heredocStates;
	}

	private static final int[] phpQuotesStates = new int[] { ST_PHP_DOUBLE_QUOTES, ST_PHP_SINGLE_QUOTE, ST_PHP_BACKQUOTE, ST_PHP_HEREDOC, ST_PHP_NOWDOC, ST_PHP_START_HEREDOC, ST_PHP_START_NOWDOC, ST_PHP_END_HEREDOC, ST_PHP_END_NOWDOC };

	@Override
	public int[] getPHPQuotesStates() {
		return phpQuotesStates;
	}

	@Override
	public int[] getParameters() {
		return new int[]{zzMarkedPos, _zzPushbackPos, zzCurrentPos, zzStartRead, zzEndRead, yyline, zzLexicalState};
	}

	@Override
	protected int getZZLexicalState() {
		return zzLexicalState;
	}

	@Override
	protected int getZZMarkedPos() {
		return zzMarkedPos;
	}

	@Override
	protected int getZZEndRead() {
		return zzEndRead;
	}

	@Override
	public char[] getZZBuffer() {
		return zzBuffer;
	}

	@Override
	protected int getZZStartRead() {
		return this.zzStartRead;
	}

	@Override
	protected int getZZPushBackPosition() {
		return this._zzPushbackPos;
	}

	@Override
	protected void pushBack(int i) {
		yypushback(i);
	}

	@Override
	public int getScriptingState() {
		return ST_PHP_IN_SCRIPTING;
	}

	// A pool of states. To avoid creation of a new state on each createMemento.
	private static final Map<LexerState, LexerState> lexerStates = new HashMap<>();

	@Override
	protected Map<LexerState, LexerState> getLexerStates() {
		return lexerStates;
	}

	// End user code


  /** the textposition at the last state to be included in yytext */
  private int _zzPushbackPos;

  /* The following fields are added in order to support the change in zzRefill */
  private String oldString = null;
  private boolean useOldString = false;
  private int startPos = 0;

  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public PHPLexer(java.io.Reader in) {
    this.zzReader = in;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    if (useOldString) {
      String saveOldString = oldString;
      oldString = new String(zzBuffer, startPos, zzMarkedPos - startPos);
      if (saveOldString != null) {
        oldString = saveOldString + oldString;
      }
    }

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      _zzPushbackPos-= zzStartRead;
      startPos = 0;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate) {
      /* if not: blow it up */
      char newBuffer[] = new char[zzBuffer.length * 2];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      throw new java.io.IOException(
          "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Gets the next input character.
   *
   * @return      the next character of the input stream, EOF if the
   *              end of the stream is reached.
   * @exception   IOException  if any I/O-Error occurs
   */
  private int yy_advance() throws java.io.IOException {

    /* standard case */
    if (zzCurrentPos < zzEndRead) return zzBuffer[zzCurrentPos++];

    /* if the eof is reached, we don't need to work hard */
    if (zzAtEOF) return YYEOF;

    /* otherwise: need to refill the buffer */

    String saveOldString = oldString;
    oldString = null;

    /* first: make room (if you can) */
    if (zzRefill()) {
      oldString = saveOldString;
      return YYEOF;
    }

    oldString = saveOldString;

    return zzBuffer[zzCurrentPos++];
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    if (zzBuffer.length > ZZ_BUFFERSIZE) {
      zzBuffer = new char[ZZ_BUFFERSIZE];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      _zzPushbackPos = 0;
      startPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      oldString = null;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }


	/**
	 * user method - common.sse
	 */
	private void updateStartPos() {
		updateStartPos(zzMarkedPos);
	}


	/**
	 * user method - common.sse
	 */
	private void updateStartPos(int position) {
		startPos = position;
		oldString = null;
	}


	/**
	 * user method - common.sse
	 */
	public final boolean isEOF() {
		return zzAtEOF;
	}




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public String yylex() throws java.io.IOException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return null;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { return PHP_ENCAPSED_AND_WHITESPACE;
            }
            // fall through
          case 141: break;
          case 2:
            { return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 142: break;
          case 3:
            { yypushback(1);
	pushState(ST_PHP_HIGHLIGHTING_ERROR);
            }
            // fall through
          case 143: break;
          case 4:
            { return WHITESPACE;
            }
            // fall through
          case 144: break;
          case 5:
            { return PHP_TOKEN;
            }
            // fall through
          case 145: break;
          case 6:
            { pushState(ST_PHP_DOUBLE_QUOTES);
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 146: break;
          case 7:
            { pushState(ST_PHP_LINE_COMMENT);
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 147: break;
          case 8:
            { pushState(ST_PHP_SINGLE_QUOTE);
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 148: break;
          case 9:
            { return PHP_NUMBER;
            }
            // fall through
          case 149: break;
          case 10:
            { return PHP_SEMICOLON;
            }
            // fall through
          case 150: break;
          case 11:
            { return PHP_LABEL;
            }
            // fall through
          case 151: break;
          case 12:
            { return PHP_NS_SEPARATOR;
            }
            // fall through
          case 152: break;
          case 13:
            { pushState(ST_PHP_BACKQUOTE);
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 153: break;
          case 14:
            { // Whitespaces are directly appended to the curly before pushState()
	// is effective or whitespaces would be stored in a separate ContextRegion.
	// Method PhpTokenContainer#addLast() will correct the curlies length...
	if (!phpStack.isEmpty()) {
		// Only push the state when stack is not empty, it's useless otherwise
		// (and it pollutes the stack).
		pushState(ST_PHP_IN_SCRIPTING);
	}
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 154: break;
          case 15:
            { // Whitespaces are directly appended to the curly before pushState()
	// is effective or whitespaces would be stored in a separate ContextRegion.
	// Method PhpTokenContainer#addLast() will correct the curlies length...
	if (!phpStack.isEmpty()) {
		popState();
		// If new state is not ST_PHP_IN_SCRIPTING then some blanks are signifiant (like newlines
		// after the closing curly and before an ending heredoc tag), so don't append them...
		// See rule <ST_PHP_HEREDOC>{HEREDOC_CHARS}*({HEREDOC_NEWLINE}+({LABEL}";"?)?)?
		if (getZZLexicalState() != ST_PHP_IN_SCRIPTING) {
			yypushback(yylength() - 1);
		}
	}
	return PHP_CURLY_CLOSE;
            }
            // fall through
          case 155: break;
          case 16:
            { popState();
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 156: break;
          case 17:
            { yypushback(1);
		popState();
            }
            // fall through
          case 157: break;
          case 18:
            { yypushback(1);
	yybegin(ST_PHP_HEREDOC);
            }
            // fall through
          case 158: break;
          case 19:
            { yypushback(1);
	yybegin(ST_PHP_NOWDOC);
            }
            // fall through
          case 159: break;
          case 20:
            { yypushback(1);
	popState();
            }
            // fall through
          case 160: break;
          case 21:
            { popState();
	return PHP_LABEL;
            }
            // fall through
          case 161: break;
          case 22:
            { yypushback(1);
	popState();
	return PHP_ENCAPSED_AND_WHITESPACE;
            }
            // fall through
          case 162: break;
          case 23:
            { //the difference from the original rules comes from the fact that we took ';' out of tokens
	return UNKNOWN_TOKEN;
            }
            // fall through
          case 163: break;
          case 24:
            { popState();
	return PHP_TOKEN;
            }
            // fall through
          case 164: break;
          case 25:
            { return PHP_COMMENT;
            }
            // fall through
          case 165: break;
          case 26:
            { return PHPDOC_COMMENT;
            }
            // fall through
          case 166: break;
          case 27:
            { String yytext = yytext();
	switch (yytext.charAt(yytext.length() - 1)) {
		case '?':
		case '%':
		case '>':
			yypushback(1);
			if (yylength() > 0) {
				return PHP_LINE_COMMENT;
			}
			break;
		default:
			popState();
			return PHP_LINE_COMMENT;
	}
            }
            // fall through
          case 167: break;
          case 28:
            { return PHP_LINE_COMMENT;
            }
            // fall through
          case 168: break;
          case 29:
            { return UNKNOWN_TOKEN;
            }
            // fall through
          case 169: break;
          case 30:
            { popState();return WHITESPACE;
            }
            // fall through
          case 170: break;
          case 31:
            { yybegin(ST_PHP_IN_SCRIPTING);
	return PHP_ENCAPSED_VARIABLE;
            }
            // fall through
          case 171: break;
          case 32:
            { yybegin(ST_PHP_IN_SCRIPTING);
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 172: break;
          case 33:
            { return PHP_OPERATOR;
            }
            // fall through
          case 173: break;
          case 34:
            { return PHP_VARIABLE;
            }
            // fall through
          case 174: break;
          case 35:
            { if (asp_tags) {
		return PHP_CLOSETAG;
	}
	return UNKNOWN_TOKEN;
            }
            // fall through
          case 175: break;
          case 36:
            { pushState(ST_PHP_LOOKING_FOR_PROPERTY);
	return PHP_OBJECT_OPERATOR;
            }
            // fall through
          case 176: break;
          case 37:
            { pushState(ST_PHP_COMMENT);
	return PHP_COMMENT_START;
            }
            // fall through
          case 177: break;
          case 38:
            { return PHP_PAAMAYIM_NEKUDOTAYIM;
            }
            // fall through
          case 178: break;
          case 39:
            { return PHP_CLOSETAG;
            }
            // fall through
          case 179: break;
          case 40:
            { return PHP_AS;
            }
            // fall through
          case 180: break;
          case 41:
            { return PHP_DO;
            }
            // fall through
          case 181: break;
          case 42:
            { return PHP_IF;
            }
            // fall through
          case 182: break;
          case 43:
            { yypushback(1);
	return PHP_ENCAPSED_AND_WHITESPACE;
            }
            // fall through
          case 183: break;
          case 44:
            { pushState(ST_PHP_QUOTES_AFTER_VARIABLE);
	return PHP_VARIABLE;
            }
            // fall through
          case 184: break;
          case 45:
            { // We can have nested curlies after applying this rule,
	// so we have to count all curlies...
	yypushback(1);
	pushState(ST_PHP_DOLLAR_CURLY_OPEN);
	return PHP_TOKEN;
            }
            // fall through
          case 185: break;
          case 46:
            { // We can have nested curlies after applying rule below for "${",
	// so we have to count all curlies...
	yypushback(1);
	pushState(ST_PHP_IN_SCRIPTING);
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 186: break;
          case 47:
            { popState();
	pushState(ST_PHP_LOOKING_FOR_PROPERTY);
	return PHP_OBJECT_OPERATOR;
            }
            // fall through
          case 187: break;
          case 48:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}

	String heredoc = getHeredocId();
	int heredoc_len = heredoc.length();
	if (label_len == heredoc_len && yytext.substring(0, label_len).equals(heredoc)) {
		// we must (at least) push the newline character back
		yypushback(1);
		popHeredocId();
		popState();
		return PHP_HEREDOC_CLOSE_TAG;
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
		return PHP_ENCAPSED_AND_WHITESPACE;
	}
            }
            // fall through
          case 188: break;
          case 49:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}

	String nowdoc = getHeredocId();
	int nowdoc_len = nowdoc.length();
	if (label_len == nowdoc_len && yytext.substring(0, label_len).equals(nowdoc)) {
		// we must (at least) push the newline character back
		yypushback(1);
		popHeredocId();
		popState();
		return PHP_NOWDOC_CLOSE_TAG;
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
		return PHP_CONSTANT_ENCAPSED_STRING;
	}
            }
            // fall through
          case 189: break;
          case 50:
            { return PHP_OBJECT_OPERATOR;
            }
            // fall through
          case 190: break;
          case 51:
            { popState();
	return PHP_COMMENT_END;
            }
            // fall through
          case 191: break;
          case 52:
            { popState();
	return PHPDOC_COMMENT_END;
            }
            // fall through
          case 192: break;
          case 53:
            { TagKind tagkind = TagKind.getTagKindFromValue(yytext());
		if (tagkind != null && tagkind != TagKind.UNKNOWN
			&& /* ignore @todo tag */ tagkind != TagKind.TODO) {
				return PHPDOC_GENERIC_TAG;
		}
		return PHPDOC_COMMENT;
            }
            // fall through
          case 193: break;
          case 54:
            { popState();
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 194: break;
          case 55:
            { if (asp_tags) {
		return PHP_CLOSETAG;
	}
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 195: break;
          case 56:
            { yypushback(yylength() - 1);
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 196: break;
          case 57:
            { pushState(ST_PHP_DOC_COMMENT);
	return PHPDOC_COMMENT_START;
            }
            // fall through
          case 197: break;
          case 58:
            { return PHP_DIE;
            }
            // fall through
          case 198: break;
          case 59:
            { return PHP_FOR;
            }
            // fall through
          case 199: break;
          case 60:
            { return PHP_NEW;
            }
            // fall through
          case 200: break;
          case 61:
            { return PHP_TRY;
            }
            // fall through
          case 201: break;
          case 62:
            { return PHP_USE;
            }
            // fall through
          case 202: break;
          case 63:
            { return PHP_VAR;
            }
            // fall through
          case 203: break;
          case 64:
            { yypushback(1);
	pushState(ST_PHP_VAR_OFFSET);
	return PHP_VARIABLE;
            }
            // fall through
          case 204: break;
          case 65:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}
	String heredoc = getHeredocId();
	int heredoc_len = heredoc.length();
	int startIndex = label_len - heredoc_len;
	if (startIndex > 0 && yytext.substring(startIndex, label_len).equals(heredoc)
		&& (yytext.charAt(startIndex - 1) == '\n' || yytext.charAt(startIndex - 1) == '\r')) {

		if (startIndex - 2 >= 0
			&& yytext.charAt(startIndex - 2) == '\r'
			&& yytext.charAt(startIndex - 1) == '\n') {
			startIndex-= 2;
		} else {
			startIndex--;
		}
		yypushback(yylength() - startIndex);

		yybegin(ST_PHP_END_HEREDOC);
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
	}
	// In some cases, all text is pushed back (using yypushback()),
	// especially when the parsed document has Windows newlines.
	// In those cases, ignore this rule and try next one...
	if (yylength() > 0) {
		return PHP_ENCAPSED_AND_WHITESPACE;
	}
            }
            // fall through
          case 205: break;
          case 66:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}
	String nowdoc = getHeredocId();
	int nowdoc_len = nowdoc.length();
	int startIndex = label_len - nowdoc_len;
	if (startIndex > 0 && yytext.substring(startIndex, label_len).equals(nowdoc)
		&& (yytext.charAt(startIndex - 1) == '\n' || yytext.charAt(startIndex - 1) == '\r')) {

		if (startIndex - 2 >= 0
			&& yytext.charAt(startIndex - 2) == '\r'
			&& yytext.charAt(startIndex - 1) == '\n') {
			startIndex-= 2;
		} else {
			startIndex--;
		}
		yypushback(yylength() - startIndex);

		yybegin(ST_PHP_END_NOWDOC);
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
	}
	// In some cases, all text is pushed back (using yypushback()),
	// especially when the parsed document has Windows newlines.
	// In those cases, ignore this rule and try next one...
	if (yylength() > 0) {
		return PHP_CONSTANT_ENCAPSED_STRING;
	}
            }
            // fall through
          case 206: break;
          case 67:
            { // we must (at least) push the newline character back
	yypushback(1);
	popHeredocId();
	popState();
	return PHP_HEREDOC_CLOSE_TAG;
            }
            // fall through
          case 207: break;
          case 68:
            { yypushback(yylength() - 2);
	if (asp_tags) {
		return PHP_CLOSETAG;
	}
	popState();
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 208: break;
          case 69:
            { // we must (at least) push the newline character back
	yypushback(1);
	popHeredocId();
	popState();
	return PHP_NOWDOC_CLOSE_TAG;
            }
            // fall through
          case 209: break;
          case 70:
            { yypushback(2);
	pushState(ST_PHP_COMMENT);
	return PHP_COMMENT_START;
            }
            // fall through
          case 210: break;
          case 71:
            { return PHP_CASE;
            }
            // fall through
          case 211: break;
          case 72:
            { return PHP_ECHO;
            }
            // fall through
          case 212: break;
          case 73:
            { return PHP_ELSE;
            }
            // fall through
          case 213: break;
          case 74:
            { return PHP_EVAL;
            }
            // fall through
          case 214: break;
          case 75:
            { return PHP_EXIT;
            }
            // fall through
          case 215: break;
          case 76:
            { return PHP_FROM;
            }
            // fall through
          case 216: break;
          case 77:
            { return PHP_GOTO;
            }
            // fall through
          case 217: break;
          case 78:
            { return PHP_LIST;
            }
            // fall through
          case 218: break;
          case 79:
            { return PHP_KEYWORD;
            }
            // fall through
          case 219: break;
          case 80:
            { return PHP_SELF;
            }
            // fall through
          case 220: break;
          case 81:
            { return PHP_TRUE;
            }
            // fall through
          case 221: break;
          case 82:
            { TagKind tagkind = TagKind.getTagKindFromValue(yytext());
		if (tagkind != null && tagkind != TagKind.UNKNOWN) {
			return PHPDOC_GENERIC_TAG;
		}
		return PHPDOC_COMMENT;
            }
            // fall through
          case 222: break;
          case 83:
            { return PHP_THIS;
            }
            // fall through
          case 223: break;
          case 84:
            { return PHP_CASTING;
            }
            // fall through
          case 224: break;
          case 85:
            { String yytext = yytext();
	int bprefix = (yytext.charAt(0) != '<') ? 1 : 0;
	int startString = 3 + bprefix;

	int hereOrNowDoc_len = yylength() - bprefix - 3 - 1 - (yytext.charAt(yylength() - 2) == '\r' ? 1 : 0);
	while ((yytext.charAt(startString) == ' ') || (yytext.charAt(startString) == '\t')) {
		startString++;
		hereOrNowDoc_len--;
	}
	String hereOrNowDoc = yytext.substring(startString, hereOrNowDoc_len + startString);
	if (hereOrNowDoc.charAt(0) == '\'') {
		pushHeredocId(hereOrNowDoc.substring(1, hereOrNowDoc_len - 1));
		pushState(ST_PHP_START_NOWDOC);
		return PHP_NOWDOC_START_TAG;
	} else if (hereOrNowDoc.charAt(0) == '"') {
		pushHeredocId(hereOrNowDoc.substring(1, hereOrNowDoc_len - 1));
		pushState(ST_PHP_START_HEREDOC);
		return PHP_HEREDOC_START_TAG;
	} else {
		pushHeredocId(hereOrNowDoc);
		pushState(ST_PHP_START_HEREDOC);
		return PHP_HEREDOC_START_TAG;
	}
            }
            // fall through
          case 225: break;
          case 86:
            { return PHP_ARRAY;
            }
            // fall through
          case 226: break;
          case 87:
            { return PHP_BREAK;
            }
            // fall through
          case 227: break;
          case 88:
            { return PHP_CATCH;
            }
            // fall through
          case 228: break;
          case 89:
            { return PHP_CLASS;
            }
            // fall through
          case 229: break;
          case 90:
            { return PHP_CLONE;
            }
            // fall through
          case 230: break;
          case 91:
            { return PHP_CONST;
            }
            // fall through
          case 231: break;
          case 92:
            { return PHP_EMPTY;
            }
            // fall through
          case 232: break;
          case 93:
            { return PHP_ENDIF;
            }
            // fall through
          case 233: break;
          case 94:
            { return PHP_FALSE;
            }
            // fall through
          case 234: break;
          case 95:
            { return PHP_FINAL;
            }
            // fall through
          case 235: break;
          case 96:
            { return PHP_ISSET;
            }
            // fall through
          case 236: break;
          case 97:
            { return PHP_PRINT;
            }
            // fall through
          case 237: break;
          case 98:
            { return PHP_THROW;
            }
            // fall through
          case 238: break;
          case 99:
            { return PHP_TRAIT;
            }
            // fall through
          case 239: break;
          case 100:
            { return PHP_UNSET;
            }
            // fall through
          case 240: break;
          case 101:
            { return PHP_WHILE;
            }
            // fall through
          case 241: break;
          case 102:
            { return PHP_ELSEIF;
            }
            // fall through
          case 242: break;
          case 103:
            { return PHP_ENDFOR;
            }
            // fall through
          case 243: break;
          case 104:
            { return PHP_GLOBAL;
            }
            // fall through
          case 244: break;
          case 105:
            { return PHP_PARENT;
            }
            // fall through
          case 245: break;
          case 106:
            { return PHP_PUBLIC;
            }
            // fall through
          case 246: break;
          case 107:
            { return PHP_RETURN;
            }
            // fall through
          case 247: break;
          case 108:
            { return PHP_STATIC;
            }
            // fall through
          case 248: break;
          case 109:
            { return PHP_SWITCH;
            }
            // fall through
          case 249: break;
          case 110:
            { return PHP_DECLARE;
            }
            // fall through
          case 250: break;
          case 111:
            { return PHP_DEFAULT;
            }
            // fall through
          case 251: break;
          case 112:
            { return PHP_EXTENDS;
            }
            // fall through
          case 252: break;
          case 113:
            { return PHP_FOREACH;
            }
            // fall through
          case 253: break;
          case 114:
            { return PHP_INCLUDE;
            }
            // fall through
          case 254: break;
          case 115:
            { return PHP_PRIVATE;
            }
            // fall through
          case 255: break;
          case 116:
            { return PHP_REQUIRE;
            }
            // fall through
          case 256: break;
          case 117:
            { return PHP__DIR__;
            }
            // fall through
          case 257: break;
          case 118:
            { return PHP_ABSTRACT;
            }
            // fall through
          case 258: break;
          case 119:
            { return PHP_CALLABLE;
            }
            // fall through
          case 259: break;
          case 120:
            { return PHP_CONTINUE;
            }
            // fall through
          case 260: break;
          case 121:
            { return PHP_ENDWHILE;
            }
            // fall through
          case 261: break;
          case 122:
            { return PHP_FUNCTION;
            }
            // fall through
          case 262: break;
          case 123:
            { return PHP__FILE__;
            }
            // fall through
          case 263: break;
          case 124:
            { return PHP__LINE__;
            }
            // fall through
          case 264: break;
          case 125:
            { return PHP_ENDSWITCH;
            }
            // fall through
          case 265: break;
          case 126:
            { return PHP_INSTEADOF;
            }
            // fall through
          case 266: break;
          case 127:
            { return PHP_INTERFACE;
            }
            // fall through
          case 267: break;
          case 128:
            { return PHP_NAMESPACE;
            }
            // fall through
          case 268: break;
          case 129:
            { return PHP_PROTECTED;
            }
            // fall through
          case 269: break;
          case 130:
            { return PHP__CLASS__;
            }
            // fall through
          case 270: break;
          case 131:
            { return PHP_ENDDECLARE;
            }
            // fall through
          case 271: break;
          case 132:
            { return PHP_ENDFOREACH;
            }
            // fall through
          case 272: break;
          case 133:
            { return PHP_IMPLEMENTS;
            }
            // fall through
          case 273: break;
          case 134:
            { return PHP_INSTANCEOF;
            }
            // fall through
          case 274: break;
          case 135:
            { return PHP__METHOD__;
            }
            // fall through
          case 275: break;
          case 136:
            { return PHP_INCLUDE_ONCE;
            }
            // fall through
          case 276: break;
          case 137:
            { return PHP_REQUIRE_ONCE;
            }
            // fall through
          case 277: break;
          case 138:
            { return PHP__FUNCTION__;
            }
            // fall through
          case 278: break;
          case 139:
            { return PHP__NAMESPACE__;
            }
            // fall through
          case 279: break;
          case 140:
            { return PHP_HALT_COMPILER;
            }
            // fall through
          case 280: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }


}
