// DO NOT EDIT
// Generated by JFlex 1.8.2 http://jflex.de/
// source: highlighting_scanner.jflex

/*******************************************************************************
 * Copyright (c) 2006, 2017 Zend Corporation and IBM Corporation.
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *   Zend and IBM - Initial implementation
 *******************************************************************************/

package org.eclipse.php.internal.core.documentModel.parser.php55;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.php.core.compiler.ast.nodes.PHPDocTag.TagKind;

//@SuppressWarnings({"unused", "nls"})


// See https://github.com/jflex-de/jflex/issues/222
@SuppressWarnings("FallThrough")
public class PHPLexer extends org.eclipse.php.internal.core.documentModel.parser.AbstractPHPLexer {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int ST_PHP_IN_SCRIPTING = 2;
  public static final int ST_PHP_DOUBLE_QUOTES = 4;
  public static final int ST_PHP_SINGLE_QUOTE = 6;
  public static final int ST_PHP_BACKQUOTE = 8;
  public static final int ST_PHP_QUOTES_AFTER_VARIABLE = 10;
  public static final int ST_PHP_HEREDOC = 12;
  public static final int ST_PHP_NOWDOC = 14;
  public static final int ST_PHP_START_HEREDOC = 16;
  public static final int ST_PHP_START_NOWDOC = 18;
  public static final int ST_PHP_END_HEREDOC = 20;
  public static final int ST_PHP_LOOKING_FOR_PROPERTY = 22;
  public static final int ST_PHP_VAR_OFFSET = 24;
  public static final int ST_PHP_COMMENT = 26;
  public static final int ST_PHP_DOC_COMMENT = 28;
  public static final int ST_PHP_LINE_COMMENT = 30;
  public static final int ST_PHP_HIGHLIGHTING_ERROR = 32;
  public static final int ST_PHP_END_NOWDOC = 34;
  public static final int ST_PHP_DOLLAR_CURLY_OPEN = 36;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7,  7, 
     8,  8,  9,  9, 10, 10, 11, 11, 12, 12, 13, 13, 14, 14, 15, 15, 
    16, 16, 17, 17, 18, 18
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\37\u0200\1\u0300\266\u0200\10\u0400\40\u0200\u1000\u0500";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\2\0\1\3\22\0\1\1\1\4"+
    "\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14"+
    "\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24"+
    "\10\25\1\26\1\27\1\30\1\31\1\32\1\33\1\34"+
    "\1\35\1\36\1\37\1\40\1\41\1\42\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\54"+
    "\1\55\1\56\1\57\1\60\1\61\1\62\1\63\1\64"+
    "\1\65\1\66\1\67\1\70\1\71\1\72\1\73\1\74"+
    "\1\35\1\36\1\37\1\40\1\41\1\42\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\54"+
    "\1\55\1\56\1\57\1\60\1\61\1\62\1\63\1\64"+
    "\1\65\1\66\1\75\1\76\1\77\1\17\1\0\260\100"+
    "\2\101\115\100\1\102\u01aa\100\1\103\325\100\u0100\104\u0100\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1536];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\6\0\1\1\1\2\13\0\1\3\1\4\1\5\1\6"+
    "\1\7\3\5\1\10\7\5\2\11\1\5\1\12\4\5"+
    "\25\13\1\14\1\13\1\15\1\16\1\5\1\17\1\1"+
    "\1\20\5\2\1\1\3\2\3\21\2\1\3\3\1\2"+
    "\2\22\2\23\1\0\1\3\2\24\1\25\1\26\2\27"+
    "\2\11\1\13\1\30\2\31\4\32\3\33\3\34\1\35"+
    "\1\36\1\0\1\3\1\37\1\40\1\41\1\0\1\2"+
    "\3\0\2\42\1\41\1\43\14\0\1\44\1\11\1\45"+
    "\1\0\1\11\1\0\1\46\1\41\1\47\3\13\1\50"+
    "\1\0\6\13\1\51\15\13\1\52\7\13\1\41\17\13"+
    "\3\0\2\53\1\54\1\55\1\56\1\53\4\0\2\53"+
    "\1\57\3\0\1\1\2\53\1\2\1\60\2\0\1\61"+
    "\3\0\1\62\1\54\1\63\1\64\1\65\1\0\1\66"+
    "\1\67\1\0\1\40\1\70\1\42\12\0\1\71\2\11"+
    "\1\0\2\13\1\0\11\13\1\72\11\13\1\73\13\13"+
    "\1\74\15\13\1\75\1\13\1\76\1\77\11\13\1\100"+
    "\1\101\1\1\1\102\1\2\1\103\2\0\2\104\1\105"+
    "\1\0\1\42\12\0\1\106\3\0\4\13\1\107\7\13"+
    "\1\110\1\111\6\13\1\112\1\113\4\13\1\114\2\13"+
    "\1\115\5\13\1\116\1\13\1\117\7\13\1\120\4\13"+
    "\1\121\13\13\1\122\1\123\6\0\1\124\5\0\2\125"+
    "\1\13\1\126\1\127\1\13\1\130\1\131\1\132\1\133"+
    "\4\13\1\134\2\13\1\135\3\13\1\136\1\137\10\13"+
    "\1\140\2\13\1\141\7\13\1\142\1\143\1\144\1\145"+
    "\1\146\10\13\5\0\5\13\1\147\1\13\1\150\6\13"+
    "\1\151\6\13\1\152\2\13\1\153\1\13\1\154\1\155"+
    "\1\156\10\13\2\0\3\13\1\157\1\160\4\13\1\161"+
    "\1\162\1\163\2\13\1\164\4\13\1\165\1\13\1\166"+
    "\1\13\1\167\6\13\1\170\1\171\1\172\3\13\1\173"+
    "\1\174\11\13\1\175\2\13\1\176\4\13\1\177\3\13"+
    "\1\200\1\201\1\202\1\203\1\13\1\204\4\13\1\205"+
    "\1\206\1\207\1\13\1\210\3\13\1\211\6\13\1\212"+
    "\1\213\1\214\3\13\1\215\1\13\1\216";

  private static int [] zzUnpackAction() {
    int [] result = new int[616];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\105\0\212\0\317\0\u0114\0\u0159\0\u019e\0\u01e3"+
    "\0\u0228\0\u026d\0\u02b2\0\u02f7\0\u033c\0\u0381\0\u03c6\0\u040b"+
    "\0\u0450\0\u0495\0\u04da\0\0\0\u051f\0\u0564\0\u05a9\0\0"+
    "\0\u05ee\0\u0633\0\u0678\0\u06bd\0\u0702\0\0\0\u0747\0\u078c"+
    "\0\u07d1\0\u0816\0\u085b\0\u08a0\0\u08e5\0\u092a\0\0\0\u096f"+
    "\0\u09b4\0\u09f9\0\u0a3e\0\u0a83\0\u0ac8\0\u0b0d\0\u0b52\0\u0b97"+
    "\0\u0bdc\0\u0c21\0\u0c66\0\u0cab\0\u0cf0\0\u0d35\0\u0d7a\0\u0dbf"+
    "\0\u0e04\0\u0e49\0\u0e8e\0\u0ed3\0\u0f18\0\u0f5d\0\u0fa2\0\u0fe7"+
    "\0\0\0\u102c\0\0\0\u1071\0\u10b6\0\u10fb\0\u1140\0\0"+
    "\0\u1185\0\u11ca\0\u120f\0\u1254\0\u1299\0\u12de\0\u1323\0\u1368"+
    "\0\u13ad\0\0\0\u13f2\0\u1437\0\u147c\0\u14c1\0\u1506\0\u154b"+
    "\0\u1590\0\u15d5\0\0\0\u161a\0\0\0\u165f\0\u16a4\0\u16e9"+
    "\0\0\0\u172e\0\u1773\0\0\0\0\0\u17b8\0\u17fd\0\u1842"+
    "\0\u1887\0\0\0\u18cc\0\u1911\0\0\0\u1956\0\u199b\0\u19e0"+
    "\0\u1a25\0\0\0\u1a6a\0\u1aaf\0\0\0\u0a3e\0\0\0\u1af4"+
    "\0\u1b39\0\u1b7e\0\u1bc3\0\u1c08\0\u0747\0\u05a9\0\0\0\u1c4d"+
    "\0\u1c92\0\u1cd7\0\u1d1c\0\u1d61\0\0\0\0\0\u06bd\0\u1da6"+
    "\0\u0702\0\u1deb\0\u1e30\0\u1e75\0\u1eba\0\u1eff\0\u1f44\0\u1f89"+
    "\0\u1fce\0\u2013\0\0\0\u2058\0\u209d\0\u20e2\0\u2127\0\u216c"+
    "\0\0\0\u21b1\0\0\0\u21f6\0\u223b\0\u2280\0\u0c66\0\u22c5"+
    "\0\u230a\0\u234f\0\u2394\0\u23d9\0\u241e\0\u2463\0\u0c66\0\u24a8"+
    "\0\u24ed\0\u2532\0\u2577\0\u25bc\0\u2601\0\u2646\0\u268b\0\u26d0"+
    "\0\u2715\0\u275a\0\u279f\0\u27e4\0\u0c66\0\u2829\0\u286e\0\u28b3"+
    "\0\u28f8\0\u293d\0\u2982\0\u29c7\0\u0c66\0\u2a0c\0\u2a51\0\u2a96"+
    "\0\u2adb\0\u2b20\0\u2b65\0\u2baa\0\u2bef\0\u2c34\0\u2c79\0\u2cbe"+
    "\0\u2d03\0\u2d48\0\u2d8d\0\u2dd2\0\u2e17\0\u11ca\0\u2e5c\0\0"+
    "\0\u2e17\0\u2ea1\0\0\0\0\0\u2e5c\0\u2ee6\0\u2f2b\0\u1368"+
    "\0\u2f70\0\u2f2b\0\u2f70\0\0\0\u2fb5\0\u154b\0\u2ffa\0\u303f"+
    "\0\u2fb5\0\u2ffa\0\u3084\0\0\0\u161a\0\u30c9\0\0\0\u165f"+
    "\0\u310e\0\u3153\0\0\0\u3198\0\0\0\0\0\u199b\0\u31dd"+
    "\0\0\0\u3222\0\u3267\0\u32ac\0\u32f1\0\u3336\0\u337b\0\u33c0"+
    "\0\u3405\0\u344a\0\u348f\0\u34d4\0\u3519\0\u355e\0\u35a3\0\u35e8"+
    "\0\u362d\0\u20e2\0\u216c\0\u3672\0\u36b7\0\u36fc\0\u3741\0\u3786"+
    "\0\u37cb\0\u3810\0\u3855\0\u389a\0\u38df\0\u3924\0\u3969\0\u39ae"+
    "\0\u0c66\0\u39f3\0\u3a38\0\u3a7d\0\u3ac2\0\u3b07\0\u3b4c\0\u3b91"+
    "\0\u3bd6\0\u3c1b\0\u3c60\0\u3ca5\0\u3cea\0\u3d2f\0\u3d74\0\u3db9"+
    "\0\u3dfe\0\u3e43\0\u3e88\0\u3ecd\0\u3f12\0\u3f57\0\u0c66\0\u3f9c"+
    "\0\u3fe1\0\u4026\0\u406b\0\u40b0\0\u40f5\0\u413a\0\u417f\0\u41c4"+
    "\0\u4209\0\u424e\0\u4293\0\u42d8\0\u0c66\0\u431d\0\u0c66\0\u0c66"+
    "\0\u4362\0\u43a7\0\u43ec\0\u4431\0\u4476\0\u44bb\0\u4500\0\u4545"+
    "\0\u458a\0\0\0\0\0\u45cf\0\0\0\u4614\0\0\0\u4659"+
    "\0\u469e\0\0\0\u46e3\0\0\0\u4728\0\u476d\0\u47b2\0\u47f7"+
    "\0\u483c\0\u4881\0\u48c6\0\u490b\0\u4950\0\u4995\0\u49da\0\u4a1f"+
    "\0\0\0\u4a64\0\u4aa9\0\u4aee\0\u4b33\0\u4b78\0\u4bbd\0\u4c02"+
    "\0\u0c66\0\u4c47\0\u4c8c\0\u4cd1\0\u4d16\0\u4d5b\0\u4da0\0\u4de5"+
    "\0\u0c66\0\u4e2a\0\u4e6f\0\u4eb4\0\u4ef9\0\u4f3e\0\u4f83\0\u4fc8"+
    "\0\u0c66\0\u0c66\0\u500d\0\u5052\0\u5097\0\u50dc\0\u0c66\0\u5121"+
    "\0\u5166\0\u0c66\0\u51ab\0\u51f0\0\u5235\0\u527a\0\u52bf\0\u0c66"+
    "\0\u5304\0\u0c66\0\u5349\0\u538e\0\u53d3\0\u5418\0\u545d\0\u54a2"+
    "\0\u54e7\0\u0c66\0\u552c\0\u5571\0\u55b6\0\u55fb\0\u0c66\0\u5640"+
    "\0\u5685\0\u56ca\0\u570f\0\u5754\0\u5799\0\u57de\0\u5823\0\u5868"+
    "\0\u58ad\0\u58f2\0\0\0\u1d1c\0\u5937\0\u597c\0\u59c1\0\u5a06"+
    "\0\u5a4b\0\u5a90\0\0\0\u5ad5\0\u5b1a\0\u5b5f\0\u5ba4\0\u5be9"+
    "\0\0\0\u5c2e\0\u5c73\0\u0c66\0\u0c66\0\u5cb8\0\u0c66\0\u0c66"+
    "\0\u0c66\0\u0c66\0\u5cfd\0\u5d42\0\u5d87\0\u5dcc\0\u0c66\0\u5e11"+
    "\0\u5e56\0\u0c66\0\u5e9b\0\u5ee0\0\u5f25\0\u0c66\0\u5f6a\0\u5faf"+
    "\0\u5ff4\0\u6039\0\u607e\0\u60c3\0\u6108\0\u614d\0\u6192\0\u0c66"+
    "\0\u61d7\0\u621c\0\u0c66\0\u6261\0\u62a6\0\u62eb\0\u6330\0\u6375"+
    "\0\u63ba\0\u63ff\0\u0c66\0\u0c66\0\u0c66\0\u0c66\0\u0c66\0\u6444"+
    "\0\u6489\0\u64ce\0\u6513\0\u6558\0\u659d\0\u65e2\0\u6627\0\u666c"+
    "\0\u66b1\0\u66f6\0\u673b\0\u6780\0\u67c5\0\u680a\0\u684f\0\u6894"+
    "\0\u68d9\0\u0c66\0\u691e\0\u6963\0\u69a8\0\u69ed\0\u6a32\0\u6a77"+
    "\0\u6abc\0\u6b01\0\u0c66\0\u6b46\0\u6b8b\0\u6bd0\0\u6c15\0\u6c5a"+
    "\0\u6c9f\0\u0c66\0\u6ce4\0\u6d29\0\u0c66\0\u6d6e\0\u0c66\0\u0c66"+
    "\0\u0c66\0\u6db3\0\u6df8\0\u6e3d\0\u6e82\0\u6ec7\0\u6f0c\0\u6f51"+
    "\0\u6f96\0\u6fdb\0\u7020\0\u7065\0\u70aa\0\u70ef\0\u0c66\0\u0c66"+
    "\0\u7134\0\u7179\0\u71be\0\u7203\0\u0c66\0\u0c66\0\u0c66\0\u7248"+
    "\0\u728d\0\u72d2\0\u7317\0\u735c\0\u73a1\0\u73e6\0\u0c66\0\u742b"+
    "\0\u7470\0\u74b5\0\u0c66\0\u74fa\0\u753f\0\u7584\0\u75c9\0\u760e"+
    "\0\u7653\0\u0c66\0\u0c66\0\u0c66\0\u7698\0\u76dd\0\u7722\0\u0c66"+
    "\0\u0c66\0\u7767\0\u77ac\0\u77f1\0\u7836\0\u787b\0\u78c0\0\u7905"+
    "\0\u794a\0\u798f\0\u0c66\0\u79d4\0\u7a19\0\u0c66\0\u7a5e\0\u7aa3"+
    "\0\u7ae8\0\u7b2d\0\u0c66\0\u7b72\0\u7bb7\0\u7bfc\0\u0c66\0\u0c66"+
    "\0\u0c66\0\u0c66\0\u7c41\0\u0c66\0\u7c86\0\u7ccb\0\u7d10\0\u7d55"+
    "\0\u0c66\0\u0c66\0\u0c66\0\u7d9a\0\u0c66\0\u7ddf\0\u7e24\0\u7e69"+
    "\0\u0c66\0\u7eae\0\u7ef3\0\u7f38\0\u7f7d\0\u7fc2\0\u8007\0\u0c66"+
    "\0\u0c66\0\u0c66\0\u804c\0\u8091\0\u80d6\0\u0c66\0\u811b\0\u0c66";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[616];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\105\0\1\24\3\25\1\26\1\27\1\30\1\31\1\32"+
    "\1\33\1\34\1\35\1\36\1\37\1\40\1\36\1\41"+
    "\1\42\1\43\1\44\2\45\1\46\1\47\1\50\1\51"+
    "\1\52\1\53\1\36\1\54\1\55\1\56\1\57\1\60"+
    "\1\61\1\62\1\63\1\64\2\63\1\65\1\63\1\66"+
    "\1\67\1\70\1\63\1\71\1\72\1\73\1\74\1\75"+
    "\1\76\1\77\1\100\1\63\1\36\1\101\1\36\1\37"+
    "\1\102\1\103\1\104\1\105\1\106\1\63\1\64\1\72"+
    "\2\63\5\107\1\110\1\107\1\111\60\107\1\112\4\107"+
    "\1\113\7\107\12\114\1\110\55\114\1\115\14\114\7\116"+
    "\1\117\60\116\1\120\3\116\1\110\1\121\7\116\20\122"+
    "\1\123\54\122\1\124\7\122\2\125\2\126\3\125\1\127"+
    "\60\125\1\130\4\125\1\131\7\125\2\10\2\132\101\10"+
    "\35\133\32\134\4\133\1\134\4\133\5\134\35\135\32\136"+
    "\4\135\1\136\4\135\5\136\2\24\1\137\1\140\100\24"+
    "\1\0\1\141\3\25\14\141\1\142\14\141\32\143\4\141"+
    "\1\143\4\141\5\143\1\24\3\144\2\145\1\144\1\146"+
    "\2\145\1\144\10\145\1\147\2\150\7\145\15\63\1\151"+
    "\14\63\1\36\1\144\1\152\1\145\1\63\4\145\5\63"+
    "\15\153\1\154\67\153\15\155\1\156\16\155\1\157\40\155"+
    "\1\160\7\155\2\161\1\162\1\163\4\161\1\164\21\161"+
    "\1\165\1\166\51\161\1\167\3\170\100\167\1\0\2\24"+
    "\1\171\1\172\100\24\1\0\2\24\1\0\32\24\32\173"+
    "\4\24\1\173\1\24\1\174\2\24\5\173\1\0\3\25"+
    "\132\0\1\175\53\0\5\176\1\177\1\176\1\200\60\176"+
    "\1\201\4\176\1\202\7\176\35\0\23\203\1\204\6\203"+
    "\4\0\1\203\4\0\5\203\31\0\1\205\1\206\63\0"+
    "\1\205\17\0\1\205\53\0\12\207\1\177\55\207\1\210"+
    "\14\207\1\0\1\211\33\0\1\212\1\213\1\0\1\214"+
    "\1\0\1\215\2\0\1\216\5\0\1\217\2\0\1\220"+
    "\1\221\1\0\1\222\17\0\1\216\1\221\33\0\1\205"+
    "\71\0\1\205\12\0\1\205\73\0\1\205\10\0\1\205"+
    "\1\223\75\0\3\224\3\0\1\205\70\0\1\225\4\0"+
    "\1\30\6\0\1\205\74\0\1\224\1\0\3\45\10\0"+
    "\1\226\2\0\1\227\22\0\1\230\41\0\1\224\1\0"+
    "\3\45\13\0\1\227\71\0\1\231\106\0\1\232\2\205"+
    "\103\0\1\175\1\205\103\0\1\205\1\175\104\0\1\233"+
    "\75\0\3\63\7\0\1\63\1\234\13\63\1\235\3\63"+
    "\1\236\1\237\7\63\4\0\1\63\4\0\2\63\1\237"+
    "\2\63\5\0\1\27\4\0\1\34\10\0\3\63\2\0"+
    "\1\240\4\0\21\63\1\241\10\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\1\242\12\63\1\243\2\63"+
    "\1\244\13\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\4\63\1\245\3\63\1\246\5\63\1\247\13\63"+
    "\4\0\1\63\4\0\1\63\1\246\3\63\23\0\3\63"+
    "\7\0\2\63\1\250\10\63\1\251\1\252\1\253\7\63"+
    "\1\254\1\63\1\255\2\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\1\256\7\63\1\257\5\63\1\260"+
    "\2\63\1\261\2\63\1\262\5\63\4\0\1\63\4\0"+
    "\1\63\1\257\3\63\23\0\3\63\7\0\13\63\1\263"+
    "\2\63\1\264\13\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\32\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\5\63\1\265\6\63\1\266\1\267\4\63"+
    "\1\270\7\63\4\0\1\63\4\0\2\63\1\270\2\63"+
    "\23\0\3\63\7\0\10\63\1\271\21\63\4\0\1\63"+
    "\4\0\1\63\1\271\3\63\23\0\3\63\7\0\1\272"+
    "\3\63\1\273\17\63\1\274\5\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\21\63\1\275\10\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\1\276\20\63"+
    "\1\277\2\63\1\300\5\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\4\63\1\301\25\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\4\63\1\302\16\63"+
    "\1\303\2\63\1\304\3\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\7\63\1\305\11\63\1\306\10\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\15\63"+
    "\1\307\4\63\1\310\7\63\4\0\1\63\4\0\2\63"+
    "\1\310\2\63\23\0\3\63\7\0\1\311\31\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\7\63\1\312"+
    "\22\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\16\63\1\67\13\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\10\63\1\313\21\63\4\0\1\63\4\0"+
    "\1\63\1\313\3\63\23\0\3\63\7\0\32\63\4\0"+
    "\1\314\4\0\5\63\1\0\3\104\132\0\1\205\44\0"+
    "\1\205\7\0\3\106\101\0\5\107\1\0\1\107\1\315"+
    "\60\107\1\316\4\107\1\317\14\107\1\320\1\107\1\321"+
    "\25\107\32\322\1\107\1\316\2\107\1\322\1\107\1\323"+
    "\2\107\5\322\112\107\1\320\1\107\1\324\60\107\1\316"+
    "\4\107\1\325\7\107\12\114\1\0\55\114\1\326\26\114"+
    "\1\177\55\114\1\177\14\114\7\116\1\327\60\116\1\330"+
    "\3\116\1\0\1\331\16\116\1\332\25\116\32\322\1\116"+
    "\1\330\2\116\1\322\1\320\1\323\2\116\5\322\114\116"+
    "\1\324\60\116\1\330\3\116\1\320\1\333\7\116\32\0"+
    "\1\334\61\0\1\324\75\0\2\125\2\126\3\125\1\335"+
    "\60\125\1\336\4\125\1\337\11\125\2\126\3\125\1\335"+
    "\25\125\32\340\1\125\1\336\2\125\1\340\1\125\1\337"+
    "\2\125\5\340\2\125\2\126\3\125\1\341\25\125\32\322"+
    "\1\125\1\336\2\125\1\322\1\125\1\323\2\125\5\322"+
    "\2\125\2\126\103\125\2\126\3\125\1\324\60\125\1\336"+
    "\4\125\1\342\7\125\2\10\2\132\31\10\32\343\4\10"+
    "\1\343\4\10\5\343\2\0\2\344\17\0\3\345\1\0"+
    "\1\346\5\0\32\345\4\0\1\345\4\0\5\345\2\0"+
    "\2\347\17\0\3\350\1\0\1\351\5\0\32\350\4\0"+
    "\1\350\4\0\5\350\35\0\32\352\4\0\1\352\4\0"+
    "\5\352\2\0\1\137\32\0\32\352\4\0\1\352\4\0"+
    "\5\352\32\0\1\353\75\0\3\143\7\0\32\143\4\0"+
    "\1\143\4\0\5\143\35\0\32\354\4\0\1\354\4\0"+
    "\5\354\23\0\3\150\10\0\1\226\25\0\1\230\43\0"+
    "\3\150\102\0\3\63\7\0\24\63\1\274\5\63\4\0"+
    "\1\63\4\0\5\63\15\153\1\0\67\153\22\0\1\355"+
    "\104\0\1\356\62\0\1\357\3\0\11\357\1\0\67\357"+
    "\34\0\1\360\50\0\2\161\2\162\4\161\1\162\21\161"+
    "\2\162\51\161\2\0\1\361\134\0\1\362\53\0\3\170"+
    "\136\0\32\363\4\0\1\363\4\0\5\363\2\0\1\171"+
    "\32\0\32\363\4\0\1\363\4\0\5\363\23\0\3\173"+
    "\7\0\32\173\4\0\1\173\4\0\5\173\1\0\3\364"+
    "\31\0\32\365\4\0\1\365\4\0\5\365\5\176\1\177"+
    "\1\176\1\200\25\176\32\0\1\176\1\201\2\176\1\0"+
    "\1\176\1\0\2\176\5\0\112\176\1\177\1\176\1\0"+
    "\60\176\1\201\4\176\1\202\7\176\23\0\3\203\7\0"+
    "\32\203\4\0\1\203\4\0\5\203\23\0\3\203\7\0"+
    "\7\203\1\366\22\203\4\0\1\203\4\0\5\203\105\207"+
    "\56\0\1\367\73\0\1\370\5\0\1\371\25\0\1\370"+
    "\56\0\1\372\101\0\1\373\106\0\1\374\70\0\1\375"+
    "\107\0\1\376\123\0\1\377\76\0\1\u0100\55\0\3\224"+
    "\13\0\1\227\60\0\1\u0101\112\0\2\u0102\76\0\1\150"+
    "\1\0\1\150\2\0\3\150\102\0\3\u0103\7\0\6\u0103"+
    "\72\0\1\u0104\1\205\76\0\3\63\7\0\22\63\1\u0105"+
    "\7\63\4\0\1\63\4\0\2\63\1\u0105\2\63\23\0"+
    "\3\63\7\0\3\63\1\275\26\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\21\63\1\u0106\10\63\4\0"+
    "\1\63\4\0\5\63\30\0\1\u0107\77\0\3\63\7\0"+
    "\4\63\1\u0108\25\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\13\63\1\u0109\6\63\1\u010a\1\u010b\6\63"+
    "\4\0\1\63\4\0\2\63\1\u010a\2\63\23\0\3\63"+
    "\7\0\1\u010c\15\63\1\u010d\13\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\15\63\1\u010e\14\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\2\63\1\u010f"+
    "\2\63\1\u0110\24\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\4\63\1\u0111\25\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\7\63\1\u0112\22\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\22\63\1\u0113"+
    "\7\63\4\0\1\63\4\0\2\63\1\u0113\2\63\23\0"+
    "\3\63\7\0\17\63\1\u0114\12\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\3\63\1\u0115\26\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\1\u0116\31\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\10\63"+
    "\1\u0117\12\63\1\u0118\6\63\4\0\1\63\4\0\1\63"+
    "\1\u0117\3\63\23\0\3\63\7\0\13\63\1\u0119\16\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\15\63"+
    "\1\u011a\14\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\21\63\1\u011b\10\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\16\63\1\u011c\13\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\15\63\1\u011d\14\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\16\63"+
    "\1\u011e\13\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\23\63\1\u011f\6\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\17\63\1\u0120\12\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\2\63\1\u0121\17\63"+
    "\1\u0122\1\u0123\6\63\4\0\1\63\4\0\2\63\1\u0122"+
    "\2\63\23\0\3\63\7\0\22\63\1\u0124\7\63\4\0"+
    "\1\63\4\0\2\63\1\u0124\2\63\23\0\3\63\7\0"+
    "\22\63\1\u0125\7\63\4\0\1\63\4\0\2\63\1\u0125"+
    "\2\63\23\0\3\63\7\0\14\63\1\u0126\15\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\26\63\1\u0127"+
    "\3\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\13\63\1\u0128\16\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\21\63\1\u0129\10\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\10\63\1\u012a\5\63\1\u012b"+
    "\13\63\4\0\1\63\4\0\1\63\1\u012a\3\63\23\0"+
    "\3\63\7\0\1\63\1\u012c\30\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\20\63\1\u012d\2\63\1\u012e"+
    "\6\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\13\63\1\u012f\16\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\1\u0130\31\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\10\63\1\u0131\21\63\4\0\1\63"+
    "\4\0\1\63\1\u0131\3\63\23\0\3\63\7\0\21\63"+
    "\1\u0132\10\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\1\u0133\23\63\1\u0134\3\63\1\u0135\1\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\22\63\1\u0136"+
    "\7\63\4\0\1\63\4\0\2\63\1\u0136\2\63\23\0"+
    "\3\63\7\0\4\63\1\u0137\25\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\21\63\1\u0138\10\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\10\63\1\u0139"+
    "\21\63\4\0\1\63\4\0\1\63\1\u0139\3\63\23\0"+
    "\3\63\7\0\4\63\1\u013a\25\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\2\63\1\u013b\1\u013c\1\63"+
    "\1\u013d\1\63\1\u013e\3\63\1\u013f\1\u0140\1\u0141\14\63"+
    "\4\0\1\63\4\0\5\63\5\107\1\320\1\107\1\321"+
    "\25\107\32\0\1\107\1\316\2\107\1\0\1\107\1\0"+
    "\2\107\5\0\5\107\1\320\1\107\1\0\60\107\1\316"+
    "\4\107\1\325\7\107\23\0\3\322\7\0\32\322\1\u0142"+
    "\3\0\1\322\4\0\5\322\12\114\1\0\55\114\1\0"+
    "\14\114\7\116\1\332\25\116\32\0\1\116\1\330\2\116"+
    "\1\0\1\320\1\0\2\116\5\0\7\116\1\0\60\116"+
    "\1\330\3\116\1\320\1\333\7\116\2\125\2\126\3\125"+
    "\1\341\25\125\32\0\1\125\1\336\2\125\1\0\1\125"+
    "\1\0\2\125\5\0\2\125\2\126\3\125\1\0\60\125"+
    "\1\336\4\125\1\342\11\125\2\u0143\3\125\1\335\13\125"+
    "\3\340\1\125\1\u0144\5\125\32\340\1\125\1\336\2\125"+
    "\1\340\1\125\1\337\2\125\5\340\2\10\2\u0145\17\10"+
    "\3\343\1\10\1\u0146\5\10\32\343\4\10\1\343\4\10"+
    "\5\343\2\0\2\344\103\0\2\347\103\0\2\u0147\17\0"+
    "\3\352\1\0\1\u0148\5\0\32\352\4\0\1\352\4\0"+
    "\5\352\23\0\3\354\7\0\32\354\4\0\1\354\4\0"+
    "\5\354\20\0\1\u0149\14\0\32\u0149\20\0\1\u014a\1\u014b"+
    "\103\0\2\u014c\17\0\3\363\1\0\1\u014d\5\0\32\363"+
    "\4\0\1\363\4\0\5\363\1\0\3\364\124\0\3\365"+
    "\7\0\32\365\4\0\1\365\4\0\5\365\23\0\3\203"+
    "\7\0\10\203\1\u014e\21\203\4\0\1\203\4\0\1\203"+
    "\1\u014e\3\203\56\0\1\u014f\100\0\1\u0150\105\0\1\u0151"+
    "\112\0\1\u0152\76\0\1\u0153\111\0\1\u0154\72\0\1\u0155"+
    "\73\0\1\u0156\125\0\1\u0157\105\0\1\u0158\22\0\1\u0158"+
    "\24\0\1\u0159\63\0\1\u0104\3\0\1\u015a\4\0\1\u015b"+
    "\22\0\32\u015c\4\0\1\u015c\4\0\5\u015c\23\0\3\63"+
    "\7\0\23\63\1\u015d\6\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\1\u015e\31\63\4\0\1\63\4\0"+
    "\5\63\30\0\1\u0104\77\0\3\63\7\0\1\u015f\31\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\13\63"+
    "\1\u0160\16\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\4\63\1\u0161\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\2\63\1\u0162\27\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\22\63\1\u0163\7\63"+
    "\4\0\1\63\4\0\2\63\1\u0163\2\63\23\0\3\63"+
    "\7\0\15\63\1\u0164\14\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\22\63\1\u0165\1\u0166\6\63\4\0"+
    "\1\63\4\0\2\63\1\u0165\2\63\23\0\3\63\7\0"+
    "\13\63\1\u0167\16\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\1\u0168\31\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\16\63\1\u0169\13\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\4\63\1\u016a\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\23\63"+
    "\1\u016b\6\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\3\63\1\u016c\1\63\1\u016d\2\63\1\u016e\11\63"+
    "\1\u016f\3\63\1\u0170\3\63\4\0\1\63\4\0\1\63"+
    "\1\u016e\1\u016f\2\63\23\0\3\63\7\0\13\63\1\u0171"+
    "\16\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\23\63\1\u0172\6\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\4\63\1\u0173\25\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\22\63\1\u0174\7\63\4\0"+
    "\1\63\4\0\2\63\1\u0174\2\63\23\0\3\63\7\0"+
    "\1\u0175\31\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\4\63\1\u0176\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\14\63\1\u0177\15\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\2\63\1\u0178\27\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\1\63"+
    "\1\u0179\30\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\16\63\1\u017a\13\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\13\63\1\u017b\16\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\13\63\1\u017c\16\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\23\63"+
    "\1\u017d\6\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\4\63\1\u017e\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\4\63\1\u017f\25\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\23\63\1\u0180\6\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\4\63"+
    "\1\u0181\25\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\13\63\1\u0182\16\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\4\63\1\u0183\25\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\15\63\1\u0184\7\63"+
    "\1\u0185\4\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\23\63\1\u0186\6\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\13\63\1\u0187\16\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\24\63\1\u0188\5\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\24\63"+
    "\1\u0189\5\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\5\63\1\u018a\24\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\23\63\1\u018b\6\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\23\63\1\u018c\6\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\16\63"+
    "\1\u018d\13\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\10\63\1\u018e\21\63\4\0\1\63\4\0\1\63"+
    "\1\u018e\3\63\23\0\3\63\7\0\4\63\1\u018f\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\4\63"+
    "\1\u0190\25\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\13\63\1\u0191\16\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\13\63\1\u0192\16\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\13\63\1\u0193\16\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\10\63"+
    "\1\u0194\21\63\4\0\1\63\4\0\1\63\1\u0194\3\63"+
    "\23\0\3\63\7\0\10\63\1\u0195\13\63\1\u0196\5\63"+
    "\4\0\1\63\4\0\1\63\1\u0195\3\63\23\0\3\63"+
    "\7\0\1\u0197\31\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\10\63\1\u0198\21\63\4\0\1\63\4\0"+
    "\1\63\1\u0198\3\63\23\0\3\63\7\0\4\63\1\u0199"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\1\u019a\31\63\4\0\1\63\4\0\5\63\2\125\2\u0143"+
    "\3\125\1\335\60\125\1\336\4\125\1\337\7\125\2\10"+
    "\2\u0145\101\10\2\0\2\u0147\121\0\1\u0149\14\0\32\u0149"+
    "\10\0\1\u019b\7\0\1\u014a\104\0\2\u014c\124\0\3\203"+
    "\7\0\22\203\1\u019c\7\203\4\0\1\203\4\0\2\203"+
    "\1\u019c\2\203\35\0\1\u019d\104\0\1\u019e\117\0\1\u019f"+
    "\72\0\1\u01a0\103\0\1\u01a1\50\0\1\u01a2\12\0\1\u01a3"+
    "\24\0\1\u01a4\104\0\1\u01a5\113\0\1\u01a2\101\0\1\u01a6"+
    "\33\0\1\u01a6\44\0\1\u01a1\100\0\32\u01a7\4\0\1\u01a7"+
    "\4\0\5\u01a7\35\0\32\u01a8\4\0\1\u01a8\4\0\5\u01a8"+
    "\2\0\1\u01a9\1\u01aa\17\0\3\u015c\7\0\32\u015c\4\0"+
    "\1\u015c\4\0\5\u015c\23\0\3\63\7\0\21\63\1\u01ab"+
    "\10\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\30\63\1\u01ac\1\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\12\63\1\u01ad\17\63\4\0\1\63\4\0"+
    "\3\63\1\u01ad\1\63\23\0\3\63\7\0\1\u01ae\31\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\7\63"+
    "\1\u01af\22\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\22\63\1\u01b0\7\63\4\0\1\63\4\0\2\63"+
    "\1\u01b0\2\63\23\0\3\63\7\0\4\63\1\u01b1\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\23\63"+
    "\1\u01b2\6\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\10\63\1\u01b3\21\63\4\0\1\63\4\0\1\63"+
    "\1\u01b3\3\63\23\0\3\63\7\0\1\u01b4\31\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\24\63\1\u01b5"+
    "\5\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\10\63\1\u01b6\21\63\4\0\1\63\4\0\1\63\1\u01b6"+
    "\3\63\23\0\3\63\7\0\30\63\1\u01b7\1\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\4\63\1\u01b8"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\16\63\1\u01b9\13\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\5\63\1\u01ba\24\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\26\63\1\u01bb\3\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\7\63\1\u01bc"+
    "\22\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\15\63\1\u01bd\14\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\4\63\1\u01be\25\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\13\63\1\u01bf\16\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\1\u01c0\31\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\23\63"+
    "\1\u01c1\6\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\1\u01c2\31\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\4\63\1\u01c3\25\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\24\63\1\u01c4\5\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\1\u01c5\3\63"+
    "\1\u01c6\25\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\21\63\1\u01c7\10\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\23\63\1\u01c8\6\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\22\63\1\u01c9\7\63"+
    "\4\0\1\63\4\0\2\63\1\u01c9\2\63\23\0\3\63"+
    "\7\0\15\63\1\u01ca\14\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\23\63\1\u01cb\6\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\1\u01cc\31\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\4\63\1\u01cd"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\10\63\1\u01ce\21\63\4\0\1\63\4\0\1\63\1\u01ce"+
    "\3\63\23\0\3\63\7\0\10\63\1\u01cf\21\63\4\0"+
    "\1\63\4\0\1\63\1\u01cf\3\63\23\0\3\63\7\0"+
    "\21\63\1\u01d0\10\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\10\63\1\u01d1\21\63\4\0\1\63\4\0"+
    "\1\63\1\u01d1\3\63\23\0\3\63\7\0\2\63\1\u01d2"+
    "\27\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\26\63\1\u01d3\3\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\23\63\1\u01d4\6\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\23\63\1\u01d5\6\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\4\63\1\u01d6"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\3\63\1\u01d7\26\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\1\u01d8\31\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\21\63\1\u01d9\10\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\13\63\1\u01da\16\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\15\63"+
    "\1\u01db\14\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\13\63\1\u01dc\16\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\15\63\1\u01dd\14\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\23\63\1\u01de\6\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\14\63"+
    "\1\u01df\15\63\4\0\1\63\4\0\5\63\65\0\1\u01a2"+
    "\75\0\1\u019d\27\0\1\u01a2\12\0\1\u01a3\24\0\1\u01e0"+
    "\113\0\1\u01e1\114\0\1\u01a2\25\0\1\u01a2\12\0\1\u01a3"+
    "\133\0\1\u01e2\100\0\1\u01a1\117\0\1\u01e3\37\0\1\u01e4"+
    "\15\0\3\u01a7\7\0\32\u01a7\4\0\1\u01a7\4\0\5\u01a7"+
    "\12\0\1\u01e4\10\0\3\u01a8\7\0\32\u01a8\4\0\1\u01a8"+
    "\4\0\5\u01a8\2\0\1\u01a9\125\0\3\63\7\0\1\u01e5"+
    "\31\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\1\63\1\u01e6\30\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\15\63\1\u01e7\14\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\21\63\1\u01e8\10\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\13\63\1\u01e9"+
    "\16\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\5\63\1\u01ea\24\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\2\63\1\u01eb\27\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\21\63\1\u01ec\10\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\10\63\1\u01ed"+
    "\21\63\4\0\1\63\4\0\1\63\1\u01ed\3\63\23\0"+
    "\3\63\7\0\10\63\1\u01ee\21\63\4\0\1\63\4\0"+
    "\1\63\1\u01ee\3\63\23\0\3\63\7\0\3\63\1\u01ef"+
    "\26\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\13\63\1\u01f0\16\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\2\63\1\u01f1\27\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\10\63\1\u01f2\21\63\4\0"+
    "\1\63\4\0\1\63\1\u01f2\3\63\23\0\3\63\7\0"+
    "\13\63\1\u01f3\16\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\14\63\1\u01f4\15\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\3\63\1\u01f5\26\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\15\63\1\u01f6"+
    "\14\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\1\u01f7\31\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\5\63\1\u01f8\24\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\17\63\1\u01f9\12\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\23\63\1\u01fa\6\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\23\63"+
    "\1\u01fb\6\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\2\63\1\u01fc\27\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\2\63\1\u01fd\27\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\21\63\1\u01fe\10\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\15\63"+
    "\1\u01ff\14\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\2\63\1\u0200\27\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\7\63\1\u0201\22\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\22\63\1\u0202\7\63"+
    "\4\0\1\63\4\0\2\63\1\u0202\2\63\23\0\3\63"+
    "\7\0\32\63\4\0\1\u0203\4\0\5\63\23\0\3\63"+
    "\7\0\4\63\1\u0204\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\2\63\1\u0205\27\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\23\63\1\u0206\6\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\4\63"+
    "\1\u0207\25\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\7\63\1\u0208\22\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\4\63\1\u0209\25\63\4\0\1\63"+
    "\4\0\5\63\35\0\1\u020a\110\0\1\u01a2\104\0\1\u020b"+
    "\106\0\1\u01a2\43\0\1\u01a9\1\u01aa\124\0\3\63\7\0"+
    "\2\63\1\u020c\27\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\13\63\1\u020d\16\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\24\63\1\u020e\5\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\4\63\1\u020f"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\23\63\1\u0210\6\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\13\63\1\u0211\16\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\4\63\1\u0212\25\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\23\63\1\u0213"+
    "\6\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\13\63\1\u0214\16\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\22\63\1\u0215\7\63\4\0\1\63\4\0"+
    "\2\63\1\u0215\2\63\23\0\3\63\7\0\30\63\1\u0216"+
    "\1\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\7\63\1\u0217\22\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\16\63\1\u0218\13\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\4\63\1\u0219\25\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\4\63\1\u021a"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\2\63\1\u021b\27\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\3\63\1\u021c\26\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\1\u021d\31\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\1\u021e\31\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\4\63\1\u021f"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\23\63\1\u0220\6\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\4\63\1\u0221\25\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\22\63\1\u0222\7\63\4\0"+
    "\1\63\4\0\2\63\1\u0222\2\63\23\0\3\63\7\0"+
    "\32\63\4\0\1\u0223\4\0\5\63\23\0\3\63\7\0"+
    "\32\63\4\0\1\u0224\4\0\5\63\23\0\3\63\7\0"+
    "\23\63\1\u0225\6\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\32\63\4\0\1\u0226\4\0\5\63\23\0"+
    "\3\63\7\0\32\63\4\0\1\u0227\4\0\5\63\23\0"+
    "\3\63\7\0\16\63\1\u0228\13\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\22\63\1\u0229\7\63\4\0"+
    "\1\63\4\0\2\63\1\u0229\2\63\52\0\1\u01a2\110\0"+
    "\1\u01a2\51\0\3\63\7\0\23\63\1\u022a\6\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\4\63\1\u022b"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\4\63\1\u022c\25\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\1\u022d\31\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\1\u022e\31\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\2\63\1\u022f\27\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\4\63\1\u0230"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\15\63\1\u0231\14\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\15\63\1\u0232\14\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\32\63\4\0\1\u0233\4\0"+
    "\5\63\23\0\3\63\7\0\4\63\1\u0234\25\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\16\63\1\u0235"+
    "\13\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\2\63\1\u0236\27\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\2\63\1\u0237\27\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\4\63\1\u0238\25\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\32\63\4\0"+
    "\1\u0239\4\0\5\63\23\0\3\63\7\0\32\63\4\0"+
    "\1\u023a\4\0\5\63\23\0\3\63\7\0\32\63\4\0"+
    "\1\u023b\4\0\5\63\23\0\3\63\7\0\10\63\1\u023c"+
    "\21\63\4\0\1\63\4\0\1\63\1\u023c\3\63\23\0"+
    "\3\63\7\0\2\63\1\u023d\27\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\32\63\4\0\1\u023e\4\0"+
    "\5\63\23\0\3\63\7\0\3\63\1\u023f\26\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\17\63\1\u0240"+
    "\12\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\21\63\1\u0241\10\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\2\63\1\u0242\27\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\7\63\1\u0243\22\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\23\63\1\u0244"+
    "\6\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\16\63\1\u0245\13\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\16\63\1\u0246\13\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\5\63\1\u0247\24\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\4\63\1\u0248"+
    "\25\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\4\63\1\u0249\25\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\3\63\1\u024a\26\63\4\0\1\63\4\0"+
    "\5\63\23\0\3\63\7\0\16\63\1\u024b\13\63\4\0"+
    "\1\63\4\0\5\63\23\0\3\63\7\0\32\63\4\0"+
    "\1\u024c\4\0\5\63\23\0\3\63\7\0\16\63\1\u024d"+
    "\13\63\4\0\1\63\4\0\5\63\23\0\3\63\7\0"+
    "\16\63\1\u024e\13\63\4\0\1\63\4\0\5\63\23\0"+
    "\3\63\7\0\32\63\4\0\1\u024f\4\0\5\63\23\0"+
    "\3\63\7\0\1\u0250\31\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\4\63\1\u0251\25\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\7\63\1\u0252\22\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\22\63"+
    "\1\u0253\7\63\4\0\1\63\4\0\2\63\1\u0253\2\63"+
    "\23\0\3\63\7\0\15\63\1\u0254\14\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\5\63\1\u0255\24\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\15\63"+
    "\1\u0256\14\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\15\63\1\u0257\14\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\14\63\1\u0258\15\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\32\63\4\0\1\u0259"+
    "\4\0\5\63\23\0\3\63\7\0\2\63\1\u025a\27\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\2\63"+
    "\1\u025b\27\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\2\63\1\u025c\27\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\32\63\4\0\1\u025d\4\0\5\63"+
    "\23\0\3\63\7\0\17\63\1\u025e\12\63\4\0\1\63"+
    "\4\0\5\63\23\0\3\63\7\0\4\63\1\u025f\25\63"+
    "\4\0\1\63\4\0\5\63\23\0\3\63\7\0\4\63"+
    "\1\u0260\25\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\4\63\1\u0261\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\32\63\4\0\1\u0262\4\0\5\63"+
    "\23\0\3\63\7\0\10\63\1\u0263\21\63\4\0\1\63"+
    "\4\0\1\63\1\u0263\3\63\23\0\3\63\7\0\32\63"+
    "\4\0\1\u0264\4\0\5\63\23\0\3\63\7\0\13\63"+
    "\1\u0265\16\63\4\0\1\63\4\0\5\63\23\0\3\63"+
    "\7\0\32\63\4\0\1\u0266\4\0\5\63\23\0\3\63"+
    "\7\0\4\63\1\u0267\25\63\4\0\1\63\4\0\5\63"+
    "\23\0\3\63\7\0\21\63\1\u0268\10\63\4\0\1\63"+
    "\4\0\5\63";

  private static int [] zzUnpackTrans() {
    int [] result = new int[33120];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\1\10\5\0\2\1\13\0\1\11\3\1\1\11\5\1"+
    "\1\11\10\1\1\11\31\1\1\11\1\1\1\11\4\1"+
    "\1\11\11\1\1\11\10\1\1\11\1\1\1\11\1\1"+
    "\1\0\1\1\1\11\2\1\2\11\4\1\1\11\2\1"+
    "\1\11\4\1\1\11\2\1\1\11\1\1\1\11\1\1"+
    "\1\0\4\1\1\0\1\11\3\0\2\1\2\11\14\0"+
    "\1\11\2\1\1\0\1\1\1\0\1\11\1\1\1\11"+
    "\4\1\1\0\54\1\3\0\1\11\2\1\2\11\1\1"+
    "\4\0\2\1\1\11\3\0\4\1\1\11\2\0\1\11"+
    "\3\0\1\11\1\1\2\11\1\1\1\0\1\11\1\1"+
    "\1\0\3\1\12\0\3\1\1\0\2\1\1\0\72\1"+
    "\2\11\1\1\1\11\1\1\1\11\2\0\1\11\1\1"+
    "\1\11\1\0\1\1\12\0\1\11\3\0\76\1\1\11"+
    "\1\1\6\0\1\11\5\0\1\11\66\1\5\0\45\1"+
    "\2\0\135\1";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[616];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  @SuppressWarnings("unused")
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  @SuppressWarnings("unused")
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  @SuppressWarnings("unused")
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	public PHPLexer(int state) {
		initialize(state);
	}

	// NB: this method resets the lexer only partially
	@Override
	protected void reset(java.io.Reader reader, char[] buffer, int[] parameters) {
		this.zzReader = reader;
		this.zzBuffer = buffer;
		this.zzFinalHighSurrogate = 0;
		this.zzMarkedPos = parameters[0];
		this._zzPushbackPos = parameters[1];
		this.zzCurrentPos = parameters[2];
		this.zzStartRead = parameters[3];
		this.zzEndRead = parameters[4];
		this.yyline = parameters[5];
		initialize(parameters[6]);
	}

	@Override
	public int getInScriptingState() {
		return ST_PHP_IN_SCRIPTING;
	}

	private static final int[] heredocStates = new int[] { ST_PHP_HEREDOC, ST_PHP_NOWDOC, ST_PHP_START_HEREDOC, ST_PHP_START_NOWDOC, ST_PHP_END_HEREDOC, ST_PHP_END_NOWDOC };

	@Override
	public int[] getHeredocStates() {
		return heredocStates;
	}

	private static final int[] phpQuotesStates = new int[] { ST_PHP_DOUBLE_QUOTES, ST_PHP_SINGLE_QUOTE, ST_PHP_BACKQUOTE, ST_PHP_HEREDOC, ST_PHP_NOWDOC, ST_PHP_START_HEREDOC, ST_PHP_START_NOWDOC, ST_PHP_END_HEREDOC, ST_PHP_END_NOWDOC };

	@Override
	public int[] getPHPQuotesStates() {
		return phpQuotesStates;
	}

	@Override
	public int[] getParameters() {
		return new int[]{zzMarkedPos, _zzPushbackPos, zzCurrentPos, zzStartRead, zzEndRead, yyline, zzLexicalState};
	}

	@Override
	protected int getZZLexicalState() {
		return zzLexicalState;
	}

	@Override
	protected int getZZMarkedPos() {
		return zzMarkedPos;
	}

	@Override
	protected int getZZEndRead() {
		return zzEndRead;
	}

	@Override
	public char[] getZZBuffer() {
		return zzBuffer;
	}

	@Override
	protected int getZZStartRead() {
		return this.zzStartRead;
	}

	@Override
	protected int getZZPushBackPosition() {
		return this._zzPushbackPos;
	}

	@Override
	protected void pushBack(int i) {
		yypushback(i);
	}

	@Override
	public int getScriptingState() {
		return ST_PHP_IN_SCRIPTING;
	}

	// A pool of states. To avoid creation of a new state on each createMemento.
	private static final Map<LexerState, LexerState> lexerStates = new HashMap<>();

	@Override
	protected Map<LexerState, LexerState> getLexerStates() {
		return lexerStates;
	}

	// End user code


  /** the textposition at the last state to be included in yytext */
  private int _zzPushbackPos;

  /* The following fields are added in order to support the change in zzRefill */
  private String oldString = null;
  private boolean useOldString = false;
  private int startPos = 0;

  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public PHPLexer(java.io.Reader in) {
    this.zzReader = in;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    if (useOldString) {
      String saveOldString = oldString;
      oldString = new String(zzBuffer, startPos, zzMarkedPos - startPos);
      if (saveOldString != null) {
        oldString = saveOldString + oldString;
      }
    }

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      _zzPushbackPos-= zzStartRead;
      startPos = 0;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate) {
      /* if not: blow it up */
      char newBuffer[] = new char[zzBuffer.length * 2];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      throw new java.io.IOException(
          "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Gets the next input character.
   *
   * @return      the next character of the input stream, EOF if the
   *              end of the stream is reached.
   * @exception   IOException  if any I/O-Error occurs
   */
  private int yy_advance() throws java.io.IOException {

    /* standard case */
    if (zzCurrentPos < zzEndRead) return zzBuffer[zzCurrentPos++];

    /* if the eof is reached, we don't need to work hard */
    if (zzAtEOF) return YYEOF;

    /* otherwise: need to refill the buffer */

    String saveOldString = oldString;
    oldString = null;

    /* first: make room (if you can) */
    if (zzRefill()) {
      oldString = saveOldString;
      return YYEOF;
    }

    oldString = saveOldString;

    return zzBuffer[zzCurrentPos++];
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    if (zzBuffer.length > ZZ_BUFFERSIZE) {
      zzBuffer = new char[ZZ_BUFFERSIZE];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      _zzPushbackPos = 0;
      startPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      oldString = null;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }


	/**
	 * user method - common.sse
	 */
	private void updateStartPos() {
		updateStartPos(zzMarkedPos);
	}


	/**
	 * user method - common.sse
	 */
	private void updateStartPos(int position) {
		startPos = position;
		oldString = null;
	}


	/**
	 * user method - common.sse
	 */
	public final boolean isEOF() {
		return zzAtEOF;
	}




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public String yylex() throws java.io.IOException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return null;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { return PHP_ENCAPSED_AND_WHITESPACE;
            }
            // fall through
          case 143: break;
          case 2:
            { return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 144: break;
          case 3:
            { yypushback(1);
	pushState(ST_PHP_HIGHLIGHTING_ERROR);
            }
            // fall through
          case 145: break;
          case 4:
            { return WHITESPACE;
            }
            // fall through
          case 146: break;
          case 5:
            { return PHP_TOKEN;
            }
            // fall through
          case 147: break;
          case 6:
            { pushState(ST_PHP_DOUBLE_QUOTES);
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 148: break;
          case 7:
            { pushState(ST_PHP_LINE_COMMENT);
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 149: break;
          case 8:
            { pushState(ST_PHP_SINGLE_QUOTE);
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 150: break;
          case 9:
            { return PHP_NUMBER;
            }
            // fall through
          case 151: break;
          case 10:
            { return PHP_SEMICOLON;
            }
            // fall through
          case 152: break;
          case 11:
            { return PHP_LABEL;
            }
            // fall through
          case 153: break;
          case 12:
            { return PHP_NS_SEPARATOR;
            }
            // fall through
          case 154: break;
          case 13:
            { pushState(ST_PHP_BACKQUOTE);
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 155: break;
          case 14:
            { // Whitespaces are directly appended to the curly before pushState()
	// is effective or whitespaces would be stored in a separate ContextRegion.
	// Method PhpTokenContainer#addLast() will correct the curlies length...
	if (!phpStack.isEmpty()) {
		// Only push the state when stack is not empty, it's useless otherwise
		// (and it pollutes the stack).
		pushState(ST_PHP_IN_SCRIPTING);
	}
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 156: break;
          case 15:
            { // Whitespaces are directly appended to the curly before pushState()
	// is effective or whitespaces would be stored in a separate ContextRegion.
	// Method PhpTokenContainer#addLast() will correct the curlies length...
	if (!phpStack.isEmpty()) {
		popState();
		// If new state is not ST_PHP_IN_SCRIPTING then some blanks are signifiant (like newlines
		// after the closing curly and before an ending heredoc tag), so don't append them...
		// See rule <ST_PHP_HEREDOC>{HEREDOC_CHARS}*({HEREDOC_NEWLINE}+({LABEL}";"?)?)?
		if (getZZLexicalState() != ST_PHP_IN_SCRIPTING) {
			yypushback(yylength() - 1);
		}
	}
	return PHP_CURLY_CLOSE;
            }
            // fall through
          case 157: break;
          case 16:
            { popState();
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 158: break;
          case 17:
            { yypushback(1);
		popState();
            }
            // fall through
          case 159: break;
          case 18:
            { yypushback(1);
	yybegin(ST_PHP_HEREDOC);
            }
            // fall through
          case 160: break;
          case 19:
            { yypushback(1);
	yybegin(ST_PHP_NOWDOC);
            }
            // fall through
          case 161: break;
          case 20:
            { yypushback(1);
	popState();
            }
            // fall through
          case 162: break;
          case 21:
            { popState();
	return PHP_LABEL;
            }
            // fall through
          case 163: break;
          case 22:
            { yypushback(1);
	popState();
	return PHP_ENCAPSED_AND_WHITESPACE;
            }
            // fall through
          case 164: break;
          case 23:
            { //the difference from the original rules comes from the fact that we took ';' out of tokens
	return UNKNOWN_TOKEN;
            }
            // fall through
          case 165: break;
          case 24:
            { popState();
	return PHP_TOKEN;
            }
            // fall through
          case 166: break;
          case 25:
            { return PHP_COMMENT;
            }
            // fall through
          case 167: break;
          case 26:
            { return PHPDOC_COMMENT;
            }
            // fall through
          case 168: break;
          case 27:
            { String yytext = yytext();
	switch (yytext.charAt(yytext.length() - 1)) {
		case '?':
		case '%':
		case '>':
			yypushback(1);
			if (yylength() > 0) {
				return PHP_LINE_COMMENT;
			}
			break;
		default:
			popState();
			return PHP_LINE_COMMENT;
	}
            }
            // fall through
          case 169: break;
          case 28:
            { return PHP_LINE_COMMENT;
            }
            // fall through
          case 170: break;
          case 29:
            { return UNKNOWN_TOKEN;
            }
            // fall through
          case 171: break;
          case 30:
            { popState();return WHITESPACE;
            }
            // fall through
          case 172: break;
          case 31:
            { yybegin(ST_PHP_IN_SCRIPTING);
	return PHP_ENCAPSED_VARIABLE;
            }
            // fall through
          case 173: break;
          case 32:
            { yybegin(ST_PHP_IN_SCRIPTING);
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 174: break;
          case 33:
            { return PHP_OPERATOR;
            }
            // fall through
          case 175: break;
          case 34:
            { return PHP_VARIABLE;
            }
            // fall through
          case 176: break;
          case 35:
            { if (asp_tags) {
		return PHP_CLOSETAG;
	}
	return UNKNOWN_TOKEN;
            }
            // fall through
          case 177: break;
          case 36:
            { pushState(ST_PHP_LOOKING_FOR_PROPERTY);
	return PHP_OBJECT_OPERATOR;
            }
            // fall through
          case 178: break;
          case 37:
            { pushState(ST_PHP_COMMENT);
	return PHP_COMMENT_START;
            }
            // fall through
          case 179: break;
          case 38:
            { return PHP_PAAMAYIM_NEKUDOTAYIM;
            }
            // fall through
          case 180: break;
          case 39:
            { return PHP_CLOSETAG;
            }
            // fall through
          case 181: break;
          case 40:
            { return PHP_AS;
            }
            // fall through
          case 182: break;
          case 41:
            { return PHP_DO;
            }
            // fall through
          case 183: break;
          case 42:
            { return PHP_IF;
            }
            // fall through
          case 184: break;
          case 43:
            { yypushback(1);
	return PHP_ENCAPSED_AND_WHITESPACE;
            }
            // fall through
          case 185: break;
          case 44:
            { pushState(ST_PHP_QUOTES_AFTER_VARIABLE);
	return PHP_VARIABLE;
            }
            // fall through
          case 186: break;
          case 45:
            { // We can have nested curlies after applying this rule,
	// so we have to count all curlies...
	yypushback(1);
	pushState(ST_PHP_DOLLAR_CURLY_OPEN);
	return PHP_TOKEN;
            }
            // fall through
          case 187: break;
          case 46:
            { // We can have nested curlies after applying rule below for "${",
	// so we have to count all curlies...
	yypushback(1);
	pushState(ST_PHP_IN_SCRIPTING);
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 188: break;
          case 47:
            { popState();
	pushState(ST_PHP_LOOKING_FOR_PROPERTY);
	return PHP_OBJECT_OPERATOR;
            }
            // fall through
          case 189: break;
          case 48:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}

	String heredoc = getHeredocId();
	int heredoc_len = heredoc.length();
	if (label_len == heredoc_len && yytext.substring(0, label_len).equals(heredoc)) {
		// we must (at least) push the newline character back
		yypushback(1);
		popHeredocId();
		popState();
		return PHP_HEREDOC_CLOSE_TAG;
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
		return PHP_ENCAPSED_AND_WHITESPACE;
	}
            }
            // fall through
          case 190: break;
          case 49:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}

	String nowdoc = getHeredocId();
	int nowdoc_len = nowdoc.length();
	if (label_len == nowdoc_len && yytext.substring(0, label_len).equals(nowdoc)) {
		// we must (at least) push the newline character back
		yypushback(1);
		popHeredocId();
		popState();
		return PHP_NOWDOC_CLOSE_TAG;
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
		return PHP_CONSTANT_ENCAPSED_STRING;
	}
            }
            // fall through
          case 191: break;
          case 50:
            { return PHP_OBJECT_OPERATOR;
            }
            // fall through
          case 192: break;
          case 51:
            { popState();
	return PHP_COMMENT_END;
            }
            // fall through
          case 193: break;
          case 52:
            { popState();
	return PHPDOC_COMMENT_END;
            }
            // fall through
          case 194: break;
          case 53:
            { TagKind tagkind = TagKind.getTagKindFromValue(yytext());
		if (tagkind != null && tagkind != TagKind.UNKNOWN
			&& /* ignore @todo tag */ tagkind != TagKind.TODO) {
				return PHPDOC_GENERIC_TAG;
		}
		return PHPDOC_COMMENT;
            }
            // fall through
          case 195: break;
          case 54:
            { popState();
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 196: break;
          case 55:
            { if (asp_tags) {
		return PHP_CLOSETAG;
	}
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 197: break;
          case 56:
            { yypushback(yylength() - 1);
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 198: break;
          case 57:
            { pushState(ST_PHP_DOC_COMMENT);
	return PHPDOC_COMMENT_START;
            }
            // fall through
          case 199: break;
          case 58:
            { return PHP_DIE;
            }
            // fall through
          case 200: break;
          case 59:
            { return PHP_FOR;
            }
            // fall through
          case 201: break;
          case 60:
            { return PHP_NEW;
            }
            // fall through
          case 202: break;
          case 61:
            { return PHP_TRY;
            }
            // fall through
          case 203: break;
          case 62:
            { return PHP_USE;
            }
            // fall through
          case 204: break;
          case 63:
            { return PHP_VAR;
            }
            // fall through
          case 205: break;
          case 64:
            { yypushback(1);
	pushState(ST_PHP_VAR_OFFSET);
	return PHP_VARIABLE;
            }
            // fall through
          case 206: break;
          case 65:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}
	String heredoc = getHeredocId();
	int heredoc_len = heredoc.length();
	int startIndex = label_len - heredoc_len;
	if (startIndex > 0 && yytext.substring(startIndex, label_len).equals(heredoc)
		&& (yytext.charAt(startIndex - 1) == '\n' || yytext.charAt(startIndex - 1) == '\r')) {

		if (startIndex - 2 >= 0
			&& yytext.charAt(startIndex - 2) == '\r'
			&& yytext.charAt(startIndex - 1) == '\n') {
			startIndex-= 2;
		} else {
			startIndex--;
		}
		yypushback(yylength() - startIndex);

		yybegin(ST_PHP_END_HEREDOC);
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
	}
	// In some cases, all text is pushed back (using yypushback()),
	// especially when the parsed document has Windows newlines.
	// In those cases, ignore this rule and try next one...
	if (yylength() > 0) {
		return PHP_ENCAPSED_AND_WHITESPACE;
	}
            }
            // fall through
          case 207: break;
          case 66:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}
	String nowdoc = getHeredocId();
	int nowdoc_len = nowdoc.length();
	int startIndex = label_len - nowdoc_len;
	if (startIndex > 0 && yytext.substring(startIndex, label_len).equals(nowdoc)
		&& (yytext.charAt(startIndex - 1) == '\n' || yytext.charAt(startIndex - 1) == '\r')) {

		if (startIndex - 2 >= 0
			&& yytext.charAt(startIndex - 2) == '\r'
			&& yytext.charAt(startIndex - 1) == '\n') {
			startIndex-= 2;
		} else {
			startIndex--;
		}
		yypushback(yylength() - startIndex);

		yybegin(ST_PHP_END_NOWDOC);
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
	}
	// In some cases, all text is pushed back (using yypushback()),
	// especially when the parsed document has Windows newlines.
	// In those cases, ignore this rule and try next one...
	if (yylength() > 0) {
		return PHP_CONSTANT_ENCAPSED_STRING;
	}
            }
            // fall through
          case 208: break;
          case 67:
            { // we must (at least) push the newline character back
	yypushback(1);
	popHeredocId();
	popState();
	return PHP_HEREDOC_CLOSE_TAG;
            }
            // fall through
          case 209: break;
          case 68:
            { yypushback(yylength() - 2);
	if (asp_tags) {
		return PHP_CLOSETAG;
	}
	popState();
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 210: break;
          case 69:
            { // we must (at least) push the newline character back
	yypushback(1);
	popHeredocId();
	popState();
	return PHP_NOWDOC_CLOSE_TAG;
            }
            // fall through
          case 211: break;
          case 70:
            { yypushback(2);
	pushState(ST_PHP_COMMENT);
	return PHP_COMMENT_START;
            }
            // fall through
          case 212: break;
          case 71:
            { return PHP_CASE;
            }
            // fall through
          case 213: break;
          case 72:
            { return PHP_ECHO;
            }
            // fall through
          case 214: break;
          case 73:
            { return PHP_ELSE;
            }
            // fall through
          case 215: break;
          case 74:
            { return PHP_EVAL;
            }
            // fall through
          case 216: break;
          case 75:
            { return PHP_EXIT;
            }
            // fall through
          case 217: break;
          case 76:
            { return PHP_FROM;
            }
            // fall through
          case 218: break;
          case 77:
            { return PHP_GOTO;
            }
            // fall through
          case 219: break;
          case 78:
            { return PHP_LIST;
            }
            // fall through
          case 220: break;
          case 79:
            { return PHP_KEYWORD;
            }
            // fall through
          case 221: break;
          case 80:
            { return PHP_SELF;
            }
            // fall through
          case 222: break;
          case 81:
            { return PHP_TRUE;
            }
            // fall through
          case 223: break;
          case 82:
            { TagKind tagkind = TagKind.getTagKindFromValue(yytext());
		if (tagkind != null && tagkind != TagKind.UNKNOWN) {
			return PHPDOC_GENERIC_TAG;
		}
		return PHPDOC_COMMENT;
            }
            // fall through
          case 224: break;
          case 83:
            { return PHP_THIS;
            }
            // fall through
          case 225: break;
          case 84:
            { return PHP_CASTING;
            }
            // fall through
          case 226: break;
          case 85:
            { String yytext = yytext();
	int bprefix = (yytext.charAt(0) != '<') ? 1 : 0;
	int startString = 3 + bprefix;

	int hereOrNowDoc_len = yylength() - bprefix - 3 - 1 - (yytext.charAt(yylength() - 2) == '\r' ? 1 : 0);
	while ((yytext.charAt(startString) == ' ') || (yytext.charAt(startString) == '\t')) {
		startString++;
		hereOrNowDoc_len--;
	}
	String hereOrNowDoc = yytext.substring(startString, hereOrNowDoc_len + startString);
	if (hereOrNowDoc.charAt(0) == '\'') {
		pushHeredocId(hereOrNowDoc.substring(1, hereOrNowDoc_len - 1));
		pushState(ST_PHP_START_NOWDOC);
		return PHP_NOWDOC_START_TAG;
	} else if (hereOrNowDoc.charAt(0) == '"') {
		pushHeredocId(hereOrNowDoc.substring(1, hereOrNowDoc_len - 1));
		pushState(ST_PHP_START_HEREDOC);
		return PHP_HEREDOC_START_TAG;
	} else {
		pushHeredocId(hereOrNowDoc);
		pushState(ST_PHP_START_HEREDOC);
		return PHP_HEREDOC_START_TAG;
	}
            }
            // fall through
          case 227: break;
          case 86:
            { return PHP_ARRAY;
            }
            // fall through
          case 228: break;
          case 87:
            { return PHP_BREAK;
            }
            // fall through
          case 229: break;
          case 88:
            { return PHP_CATCH;
            }
            // fall through
          case 230: break;
          case 89:
            { return PHP_CLASS;
            }
            // fall through
          case 231: break;
          case 90:
            { return PHP_CLONE;
            }
            // fall through
          case 232: break;
          case 91:
            { return PHP_CONST;
            }
            // fall through
          case 233: break;
          case 92:
            { return PHP_EMPTY;
            }
            // fall through
          case 234: break;
          case 93:
            { return PHP_ENDIF;
            }
            // fall through
          case 235: break;
          case 94:
            { return PHP_FALSE;
            }
            // fall through
          case 236: break;
          case 95:
            { return PHP_FINAL;
            }
            // fall through
          case 237: break;
          case 96:
            { return PHP_ISSET;
            }
            // fall through
          case 238: break;
          case 97:
            { return PHP_PRINT;
            }
            // fall through
          case 239: break;
          case 98:
            { return PHP_THROW;
            }
            // fall through
          case 240: break;
          case 99:
            { return PHP_TRAIT;
            }
            // fall through
          case 241: break;
          case 100:
            { return PHP_UNSET;
            }
            // fall through
          case 242: break;
          case 101:
            { return PHP_WHILE;
            }
            // fall through
          case 243: break;
          case 102:
            { return PHP_YIELD;
            }
            // fall through
          case 244: break;
          case 103:
            { return PHP_ELSEIF;
            }
            // fall through
          case 245: break;
          case 104:
            { return PHP_ENDFOR;
            }
            // fall through
          case 246: break;
          case 105:
            { return PHP_GLOBAL;
            }
            // fall through
          case 247: break;
          case 106:
            { return PHP_PARENT;
            }
            // fall through
          case 248: break;
          case 107:
            { return PHP_PUBLIC;
            }
            // fall through
          case 249: break;
          case 108:
            { return PHP_RETURN;
            }
            // fall through
          case 250: break;
          case 109:
            { return PHP_STATIC;
            }
            // fall through
          case 251: break;
          case 110:
            { return PHP_SWITCH;
            }
            // fall through
          case 252: break;
          case 111:
            { return PHP_DECLARE;
            }
            // fall through
          case 253: break;
          case 112:
            { return PHP_DEFAULT;
            }
            // fall through
          case 254: break;
          case 113:
            { return PHP_EXTENDS;
            }
            // fall through
          case 255: break;
          case 114:
            { return PHP_FINALLY;
            }
            // fall through
          case 256: break;
          case 115:
            { return PHP_FOREACH;
            }
            // fall through
          case 257: break;
          case 116:
            { return PHP_INCLUDE;
            }
            // fall through
          case 258: break;
          case 117:
            { return PHP_PRIVATE;
            }
            // fall through
          case 259: break;
          case 118:
            { return PHP_REQUIRE;
            }
            // fall through
          case 260: break;
          case 119:
            { return PHP__DIR__;
            }
            // fall through
          case 261: break;
          case 120:
            { return PHP_ABSTRACT;
            }
            // fall through
          case 262: break;
          case 121:
            { return PHP_CALLABLE;
            }
            // fall through
          case 263: break;
          case 122:
            { return PHP_CONTINUE;
            }
            // fall through
          case 264: break;
          case 123:
            { return PHP_ENDWHILE;
            }
            // fall through
          case 265: break;
          case 124:
            { return PHP_FUNCTION;
            }
            // fall through
          case 266: break;
          case 125:
            { return PHP__FILE__;
            }
            // fall through
          case 267: break;
          case 126:
            { return PHP__LINE__;
            }
            // fall through
          case 268: break;
          case 127:
            { return PHP_ENDSWITCH;
            }
            // fall through
          case 269: break;
          case 128:
            { return PHP_INSTEADOF;
            }
            // fall through
          case 270: break;
          case 129:
            { return PHP_INTERFACE;
            }
            // fall through
          case 271: break;
          case 130:
            { return PHP_NAMESPACE;
            }
            // fall through
          case 272: break;
          case 131:
            { return PHP_PROTECTED;
            }
            // fall through
          case 273: break;
          case 132:
            { return PHP__CLASS__;
            }
            // fall through
          case 274: break;
          case 133:
            { return PHP_ENDDECLARE;
            }
            // fall through
          case 275: break;
          case 134:
            { return PHP_ENDFOREACH;
            }
            // fall through
          case 276: break;
          case 135:
            { return PHP_IMPLEMENTS;
            }
            // fall through
          case 277: break;
          case 136:
            { return PHP_INSTANCEOF;
            }
            // fall through
          case 278: break;
          case 137:
            { return PHP__METHOD__;
            }
            // fall through
          case 279: break;
          case 138:
            { return PHP_INCLUDE_ONCE;
            }
            // fall through
          case 280: break;
          case 139:
            { return PHP_REQUIRE_ONCE;
            }
            // fall through
          case 281: break;
          case 140:
            { return PHP__FUNCTION__;
            }
            // fall through
          case 282: break;
          case 141:
            { return PHP__NAMESPACE__;
            }
            // fall through
          case 283: break;
          case 142:
            { return PHP_HALT_COMPILER;
            }
            // fall through
          case 284: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }


}
