// DO NOT EDIT
// Generated by JFlex 1.8.2 http://jflex.de/
// source: highlighting_scanner.jflex

/*******************************************************************************
 * Copyright (c) 2006, 2017 Zend Corporation and IBM Corporation.
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *   Zend and IBM - Initial implementation
 *******************************************************************************/

package org.eclipse.php.internal.core.documentModel.parser.php7;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.php.core.compiler.ast.nodes.PHPDocTag.TagKind;

//@SuppressWarnings({"unused", "nls"})


// See https://github.com/jflex-de/jflex/issues/222
@SuppressWarnings("FallThrough")
public class PHPLexer extends org.eclipse.php.internal.core.documentModel.parser.AbstractPHPLexer {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int ST_PHP_IN_SCRIPTING = 2;
  public static final int ST_PHP_DOUBLE_QUOTES = 4;
  public static final int ST_PHP_SINGLE_QUOTE = 6;
  public static final int ST_PHP_BACKQUOTE = 8;
  public static final int ST_PHP_QUOTES_AFTER_VARIABLE = 10;
  public static final int ST_PHP_HEREDOC = 12;
  public static final int ST_PHP_NOWDOC = 14;
  public static final int ST_PHP_START_HEREDOC = 16;
  public static final int ST_PHP_START_NOWDOC = 18;
  public static final int ST_PHP_END_HEREDOC = 20;
  public static final int ST_PHP_LOOKING_FOR_PROPERTY = 22;
  public static final int ST_PHP_VAR_OFFSET = 24;
  public static final int ST_PHP_COMMENT = 26;
  public static final int ST_PHP_DOC_COMMENT = 28;
  public static final int ST_PHP_LINE_COMMENT = 30;
  public static final int ST_PHP_HIGHLIGHTING_ERROR = 32;
  public static final int ST_PHP_END_NOWDOC = 34;
  public static final int ST_PHP_IDENTIFIER = 36;
  public static final int ST_PHP_DOLLAR_CURLY_OPEN = 38;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7,  7, 
     8,  8,  9,  9, 10, 10, 11, 11, 12, 12, 13, 13, 14, 14, 15, 15, 
    16, 16, 17, 17, 18, 18, 19, 19
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\37\u0200\1\u0300\266\u0200\10\u0400\40\u0200\u1000\u0500";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\2\0\1\3\22\0\1\1\1\4"+
    "\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14"+
    "\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24"+
    "\10\25\1\26\1\27\1\30\1\31\1\32\1\33\1\34"+
    "\1\35\1\36\1\37\1\40\1\41\1\42\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\54"+
    "\1\55\1\56\1\57\1\60\1\61\1\62\1\63\1\64"+
    "\1\65\1\66\1\67\1\70\1\71\1\72\1\73\1\74"+
    "\1\35\1\36\1\37\1\40\1\41\1\42\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\54"+
    "\1\55\1\56\1\57\1\60\1\61\1\62\1\63\1\64"+
    "\1\65\1\66\1\75\1\76\1\77\1\17\1\0\260\100"+
    "\2\101\115\100\1\102\u01aa\100\1\103\325\100\u0100\104\u0100\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1536];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\6\0\1\1\1\2\14\0\1\3\1\4\1\5\1\6"+
    "\1\7\3\5\1\10\7\5\2\11\1\5\1\12\4\5"+
    "\25\13\1\14\1\5\1\13\1\15\1\16\1\5\1\17"+
    "\1\1\1\20\5\2\1\1\3\2\3\21\2\1\3\3"+
    "\1\2\2\22\2\23\1\0\1\3\2\24\1\25\1\26"+
    "\2\27\2\11\1\13\1\30\2\31\4\32\3\33\3\34"+
    "\1\35\1\36\1\0\1\3\1\24\2\25\1\37\1\40"+
    "\1\41\1\0\1\2\3\0\2\42\1\41\1\43\14\0"+
    "\1\44\1\11\1\45\1\0\1\11\1\0\1\46\2\41"+
    "\1\47\3\13\1\50\1\0\7\13\1\51\16\13\1\52"+
    "\7\13\1\41\17\13\3\0\2\53\1\54\1\55\1\56"+
    "\1\53\4\0\2\53\1\57\3\0\1\1\2\53\1\2"+
    "\1\60\2\0\1\61\3\0\1\62\1\54\1\63\1\64"+
    "\1\65\1\0\1\66\1\67\1\0\1\70\2\25\1\40"+
    "\1\71\1\42\12\0\1\72\2\11\1\0\2\13\1\0"+
    "\12\13\1\73\12\13\1\74\7\13\1\75\3\13\1\76"+
    "\16\13\1\77\1\13\1\100\1\101\11\13\1\102\1\103"+
    "\1\1\1\104\1\2\1\105\2\0\2\106\1\107\1\0"+
    "\2\25\1\42\12\0\1\110\3\0\2\13\1\111\2\13"+
    "\1\112\7\13\1\113\1\114\6\13\1\115\1\116\5\13"+
    "\1\117\2\13\1\120\5\13\1\121\1\13\1\122\7\13"+
    "\1\123\5\13\1\124\13\13\1\125\2\25\1\126\6\0"+
    "\1\127\5\0\2\130\1\13\1\131\1\132\1\13\1\133"+
    "\1\134\1\135\1\136\4\13\1\137\2\13\1\140\3\13"+
    "\1\141\1\142\1\143\10\13\1\144\2\13\1\145\10\13"+
    "\1\146\1\147\1\150\1\151\1\152\10\13\1\134\1\25"+
    "\5\0\5\13\1\153\1\13\1\154\6\13\1\155\6\13"+
    "\1\156\2\13\1\157\1\13\1\160\1\161\1\162\1\163"+
    "\1\0\10\13\1\25\2\0\3\13\1\164\1\165\4\13"+
    "\1\166\1\167\1\170\2\13\1\171\4\13\1\172\1\13"+
    "\1\173\1\0\1\13\1\174\6\13\1\25\1\175\1\176"+
    "\1\177\3\13\1\200\1\201\10\13\1\0\1\13\1\202"+
    "\2\13\1\203\2\13\1\204\2\13\1\205\3\13\1\206"+
    "\1\207\1\210\1\211\1\13\1\0\1\212\4\13\1\213"+
    "\1\214\1\215\1\13\1\216\1\13\1\152\2\13\1\217"+
    "\6\13\1\220\1\221\1\222\3\13\1\223\1\13\1\224";

  private static int [] zzUnpackAction() {
    int [] result = new int[650];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\105\0\212\0\317\0\u0114\0\u0159\0\u019e\0\u01e3"+
    "\0\u0228\0\u026d\0\u02b2\0\u02f7\0\u033c\0\u0381\0\u03c6\0\u040b"+
    "\0\u0450\0\u0495\0\u04da\0\u051f\0\0\0\u0564\0\u05a9\0\u05ee"+
    "\0\0\0\u0633\0\u0678\0\u06bd\0\u0702\0\u0747\0\0\0\u078c"+
    "\0\u07d1\0\u0816\0\u085b\0\u08a0\0\u08e5\0\u092a\0\u096f\0\0"+
    "\0\u09b4\0\u09f9\0\u0a3e\0\u0a83\0\u0ac8\0\u0b0d\0\u0b52\0\u0b97"+
    "\0\u0bdc\0\u0c21\0\u0c66\0\u0cab\0\u0cf0\0\u0d35\0\u0d7a\0\u0dbf"+
    "\0\u0e04\0\u0e49\0\u0e8e\0\u0ed3\0\u0f18\0\u0f5d\0\u0fa2\0\u0fe7"+
    "\0\u102c\0\0\0\u1071\0\u10b6\0\0\0\u10fb\0\u1140\0\u1185"+
    "\0\u11ca\0\0\0\u120f\0\u1254\0\u1299\0\u12de\0\u1323\0\u1368"+
    "\0\u13ad\0\u13f2\0\u1437\0\0\0\u147c\0\u14c1\0\u1506\0\u154b"+
    "\0\u1590\0\u15d5\0\u161a\0\u165f\0\0\0\u16a4\0\0\0\u16e9"+
    "\0\u172e\0\u1773\0\0\0\u17b8\0\u17fd\0\0\0\0\0\u1842"+
    "\0\u1887\0\u18cc\0\u1911\0\0\0\u1956\0\u199b\0\0\0\u19e0"+
    "\0\u1a25\0\u1a6a\0\u1aaf\0\0\0\u1af4\0\u1b39\0\0\0\u1b7e"+
    "\0\0\0\u1bc3\0\u1c08\0\u1c4d\0\u1c92\0\u1cd7\0\u1d1c\0\u1d61"+
    "\0\u1da6\0\u1071\0\u05ee\0\0\0\u1deb\0\u1e30\0\u1e75\0\u1eba"+
    "\0\u1eff\0\0\0\0\0\u0702\0\u1f44\0\u0747\0\u1f89\0\u1fce"+
    "\0\u2013\0\u2058\0\u209d\0\u20e2\0\u2127\0\u216c\0\u21b1\0\0"+
    "\0\u21f6\0\u223b\0\u2280\0\u22c5\0\u230a\0\0\0\u234f\0\u2394"+
    "\0\0\0\u23d9\0\u241e\0\u2463\0\u0cab\0\u24a8\0\u24ed\0\u2532"+
    "\0\u2577\0\u25bc\0\u2601\0\u2646\0\u268b\0\u0cab\0\u26d0\0\u2715"+
    "\0\u275a\0\u279f\0\u27e4\0\u2829\0\u286e\0\u28b3\0\u28f8\0\u293d"+
    "\0\u2982\0\u29c7\0\u2a0c\0\u2a51\0\u0cab\0\u2a96\0\u2adb\0\u2b20"+
    "\0\u2b65\0\u2baa\0\u2bef\0\u2c34\0\u0cab\0\u2c79\0\u2cbe\0\u2d03"+
    "\0\u2d48\0\u2d8d\0\u2dd2\0\u2e17\0\u2e5c\0\u2ea1\0\u2ee6\0\u2f2b"+
    "\0\u2f70\0\u2fb5\0\u2ffa\0\u303f\0\u3084\0\u1254\0\u30c9\0\0"+
    "\0\u3084\0\u310e\0\0\0\0\0\u30c9\0\u3153\0\u3198\0\u13f2"+
    "\0\u31dd\0\u3198\0\u31dd\0\0\0\u3222\0\u15d5\0\u3267\0\u32ac"+
    "\0\u3222\0\u3267\0\u32f1\0\0\0\u16a4\0\u3336\0\0\0\u16e9"+
    "\0\u337b\0\u33c0\0\0\0\u3405\0\0\0\0\0\u1a25\0\u344a"+
    "\0\0\0\u348f\0\u34d4\0\0\0\u3519\0\u355e\0\u35a3\0\u35e8"+
    "\0\u362d\0\u3672\0\u36b7\0\u36fc\0\u3741\0\u3786\0\u37cb\0\u3810"+
    "\0\u3855\0\u389a\0\u38df\0\u3924\0\u2280\0\u230a\0\u3969\0\u39ae"+
    "\0\u39f3\0\u3a38\0\u3a7d\0\u3ac2\0\u3b07\0\u3b4c\0\u3b91\0\u3bd6"+
    "\0\u3c1b\0\u3c60\0\u3ca5\0\u3cea\0\u0cab\0\u3d2f\0\u3d74\0\u3db9"+
    "\0\u3dfe\0\u3e43\0\u3e88\0\u3ecd\0\u3f12\0\u3f57\0\u3f9c\0\u3fe1"+
    "\0\u4026\0\u406b\0\u40b0\0\u40f5\0\u413a\0\u417f\0\u41c4\0\u4209"+
    "\0\u424e\0\u4293\0\u42d8\0\u0cab\0\u431d\0\u4362\0\u43a7\0\u43ec"+
    "\0\u4431\0\u4476\0\u44bb\0\u4500\0\u4545\0\u458a\0\u45cf\0\u4614"+
    "\0\u4659\0\u469e\0\u0cab\0\u46e3\0\u0cab\0\u0cab\0\u4728\0\u476d"+
    "\0\u47b2\0\u47f7\0\u483c\0\u4881\0\u48c6\0\u490b\0\u4950\0\0"+
    "\0\0\0\u4995\0\0\0\u49da\0\0\0\u4a1f\0\u4a64\0\0"+
    "\0\u4aa9\0\0\0\u4aee\0\u4b33\0\u4b78\0\u4bbd\0\u4c02\0\u4c47"+
    "\0\u4c8c\0\u4cd1\0\u4d16\0\u4d5b\0\u4da0\0\u4de5\0\u4e2a\0\u4e6f"+
    "\0\0\0\u4eb4\0\u4ef9\0\u4f3e\0\u4f83\0\u4fc8\0\u0cab\0\u500d"+
    "\0\u5052\0\u0cab\0\u5097\0\u50dc\0\u5121\0\u5166\0\u51ab\0\u51f0"+
    "\0\u5235\0\u0cab\0\u527a\0\u52bf\0\u5304\0\u5349\0\u538e\0\u53d3"+
    "\0\u5418\0\u0cab\0\u0cab\0\u545d\0\u54a2\0\u54e7\0\u552c\0\u5571"+
    "\0\u0cab\0\u55b6\0\u55fb\0\u0cab\0\u5640\0\u5685\0\u56ca\0\u570f"+
    "\0\u5754\0\u0cab\0\u5799\0\u0cab\0\u57de\0\u5823\0\u5868\0\u58ad"+
    "\0\u58f2\0\u5937\0\u597c\0\u0cab\0\u59c1\0\u5a06\0\u5a4b\0\u5a90"+
    "\0\u5ad5\0\u0cab\0\u5b1a\0\u5b5f\0\u5ba4\0\u5be9\0\u5c2e\0\u5c73"+
    "\0\u5cb8\0\u5cfd\0\u5d42\0\u5d87\0\u5dcc\0\0\0\u5e11\0\u5e56"+
    "\0\u1eba\0\u5e9b\0\u5ee0\0\u5f25\0\u5f6a\0\u5faf\0\u5ff4\0\0"+
    "\0\u6039\0\u607e\0\u60c3\0\u6108\0\u614d\0\0\0\u6192\0\u61d7"+
    "\0\u0cab\0\u0cab\0\u621c\0\u0cab\0\u0cab\0\u0cab\0\u0cab\0\u6261"+
    "\0\u62a6\0\u62eb\0\u6330\0\u0cab\0\u6375\0\u63ba\0\u0cab\0\u63ff"+
    "\0\u6444\0\u6489\0\u0cab\0\u64ce\0\u0cab\0\u6513\0\u6558\0\u659d"+
    "\0\u65e2\0\u6627\0\u666c\0\u66b1\0\u66f6\0\u0cab\0\u673b\0\u6780"+
    "\0\u0cab\0\u67c5\0\u680a\0\u684f\0\u6894\0\u68d9\0\u691e\0\u6963"+
    "\0\u69a8\0\u0cab\0\u0cab\0\u0cab\0\u0cab\0\u69ed\0\u6a32\0\u6a77"+
    "\0\u6abc\0\u6b01\0\u6b46\0\u6b8b\0\u6bd0\0\u6c15\0\u17fd\0\u6c5a"+
    "\0\u6c9f\0\u6ce4\0\u6d29\0\u6d6e\0\u6db3\0\u6df8\0\u6e3d\0\u6e82"+
    "\0\u6ec7\0\u6f0c\0\u0cab\0\u6f51\0\u6f96\0\u6fdb\0\u7020\0\u7065"+
    "\0\u70aa\0\u70ef\0\u7134\0\u0cab\0\u7179\0\u71be\0\u7203\0\u7248"+
    "\0\u728d\0\u72d2\0\u0cab\0\u7317\0\u735c\0\u0cab\0\u73a1\0\u0cab"+
    "\0\u0cab\0\u0cab\0\u0cab\0\u73e6\0\u742b\0\u7470\0\u74b5\0\u74fa"+
    "\0\u753f\0\u7584\0\u75c9\0\u760e\0\u7653\0\u7698\0\u76dd\0\u7722"+
    "\0\u7767\0\u77ac\0\u0cab\0\u0cab\0\u77f1\0\u7836\0\u787b\0\u78c0"+
    "\0\u0cab\0\u0cab\0\u0cab\0\u7905\0\u794a\0\u798f\0\u79d4\0\u7a19"+
    "\0\u7a5e\0\u7aa3\0\u0cab\0\u7ae8\0\u7b2d\0\u7b72\0\u7bb7\0\u0cab"+
    "\0\u7bfc\0\u7c41\0\u7c86\0\u7ccb\0\u7d10\0\u7d55\0\u7d9a\0\u0cab"+
    "\0\u0cab\0\u0cab\0\u7ddf\0\u7e24\0\u7e69\0\u0cab\0\u0cab\0\u7eae"+
    "\0\u7ef3\0\u7f38\0\u7f7d\0\u7fc2\0\u8007\0\u804c\0\u8091\0\u80d6"+
    "\0\u811b\0\u0cab\0\u8160\0\u81a5\0\u0cab\0\u81ea\0\u822f\0\u17fd"+
    "\0\u8274\0\u82b9\0\u0cab\0\u82fe\0\u8343\0\u8388\0\u0cab\0\u0cab"+
    "\0\u0cab\0\u0cab\0\u83cd\0\u8412\0\u0cab\0\u8457\0\u849c\0\u84e1"+
    "\0\u8526\0\u0cab\0\u0cab\0\u0cab\0\u856b\0\u0cab\0\u85b0\0\0"+
    "\0\u85f5\0\u863a\0\u0cab\0\u867f\0\u86c4\0\u8709\0\u874e\0\u8793"+
    "\0\u87d8\0\u0cab\0\u0cab\0\u0cab\0\u881d\0\u8862\0\u88a7\0\u0cab"+
    "\0\u88ec\0\u0cab";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[650];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\105\0\1\25\3\26\1\27\1\30\1\31\1\32\1\33"+
    "\1\34\1\35\1\36\1\37\1\40\1\41\1\37\1\42"+
    "\1\43\1\44\1\45\2\46\1\47\1\50\1\51\1\52"+
    "\1\53\1\54\1\37\1\55\1\56\1\57\1\60\1\61"+
    "\1\62\1\63\1\64\1\65\2\64\1\66\1\64\1\67"+
    "\1\70\1\71\1\64\1\72\1\73\1\74\1\75\1\76"+
    "\1\77\1\100\1\101\1\64\1\37\1\102\1\37\1\103"+
    "\1\104\1\105\1\106\1\107\1\110\1\64\1\65\1\73"+
    "\2\64\5\111\1\112\1\111\1\113\60\111\1\114\4\111"+
    "\1\115\7\111\12\116\1\112\55\116\1\117\14\116\7\120"+
    "\1\121\60\120\1\122\3\120\1\112\1\123\7\120\20\124"+
    "\1\125\54\124\1\126\7\124\2\127\2\130\3\127\1\131"+
    "\60\127\1\132\4\127\1\133\7\127\2\10\2\134\101\10"+
    "\35\135\32\136\4\135\1\136\4\135\5\136\35\137\32\140"+
    "\4\137\1\140\4\137\5\140\2\25\1\141\1\142\100\25"+
    "\1\0\1\143\3\26\14\143\1\144\14\143\32\145\4\143"+
    "\1\145\4\143\5\145\1\25\3\146\2\147\1\146\1\150"+
    "\2\147\1\146\10\147\1\151\2\152\7\147\15\64\1\153"+
    "\14\64\1\37\1\146\1\154\1\147\1\64\4\147\5\64"+
    "\15\155\1\156\67\155\15\157\1\160\16\157\1\161\40\157"+
    "\1\162\7\157\2\163\1\164\1\165\4\163\1\166\21\163"+
    "\1\167\1\170\51\163\1\171\3\172\100\171\1\0\2\25"+
    "\1\173\1\174\100\25\1\0\1\143\3\26\22\143\1\175"+
    "\6\143\2\145\1\176\2\145\1\177\24\145\4\143\1\145"+
    "\4\143\5\145\2\25\1\0\32\25\32\200\4\25\1\200"+
    "\1\25\1\201\2\25\5\200\1\0\3\26\132\0\1\202"+
    "\53\0\5\203\1\204\1\203\1\205\60\203\1\206\4\203"+
    "\1\207\7\203\35\0\23\210\1\211\6\210\4\0\1\210"+
    "\4\0\5\210\31\0\1\212\1\213\63\0\1\212\17\0"+
    "\1\212\53\0\12\214\1\204\55\214\1\215\14\214\1\0"+
    "\1\216\33\0\1\217\1\220\1\0\1\221\1\0\1\222"+
    "\2\0\1\223\5\0\1\224\2\0\1\225\1\226\1\0"+
    "\1\227\17\0\1\223\1\226\17\0\1\202\13\0\1\212"+
    "\71\0\1\212\12\0\1\212\73\0\1\212\10\0\1\212"+
    "\1\230\75\0\3\231\3\0\1\212\70\0\1\232\4\0"+
    "\1\31\6\0\1\212\74\0\1\231\1\0\3\46\10\0"+
    "\1\233\2\0\1\234\22\0\1\235\41\0\1\231\1\0"+
    "\3\46\13\0\1\234\71\0\1\236\106\0\1\237\1\240"+
    "\1\212\103\0\1\202\1\212\103\0\1\212\1\202\104\0"+
    "\1\241\1\212\74\0\3\64\7\0\1\64\1\242\13\64"+
    "\1\243\3\64\1\244\1\245\7\64\4\0\1\64\4\0"+
    "\2\64\1\245\2\64\5\0\1\30\4\0\1\35\10\0"+
    "\3\64\2\0\1\246\4\0\16\64\1\247\2\64\1\250"+
    "\10\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\1\251\12\64\1\252\2\64\1\253\13\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\4\64\1\254\3\64"+
    "\1\255\5\64\1\256\13\64\4\0\1\64\4\0\1\64"+
    "\1\255\3\64\23\0\3\64\7\0\2\64\1\257\10\64"+
    "\1\260\1\261\1\262\7\64\1\263\1\64\1\264\2\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\1\265"+
    "\7\64\1\266\2\64\1\267\2\64\1\270\2\64\1\271"+
    "\2\64\1\272\5\64\4\0\1\64\4\0\1\64\1\266"+
    "\3\64\23\0\3\64\7\0\13\64\1\273\2\64\1\274"+
    "\13\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\32\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\5\64\1\275\6\64\1\276\1\277\4\64\1\300\7\64"+
    "\4\0\1\64\4\0\2\64\1\300\2\64\23\0\3\64"+
    "\7\0\10\64\1\301\21\64\4\0\1\64\4\0\1\64"+
    "\1\301\3\64\23\0\3\64\7\0\1\302\3\64\1\303"+
    "\17\64\1\304\5\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\21\64\1\305\10\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\1\306\20\64\1\307\2\64"+
    "\1\310\5\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\4\64\1\311\25\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\4\64\1\312\16\64\1\313\2\64"+
    "\1\314\3\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\7\64\1\315\11\64\1\316\10\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\15\64\1\317\4\64"+
    "\1\320\7\64\4\0\1\64\4\0\2\64\1\320\2\64"+
    "\23\0\3\64\7\0\1\321\31\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\7\64\1\322\22\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\16\64\1\70"+
    "\13\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\10\64\1\323\21\64\4\0\1\64\4\0\1\64\1\323"+
    "\3\64\31\0\1\212\76\0\3\64\7\0\32\64\4\0"+
    "\1\324\4\0\5\64\1\0\3\106\132\0\1\212\44\0"+
    "\1\212\7\0\3\110\101\0\5\111\1\0\1\111\1\325"+
    "\60\111\1\326\4\111\1\327\14\111\1\330\1\111\1\331"+
    "\25\111\32\332\1\111\1\326\2\111\1\332\1\111\1\333"+
    "\2\111\5\332\112\111\1\330\1\111\1\334\60\111\1\326"+
    "\4\111\1\335\7\111\12\116\1\0\55\116\1\336\26\116"+
    "\1\204\55\116\1\204\14\116\7\120\1\337\60\120\1\340"+
    "\3\120\1\0\1\341\16\120\1\342\25\120\32\332\1\120"+
    "\1\340\2\120\1\332\1\330\1\333\2\120\5\332\114\120"+
    "\1\334\60\120\1\340\3\120\1\330\1\343\7\120\32\0"+
    "\1\344\61\0\1\334\75\0\2\127\2\130\3\127\1\345"+
    "\60\127\1\346\4\127\1\347\11\127\2\130\3\127\1\345"+
    "\25\127\32\350\1\127\1\346\2\127\1\350\1\127\1\347"+
    "\2\127\5\350\2\127\2\130\3\127\1\351\25\127\32\332"+
    "\1\127\1\346\2\127\1\332\1\127\1\333\2\127\5\332"+
    "\2\127\2\130\103\127\2\130\3\127\1\334\60\127\1\346"+
    "\4\127\1\352\7\127\2\10\2\134\31\10\32\353\4\10"+
    "\1\353\4\10\5\353\2\0\2\354\17\0\3\355\1\0"+
    "\1\356\5\0\32\355\4\0\1\355\4\0\5\355\2\0"+
    "\2\357\17\0\3\360\1\0\1\361\5\0\32\360\4\0"+
    "\1\360\4\0\5\360\35\0\32\362\4\0\1\362\4\0"+
    "\5\362\2\0\1\141\32\0\32\362\4\0\1\362\4\0"+
    "\5\362\32\0\1\363\75\0\3\145\7\0\32\145\4\0"+
    "\1\145\4\0\5\145\35\0\32\364\4\0\1\364\4\0"+
    "\5\364\23\0\3\152\10\0\1\233\25\0\1\235\43\0"+
    "\3\152\102\0\3\64\7\0\24\64\1\304\5\64\4\0"+
    "\1\64\4\0\5\64\15\155\1\0\67\155\22\0\1\365"+
    "\104\0\1\366\62\0\1\367\3\0\11\367\1\0\67\367"+
    "\34\0\1\370\50\0\2\163\2\164\4\163\1\164\21\163"+
    "\2\164\51\163\2\0\1\371\134\0\1\372\104\0\1\241"+
    "\53\0\3\172\136\0\32\373\4\0\1\373\4\0\5\373"+
    "\2\0\1\173\32\0\32\373\4\0\1\373\4\0\5\373"+
    "\26\0\1\374\101\0\3\145\7\0\13\145\1\375\16\145"+
    "\4\0\1\145\4\0\5\145\23\0\3\145\7\0\24\145"+
    "\1\376\5\145\4\0\1\145\4\0\5\145\23\0\3\200"+
    "\7\0\32\200\4\0\1\200\4\0\5\200\1\0\3\377"+
    "\31\0\32\u0100\4\0\1\u0100\4\0\5\u0100\5\203\1\204"+
    "\1\203\1\205\25\203\32\0\1\203\1\206\2\203\1\0"+
    "\1\203\1\0\2\203\5\0\112\203\1\204\1\203\1\0"+
    "\60\203\1\206\4\203\1\207\7\203\23\0\3\210\7\0"+
    "\32\210\4\0\1\210\4\0\5\210\23\0\3\210\7\0"+
    "\7\210\1\u0101\22\210\4\0\1\210\4\0\5\210\105\214"+
    "\56\0\1\u0102\73\0\1\u0103\5\0\1\u0104\25\0\1\u0103"+
    "\56\0\1\u0105\101\0\1\u0106\106\0\1\u0107\70\0\1\u0108"+
    "\107\0\1\u0109\123\0\1\u010a\76\0\1\u010b\55\0\3\231"+
    "\13\0\1\234\60\0\1\u010c\112\0\2\u010d\76\0\1\152"+
    "\1\0\1\152\2\0\3\152\102\0\3\u010e\7\0\6\u010e"+
    "\72\0\1\u010f\1\212\105\0\1\212\75\0\3\64\7\0"+
    "\22\64\1\u0110\7\64\4\0\1\64\4\0\2\64\1\u0110"+
    "\2\64\23\0\3\64\7\0\3\64\1\305\26\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\21\64\1\u0111"+
    "\10\64\4\0\1\64\4\0\5\64\30\0\1\u0112\77\0"+
    "\3\64\7\0\16\64\1\u0113\13\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\4\64\1\u0114\25\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\13\64\1\u0115"+
    "\6\64\1\u0116\1\u0117\6\64\4\0\1\64\4\0\2\64"+
    "\1\u0116\2\64\23\0\3\64\7\0\1\u0118\15\64\1\u0119"+
    "\13\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\15\64\1\u011a\14\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\2\64\1\u011b\2\64\1\u011c\24\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\4\64\1\u011d"+
    "\25\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\7\64\1\u011e\22\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\22\64\1\u011f\7\64\4\0\1\64\4\0"+
    "\2\64\1\u011f\2\64\23\0\3\64\7\0\17\64\1\u0120"+
    "\12\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\3\64\1\u0121\26\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\1\u0122\31\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\10\64\1\u0123\12\64\1\u0124\6\64"+
    "\4\0\1\64\4\0\1\64\1\u0123\3\64\23\0\3\64"+
    "\7\0\13\64\1\u0125\16\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\15\64\1\u0126\14\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\16\64\1\u0127\13\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\21\64"+
    "\1\u0128\10\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\16\64\1\u0129\13\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\15\64\1\u012a\14\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\16\64\1\u012b\13\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\23\64"+
    "\1\u012c\6\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\17\64\1\u012d\12\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\2\64\1\u012e\17\64\1\u012f\1\u0130"+
    "\6\64\4\0\1\64\4\0\2\64\1\u012f\2\64\23\0"+
    "\3\64\7\0\22\64\1\u0131\7\64\4\0\1\64\4\0"+
    "\2\64\1\u0131\2\64\23\0\3\64\7\0\22\64\1\u0132"+
    "\7\64\4\0\1\64\4\0\2\64\1\u0132\2\64\23\0"+
    "\3\64\7\0\14\64\1\u0133\15\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\26\64\1\u0134\3\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\13\64\1\u0135"+
    "\16\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\21\64\1\u0136\10\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\10\64\1\u0137\5\64\1\u0138\13\64\4\0"+
    "\1\64\4\0\1\64\1\u0137\3\64\23\0\3\64\7\0"+
    "\1\64\1\u0139\30\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\20\64\1\u013a\2\64\1\u013b\6\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\13\64\1\u013c"+
    "\16\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\1\u013d\20\64\1\u013e\10\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\10\64\1\u013f\21\64\4\0\1\64"+
    "\4\0\1\64\1\u013f\3\64\23\0\3\64\7\0\21\64"+
    "\1\u0140\10\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\1\u0141\23\64\1\u0142\3\64\1\u0143\1\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\22\64\1\u0144"+
    "\7\64\4\0\1\64\4\0\2\64\1\u0144\2\64\23\0"+
    "\3\64\7\0\4\64\1\u0145\25\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\21\64\1\u0146\10\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\10\64\1\u0147"+
    "\21\64\4\0\1\64\4\0\1\64\1\u0147\3\64\23\0"+
    "\3\64\7\0\4\64\1\u0148\25\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\2\64\1\u0149\1\u014a\1\64"+
    "\1\u014b\1\64\1\u014c\3\64\1\u014d\1\u014e\1\u014f\14\64"+
    "\4\0\1\64\4\0\5\64\5\111\1\330\1\111\1\331"+
    "\25\111\32\0\1\111\1\326\2\111\1\0\1\111\1\0"+
    "\2\111\5\0\5\111\1\330\1\111\1\0\60\111\1\326"+
    "\4\111\1\335\7\111\23\0\3\332\7\0\32\332\1\u0150"+
    "\3\0\1\332\4\0\5\332\12\116\1\0\55\116\1\0"+
    "\14\116\7\120\1\342\25\120\32\0\1\120\1\340\2\120"+
    "\1\0\1\330\1\0\2\120\5\0\7\120\1\0\60\120"+
    "\1\340\3\120\1\330\1\343\7\120\2\127\2\130\3\127"+
    "\1\351\25\127\32\0\1\127\1\346\2\127\1\0\1\127"+
    "\1\0\2\127\5\0\2\127\2\130\3\127\1\0\60\127"+
    "\1\346\4\127\1\352\11\127\2\u0151\3\127\1\345\13\127"+
    "\3\350\1\127\1\u0152\5\127\32\350\1\127\1\346\2\127"+
    "\1\350\1\127\1\347\2\127\5\350\2\10\2\u0153\17\10"+
    "\3\353\1\10\1\u0154\5\10\32\353\4\10\1\353\4\10"+
    "\5\353\2\0\2\354\103\0\2\357\103\0\2\u0155\17\0"+
    "\3\362\1\0\1\u0156\5\0\32\362\4\0\1\362\4\0"+
    "\5\362\23\0\3\364\7\0\32\364\4\0\1\364\4\0"+
    "\5\364\20\0\1\u0157\14\0\32\u0157\20\0\1\u0158\1\u0159"+
    "\103\0\2\u015a\17\0\3\373\1\0\1\u015b\5\0\32\373"+
    "\4\0\1\373\4\0\5\373\23\0\3\145\7\0\1\u015c"+
    "\31\145\4\0\1\145\4\0\5\145\23\0\3\145\7\0"+
    "\15\145\1\u015d\14\145\4\0\1\145\4\0\5\145\1\0"+
    "\3\377\124\0\3\u0100\7\0\32\u0100\4\0\1\u0100\4\0"+
    "\5\u0100\23\0\3\210\7\0\10\210\1\u015e\21\210\4\0"+
    "\1\210\4\0\1\210\1\u015e\3\210\56\0\1\u015f\100\0"+
    "\1\u0160\105\0\1\u0161\112\0\1\u0162\76\0\1\u0163\111\0"+
    "\1\u0164\72\0\1\u0165\73\0\1\u0166\125\0\1\u0167\105\0"+
    "\1\u0168\22\0\1\u0168\24\0\1\u0169\63\0\1\u010f\3\0"+
    "\1\u016a\4\0\1\u016b\22\0\32\u016c\4\0\1\u016c\4\0"+
    "\5\u016c\23\0\3\64\7\0\23\64\1\u016d\6\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\1\u016e\31\64"+
    "\4\0\1\64\4\0\5\64\30\0\1\u010f\77\0\3\64"+
    "\7\0\13\64\1\u016f\16\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\1\u0170\31\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\13\64\1\u0171\16\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\4\64\1\u0172"+
    "\25\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\2\64\1\u0173\27\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\22\64\1\u0174\7\64\4\0\1\64\4\0"+
    "\2\64\1\u0174\2\64\23\0\3\64\7\0\15\64\1\u0175"+
    "\14\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\22\64\1\u0176\1\u0177\6\64\4\0\1\64\4\0\2\64"+
    "\1\u0176\2\64\23\0\3\64\7\0\13\64\1\u0178\16\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\1\u0179"+
    "\31\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\16\64\1\u017a\13\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\4\64\1\u017b\25\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\23\64\1\u017c\6\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\3\64\1\u017d"+
    "\1\64\1\u017e\2\64\1\u017f\11\64\1\u0180\3\64\1\u0181"+
    "\3\64\4\0\1\64\4\0\1\64\1\u017f\1\u0180\2\64"+
    "\23\0\3\64\7\0\13\64\1\u0182\16\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\23\64\1\u0183\6\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\4\64"+
    "\1\u0184\25\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\22\64\1\u0185\7\64\4\0\1\64\4\0\2\64"+
    "\1\u0185\2\64\23\0\3\64\7\0\1\u0186\31\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\1\u0187\31\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\4\64"+
    "\1\u0188\25\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\14\64\1\u0189\15\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\2\64\1\u018a\27\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\1\64\1\u018b\30\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\16\64"+
    "\1\u018c\13\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\13\64\1\u018d\16\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\13\64\1\u018e\16\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\23\64\1\u018f\6\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\4\64"+
    "\1\u0190\25\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\4\64\1\u0191\25\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\23\64\1\u0192\6\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\4\64\1\u0193\25\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\13\64"+
    "\1\u0194\16\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\4\64\1\u0195\25\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\15\64\1\u0196\7\64\1\u0197\4\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\23\64"+
    "\1\u0198\6\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\13\64\1\u0199\16\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\24\64\1\u019a\5\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\24\64\1\u019b\5\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\5\64"+
    "\1\u019c\24\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\23\64\1\u019d\6\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\10\64\1\u019e\21\64\4\0\1\64"+
    "\4\0\1\64\1\u019e\3\64\23\0\3\64\7\0\23\64"+
    "\1\u019f\6\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\16\64\1\u01a0\13\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\10\64\1\u01a1\21\64\4\0\1\64"+
    "\4\0\1\64\1\u01a1\3\64\23\0\3\64\7\0\4\64"+
    "\1\u01a2\25\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\4\64\1\u01a3\25\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\13\64\1\u01a4\16\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\13\64\1\u01a5\16\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\13\64"+
    "\1\u01a6\16\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\10\64\1\u01a7\21\64\4\0\1\64\4\0\1\64"+
    "\1\u01a7\3\64\23\0\3\64\7\0\10\64\1\u01a8\13\64"+
    "\1\u01a9\5\64\4\0\1\64\4\0\1\64\1\u01a8\3\64"+
    "\23\0\3\64\7\0\1\u01aa\31\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\10\64\1\u01ab\21\64\4\0"+
    "\1\64\4\0\1\64\1\u01ab\3\64\23\0\3\64\7\0"+
    "\4\64\1\u01ac\25\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\1\u01ad\31\64\4\0\1\64\4\0\5\64"+
    "\2\127\2\u0151\3\127\1\345\60\127\1\346\4\127\1\347"+
    "\7\127\2\10\2\u0153\101\10\2\0\2\u0155\121\0\1\u0157"+
    "\14\0\32\u0157\10\0\1\u01ae\7\0\1\u0158\104\0\2\u015a"+
    "\124\0\3\145\7\0\22\145\1\u01af\7\145\4\0\1\145"+
    "\4\0\2\145\1\u01af\2\145\23\0\3\145\7\0\2\145"+
    "\1\u01b0\27\145\4\0\1\145\4\0\5\145\23\0\3\210"+
    "\7\0\22\210\1\u01b1\7\210\4\0\1\210\4\0\2\210"+
    "\1\u01b1\2\210\35\0\1\u01b2\104\0\1\u01b3\117\0\1\u01b4"+
    "\72\0\1\u01b5\103\0\1\u01b6\50\0\1\u01b7\12\0\1\u01b8"+
    "\24\0\1\u01b9\104\0\1\u01ba\113\0\1\u01b7\101\0\1\u01bb"+
    "\33\0\1\u01bb\44\0\1\u01b6\100\0\32\u01bc\4\0\1\u01bc"+
    "\4\0\5\u01bc\35\0\32\u01bd\4\0\1\u01bd\4\0\5\u01bd"+
    "\2\0\1\u01be\1\u01bf\17\0\3\u016c\7\0\32\u016c\4\0"+
    "\1\u016c\4\0\5\u016c\23\0\3\64\7\0\21\64\1\u01c0"+
    "\10\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\30\64\1\u01c1\1\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\12\64\1\u01c2\17\64\4\0\1\64\4\0"+
    "\3\64\1\u01c2\1\64\23\0\3\64\7\0\1\u01c3\31\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\7\64"+
    "\1\u01c4\22\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\22\64\1\u01c5\7\64\4\0\1\64\4\0\2\64"+
    "\1\u01c5\2\64\23\0\3\64\7\0\4\64\1\u01c6\25\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\23\64"+
    "\1\u01c7\6\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\10\64\1\u01c8\21\64\4\0\1\64\4\0\1\64"+
    "\1\u01c8\3\64\23\0\3\64\7\0\1\u01c9\31\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\24\64\1\u01ca"+
    "\5\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\10\64\1\u01cb\21\64\4\0\1\64\4\0\1\64\1\u01cb"+
    "\3\64\23\0\3\64\7\0\30\64\1\u01cc\1\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\4\64\1\u01cd"+
    "\25\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\16\64\1\u01ce\13\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\5\64\1\u01cf\24\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\26\64\1\u01d0\3\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\7\64\1\u01d1"+
    "\22\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\15\64\1\u01d2\14\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\4\64\1\u01d3\25\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\13\64\1\u01d4\16\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\23\64\1\u01d5"+
    "\6\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\1\u01d6\31\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\23\64\1\u01d7\6\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\1\u01d8\31\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\4\64\1\u01d9\25\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\24\64\1\u01da"+
    "\5\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\1\u01db\3\64\1\u01dc\25\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\21\64\1\u01dd\10\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\23\64\1\u01de\6\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\22\64"+
    "\1\u01df\7\64\4\0\1\64\4\0\2\64\1\u01df\2\64"+
    "\23\0\3\64\7\0\15\64\1\u01e0\14\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\23\64\1\u01e1\6\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\1\u01e2"+
    "\31\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\4\64\1\u01e3\25\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\10\64\1\u01e4\21\64\4\0\1\64\4\0"+
    "\1\64\1\u01e4\3\64\23\0\3\64\7\0\10\64\1\u01e5"+
    "\21\64\4\0\1\64\4\0\1\64\1\u01e5\3\64\23\0"+
    "\3\64\7\0\21\64\1\u01e6\10\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\10\64\1\u01e7\21\64\4\0"+
    "\1\64\4\0\1\64\1\u01e7\3\64\23\0\3\64\7\0"+
    "\15\64\1\u01e8\14\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\2\64\1\u01e9\27\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\26\64\1\u01ea\3\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\23\64\1\u01eb"+
    "\6\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\23\64\1\u01ec\6\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\4\64\1\u01ed\25\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\3\64\1\u01ee\26\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\1\u01ef\31\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\21\64"+
    "\1\u01f0\10\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\13\64\1\u01f1\16\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\15\64\1\u01f2\14\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\13\64\1\u01f3\16\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\15\64"+
    "\1\u01f4\14\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\23\64\1\u01f5\6\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\14\64\1\u01f6\15\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\145\7\0\22\145\1\u01f7\7\145"+
    "\4\0\1\145\4\0\2\145\1\u01f7\2\145\23\0\3\145"+
    "\7\0\23\145\1\u01f8\6\145\4\0\1\145\4\0\5\145"+
    "\65\0\1\u01b7\75\0\1\u01b2\27\0\1\u01b7\12\0\1\u01b8"+
    "\24\0\1\u01f9\113\0\1\u01fa\114\0\1\u01b7\25\0\1\u01b7"+
    "\12\0\1\u01b8\133\0\1\u01fb\100\0\1\u01b6\117\0\1\u01fc"+
    "\37\0\1\u01fd\15\0\3\u01bc\7\0\32\u01bc\4\0\1\u01bc"+
    "\4\0\5\u01bc\12\0\1\u01fd\10\0\3\u01bd\7\0\32\u01bd"+
    "\4\0\1\u01bd\4\0\5\u01bd\2\0\1\u01be\125\0\3\64"+
    "\7\0\1\u01fe\31\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\1\64\1\u01ff\30\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\15\64\1\u0200\14\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\21\64\1\u0201"+
    "\10\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\13\64\1\u0202\16\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\5\64\1\u0203\24\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\2\64\1\u0204\27\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\21\64\1\u0205"+
    "\10\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\10\64\1\u0206\21\64\4\0\1\64\4\0\1\64\1\u0206"+
    "\3\64\23\0\3\64\7\0\10\64\1\u0207\21\64\4\0"+
    "\1\64\4\0\1\64\1\u0207\3\64\23\0\3\64\7\0"+
    "\3\64\1\u0208\26\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\13\64\1\u0209\16\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\2\64\1\u020a\27\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\10\64\1\u020b"+
    "\21\64\4\0\1\64\4\0\1\64\1\u020b\3\64\23\0"+
    "\3\64\7\0\13\64\1\u020c\16\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\14\64\1\u020d\15\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\3\64\1\u020e"+
    "\26\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\15\64\1\u020f\14\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\1\u0210\31\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\5\64\1\u0211\24\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\17\64\1\u0212\12\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\23\64"+
    "\1\u0213\6\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\23\64\1\u0214\6\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\2\64\1\u0215\27\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\2\64\1\u0216\27\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\21\64"+
    "\1\u0217\10\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\15\64\1\u0218\14\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\2\64\1\u0219\27\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\6\64\1\u021a\23\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\7\64"+
    "\1\u021b\22\64\4\0\1\64\4\0\5\64\1\0\3\u021c"+
    "\17\0\3\64\7\0\32\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\22\64\1\u021d\7\64\4\0\1\64"+
    "\4\0\2\64\1\u021d\2\64\23\0\3\64\7\0\32\64"+
    "\4\0\1\u021e\4\0\5\64\23\0\3\64\7\0\4\64"+
    "\1\u021f\25\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\2\64\1\u0220\27\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\23\64\1\u0221\6\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\4\64\1\u0222\25\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\7\64"+
    "\1\u0223\22\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\4\64\1\u0224\25\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\145\7\0\10\145\1\u0225\21\145\4\0\1\145"+
    "\4\0\1\145\1\u0225\3\145\35\0\1\u0226\110\0\1\u01b7"+
    "\104\0\1\u0227\106\0\1\u01b7\43\0\1\u01be\1\u01bf\124\0"+
    "\3\64\7\0\2\64\1\u0228\27\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\13\64\1\u0229\16\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\24\64\1\u022a"+
    "\5\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\4\64\1\u022b\25\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\23\64\1\u022c\6\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\13\64\1\u022d\16\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\4\64\1\u022e"+
    "\25\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\23\64\1\u022f\6\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\13\64\1\u0230\16\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\22\64\1\u0231\7\64\4\0"+
    "\1\64\4\0\2\64\1\u0231\2\64\23\0\3\64\7\0"+
    "\30\64\1\u0232\1\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\7\64\1\u0233\22\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\16\64\1\u0234\13\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\4\64\1\u0235"+
    "\25\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\4\64\1\u0236\25\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\2\64\1\u0237\27\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\3\64\1\u0238\26\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\1\u0239\31\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\1\u023a"+
    "\31\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\4\64\1\u023b\25\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\23\64\1\u023c\6\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\4\64\1\u023d\25\64\4\0"+
    "\1\64\4\0\5\64\1\0\3\u021c\36\0\1\u023e\65\0"+
    "\3\64\7\0\22\64\1\u023f\7\64\4\0\1\64\4\0"+
    "\2\64\1\u023f\2\64\23\0\3\64\7\0\32\64\4\0"+
    "\1\u0240\4\0\5\64\23\0\3\64\7\0\32\64\4\0"+
    "\1\u0241\4\0\5\64\23\0\3\64\7\0\23\64\1\u0242"+
    "\6\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\32\64\4\0\1\u0243\4\0\5\64\23\0\3\64\7\0"+
    "\32\64\4\0\1\u0244\4\0\5\64\23\0\3\64\7\0"+
    "\16\64\1\u0245\13\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\22\64\1\u0246\7\64\4\0\1\64\4\0"+
    "\2\64\1\u0246\2\64\23\0\3\145\7\0\16\145\1\u0247"+
    "\13\145\4\0\1\145\4\0\5\145\52\0\1\u01b7\110\0"+
    "\1\u01b7\51\0\3\64\7\0\23\64\1\u0248\6\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\4\64\1\u0249"+
    "\25\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\4\64\1\u024a\25\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\1\u024b\31\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\1\u024c\31\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\2\64\1\u024d\27\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\4\64\1\u024e"+
    "\25\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\15\64\1\u024f\14\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\15\64\1\u0250\14\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\32\64\4\0\1\u0251\4\0"+
    "\5\64\23\0\3\64\7\0\4\64\1\u0252\25\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\16\64\1\u0253"+
    "\13\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\2\64\1\u0254\27\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\2\64\1\u0255\27\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\4\64\1\u0256\25\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\32\64\4\0"+
    "\1\u0257\4\0\5\64\56\0\1\u0258\51\0\3\64\7\0"+
    "\32\64\4\0\1\u0259\4\0\5\64\23\0\3\64\7\0"+
    "\32\64\4\0\1\u025a\4\0\5\64\23\0\3\64\7\0"+
    "\10\64\1\u025b\21\64\4\0\1\64\4\0\1\64\1\u025b"+
    "\3\64\23\0\3\64\7\0\2\64\1\u025c\27\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\32\64\4\0"+
    "\1\u025d\4\0\5\64\23\0\3\64\7\0\3\64\1\u025e"+
    "\26\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\17\64\1\u025f\12\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\145\7\0\15\145\1\u0260\14\145\4\0\1\145\4\0"+
    "\5\145\23\0\3\64\7\0\21\64\1\u0261\10\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\2\64\1\u0262"+
    "\27\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\7\64\1\u0263\22\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\23\64\1\u0264\6\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\16\64\1\u0265\13\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\16\64\1\u0266"+
    "\13\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\5\64\1\u0267\24\64\4\0\1\64\4\0\5\64\23\0"+
    "\3\64\7\0\4\64\1\u0268\25\64\4\0\1\64\4\0"+
    "\5\64\23\0\3\64\7\0\4\64\1\u0269\25\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\3\64\1\u026a"+
    "\26\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\16\64\1\u026b\13\64\4\0\1\64\4\0\5\64\53\0"+
    "\1\u026c\54\0\3\64\7\0\32\64\4\0\1\u026d\4\0"+
    "\5\64\23\0\3\64\7\0\16\64\1\u026e\13\64\4\0"+
    "\1\64\4\0\5\64\23\0\3\64\7\0\16\64\1\u026f"+
    "\13\64\4\0\1\64\4\0\5\64\23\0\3\64\7\0"+
    "\32\64\4\0\1\u0270\4\0\5\64\23\0\3\64\7\0"+
    "\1\u0271\31\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\4\64\1\u0272\25\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\7\64\1\u0273\22\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\22\64\1\u0274\7\64"+
    "\4\0\1\64\4\0\2\64\1\u0274\2\64\23\0\3\64"+
    "\7\0\15\64\1\u0275\14\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\5\64\1\u0276\24\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\15\64\1\u0277\14\64"+
    "\4\0\1\64\4\0\5\64\51\0\1\u0278\56\0\3\64"+
    "\7\0\15\64\1\u0279\14\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\14\64\1\u027a\15\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\32\64\4\0\1\u027b"+
    "\4\0\5\64\23\0\3\64\7\0\2\64\1\u027c\27\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\2\64"+
    "\1\u027d\27\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\2\64\1\u027e\27\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\32\64\4\0\1\u027f\4\0\5\64"+
    "\23\0\3\64\7\0\17\64\1\u0280\12\64\4\0\1\64"+
    "\4\0\5\64\23\0\3\64\7\0\4\64\1\u0281\25\64"+
    "\4\0\1\64\4\0\5\64\23\0\3\64\7\0\4\64"+
    "\1\u0282\25\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\4\64\1\u0283\25\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\32\64\4\0\1\u0284\4\0\5\64"+
    "\23\0\3\64\7\0\10\64\1\u0285\21\64\4\0\1\64"+
    "\4\0\1\64\1\u0285\3\64\23\0\3\64\7\0\32\64"+
    "\4\0\1\u0286\4\0\5\64\23\0\3\64\7\0\13\64"+
    "\1\u0287\16\64\4\0\1\64\4\0\5\64\23\0\3\64"+
    "\7\0\32\64\4\0\1\u0288\4\0\5\64\23\0\3\64"+
    "\7\0\4\64\1\u0289\25\64\4\0\1\64\4\0\5\64"+
    "\23\0\3\64\7\0\21\64\1\u028a\10\64\4\0\1\64"+
    "\4\0\5\64";

  private static int [] zzUnpackTrans() {
    int [] result = new int[35121];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\1\10\5\0\2\1\14\0\1\11\3\1\1\11\5\1"+
    "\1\11\10\1\1\11\31\1\1\11\2\1\1\11\4\1"+
    "\1\11\11\1\1\11\10\1\1\11\1\1\1\11\1\1"+
    "\1\0\1\1\1\11\2\1\2\11\4\1\1\11\2\1"+
    "\1\11\4\1\1\11\2\1\1\11\1\1\1\11\1\1"+
    "\1\0\7\1\1\0\1\11\3\0\2\1\2\11\14\0"+
    "\1\11\2\1\1\0\1\1\1\0\1\11\2\1\1\11"+
    "\4\1\1\0\56\1\3\0\1\11\2\1\2\11\1\1"+
    "\4\0\2\1\1\11\3\0\4\1\1\11\2\0\1\11"+
    "\3\0\1\11\1\1\2\11\1\1\1\0\1\11\1\1"+
    "\1\0\1\11\5\1\12\0\3\1\1\0\2\1\1\0"+
    "\75\1\2\11\1\1\1\11\1\1\1\11\2\0\1\11"+
    "\1\1\1\11\1\0\3\1\12\0\1\11\3\0\101\1"+
    "\1\11\3\1\6\0\1\11\5\0\1\11\72\1\5\0"+
    "\36\1\1\0\11\1\2\0\26\1\1\0\31\1\1\0"+
    "\23\1\1\0\13\1\1\11\22\1";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[650];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  @SuppressWarnings("unused")
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  @SuppressWarnings("unused")
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  @SuppressWarnings("unused")
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	public PHPLexer(int state) {
		initialize(state);
	}

	// NB: this method resets the lexer only partially
	@Override
	protected void reset(java.io.Reader reader, char[] buffer, int[] parameters) {
		this.zzReader = reader;
		this.zzBuffer = buffer;
		this.zzFinalHighSurrogate = 0;
		this.zzMarkedPos = parameters[0];
		this._zzPushbackPos = parameters[1];
		this.zzCurrentPos = parameters[2];
		this.zzStartRead = parameters[3];
		this.zzEndRead = parameters[4];
		this.yyline = parameters[5];
		initialize(parameters[6]);
	}

	@Override
	public int getInScriptingState() {
		return ST_PHP_IN_SCRIPTING;
	}

	private static final int[] heredocStates = new int[] { ST_PHP_HEREDOC, ST_PHP_NOWDOC, ST_PHP_START_HEREDOC, ST_PHP_START_NOWDOC, ST_PHP_END_HEREDOC, ST_PHP_END_NOWDOC };

	@Override
	public int[] getHeredocStates() {
		return heredocStates;
	}

	private static final int[] phpQuotesStates = new int[] { ST_PHP_DOUBLE_QUOTES, ST_PHP_SINGLE_QUOTE, ST_PHP_BACKQUOTE, ST_PHP_HEREDOC, ST_PHP_NOWDOC, ST_PHP_START_HEREDOC, ST_PHP_START_NOWDOC, ST_PHP_END_HEREDOC, ST_PHP_END_NOWDOC };

	@Override
	public int[] getPHPQuotesStates() {
		return phpQuotesStates;
	}

	@Override
	public int[] getParameters() {
		return new int[]{zzMarkedPos, _zzPushbackPos, zzCurrentPos, zzStartRead, zzEndRead, yyline, zzLexicalState};
	}

	@Override
	protected int getZZLexicalState() {
		return zzLexicalState;
	}

	@Override
	protected int getZZMarkedPos() {
		return zzMarkedPos;
	}

	@Override
	protected int getZZEndRead() {
		return zzEndRead;
	}

	@Override
	public char[] getZZBuffer() {
		return zzBuffer;
	}

	@Override
	protected int getZZStartRead() {
		return this.zzStartRead;
	}

	@Override
	protected int getZZPushBackPosition() {
		return this._zzPushbackPos;
	}

	@Override
	protected void pushBack(int i) {
		yypushback(i);
	}

	@Override
	public int getScriptingState() {
		return ST_PHP_IN_SCRIPTING;
	}

	// A pool of states. To avoid creation of a new state on each createMemento.
	private static final Map<LexerState, LexerState> lexerStates = new HashMap<>();

	@Override
	protected Map<LexerState, LexerState> getLexerStates() {
		return lexerStates;
	}

	// End user code


  /** the textposition at the last state to be included in yytext */
  private int _zzPushbackPos;

  /* The following fields are added in order to support the change in zzRefill */
  private String oldString = null;
  private boolean useOldString = false;
  private int startPos = 0;

  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public PHPLexer(java.io.Reader in) {
    this.zzReader = in;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    if (useOldString) {
      String saveOldString = oldString;
      oldString = new String(zzBuffer, startPos, zzMarkedPos - startPos);
      if (saveOldString != null) {
        oldString = saveOldString + oldString;
      }
    }

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      _zzPushbackPos-= zzStartRead;
      startPos = 0;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate) {
      /* if not: blow it up */
      char newBuffer[] = new char[zzBuffer.length * 2];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      throw new java.io.IOException(
          "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Gets the next input character.
   *
   * @return      the next character of the input stream, EOF if the
   *              end of the stream is reached.
   * @exception   IOException  if any I/O-Error occurs
   */
  private int yy_advance() throws java.io.IOException {

    /* standard case */
    if (zzCurrentPos < zzEndRead) return zzBuffer[zzCurrentPos++];

    /* if the eof is reached, we don't need to work hard */
    if (zzAtEOF) return YYEOF;

    /* otherwise: need to refill the buffer */

    String saveOldString = oldString;
    oldString = null;

    /* first: make room (if you can) */
    if (zzRefill()) {
      oldString = saveOldString;
      return YYEOF;
    }

    oldString = saveOldString;

    return zzBuffer[zzCurrentPos++];
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    if (zzBuffer.length > ZZ_BUFFERSIZE) {
      zzBuffer = new char[ZZ_BUFFERSIZE];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      _zzPushbackPos = 0;
      startPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      oldString = null;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }


	/**
	 * user method - common.sse
	 */
	private void updateStartPos() {
		updateStartPos(zzMarkedPos);
	}


	/**
	 * user method - common.sse
	 */
	private void updateStartPos(int position) {
		startPos = position;
		oldString = null;
	}


	/**
	 * user method - common.sse
	 */
	public final boolean isEOF() {
		return zzAtEOF;
	}




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public String yylex() throws java.io.IOException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return null;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { return PHP_ENCAPSED_AND_WHITESPACE;
            }
            // fall through
          case 149: break;
          case 2:
            { return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 150: break;
          case 3:
            { yypushback(1);
	pushState(ST_PHP_HIGHLIGHTING_ERROR);
            }
            // fall through
          case 151: break;
          case 4:
            { return WHITESPACE;
            }
            // fall through
          case 152: break;
          case 5:
            { return PHP_TOKEN;
            }
            // fall through
          case 153: break;
          case 6:
            { pushState(ST_PHP_DOUBLE_QUOTES);
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 154: break;
          case 7:
            { pushState(ST_PHP_LINE_COMMENT);
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 155: break;
          case 8:
            { pushState(ST_PHP_SINGLE_QUOTE);
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 156: break;
          case 9:
            { return PHP_NUMBER;
            }
            // fall through
          case 157: break;
          case 10:
            { return PHP_SEMICOLON;
            }
            // fall through
          case 158: break;
          case 11:
            { return PHP_LABEL;
            }
            // fall through
          case 159: break;
          case 12:
            { return PHP_NS_SEPARATOR;
            }
            // fall through
          case 160: break;
          case 13:
            { pushState(ST_PHP_BACKQUOTE);
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 161: break;
          case 14:
            { // Whitespaces are directly appended to the curly before pushState()
	// is effective or whitespaces would be stored in a separate ContextRegion.
	// Method PhpTokenContainer#addLast() will correct the curlies length...
	if (!phpStack.isEmpty()) {
		// Only push the state when stack is not empty, it's useless otherwise
		// (and it pollutes the stack).
		pushState(ST_PHP_IN_SCRIPTING);
	}
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 162: break;
          case 15:
            { // Whitespaces are directly appended to the curly before pushState()
	// is effective or whitespaces would be stored in a separate ContextRegion.
	// Method PhpTokenContainer#addLast() will correct the curlies length...
	if (!phpStack.isEmpty()) {
		popState();
		// If new state is not ST_PHP_IN_SCRIPTING then some blanks are signifiant (like newlines
		// after the closing curly and before an ending heredoc tag), so don't append them...
		// See rule <ST_PHP_HEREDOC>{HEREDOC_CHARS}*({HEREDOC_NEWLINE}+({LABEL}";"?)?)?
		if (getZZLexicalState() != ST_PHP_IN_SCRIPTING) {
			yypushback(yylength() - 1);
		}
	}
	return PHP_CURLY_CLOSE;
            }
            // fall through
          case 163: break;
          case 16:
            { popState();
	return PHP_CONSTANT_ENCAPSED_STRING;
            }
            // fall through
          case 164: break;
          case 17:
            { yypushback(1);
		popState();
            }
            // fall through
          case 165: break;
          case 18:
            { yypushback(1);
	yybegin(ST_PHP_HEREDOC);
            }
            // fall through
          case 166: break;
          case 19:
            { yypushback(1);
	yybegin(ST_PHP_NOWDOC);
            }
            // fall through
          case 167: break;
          case 20:
            { yypushback(1);
	popState();
            }
            // fall through
          case 168: break;
          case 21:
            { popState();
	return PHP_LABEL;
            }
            // fall through
          case 169: break;
          case 22:
            { yypushback(1);
	popState();
	return PHP_ENCAPSED_AND_WHITESPACE;
            }
            // fall through
          case 170: break;
          case 23:
            { //the difference from the original rules comes from the fact that we took ';' out of tokens
	return UNKNOWN_TOKEN;
            }
            // fall through
          case 171: break;
          case 24:
            { popState();
	return PHP_TOKEN;
            }
            // fall through
          case 172: break;
          case 25:
            { return PHP_COMMENT;
            }
            // fall through
          case 173: break;
          case 26:
            { return PHPDOC_COMMENT;
            }
            // fall through
          case 174: break;
          case 27:
            { String yytext = yytext();
	switch (yytext.charAt(yytext.length() - 1)) {
		case '?':
		case '%':
		case '>':
			yypushback(1);
			if (yylength() > 0) {
				return PHP_LINE_COMMENT;
			}
			break;
		default:
			popState();
			return PHP_LINE_COMMENT;
	}
            }
            // fall through
          case 175: break;
          case 28:
            { return PHP_LINE_COMMENT;
            }
            // fall through
          case 176: break;
          case 29:
            { return UNKNOWN_TOKEN;
            }
            // fall through
          case 177: break;
          case 30:
            { popState();return WHITESPACE;
            }
            // fall through
          case 178: break;
          case 31:
            { yybegin(ST_PHP_IN_SCRIPTING);
	return PHP_ENCAPSED_VARIABLE;
            }
            // fall through
          case 179: break;
          case 32:
            { yybegin(ST_PHP_IN_SCRIPTING);
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 180: break;
          case 33:
            { return PHP_OPERATOR;
            }
            // fall through
          case 181: break;
          case 34:
            { return PHP_VARIABLE;
            }
            // fall through
          case 182: break;
          case 35:
            { if (asp_tags) {
		return PHP_CLOSETAG;
	}
	return UNKNOWN_TOKEN;
            }
            // fall through
          case 183: break;
          case 36:
            { pushState(ST_PHP_LOOKING_FOR_PROPERTY);
	return PHP_OBJECT_OPERATOR;
            }
            // fall through
          case 184: break;
          case 37:
            { pushState(ST_PHP_COMMENT);
	return PHP_COMMENT_START;
            }
            // fall through
          case 185: break;
          case 38:
            { pushState(ST_PHP_IDENTIFIER);
	return PHP_PAAMAYIM_NEKUDOTAYIM;
            }
            // fall through
          case 186: break;
          case 39:
            { return PHP_CLOSETAG;
            }
            // fall through
          case 187: break;
          case 40:
            { return PHP_AS;
            }
            // fall through
          case 188: break;
          case 41:
            { return PHP_DO;
            }
            // fall through
          case 189: break;
          case 42:
            { return PHP_IF;
            }
            // fall through
          case 190: break;
          case 43:
            { yypushback(1);
	return PHP_ENCAPSED_AND_WHITESPACE;
            }
            // fall through
          case 191: break;
          case 44:
            { pushState(ST_PHP_QUOTES_AFTER_VARIABLE);
	return PHP_VARIABLE;
            }
            // fall through
          case 192: break;
          case 45:
            { // We can have nested curlies after applying this rule,
	// so we have to count all curlies...
	yypushback(1);
	pushState(ST_PHP_DOLLAR_CURLY_OPEN);
	return PHP_TOKEN;
            }
            // fall through
          case 193: break;
          case 46:
            { // We can have nested curlies after applying rule below for "${",
	// so we have to count all curlies...
	yypushback(1);
	pushState(ST_PHP_IN_SCRIPTING);
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 194: break;
          case 47:
            { popState();
	pushState(ST_PHP_LOOKING_FOR_PROPERTY);
	return PHP_OBJECT_OPERATOR;
            }
            // fall through
          case 195: break;
          case 48:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}

	String heredoc = getHeredocId();
	int heredoc_len = heredoc.length();
	if (label_len == heredoc_len && yytext.substring(0, label_len).equals(heredoc)) {
		// we must (at least) push the newline character back
		yypushback(1);
		popHeredocId();
		popState();
		return PHP_HEREDOC_CLOSE_TAG;
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
		return PHP_ENCAPSED_AND_WHITESPACE;
	}
            }
            // fall through
          case 196: break;
          case 49:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}

	String nowdoc = getHeredocId();
	int nowdoc_len = nowdoc.length();
	if (label_len == nowdoc_len && yytext.substring(0, label_len).equals(nowdoc)) {
		// we must (at least) push the newline character back
		yypushback(1);
		popHeredocId();
		popState();
		return PHP_NOWDOC_CLOSE_TAG;
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
		return PHP_CONSTANT_ENCAPSED_STRING;
	}
            }
            // fall through
          case 197: break;
          case 50:
            { return PHP_OBJECT_OPERATOR;
            }
            // fall through
          case 198: break;
          case 51:
            { popState();
	return PHP_COMMENT_END;
            }
            // fall through
          case 199: break;
          case 52:
            { popState();
	return PHPDOC_COMMENT_END;
            }
            // fall through
          case 200: break;
          case 53:
            { TagKind tagkind = TagKind.getTagKindFromValue(yytext());
		if (tagkind != null && tagkind != TagKind.UNKNOWN
			&& /* ignore @todo tag */ tagkind != TagKind.TODO) {
				return PHPDOC_GENERIC_TAG;
		}
		return PHPDOC_COMMENT;
            }
            // fall through
          case 201: break;
          case 54:
            { popState();
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 202: break;
          case 55:
            { if (asp_tags) {
		return PHP_CLOSETAG;
	}
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 203: break;
          case 56:
            { return PHP_PAAMAYIM_NEKUDOTAYIM;
            }
            // fall through
          case 204: break;
          case 57:
            { yypushback(yylength() - 1);
	return PHP_CURLY_OPEN;
            }
            // fall through
          case 205: break;
          case 58:
            { pushState(ST_PHP_DOC_COMMENT);
	return PHPDOC_COMMENT_START;
            }
            // fall through
          case 206: break;
          case 59:
            { return PHP_DIE;
            }
            // fall through
          case 207: break;
          case 60:
            { return PHP_FOR;
            }
            // fall through
          case 208: break;
          case 61:
            { return PHP_INT;
            }
            // fall through
          case 209: break;
          case 62:
            { return PHP_NEW;
            }
            // fall through
          case 210: break;
          case 63:
            { return PHP_TRY;
            }
            // fall through
          case 211: break;
          case 64:
            { return PHP_USE;
            }
            // fall through
          case 212: break;
          case 65:
            { return PHP_VAR;
            }
            // fall through
          case 213: break;
          case 66:
            { yypushback(1);
	pushState(ST_PHP_VAR_OFFSET);
	return PHP_VARIABLE;
            }
            // fall through
          case 214: break;
          case 67:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}
	String heredoc = getHeredocId();
	int heredoc_len = heredoc.length();
	int startIndex = label_len - heredoc_len;
	if (startIndex > 0 && yytext.substring(startIndex, label_len).equals(heredoc)
		&& (yytext.charAt(startIndex - 1) == '\n' || yytext.charAt(startIndex - 1) == '\r')) {

		if (startIndex - 2 >= 0
			&& yytext.charAt(startIndex - 2) == '\r'
			&& yytext.charAt(startIndex - 1) == '\n') {
			startIndex-= 2;
		} else {
			startIndex--;
		}
		yypushback(yylength() - startIndex);

		yybegin(ST_PHP_END_HEREDOC);
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
	}
	// In some cases, all text is pushed back (using yypushback()),
	// especially when the parsed document has Windows newlines.
	// In those cases, ignore this rule and try next one...
	if (yylength() > 0) {
		return PHP_ENCAPSED_AND_WHITESPACE;
	}
            }
            // fall through
          case 215: break;
          case 68:
            { String yytext = yytext();
	int label_len = yylength() - 1;

	if (yytext.charAt(label_len - 1) == ';') {
		label_len--;
	}
	String nowdoc = getHeredocId();
	int nowdoc_len = nowdoc.length();
	int startIndex = label_len - nowdoc_len;
	if (startIndex > 0 && yytext.substring(startIndex, label_len).equals(nowdoc)
		&& (yytext.charAt(startIndex - 1) == '\n' || yytext.charAt(startIndex - 1) == '\r')) {

		if (startIndex - 2 >= 0
			&& yytext.charAt(startIndex - 2) == '\r'
			&& yytext.charAt(startIndex - 1) == '\n') {
			startIndex-= 2;
		} else {
			startIndex--;
		}
		yypushback(yylength() - startIndex);

		yybegin(ST_PHP_END_NOWDOC);
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
	}
	// In some cases, all text is pushed back (using yypushback()),
	// especially when the parsed document has Windows newlines.
	// In those cases, ignore this rule and try next one...
	if (yylength() > 0) {
		return PHP_CONSTANT_ENCAPSED_STRING;
	}
            }
            // fall through
          case 216: break;
          case 69:
            { // we must (at least) push the newline character back
	yypushback(1);
	popHeredocId();
	popState();
	return PHP_HEREDOC_CLOSE_TAG;
            }
            // fall through
          case 217: break;
          case 70:
            { yypushback(yylength() - 2);
	if (asp_tags) {
		return PHP_CLOSETAG;
	}
	popState();
	return PHP_LINE_COMMENT;
            }
            // fall through
          case 218: break;
          case 71:
            { // we must (at least) push the newline character back
	yypushback(1);
	popHeredocId();
	popState();
	return PHP_NOWDOC_CLOSE_TAG;
            }
            // fall through
          case 219: break;
          case 72:
            { yypushback(2);
	pushState(ST_PHP_COMMENT);
	return PHP_COMMENT_START;
            }
            // fall through
          case 220: break;
          case 73:
            { return PHP_BOOL;
            }
            // fall through
          case 221: break;
          case 74:
            { return PHP_CASE;
            }
            // fall through
          case 222: break;
          case 75:
            { return PHP_ECHO;
            }
            // fall through
          case 223: break;
          case 76:
            { return PHP_ELSE;
            }
            // fall through
          case 224: break;
          case 77:
            { return PHP_EVAL;
            }
            // fall through
          case 225: break;
          case 78:
            { return PHP_EXIT;
            }
            // fall through
          case 226: break;
          case 79:
            { return PHP_FROM;
            }
            // fall through
          case 227: break;
          case 80:
            { return PHP_GOTO;
            }
            // fall through
          case 228: break;
          case 81:
            { return PHP_LIST;
            }
            // fall through
          case 229: break;
          case 82:
            { return PHP_KEYWORD;
            }
            // fall through
          case 230: break;
          case 83:
            { return PHP_SELF;
            }
            // fall through
          case 231: break;
          case 84:
            { return PHP_TRUE;
            }
            // fall through
          case 232: break;
          case 85:
            { TagKind tagkind = TagKind.getTagKindFromValue(yytext());
		if (tagkind != null && tagkind != TagKind.UNKNOWN) {
			return PHPDOC_GENERIC_TAG;
		}
		return PHPDOC_COMMENT;
            }
            // fall through
          case 233: break;
          case 86:
            { return PHP_THIS;
            }
            // fall through
          case 234: break;
          case 87:
            { return PHP_CASTING;
            }
            // fall through
          case 235: break;
          case 88:
            { String yytext = yytext();
	int bprefix = (yytext.charAt(0) != '<') ? 1 : 0;
	int startString = 3 + bprefix;

	int hereOrNowDoc_len = yylength() - bprefix - 3 - 1 - (yytext.charAt(yylength() - 2) == '\r' ? 1 : 0);
	while ((yytext.charAt(startString) == ' ') || (yytext.charAt(startString) == '\t')) {
		startString++;
		hereOrNowDoc_len--;
	}
	String hereOrNowDoc = yytext.substring(startString, hereOrNowDoc_len + startString);
	if (hereOrNowDoc.charAt(0) == '\'') {
		pushHeredocId(hereOrNowDoc.substring(1, hereOrNowDoc_len - 1));
		pushState(ST_PHP_START_NOWDOC);
		return PHP_NOWDOC_START_TAG;
	} else if (hereOrNowDoc.charAt(0) == '"') {
		pushHeredocId(hereOrNowDoc.substring(1, hereOrNowDoc_len - 1));
		pushState(ST_PHP_START_HEREDOC);
		return PHP_HEREDOC_START_TAG;
	} else {
		pushHeredocId(hereOrNowDoc);
		pushState(ST_PHP_START_HEREDOC);
		return PHP_HEREDOC_START_TAG;
	}
            }
            // fall through
          case 236: break;
          case 89:
            { return PHP_ARRAY;
            }
            // fall through
          case 237: break;
          case 90:
            { return PHP_BREAK;
            }
            // fall through
          case 238: break;
          case 91:
            { return PHP_CATCH;
            }
            // fall through
          case 239: break;
          case 92:
            { return PHP_CLASS;
            }
            // fall through
          case 240: break;
          case 93:
            { return PHP_CLONE;
            }
            // fall through
          case 241: break;
          case 94:
            { pushState(ST_PHP_IDENTIFIER);
	return PHP_CONST;
            }
            // fall through
          case 242: break;
          case 95:
            { return PHP_EMPTY;
            }
            // fall through
          case 243: break;
          case 96:
            { return PHP_ENDIF;
            }
            // fall through
          case 244: break;
          case 97:
            { return PHP_FALSE;
            }
            // fall through
          case 245: break;
          case 98:
            { return PHP_FINAL;
            }
            // fall through
          case 246: break;
          case 99:
            { return PHP_FLOAT;
            }
            // fall through
          case 247: break;
          case 100:
            { return PHP_ISSET;
            }
            // fall through
          case 248: break;
          case 101:
            { return PHP_PRINT;
            }
            // fall through
          case 249: break;
          case 102:
            { return PHP_THROW;
            }
            // fall through
          case 250: break;
          case 103:
            { return PHP_TRAIT;
            }
            // fall through
          case 251: break;
          case 104:
            { return PHP_UNSET;
            }
            // fall through
          case 252: break;
          case 105:
            { return PHP_WHILE;
            }
            // fall through
          case 253: break;
          case 106:
            { return PHP_YIELD;
            }
            // fall through
          case 254: break;
          case 107:
            { return PHP_ELSEIF;
            }
            // fall through
          case 255: break;
          case 108:
            { return PHP_ENDFOR;
            }
            // fall through
          case 256: break;
          case 109:
            { return PHP_GLOBAL;
            }
            // fall through
          case 257: break;
          case 110:
            { return PHP_PARENT;
            }
            // fall through
          case 258: break;
          case 111:
            { return PHP_PUBLIC;
            }
            // fall through
          case 259: break;
          case 112:
            { return PHP_RETURN;
            }
            // fall through
          case 260: break;
          case 113:
            { return PHP_STATIC;
            }
            // fall through
          case 261: break;
          case 114:
            { return PHP_STRING;
            }
            // fall through
          case 262: break;
          case 115:
            { return PHP_SWITCH;
            }
            // fall through
          case 263: break;
          case 116:
            { return PHP_DECLARE;
            }
            // fall through
          case 264: break;
          case 117:
            { return PHP_DEFAULT;
            }
            // fall through
          case 265: break;
          case 118:
            { return PHP_EXTENDS;
            }
            // fall through
          case 266: break;
          case 119:
            { return PHP_FINALLY;
            }
            // fall through
          case 267: break;
          case 120:
            { return PHP_FOREACH;
            }
            // fall through
          case 268: break;
          case 121:
            { return PHP_INCLUDE;
            }
            // fall through
          case 269: break;
          case 122:
            { return PHP_PRIVATE;
            }
            // fall through
          case 270: break;
          case 123:
            { return PHP_REQUIRE;
            }
            // fall through
          case 271: break;
          case 124:
            { return PHP__DIR__;
            }
            // fall through
          case 272: break;
          case 125:
            { return PHP_ABSTRACT;
            }
            // fall through
          case 273: break;
          case 126:
            { return PHP_CALLABLE;
            }
            // fall through
          case 274: break;
          case 127:
            { return PHP_CONTINUE;
            }
            // fall through
          case 275: break;
          case 128:
            { return PHP_ENDWHILE;
            }
            // fall through
          case 276: break;
          case 129:
            { pushState(ST_PHP_IDENTIFIER);
	return PHP_FUNCTION;
            }
            // fall through
          case 277: break;
          case 130:
            { return PHP__FILE__;
            }
            // fall through
          case 278: break;
          case 131:
            { return PHP__LINE__;
            }
            // fall through
          case 279: break;
          case 132:
            { return PHP_FUNCTION;
            }
            // fall through
          case 280: break;
          case 133:
            { return PHP_ENDSWITCH;
            }
            // fall through
          case 281: break;
          case 134:
            { return PHP_INSTEADOF;
            }
            // fall through
          case 282: break;
          case 135:
            { return PHP_INTERFACE;
            }
            // fall through
          case 283: break;
          case 136:
            { return PHP_NAMESPACE;
            }
            // fall through
          case 284: break;
          case 137:
            { return PHP_PROTECTED;
            }
            // fall through
          case 285: break;
          case 138:
            { return PHP__CLASS__;
            }
            // fall through
          case 286: break;
          case 139:
            { return PHP_ENDDECLARE;
            }
            // fall through
          case 287: break;
          case 140:
            { return PHP_ENDFOREACH;
            }
            // fall through
          case 288: break;
          case 141:
            { return PHP_IMPLEMENTS;
            }
            // fall through
          case 289: break;
          case 142:
            { return PHP_INSTANCEOF;
            }
            // fall through
          case 290: break;
          case 143:
            { return PHP__METHOD__;
            }
            // fall through
          case 291: break;
          case 144:
            { return PHP_INCLUDE_ONCE;
            }
            // fall through
          case 292: break;
          case 145:
            { return PHP_REQUIRE_ONCE;
            }
            // fall through
          case 293: break;
          case 146:
            { return PHP__FUNCTION__;
            }
            // fall through
          case 294: break;
          case 147:
            { return PHP__NAMESPACE__;
            }
            // fall through
          case 295: break;
          case 148:
            { return PHP_HALT_COMPILER;
            }
            // fall through
          case 296: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }


}
